package seu;

import static rescuecore2.misc.java.JavaTools.instantiate;

import java.io.File;
import java.io.IOException;
import javax.swing.JFrame;

import seu.Viewer.TestViewer;
import seu.agent.at.AmbulanceCentreAgent;
import seu.agent.at.AmbulanceTeamAgent;
import seu.agent.fb.FireBrigadeAgent;
import seu.agent.fb.FireStationAgent;
import seu.agent.pf.PoliceForceAgent;
import seu.agent.pf.PoliceOfficeAgent;
import seu.model.AgentConstants;

import java.util.List;
import java.util.ArrayList;
import rescuecore2.Constants;
import rescuecore2.GUIComponent;
import rescuecore2.components.Component;
import rescuecore2.components.ComponentLauncher;
import rescuecore2.components.TCPComponentLauncher;
import rescuecore2.components.ComponentConnectionException;
import rescuecore2.components.ComponentInitialisationException;
import rescuecore2.connection.ConnectionException;
import rescuecore2.config.Config;
import rescuecore2.config.ConfigException;
import rescuecore2.misc.java.LoadableTypeProcessor;
import rescuecore2.misc.CommandLineOptions;
import rescuecore2.registry.Registry;
import rescuecore2.standard.entities.StandardEntityFactory;
import rescuecore2.standard.entities.StandardPropertyFactory;
import rescuecore2.standard.messages.StandardMessageFactory;
import rescuecore2.log.Logger;

public final class LaunchAgents {

	private static final String NO_GUI_FLAG = "--nogui";
	private static final String PRECOMPUTE_FLAG = "-precompute";
	/**
	 * An controll flag to determines whether to use precompute in the
	 * implemention of agents.
	 */
	public static boolean SHOULD_PRECOMPUTE = true;

	
	private static final String RANDOM_SEED = "122";  //yuan_seu
	// Rule 中规定的智能体最大数量                                   //yuan_seu
	private static final int maxAgent = 200;  //yuan_seu
	private static final int maxCentre = 20;  //yuan_seu
	
	
	private LaunchAgents() {
		
	}

	public static void main(String[] args) {
/*
		try {
			Registry.SYSTEM_REGISTRY
					.registerEntityFactory(StandardEntityFactory.INSTANCE);
			Registry.SYSTEM_REGISTRY
					.registerMessageFactory(StandardMessageFactory.INSTANCE);
			Registry.SYSTEM_REGISTRY
					.registerPropertyFactory(StandardPropertyFactory.INSTANCE);
			Config config = new Config();

			args = CommandLineOptions.processArgs(args, config);

			// Keep
			config.setValue(Constants.RANDOM_SEED_KEY, RANDOM_SEED);

			int port = config.getIntValue(Constants.KERNEL_PORT_NUMBER_KEY,
					Constants.DEFAULT_KERNEL_PORT_NUMBER);
			port = 7000;
			String defaultHost = config.getValue(
					Constants.KERNEL_HOST_NAME_KEY,
					Constants.DEFAULT_KERNEL_HOST_NAME);

			int fb = -1;
			int fs = -1;

			int pf = -1;
			int po = -1;

			int at = -1;
			int ac = -1;
			String host="localhost";
			if(args==null||args.length==0){
				fb=maxAgent;
				fs=maxAgent;
				po=maxAgent;
				pf=maxAgent;
				at=maxAgent;
				ac=maxAgent;
				
			}else{
				fb = (args[0].equals("-1")) ? maxAgent : Integer.parseInt(args[0]);

				fs = (args[1].equals("-1")) ? maxCentre : Integer.parseInt(args[1]);

				pf = (args[2].equals("-1")) ? maxAgent : Integer.parseInt(args[2]);

				po = (args[3].equals("-1")) ? maxCentre : Integer.parseInt(args[3]);

				at = (args[4].equals("-1")) ? maxAgent : Integer.parseInt(args[4]);

				ac = (args[5].equals("-1")) ? maxCentre : Integer.parseInt(args[5]);

				host = (args[6].equals("-1")) ? defaultHost : args[6];
			}
			

			ComponentLauncher launcher = new TCPComponentLauncher(host, port,
					config);

			// 建立连接
			connect(launcher, fb, fs, pf, po, at, ac, config);

		} catch (IOException e) {
			e.printStackTrace();
		} catch (ConfigException e) {
			e.printStackTrace();
		} catch (ConnectionException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		return;
*/	
		
		
		// Logger.setLogContext("launcher");
		Config config = new Config();
		boolean gui = true;
		try {
			// the hostname and random seed will be processed.
			args = CommandLineOptions.processArgs(args, config);  
			List<String> toLaunch = new ArrayList<String>();
			boolean precompute = false;   // flag to determines whether to use precompute
			if(args==null||args.length==0){
				System.out.println(" args==null||args.length==0 ");
			}
			for (String next : args) {
				if (NO_GUI_FLAG.equals(next)) {
					System.out.println(" gui = false;");
					gui = false;
				} else if (PRECOMPUTE_FLAG.equals(next)) {
					System.out.println("SEU--Precompute...Success  ");
					precompute = true;
					SHOULD_PRECOMPUTE = precompute;
				} else {
					//System.out.println(" toLaunch.add(next)");
					toLaunch.add(next);
				}
			}
			
			/*
			 * Handle the precompute case. If the precompute directory does not exist, then make it. 
			 * If the precompute directory exists, then delete all items generated in last simulation.
			 */
			if (precompute/*SHOULD_PRECOMPUTE*/) {
				File data = new File("precompute");
				if (!data.exists() || !data.isDirectory()) {
					data.mkdir();	
				} else {
					for (File file : data.listFiles()) {
						if (!file.isDirectory())
							file.delete();
					}
				}
			} /*else {
				File data = new File("precompute");
				if (data.exists()) {
					if (data.isDirectory()) {
						for (File file : data.listFiles()) {
							if (!file.isDirectory())
								file.delete();
						}
					}
				}
			}*/
			
			if (AgentConstants.PRINT_COMMUNICATION) {
				File data = new File("commOutput");
				if (!data.exists() || !data.isDirectory()) {
					data.mkdir();
				} else {
					for (File file : data.listFiles()) {
						if (!file.isDirectory())
							file.delete();
					}
				}
			}
			
			int port = config.getIntValue(Constants.KERNEL_PORT_NUMBER_KEY,
					Constants.DEFAULT_KERNEL_PORT_NUMBER);
			String host = config.getValue(Constants.KERNEL_HOST_NAME_KEY,
					Constants.DEFAULT_KERNEL_HOST_NAME);
			processJarFiles(config);

			ComponentLauncher launcher = new TCPComponentLauncher(host, port, config);
			if(toLaunch==null||toLaunch.isEmpty()){
				System.out.println("toLaunch==null||toLaunch.isEmpty()");
			}
			for (String next : toLaunch) {
				connect(launcher, next, gui);
			}
			System.out.println("All agents was connected.");
			
			// test viewer part
			if (AgentConstants.LAUNCH_VIEWER) {
				try { 
					Logger.info("Connecting viewer ...");
					launcher.connect(new TestViewer());
					Logger.info("success");
				} catch (ComponentConnectionException e) {
					Logger.info("failed: " + e.getMessage());
				}
			}
			
		} catch (IOException e) {
			Logger.error("Error connecting components", e);
		} catch (ConfigException e) {
			Logger.error("Configuration error", e);
		} catch (ConnectionException e) {
			Logger.error("Error connecting components", e);
		} catch (InterruptedException e) {
			Logger.error("Error connecting components", e);
		}

	}

	/**
	 * This method will register the Entity, Message and Property factory.
	 */
	private static void processJarFiles(Config config) throws IOException {
		LoadableTypeProcessor processor = new LoadableTypeProcessor(config);
		processor.addFactoryRegisterCallbacks(Registry.SYSTEM_REGISTRY);
		processor.process();
	}

	private static void connect(ComponentLauncher launcher, String argLine, boolean gui) 
			throws InterruptedException, ConnectionException {
		// the class name of agent and the number of this agent was sperated by "*"
		int index = argLine.indexOf("*");
		int count = 1;						// the count of agent
		String className = argLine;			// the class name of the component to be launch

		if (index != -1) {
			String mult = argLine.substring(index + 1);
			if ("n".equals(mult)) {
				count = Integer.MAX_VALUE;
			} else {
				count = Integer.parseInt(mult);
			}
			className = argLine.substring(0, index);
			//if(className=="fb") 
		}
		System.out.println("Connecting " + (count == Integer.MAX_VALUE ? "many" : count)
				 + className );
		for (int i = 0; i != count; ++i) {
			Component c = instantiate(className, Component.class);
			if (c == null) {
				System.out.println("c == null");
				break;
			}
			System.out.println("Connecting  " + (i + 1) );
			try {
				c.initialise();
				launcher.connect(c);
				if (gui && c instanceof GUIComponent) {

					GUIComponent g = (GUIComponent) c;
					JFrame frame = new JFrame(g.getGUIComponentName());
					frame.setContentPane(g.getGUIComponent());
					frame.pack();
					frame.setVisible(true);
				}
				System.out.println("success");
			} catch (ComponentConnectionException e) {
				Logger.info("failed: " + e.getMessage());
				break;
			} catch (ComponentInitialisationException e) {
				Logger.info("failed: " + e);
			} catch (ConnectionException e) {
				Logger.info("failed: " + e);
				break;
			}
		}
	}
	
//	private static void connect(ComponentLauncher launcher, int fb, int fs,
//			int pf, int po, int at, int ac, Config config)
//			throws InterruptedException, ConnectionException {
//
//		int i = 0;
//		try {
//			while (fb-- > 0) {
//				launcher.connect(new FireBrigadeAgent());
//				System.out.println("Connecting Fire Brigade " + (i++)
//						+ "... Success");
//			}
//		} catch (ComponentConnectionException e) {
//			System.out.println("Fire Brigade Conncetion Done");
//		}
//
//		i = 0;
//		try {
//			while (fs-- > 0) {
//				launcher.connect(new FireStationAgent());
//				System.out.println("Connecting FireStation " + (i++)
//						+ "... Success");
//			}
//		} catch (ComponentConnectionException e) {
//			System.out.println("Fire Station Connection Done");
//		}
//
//		i = 0;
//		try {
//			while (pf-- > 0) {
//				launcher.connect(new PoliceForceAgent());
//				System.out.println("Connecting Police Force " + (i++)
//						+ "... Success");
//			}
//		} catch (ComponentConnectionException e) {
//			System.out.println("Police Force Connection Done");
//		}
//
//		i = 0;
//		try {
//			while (po-- > 0) {
//				launcher.connect(new PoliceOfficeAgent());
//				System.out.println("Connecting PoliceOffice " + (i++)
//						+ "... Success");
//			}
//		} catch (ComponentConnectionException e) {
//			System.out.println("Police Office Connection Done");
//		}
//
//		i = 0;
//		try {
//			while (at-- > 0) {
//				launcher.connect(new AmbulanceTeamAgent());
//				System.out.println("Connecting Ambulance Team " + (i++)
//						+ "... Success");
//			}
//		} catch (ComponentConnectionException e) {
//			System.out.println("Ambulance Team Connection Done");
//		}
//
//		i = 0;
//		try {
//			while (ac-- > 0) {
//				launcher.connect(new AmbulanceCentreAgent());
//				System.out.println("Connecting Ambulance Centre " + (i++)
//						+ "... Success");
//			}
//		} catch (Exception e) {
//			System.out.println("Ambulance Centre Connection Done");
//			System.out.println("SEU ALL Agents Connection Done");
//		}
//	}
	
}
