package seu.Viewer;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

import seu.Viewer.layers.SEU_BuildingLayer;
import seu.Viewer.layers.SEU_ConvexHullLayer;
import seu.Viewer.layers.SEU_CriticalAreaLayer;
import seu.Viewer.layers.SEU_PartitionLayer;
//import seu.Viewer.layers.SEU_PovLayer;
import seu.Viewer.layers.SEU_RoadLayer;
import seu.Viewer.layers.SEU_ZonePolygonLayer;
import rescuecore2.standard.view.AnimatedHumanLayer;
import rescuecore2.standard.view.AreaIconLayer;
import rescuecore2.standard.view.AreaNeighboursLayer;
import rescuecore2.standard.view.CommandLayer;
import rescuecore2.standard.view.PositionHistoryLayer;
import rescuecore2.standard.view.RoadBlockageLayer;

/**
 * 
 * Date: Feb 23, 2014 Time: 3:48pm
 * 
 * @author appreciation-seu
 *
 */
@SuppressWarnings("serial")
public class TestAnimatedWorldModelViewer extends TestStandardWorldModelViewer{
	private static final int FRAME_COUNT = 10;									// frame count
	private static final int ANIMATION_TIME = 750;								// animation time
	private static final int FRAME_DELAY = ANIMATION_TIME / FRAME_COUNT;			// frame delay

	private AnimatedHumanLayer humans;
	private Timer timer;
	private final Object lock = new Object();
	private boolean done;
	
	public TestAnimatedWorldModelViewer() {
		super();
		timer = new Timer(FRAME_DELAY, new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				synchronized (lock) {
					if (done) {
						return;
					}
					done = true;
					if (humans.nextFrame()) {
						done = false;
						repaint();
					}
				}
			}
		});
		timer.setRepeats(true);
		timer.start();
	}
	
	@Override
	public String getViewerName() {
		return "SEU Animated World Model Viewer";
	}
	
	@Override
	public void addDefaultLayers() {
		addLayer(new SEU_RoadLayer());
		addLayer(new SEU_BuildingLayer());
		addLayer(new SEU_ConvexHullLayer());
		addLayer(new SEU_ZonePolygonLayer());
		addLayer(new SEU_CriticalAreaLayer());
//		addLayer(new SEU_PovLayer());
		addLayer(new SEU_PartitionLayer());
		
//		addLayer(new BuildingLayer());						
//		addLayer(new RoadLayer());							
		addLayer(new AreaNeighboursLayer());				
		addLayer(new RoadBlockageLayer());					
		
		AreaIconLayer areaIcon = new AreaIconLayer();
		areaIcon.setVisible(true);
		addLayer(areaIcon);						
		
		humans = new AnimatedHumanLayer();		
		humans.setVisible(true);
		addLayer(humans);	
		
		CommandLayer commands = new CommandLayer();
		addLayer(commands);									
		commands.setRenderMove(false);
		addLayer(new PositionHistoryLayer());				
	}
	
	@Override
	public void view(Object... objects) {
		super.view(objects);
		synchronized (lock) {
			done = false;
//			humans.computeAnimation(FRAME_COUNT);
		}
	}
}
