package seu.agent;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.TreeMap;

















import seu.util.BitArrayInputStream;

































import seu.Viewer.SelectedObject;
import seu.Viewer.layers.SEU_RoadLayer;
import seu.agent.at.AmbulanceTeamAgent;
import seu.agent.pf.PoliceForceAgent;
import seu.common.State;
import rescuecore2.log.Logger;
import rescuecore2.messages.Command;
import rescuecore2.misc.Pair;
import rescuecore2.standard.components.StandardAgent;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.standard.messages.AKMove;
import rescuecore2.standard.messages.StandardMessageURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.common.TimeOutException;
import seu.communication.CommunicationManager;
import seu.communication.CommunicationManagerPortsBuilder;
import seu.communication.CommunicationUtil;
import seu.communication.MessageBitSection;
import seu.communication.MessageConstant;
import seu.communication.MessageConstant.MessageReportedType;
import seu.communication.Port;
import seu.geom.Distance;
import seu.message.MessageController;
import seu.message.MessageMemory;
import seu.message.MessagePriority;
import seu.message.MessageTranslator;
import seu.message.QueueMessage;
import seu.message.messageKeeper;
import seu.message.Type.ChannelCondition;
import seu.message.Type.Message;
import seu.message.Type.MessageCount;
import seu.message.Type.MessageType;
import seu.message.newPart.MessageCount1;
import seu.message.newPart.MessageCount2;
import seu.message.newPart.MessageCount3;
import seu.message.newPart.MessageCount4;
import seu.message.newPart.MessageCount5;
import seu.message.newPart.MessageCount6;
import seu.message.newPart.MessageCount7;
import seu.message.newPart.MessageCount8;
import seu.message.newPart.MessageCount9;
import seu.model.AgentConstants;
import seu.model.SEUWorldModel;
import seu.model.SearchedBuildings;
import seu.model.WaterPort;
import seu.model.object.SEUBuriedHumans;
import seu.model.object.SEUBurningBuildings;
import seu.model.object.SEUBurningOutBuildings;
import seu.model.object.SEUCriticalArea;
import seu.model.object.SEUExtinguishedBuilding;
import seu.model.object.SEUManageCluster;
import seu.model.object.SEURoad;
import seu.model.object.SEUSearchedBuildings;
import seu.model.object.SEUWaterPort;
import seu.model.route.pov.CostFunction;
import seu.model.route.pov.POVRouter;


import seu.standard.simplePartition.GroupingType;
import seu.util.BitUtil;

 

 
public abstract class SEUAgent<E extends StandardEntity> extends StandardAgent<E> {
	/*Used to monitor the runing time of code, represent the time before think() do anything.*/
	protected long preTime;  
	/* Used to monitor the runing time of code, represent the time after a specified action.*/
	protected long afterTime;
	@SuppressWarnings({ "rawtypes" })
	//protected List<BasicTask> tasks;
	
	public State  lastState;
	public State currentState;
	public static final double AGENT_RADIUS = 500;	
	protected SEUWorldModel world;
	protected int timeStep;
	public ChangeSet changeSet;
	public Map<Integer, StandardMessageURN> commandHistory = new TreeMap<Integer, StandardMessageURN>();
	public Map<Integer, Pair<Integer, Integer>> locationHistory= new TreeMap<Integer, Pair<Integer, Integer>>();
	protected Map<Integer, EntityID> positionHistory = new TreeMap<Integer, EntityID>();
	protected int timestep;
	protected long thinkTime;	
	protected int distance;
	///////////////////////////////////////////// Communication
	protected CommunicationManager comManager = null;
	protected int[] fireChannel;
	protected int[] ambulanceChannel;
	protected int[] policeChannel;
	protected int voiceChannel;
	
	protected int fireChannelRealSize = 0;
	protected int ambulanceChannelRealSize = 0;
	protected int policeChannelRealSize = 0;
	
	public boolean isLimited=false;
	protected MessageTranslator sayMessageTransfer; 
	public testChannel tChannel;
	public messageKeeper mKeeper;
	protected MessageController messageController;
	protected MessageMemory messageMemory;
	private static final int IGNORE_COMMANDS_AFTER = 2;
	public StandardEntityURN agentType;
	
	protected SEUBurningBuildings seuburningBuildings = null;
	protected SEUExtinguishedBuilding seuextinguishBuildings = null;
	protected SEUBurningOutBuildings seuburningOutBuildings = null;
	protected SEUBuriedHumans seuburiedHumans = null;
	protected SEUManageCluster seuremainCluster = null;
	protected SEUSearchedBuildings seusearchedBuildings = null;
	protected SEUCriticalArea seucriticalArea = null;
	protected SEUWaterPort seuwaterPort = null;
	public Collection<Command> heard;
	
	protected Collection<Pair<Building, Integer>> oldbuildings=new ArrayList<Pair<Building,Integer>>();//??wujie 放在哪？;
	public int aftershocktime=300;
	public int totalTime;
	public POVRouter router;
	protected List<EntityID> path;
	protected Area prevTarget_area = null;
	protected EntityID prevTarget_id;	
	protected boolean followLastPlan = false;
	protected List<EntityID> previousPath = new ArrayList<EntityID>();
	protected List<EntityID> lastMovePlan = new ArrayList<EntityID>();
	protected int tryToReachTargetCount = 0;
	Pair<Integer, Integer> preLocation = null;
	protected double distAverage = 0.0;
	private int distCount = 0;
	////////////////////////////////////////PlatoonAgent
	// private Road road;
		private Point oldPosition;
		private Point lastPosition;
		private Point currentPosition;
		StandardEntity oldLocation = null;
		protected Road fireBuildingEntrance = null;
		protected Road cannotLeaveBuildingEntrance = null;
		protected Set<EntityID> someoneVisitedArea = null;
		protected Set<EntityID> unenteredBuildings = null;
		protected Set<EntityID> unlookupedBuildings = null;
		private  List<Human> visualHumans =new ArrayList<Human>();
		
		protected void initialize() {
		// index all entities in this world model
		model.indexClass(StandardEntityURN.AMBULANCE_TEAM, 
				StandardEntityURN.FIRE_BRIGADE, 
				StandardEntityURN.POLICE_FORCE, 
				StandardEntityURN.BUILDING, 
				StandardEntityURN.AMBULANCE_CENTRE, 
				StandardEntityURN.FIRE_STATION, 
				StandardEntityURN.POLICE_OFFICE, 
				StandardEntityURN.ROAD, 
				StandardEntityURN.REFUGE, 
				StandardEntityURN.BLOCKADE, 
				StandardEntityURN.CIVILIAN,
				StandardEntityURN.GAS_STATION,
				StandardEntityURN.HYDRANT);
		
		world = (SEUWorldModel) model;	
		//////////////////////////////////////////////////
		world.initialize(this, config, getGroupingType());
		
		timestep = world.getConfig().timestep;
		thinkTime = world.getConfig().thinkTime;
		random = new Random(getID().getValue());
		currentState=State.Waiting;
		
		distance = world.getConfig().repairDistance - 500;
		 ////////////////////////////////
		initializeCommunication();
		router = world.getRouter();
		initializeVisualBuings();
		
// communication niu		
		    tChannel = new testChannel(this);
			mKeeper = new messageKeeper(this);
		    messageController= new MessageController(this);
			sayMessageTransfer=new MessageTranslator(this,config);
			messageMemory = new MessageMemory(IGNORE_COMMANDS_AFTER);
	}
	@Override
	protected void postConnect() {
		super.postConnect();
		initialize();
	}
	@Override
	protected StandardWorldModel createWorldModel() {
		return new SEUWorldModel();
	}

	protected void BeforeAct() throws TimeOutException{
		/*
		//niu
		if (timeStep == world.getConfig().ignoreTime) {
			addTeamMembers();
				System.out.println(getID()+"    SEU  初始信道1111111111     "+timeStep);
			sayMessageTransfer.setChannelMap();
			int[] channels = getChannelsToSubscribe();
			sendSubscribe(timeStep, channels);
			return;
		}

   if(timeStep>world.getConfig().ignoreTime){
	 // ? world.update( changeSet); 
	 seuwaterPort.update();
	 seusearchedBuildings.update();
	 BeforeActMoving();
	 if(!world.isNoRadio()){
	 
		 sendMessage();
	   // sendVoiceMessageRepeatly();
	 }
		
	    	
	 if(timeStep>world.getConfig().ignoreTime+1){
			try {
				if(isLimited||world.isNoRadio()){
				comManager.read(heard);
				}
				if(!world.isNoRadio()){
				processHearing(heard);
				}
				
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	 seuburiedHumans.update();
 	 
		
		someoneVisitedArea = getSearchedBuildings();
		}
	 */
	 
		world.update((Human) me(), changeSet); 
		BeforeActCommunication();
		BeforeActMoving();
		someoneVisitedArea = world.getSearchedBuildings();
	}
		protected void act() throws ActionCommandException, TimeOutException{
		
	}
	
	 protected void AfterAct() {
		/*
		 if(isLimited||world.isNoRadio()){
				sendMessagesForNoRadio();
			}
        if(!world.isNoRadio()){
			 sendMessagesFromQueue();
			}
		 getBuriedHumans().fromCommunication.clear();
		 getBuriedHumans().fromVoiceOfCivilian.clear();
		 */
		 AfterActCommunication();
		 
	 }	 

	protected void hear(Collection<Command> heard){
	 processHearing(heard);
	}

	
	@Override
	protected void think(int time, ChangeSet changed, Collection<Command> heard) { 
		if (AgentConstants.LAUNCH_VIEWER) {
			SelectedObject.renderBuildingValueKey = false;
			
			if (world.getAgent().getID().getValue() == 485278126) {
				SEU_RoadLayer.selfL = null;
				SEU_RoadLayer.road = null;
				SEU_RoadLayer.dir = null;
				
				SEU_RoadLayer.repairDistance = world.getConfig().repairDistance;
			}
			
			SEU_RoadLayer.openParts.clear();
		}
		
		world.setThinkStartTime(System.currentTimeMillis());
		this.timeStep = time;
		world.setTime(time);
		this.changeSet = changed;

		try {
			hear(heard);
		} catch (Exception e) {
			e.printStackTrace(System.out);
		}

		try {
			try {
				BeforeAct();
			} catch (Exception e) {
				e.printStackTrace(System.out);
			}

			if (world.getConfig().ignoreTime <= time) {
				act();
				isThinkTimeOver("after act");
				sendRest();
			}
		} catch (ActionCommandException ace) {
			commandHistory.put(time, ace.message);
		} catch (TimeOutException toe) {
			System.out.println("Time Out Exception message is: " + toe.getMessage());
			commandHistory.put(time, StandardMessageURN.AK_REST);
			world.setExceptionMessage(toe.getMessage());
		} catch (Exception e) {
			commandHistory.put(time, StandardMessageURN.AK_REST);
			e.printStackTrace(System.out);
			System.err.println("Exception : time = " + time + " id = " + me().getID() + " ----- think()");
		}

		try {
			AfterAct();
		} catch (Exception e) {
			e.printStackTrace(System.out);
		}
	}
	
	public boolean isThinkTimeOver(String str) throws TimeOutException {
		long thinkTimeThreshold;
		if (AgentConstants.IS_DEBUG) {
			thinkTimeThreshold = (long)1000000000;
		} else {
			thinkTimeThreshold = (long)(thinkTime * 0.9);
		}
		if (System.currentTimeMillis() - world.getThinkStartTime() > thinkTimeThreshold)
			throw new TimeOutException(str);
		return false;
	}
	
	public Human getMeAsHuman() {
		Human me = null;
        StandardEntity entity = world.getEntity(me().getID());
        if (entity instanceof Human)
        	me = (Human) entity;
        return me;
    }

	
	public void sendRest() throws ActionCommandException {
		sendRest(timeStep);
		throw new ActionCommandException(StandardMessageURN.AK_REST);
	}
	
	public StandardMessageURN getCommandHistory(int time) {
		return commandHistory.get(time);
	}
	
	protected int getUniform() {
		return world.getUniform().toUniform(getID());
	}

	public boolean isVisible(StandardEntity entity) {
		return isVisible(entity.getID());
	}
	
	public boolean isVisible(EntityID id){
		return changeSet.getChangedEntities().contains(id);
	}
	
	
	public Set<EntityID> getVisibleEntities() {
		if (changeSet != null)
			return changeSet.getChangedEntities();
		return null;
	}
	
	public SEUWorldModel getModel() {
		return world;
	}

	public GroupingType getGroupingType() {
		if(me()==null){
			System.out.println("me()==null");
		}
		return GroupingType.getGroupingType(me().getStandardURN());
	}
	
	public Random getRandom() {
		return random;
	}
	
	public Set<EntityID> getChanged() {
		return this.changeSet.getChangedEntities();
	}
	

	public boolean isStucked(Human human) {
		Blockade blockade = isLocateInBlockade(human);
		if (blockade == null)
			return false;
		double minDistance = Distance.getDistanceToBlock(blockade, human.getX(), human.getY());
		
		if (minDistance > 500){
			return true;
		}
		
		if (location() instanceof Building) {
			Building loc = (Building) location();
			
			Set<Road> entrances = world.getEntrance().getEntrance(loc);
			int size = entrances.size();
			int count = 0;
			for (Road next : world.getEntrance().getEntrance(loc)) {
				SEURoad road = world.getSeuRoad(next.getID());
				if (road.isNeedlessToClear())
					continue;
				count++;
			}
			
			if (count == size)
				return true;
		}
		
		return false;
	}
	public Blockade isLocateInBlockade(Human human) {
		int x = human.getX();
		int y = human.getY();
		for (EntityID entityID : changeSet.getChangedEntities()){
			StandardEntity se = world.getEntity(entityID);
			if (se instanceof Blockade){
				Blockade blockade = (Blockade) se;
				Shape s = blockade.getShape();
				if (s != null && s.contains(x, y)) {
					return blockade;
				}
			}
		}
		return null;
	}
	
	public boolean isBlocked() {
		if (timeStep < world.getConfig().ignoreTime + 3)
			return false;
		
		if (commandHistory.get(timeStep - 1).equals(StandardMessageURN.AK_MOVE) &&
				commandHistory.get(timeStep - 2).equals(StandardMessageURN.AK_MOVE)) {
			
			Pair<Integer, Integer> location_1 = locationHistory.get(timeStep - 2);
			Pair<Integer, Integer> location_2 = locationHistory.get(timeStep - 1);
			Pair<Integer, Integer> location_3 = locationHistory.get(timeStep);
			
			if (location_1 == null || location_2 == null || location_3 == null)
				return false;
			
			double distance_1 = Distance.getDistance(location_1, location_2);
			double distance_2 = Distance.getDistance(location_2, location_3);
			
			if (distance_1 < 8000 && distance_2 < 8000) {
				return true;
			}
		}
		
		return false;
	}
	
	@SuppressWarnings("serial")
	public static class ActionCommandException extends Exception {
		private StandardMessageURN message;

		public ActionCommandException(StandardMessageURN message) {
			super();
			this.message = message;
		}
	}
	public void initializeCommunication(){
		CommunicationManagerPortsBuilder builder = new CommunicationManagerPortsBuilder(me(), world);
		CommunicationUtil comUtil = builder.getCommunicationUtil();
		world.setNoRadio(comUtil.isNoRadio());
		if (comUtil.isNoRadio()) {
			// decideNoComAgents();
			final Port ownInfoPort = createNoComPort(comUtil);
			builder.addVoiceEventListener(ownInfoPort);

			final Port burningBuildingsNoCommuPort = world.getBurningBuildings().createNoComPort(comUtil, comUtil.NO_RADIO_TIME_TO_LIVE);
			builder.addVoiceEventListener(burningBuildingsNoCommuPort);
			
			final Port burningBuildingVeryLimitPort = world.getBurningBuildings().createVeryLimitComPort(comUtil, comUtil.VERY_LIMIT_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(burningBuildingVeryLimitPort);
			
			final Port extinguishedBuildingsPort = world.getExtinguishedBuildings().createAddPortNoRadio(comUtil, comUtil.NO_RADIO_TIME_TO_LIVE * 2);
			builder.addRadioEventListener(extinguishedBuildingsPort);
			builder.addVoiceEventListener(extinguishedBuildingsPort);
			
			
			final Port collapsedBuildingsPort = world.getCollapsedBuildings().createAddPortNoRadio(comUtil, comUtil.NO_RADIO_TIME_TO_LIVE, 10);
			// builder.addRadioEventListener(collapsedBuildingsPort);
			builder.addVoiceEventListener(collapsedBuildingsPort);
			
			final Port buriedHumanInfosPort = world.getBuriedHumans().createBHIPortForNoRadio(comUtil);
			builder.addVoiceEventListener(buriedHumanInfosPort);
			
			final Port buriedHumanAddPort = world.getBuriedHumans().createAddPortForNoRadio(comUtil, comUtil.NO_RADIO_TIME_TO_LIVE);
			builder.addVoiceEventListener(buriedHumanAddPort);
			
			final Port buriedHumanRemovePort = world.getBuriedHumans().createRemovePortForNoRadio(comUtil);
			builder.addVoiceEventListener(buriedHumanRemovePort);
			
			final Port buriedHumanRescuedPort = world.getBuriedHumans().createRescuedPortForNorRadio(comUtil);
			builder.addVoiceEventListener(buriedHumanRescuedPort);
			
			final Port buriedHumanRescuingPort = world.getBuriedHumans().createRescuingPortForNorRadio(comUtil);
			builder.addVoiceEventListener(buriedHumanRescuingPort);
			
			final Port removeClusterPort = world.getRemainCluster().createRemovePortForNoRadio(comUtil);
			builder.addVoiceEventListener(removeClusterPort);
			
			final Port waterPort = world.getWaterPort().createWaterPort(comUtil, comUtil.NO_RADIO_TIME_TO_LIVE * 2);
			builder.addRadioEventListener(waterPort);
			builder.addVoiceEventListener(waterPort);
			
		} else {

			final Port ownInfoPort = createPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(ownInfoPort);
			
			final Port criticalAreaPort = world.getCriticalArea().createPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(criticalAreaPort);
			
			final Port burningBuildingsAddPort = world.getBurningBuildings().createAddPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(burningBuildingsAddPort);
			builder.addVoiceEventListener(burningBuildingsAddPort);
			
			final Port extinguishedBuildingAddPort = world.getExtinguishedBuildings().createAddPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(extinguishedBuildingAddPort);
			builder.addVoiceEventListener(extinguishedBuildingAddPort);

			// NeedRescueHuman
			final Port buriedHumanAddPort = world.getBuriedHumans().createAddPort(comUtil);
			builder.addRadioEventListener(buriedHumanAddPort);
			builder.addVoiceEventListener(buriedHumanAddPort);

			final Port buriedHumanRemovePort = world.getBuriedHumans().createRemovePort(comUtil);
			builder.addRadioEventListener(buriedHumanRemovePort);
			builder.addVoiceEventListener(buriedHumanRemovePort);
			
			final Port buriedHumanRescuedPort = world.getBuriedHumans().createRescuedPort(comUtil);
			builder.addRadioEventListener(buriedHumanRescuedPort);
			builder.addVoiceEventListener(buriedHumanRescuedPort);
			
			final Port buriedHumanRescuingPort = world.getBuriedHumans().createRescuingPortForNorRadio(comUtil);
			builder.addVoiceEventListener(buriedHumanRescuingPort);
			
			final Port removeClusterPort = world.getRemainCluster().createRemovePort(comUtil);
			builder.addRadioEventListener(removeClusterPort);

			final Port waterPort = world.getWaterPort().createWaterPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE);
			builder.addRadioEventListener(waterPort);
			
			final Port collapsedBuildingPort = world.getCollapsedBuildings().createAddPort(comUtil, comUtil.NORMAL_RADIO_TIME_TO_LIVE, 10);
			builder.addVoiceEventListener(collapsedBuildingPort);
		}

		builder.addCivilianVoiceListener(world.createNewCivilianListener());
		builder.addCivilianVoiceListener(world.getBuriedHumans().createCivilianVoiceListener());
		
		comManager = new CommunicationManager(builder);
		voiceChannel = comManager.getVoiceChannel();
		fireChannel = comManager.getFireChannel();
		policeChannel = comManager.getPoliceChannel();
		ambulanceChannel = comManager.getAmbulanceChannel();
		
		fireChannelRealSize = channelRealSize(fireChannel);
		ambulanceChannelRealSize = channelRealSize(ambulanceChannel);
		policeChannelRealSize = channelRealSize(policeChannel);
	}
	public void initializeVisualBuings(){
		Collection<StandardEntity> initedBuildings = world.getEntitiesOfType(StandardEntityURN.BUILDING);
		unlookupedBuildings = new HashSet<EntityID>(initedBuildings.size());
		for (StandardEntity se : initedBuildings) {
			unlookupedBuildings.add(se.getID());
		}
		StandardEntityURN[] initedURN;
		if (this instanceof AmbulanceTeamAgent) {
			initedURN = new StandardEntityURN[] {
					StandardEntityURN.BUILDING,
					StandardEntityURN.AMBULANCE_CENTRE,
					StandardEntityURN.FIRE_STATION,
					StandardEntityURN.POLICE_OFFICE,	
					StandardEntityURN.GAS_STATION
			};
		} else {
			initedURN = new StandardEntityURN[] {
					StandardEntityURN.BUILDING,
			};
		}
		Collection<StandardEntity> initedBuildings1 = world.getEntitiesOfType(initedURN);
		unenteredBuildings = new HashSet<EntityID>(initedBuildings1.size());
		for (StandardEntity se : initedBuildings1) {
			unenteredBuildings.add(se.getID());
		}
		
	}
	private int channelRealSize(int[] channels) {
		int count = 0;
		for (int i = 0; i < channels.length; i++) {
			if (channels[i] != 0)
				count++;
		}
		return count;
	}
	protected Port createNoComPort(final CommunicationUtil comUtil) {
		
		return new Port() {
			private List<MessageBitSection> packetList = new ArrayList<MessageBitSection>();
			private int counter = 0;
			private String readString = "";

			@Override
			public boolean hasNext() {
				if (counter < packetList.size())
					return true;
				else
					return false;
			}

			@Override
			public void init(ChangeSet changed) {
				MessageBitSection newPacket = createNewPacket();
				if (newPacket != null)
					packetList.add(newPacket);
				for (Iterator<MessageBitSection> it = packetList.iterator(); it.hasNext();)
					if (it.next().getTimeToLive() <= 0)
						it.remove();
			}
			
			private MessageBitSection createNewPacket() {
				if (!(me() instanceof Human))
					return null;
				MessageBitSection sec = new MessageBitSection(15);
				sec.setTimeToLive(1);
				comUtil.writeArea(sec, (Area) location(), world.getUniform());
				if (isStucked((Human)me()) || isBlocked()) {
					sec.add(1, 1);			// 1 means the agent is stucked
				} else {
					sec.add(0, 1);			// 0 means the agent is not stucked
				}
				return sec;
			}

			@Override
			public MessageBitSection next() {
				MessageBitSection next = packetList.get(counter);
				// TODO in other port, you should not decrement TTL of packet here. but in this 
				// port you must do this to avoid repeating to send same messages
				next.decrementTTL();
				counter++;
				return next;
			}

			@Override
			public void read(final EntityID senderID, final int time, final BitArrayInputStream stream) {
				final StandardEntity sender = world.getEntity(senderID);
				readString = "sender: " + sender + ", sendTime = " + time;
				final EntityID areaID = comUtil.readArea(stream, world.getUniform());
				readString = ", areaId: " + areaID;
				final int stuckMarker = stream.readBit(1);
				if (stuckMarker == 1) {
					world.getStuckedAgents().add(senderID);
					readString = readString + ", isStucked = true";
				} else {
					world.getStuckedAgents().remove(senderID);
					readString = readString + ", isStucked = false";
				}
				 
				if (areaID == null)
					return;
				final Area area = (Area) world.getEntity(areaID);
				if (sender == null || area == null)
					return;
				if (world.getTimestamp().getLastChangedTime(senderID) < time) {
					if (sender instanceof Human && senderID.getValue() != getID().getValue()) {
						Human sendHuman = (Human) sender;
						sendHuman.setPosition(area.getID(), area.getX(), area.getY());
					}
				}
			}
			
			@Override
			public MessageReportedType getMessageReportedType() {
				return MessageReportedType.REPORTRD_TO_ALL;
			}
			
			@Override
			public void printWrite(MessageBitSection packet, int channel) {
			 
			}
			
			@Override
			public void printRead(int channel) {
			 
			}
			
			@Override
			public void resetCounter() {
				counter = 0;
			}
		};
	}

	
	protected Port createPort(final CommunicationUtil comUtil, final int timeToLive) {
		final int tankCapacity = world.getConfig().maxTankCapacity;
		final int waterPower = world.getConfig().maxPower;
		final int FB_TANK_BIT_SIZE = BitUtil.needBitSize(tankCapacity / waterPower);
		
		return new Port() {
			private List<MessageBitSection> packetList = new ArrayList<MessageBitSection>();
			private int counter = 0;
			private String readString = "";

			@Override
			public boolean hasNext() {
				if (counter < packetList.size())
					return true;
				else
					return false;
			}

			@Override
			public void init(ChangeSet changed) {
				MessageBitSection newPacket = createNewPacket();
				if (newPacket != null)
					packetList.add(newPacket);
				for (Iterator<MessageBitSection> it = packetList.iterator(); it.hasNext();)
					if (it.next().getTimeToLive() <= 0)
						it.remove();
			}

			private MessageBitSection createNewPacket() {
				if (!(me() instanceof Human))
					return null;
				MessageBitSection sec;
				if (comUtil.isNoRadio()) {
					sec = new MessageBitSection(5);
				} else {
					sec = new MessageBitSection(1);
				}
				
				sec.setTimeToLive(timeToLive);
				comUtil.writeArea(sec, (Area)location(), world.getUniform());
				if (isStucked((Human)me()) || isBlocked()) {
					sec.add(1, 1);			// 1 means the agent is stucked
				} else {
					sec.add(0, 1);			// 0 means the agent is not stucked
				}
				
				if (me() instanceof FireBrigade) {
					sec.add(((FireBrigade) me()).getWater() / waterPower, FB_TANK_BIT_SIZE);
				}
				return sec;
			}
			
			@Override
			public MessageBitSection next() {
				MessageBitSection next = packetList.get(counter);
				// TODO in other port, you should not decrement TTL of packet here. but in this 
				// port you must do this to avoid repeating to send same messages
				next.decrementTTL();
				counter++;
				return next;
			}

			@Override
			public void read(final EntityID senderID, final int time, final BitArrayInputStream stream) {
				final StandardEntity sender = world.getEntity(senderID);
				readString = "sender: " + sender + ", sendTime = " + time;
				if (sender == null) {
					return;
				}
					
				final EntityID areaID = comUtil.readArea(stream, world.getUniform());
				readString = readString + ", areaId: " + areaID;
				final int stuckMarker = stream.readBit(1);
				if (stuckMarker == 1) {
					world.getStuckedAgents().add(senderID);
					readString = readString + ", isStuck = true";
				} else {
					world.getStuckedAgents().remove(senderID);
					readString = readString + ", isStuck = false";
				}
				
				int tank = 0;
				FireBrigade senderFB = null;
				if (sender instanceof FireBrigade) {
					senderFB = (FireBrigade) sender;
					tank = stream.readBit(FB_TANK_BIT_SIZE);
					readString = readString + ", water = " + tank  + " * " + waterPower;
					readString = readString + " = " + tank * waterPower;
				}
				
				Area area = null;
				if (areaID != null) {
					area = (Area) world.getEntity(areaID);
				}
				
				if (world.getTimestamp().getLastChangedTime(senderID) < time) {
					if (sender instanceof FireBrigade) {
						if (senderFB != null && tank <= tankCapacity)
							senderFB.setWater(tank * world.getConfig().maxPower);
					}
					
					if (sender instanceof Human) {
						Human sendHuman = (Human) sender;
						if (area != null)
							sendHuman.setPosition(area.getID(), area.getX(), area.getY());
					}
				}
			}
			
			@Override
			public MessageReportedType getMessageReportedType() {
				return MessageReportedType.REPORTRD_TO_ALL;
			}
			
			@Override
			public void printWrite(MessageBitSection packet, int channel) {
				 
			}
			
			@Override
			public void printRead(int channel) {
			 
			}
			
			@Override
			public void resetCounter() {
				counter = 0;
			}
		};
	}
	
	 
	protected void processHearing(Collection<Command> heard) {
		comManager.read(heard);
	}
	 
	protected void  BeforeActCommunication() throws TimeOutException{
		 
		if (timeStep == world.getConfig().ignoreTime) {
			sendSubscribe(timeStep, comManager.getSubscribeChannels());
		}
		if (timeStep >= world.getConfig().ignoreTime) {
			comManager.update();// no method to update yet.     niu
		}
	}
	protected void BeforeActMoving()throws TimeOutException{
		EntityID position = ((Human) me()).getPosition();
		this.router.update(position, getVisibleEntities());
		this.positionHistory.put(new Integer(timeStep), position);
		this.locationHistory.put(timeStep, world.getSelfLocation());
		updateMoveAverage();
		
	}
	
	protected void AfterActCommunication() {
		
		if (world.getConfig().radioChannels.size() != 0) {
			
			byte[] messageForAll = null, messageForAT_PF = null;
			byte[] messageForAT = null, messageForPF = null, messageForFB = null;
			
			if (fireChannel[0] == policeChannel[0] && fireChannel[0] == ambulanceChannel[0]) {
				messageForAll = comManager.createRadioMessage(fireChannel[0], changeSet);
				sendSpeak(timeStep, fireChannel[0], messageForAll);
				
			} else if (fireChannel[0] != policeChannel[0] && policeChannel[0] == ambulanceChannel[0]) {
				messageForFB = comManager.
						createRadioMessage(fireChannel[0], changeSet, MessageConstant.MESSAGE_FOR_FB);
				messageForAT_PF = comManager.
						createRadioMessage(ambulanceChannel[0], changeSet, MessageConstant.MESSAGE_FOR_AT_PF);
				
				sendSpeak(timeStep, fireChannel[0], messageForFB);
				sendSpeak(timeStep, ambulanceChannel[0], messageForAT_PF);
				
			} else if (fireChannel[0] != policeChannel[0] && policeChannel[0] != ambulanceChannel[0]){
				int canSubscribeSize = world.getConfig().subscribePlatoonSize;
				int canUse = Math.min(4, canSubscribeSize);
				
				comManager.initRadioMessage(changeSet, MessageConstant.MESSAGE_FOR_FB);
				int fbCanUse = Math.min(canUse, fireChannelRealSize);
				for (int i = 0; i < fbCanUse; i++) {
					if (world.getUniform().toUniform(me().getID()) % fbCanUse == i) {
						messageForFB = comManager.createRadioMessage(fireChannel[i]);
						sendSpeak(timeStep, fireChannel[i], messageForFB);
					}
				}
				
				comManager.initRadioMessage(changeSet, MessageConstant.MESSAGE_FOR_PF);
				int pfCanUse = Math.min(canUse, policeChannelRealSize);
				for (int i = 0; i < pfCanUse; i++) {
					if (world.getUniform().toUniform(me().getID()) % pfCanUse == i) {
						messageForPF = comManager.createRadioMessage(policeChannel[i]);
						sendSpeak(timeStep, policeChannel[i], messageForPF);
					}
				}
				
				comManager.initRadioMessage(changeSet, MessageConstant.MESSAGE_FOR_AT);
				int atCanUse = Math.min(canUse, ambulanceChannelRealSize);
				for (int i = 0; i < atCanUse; i++) {
					if (world.getUniform().toUniform(me().getID()) % atCanUse == i) {
						messageForAT = comManager.createRadioMessage(ambulanceChannel[i]);
						sendSpeak(timeStep, ambulanceChannel[i], messageForAT);
					}
				}
				
			}
		}	
		
		if (me() instanceof Human) {
			sendSpeak(timeStep, voiceChannel, comManager.createVoiceMessage(voiceChannel, changeSet));
		}
		
		for (Port next : comManager.getRadioEventListers()) {
			next.resetCounter();
			for (; next.hasNext(); ) {
				MessageBitSection sec = next.next();
				if (sec != null)
					sec.decrementTTL();
			}
			next.resetCounter();
		}

		for (Port next : comManager.getVoiceEventListeners()) {
			next.resetCounter();
			for (; next.hasNext(); ) {
				MessageBitSection sec = next.next();
				if (sec != null)
					sec.decrementTTL();
			}
			next.resetCounter();
		}
	}
	
	public void doNothing() {
		
	}
	
	private void updateMoveAverage() {
		// get the current position of me
		final Pair<Integer, Integer> location = me().getLocation(world);
		// If command send in last circle is AK_MOVE
		if (getCommandHistory(world.getTime() - 1) == StandardMessageURN.AK_MOVE) {
			if (preLocation != null) {
				// the distance of current location and pre-location
				final double dist = Math.hypot(
						location.first() - preLocation.first(), location.second() - preLocation.second());
				distCount++;
				if (distAverage == 0.0) {
					distAverage = dist;
				} else {
					// the arithmetic mean value
					double t = (double) (distCount - 1) / distCount;
					distAverage = distAverage * t + dist / distCount;
				}
			}
		}
		preLocation = location;
	}
	

	@Override
	public Area location() {
		
		StandardEntity location = super.location();
		
		if (location instanceof Area)
			return (Area) location;
		
		return null;
	}

	public double getDistAverage() {
		return Math.max(10000.0, distAverage);
	}

	public POVRouter getRouter() {
		return router;
	}
	
	
	
	public boolean newMove(Area target, CostFunction costFunc) throws ActionCommandException {
		if (target == null)
			return false;
		
		if (world.getSelfPosition().getID().equals(target.getID()))
			return false;
		
		List<EntityID> areaPath = getPath((Area)world.getSelfPosition(), target, costFunc);
		
		if (!target.getID().equals(this.prevTarget_id)) {
			this.prevTarget_id = target.getID();
			this.tryToReachTargetCount = 0;
		}
		
		moveOnPlan(areaPath);
		
		return false;
	}
	
	public boolean newMove(Collection<? extends StandardEntity> targets,
			CostFunction costFunc, boolean force) throws ActionCommandException {
		
		moveOnPlan(getPath(targets, costFunc, me() instanceof PoliceForce));
		return false;
	}
	
	public List<EntityID> getPath(Area sourArea, Area destArea, CostFunction costFunc) {
		
		List<EntityID> finalPath = new ArrayList<EntityID>();
		
		if (sourArea == null || destArea == null)
			return finalPath;
		
		if (destArea.getID().equals(this.prevTarget_id)) {
			this.prevTarget_id = destArea.getID();
			this.tryToReachTargetCount = 0;
		}
		
		if (sourArea.equals(destArea)) {
			Logger.warn("Already in target! ----- Time: " + world.getTime());
			return finalPath;
		}
		
		boolean shouldReplan;
		if (prevTarget_area != null && prevTarget_area.equals(destArea) && followLastPlan) {
			this.followLastPlan = false;
			shouldReplan = false;
		} else {
			this.followLastPlan = true;
			shouldReplan = true;
		}
		
		if (shouldReplan) {
			this.previousPath.clear();
			
			finalPath = router.getAStar(sourArea, destArea, costFunc, new Point(((Human) me()).getX(), ((Human)me()).getY()));
			this.prevTarget_area = destArea;
			this.previousPath = finalPath;
		} else {
			List<EntityID> temp = new ArrayList<EntityID>();
			
			for (EntityID next : previousPath) {
				if (!sourArea.getID().equals(next)) {
					temp.add(next);
				} else {
					break;
				}
			}
			
			this.previousPath.removeAll(temp);
			finalPath = this.previousPath;
		}
		
		if (!finalPath.isEmpty() && !(this instanceof PoliceForceAgent)) {
			// if the target is blocked by blockades, just return a empty path
		}
		
		return finalPath;
	}
	
	public List<EntityID> getPath(Collection<? extends StandardEntity> targets, CostFunction costFunc, boolean force) {
		List<EntityID> areaPath = new ArrayList<EntityID> ();
		Area positionArea = (Area) world.getSelfPosition();
		
		if (targets.isEmpty()) 
			return areaPath;
		
		boolean shouldReplan;
		if (this.prevTarget_area != null && targets.contains(this.prevTarget_area) && followLastPlan) {
			this.followLastPlan = false;
			shouldReplan = false;
		} else {
			this.followLastPlan = true;
			shouldReplan = true;
		}
		
		if (shouldReplan) {
			this.previousPath = router.getMultiAStar(positionArea, targets,
					force ? router.getPfCostFunction() : router.getNormalCostFunction(), 
							new Point(((Human)me()).getX(),((Human)me()).getY()));
		} else {
			List<EntityID> temp = new ArrayList<EntityID>();

			for (EntityID next : previousPath) {
				if (!positionArea.getID().equals(next)) {
					temp.add(next);
				} else {
					break;
				}
			}

			this.previousPath.removeAll(temp);
		}
		
		areaPath = this.previousPath;
		return areaPath;
	}
	
	public void moveOnPlan(List<EntityID> path) throws ActionCommandException {
		if (path == null)
			return;

		this.lastMovePlan.clear();
		this.lastMovePlan.addAll(path);
		

		sendMove(world.getTime(), path);
		throw new ActionCommandException(StandardMessageURN.AK_MOVE);
	}
	
	public void moveToPoint(EntityID area, int destX, int destY) throws ActionCommandException{
		if (location().getID().equals(area)) {
			List<EntityID> list = new ArrayList<EntityID>();
			list.add(area);
			sendMove(world.getTime(), list, destX, destY);
			throw new ActionCommandException(StandardMessageURN.AK_MOVE);
		} else {
			sendMove(world.getEntity(area, Area.class), router.getNormalCostFunction());
			throw new ActionCommandException(StandardMessageURN.AK_MOVE);
		}
	}
	

	public void moveFront(StandardEntity destination, CostFunction costFunc) throws ActionCommandException {
		if (destination instanceof Human) {
			Human human = (Human) destination;
			StandardEntity position = human.getPosition(world);
			if (position instanceof Area) {
				moveFront(router.getAStar((Human) me(), (Area) position, costFunc),
						destination.getLocation(world));
			} else {
				if (position == null) {
					System.err.println("Move error\ttime=" + timeStep + " id="
							+ me().getID() + " my position is null");
				} else {
					// this human was load by an AT
					System.err.println("Move error\ttime=" + timeStep + " id="
							+ me().getID() + " move from " + position);
				}
				return;
			}
		} else if (destination instanceof Blockade) {
			Blockade block = (Blockade) destination;
			EntityID position = block.getPosition();
			moveFront(router.getAStar((Human) me(), (Area) world.getEntity(position), costFunc), 
					destination.getLocation(world));
		}
		
		moveFront(router.getAStar((Human) me(), (Area) destination, costFunc), destination.getLocation(world));
	}

	
	private void moveFront(List<EntityID> path, Pair<Integer, Integer> location) 
			throws ActionCommandException {
		if (location == null) {
			moveFront(path, -1, -1);
		} else {
			moveFront(path, location.first(), location.second());
		}
	}
	
	
	public void moveFront(List<EntityID> path) throws ActionCommandException {
		moveFront(path, -1, -1);
	}
	
	
	public void moveFront(List<EntityID> path, int x, int y) throws ActionCommandException {
		int last = path.size() - 1;
		if (world.getEntity(path.get(last)) instanceof Building) {
			path.remove(last);
			last = path.size() - 1;
		}

		send(new AKMove(getID(), timeStep, path, x, y));
		throw new ActionCommandException(StandardMessageURN.AK_MOVE);
	}
	
	
	public void moveFront(Collection<? extends StandardEntity> destinations) throws ActionCommandException {
		moveFront(destinations, router.getStrictCostFunction());
	}

	
	public void moveFront(Collection<? extends StandardEntity> destinations,
			CostFunction costFunc) throws ActionCommandException {
		moveFront(router.getMultiDest(location(), destinations, costFunc, new Point(((Human)me()).getX(),((Human)me()).getY())));
	}
	
	
	public void move(EntityID destination) throws ActionCommandException {
		move(world.getEntity(destination));
	}
	
	public void move(StandardEntity destination) throws ActionCommandException {
		sendMove(destination, router.getNormalCostFunction());
	}

	
	public void sendMove(EntityID destination, CostFunction costFunc) throws ActionCommandException {
		sendMove(world.getEntity(destination), costFunc);
	}

	public void sendMove(StandardEntity destination, CostFunction costFunc) throws ActionCommandException {
		if (destination instanceof Human) {
			Human human = (Human) destination;
			StandardEntity position = human.getPosition(world);
			if (position instanceof Area) {
				sendMove(router.getAStar((Human)me(), (Area) position, costFunc), destination.getLocation(world));
			} else {
				if (position == null) {
					System.err.println("Move error\ttime=" + timeStep + " id="
							+ me().getID() + " my position is null");
				} else {
					System.err.println("Move error\ttime=" + timeStep + " id="
							+ me().getID() + " move from " + position);
				}
				return;
			}
		} else if (destination instanceof Blockade) {
			Blockade block = (Blockade) destination;
			EntityID position = block.getPosition();
			sendMove(router.getAStar((Human)me(), (Area) world.getEntity(position), 
					costFunc), destination.getLocation(world));
		}
		sendMove(router.getAStar((Human)me(), (Area) destination, costFunc),
				destination.getLocation(world));
	}
	
	public void sendMove(List<EntityID> path, Pair<Integer, Integer> location) throws ActionCommandException {
		if (location == null) {
			sendMove(path, -1, -1);
		} else {
			sendMove(path, location.first(), location.second());
		}
	}

	public void sendMove(Area destination, int x, int y) throws ActionCommandException {
		sendMove(router.getAStar((Human)me(), destination, router.getNormalCostFunction()), x, y);
	}

	public void sendMove(List<EntityID> path) throws ActionCommandException {
		StandardEntity entity = world.getEntity(path.get(path.size() - 1));
		Pair<Integer, Integer> e_location = entity.getLocation(world);
		if (e_location == null) {
			sendMove(path, -1, -1);
		} else {
			sendMove(path, e_location.first().intValue(), e_location.second().intValue());
		}
	}

	public void sendMove(List<EntityID> path, int x, int y) throws ActionCommandException {
		send(new AKMove(getID(), timeStep, path, x, y));
		throw new ActionCommandException(StandardMessageURN.AK_MOVE);
	}

	
	public void move(Collection<? extends StandardEntity> destinations) throws ActionCommandException {
		move(destinations, router.getNormalCostFunction());
	}
	
	public void move(Collection<? extends StandardEntity> destinations,
			CostFunction costFunc) throws ActionCommandException {
		sendMove(router.getMultiDest(location(), destinations, costFunc, new Point(((Human)me()).getX(), ((Human)me()).getY())));
	}


	public void moveReachable(Collection<? extends StandardEntity> destinations, boolean front)
			throws ActionCommandException {
		moveReachable(destinations, router.getNormalCostFunction(), front);
	}


	public void moveReachable(Collection<? extends StandardEntity> destinations,
			CostFunction costFunc, boolean front) throws ActionCommandException {
		for (Iterator<? extends StandardEntity> it = destinations.iterator(); it.hasNext();) {
			if (!router.isSureReachable((Area) it.next())) {
				it.remove();
			}
		}
		if (destinations.isEmpty())
			return;
		moveReachable(router.getMultiDest(location(), 
				destinations, costFunc, new Point(((Human)me()).getX(), ((Human)me()).getY())), front);
	}

	
	public void moveReachable(List<EntityID> path, boolean front) throws ActionCommandException {
		moveReachable(path, -1, -1, front);
	}


	public void moveReachable(List<EntityID> path, int x, int y, boolean front)
			throws ActionCommandException {
		if (front && world.getEntity(path.get(path.size() - 1)) instanceof Building) {
			path.remove(path.size() - 1);
		}
		send(new AKMove(getID(), timeStep, path, x, y));
		throw new ActionCommandException(StandardMessageURN.AK_MOVE);
	}

	protected abstract void cantMove() throws ActionCommandException, TimeOutException;

	public void lookupSearchBuildings() throws ActionCommandException {
//		setAgentState(AgentState.SEARCH);
		if (unlookupedBuildings.isEmpty()) {
			Collection<StandardEntity> initedBuildings = world.getEntitiesOfType(StandardEntityURN.BUILDING);
			unlookupedBuildings = new HashSet<EntityID>(initedBuildings.size());
			for (StandardEntity se : initedBuildings) {
				unlookupedBuildings.add(se.getID());
			}   // think all building in world are unlookuped
		}
		/* Remove all Buildings that someone has visited.*/
		unlookupedBuildings.removeAll(someoneVisitedArea);
		unlookupedBuildings.removeAll(changeSet.getChangedEntities());
		
		/* Remove all Buildings that is on fire or burnt out.*/
		for (Iterator<EntityID> it = unlookupedBuildings.iterator(); it.hasNext();) {
			EntityID id = it.next();
			StandardEntity se = world.getEntity(id);
			if (se instanceof Building) {
				Building building = (Building) se;
				if ((building.isFierynessDefined() && building.getFierynessEnum() == Fieryness.BURNT_OUT)
						|| building.isOnFire()) {
					it.remove();
				}
			}
		}
		
		// if a entrance is blocked, then unsearch all buildings related to this entrance
		for (EntityID next : getChanged()) {
			StandardEntity entity = world.getEntity(next);
			if (!(entity instanceof Road))
				continue;
			SEURoad road = world.getSeuRoad(next);
			
			if (road.isEntrance()) {
				for (Building build : world.getEntrance().getBuilding(road.getSelfRoad())) {
					unlookupedBuildings.remove(build.getID());
				}
			}
		}
		
		/* If the unlookupedBuildings is not empty, then I need go to one of them and do something.*/
		if (!unlookupedBuildings.isEmpty()) {
			Set<StandardEntity> dest = new HashSet<StandardEntity>(unlookupedBuildings.size());
			for (EntityID id : unlookupedBuildings) {
				dest.add(world.getEntity(id));
			}
			if (me() instanceof PoliceForce) {
				moveFront(dest, router.getPfCostFunction());
			}

			
			moveFront(dest);
		}
	}
	
	public void enterSearchBuildings() throws ActionCommandException {
		
		if (unenteredBuildings.isEmpty()) {
			StandardEntityURN[] initedURN;
			if (this instanceof AmbulanceTeamAgent) {
				initedURN = new StandardEntityURN[] {
						StandardEntityURN.BUILDING,
						StandardEntityURN.AMBULANCE_CENTRE,
						StandardEntityURN.FIRE_STATION,
						StandardEntityURN.POLICE_OFFICE,	
						StandardEntityURN.GAS_STATION
				};
			} else {
				initedURN = new StandardEntityURN[] {
						StandardEntityURN.BUILDING,
				};
			}
			Collection<StandardEntity> initedBuildings = world.getEntitiesOfType(initedURN);
			unenteredBuildings = new HashSet<EntityID>(initedBuildings.size());
			for (StandardEntity se : initedBuildings) {
				unenteredBuildings.add(se.getID());
			}
		}
		unenteredBuildings.removeAll(someoneVisitedArea);
		for (Iterator<EntityID> it = unenteredBuildings.iterator(); it.hasNext();) {
			EntityID id = it.next();
			StandardEntity se = world.getEntity(id);
			if (se instanceof Building) {
				Building building = (Building) se;
				if (world.getCollapsedBuildings().contains(building) 
						|| world.getBurningBuildings().contains(building)) {
					it.remove();
				} else if (building.isTemperatureDefined() && building.getTemperature() > 25) {
					it.remove();
				}
			}
		}
		
		for (EntityID next : getChanged()) {
			StandardEntity entity = world.getEntity(next);
			if (!(entity instanceof Road))
				continue;
			SEURoad road = world.getSeuRoad(next);

			if (road.isEntrance()) {
				for (Building build : world.getEntrance().getBuilding(road.getSelfRoad())) {
					unenteredBuildings.remove(build.getID());
				}
			}
		}
		
		if (!unenteredBuildings.isEmpty()) {
			Set<StandardEntity> dest = new HashSet<StandardEntity>(unenteredBuildings.size());
			for (EntityID id : unenteredBuildings) {
				dest.add(world.getEntity(id));
			}
			
			dest.remove(location().getID());
			
			if (me() instanceof PoliceForce) {
				move(dest, router.getPfCostFunction());
			}
			
			
			move(dest);
		}
	}

	public void randomWalk() throws ActionCommandException {////在platoongent
		Collection<StandardEntity> inRnage = world.getObjectsInRange(me().getID(), 50000);
		List<Area> target = new ArrayList<Area>();
		Collection<Area> blockadeDefinedArea = new ArrayList<Area>();
		
		for (StandardEntity entity : inRnage) {
			if (!(entity instanceof Area))
				continue;
			if (entity.getID().getValue() == location().getID().getValue())
				continue;
			Area nearArea = (Area) entity;
			if (nearArea.isBlockadesDefined() && nearArea.getBlockades().size() > 0) {
				blockadeDefinedArea.add(nearArea);
				continue;
			}
				
			target.add(nearArea);
		}
		
		if (target.isEmpty())
			target.addAll(blockadeDefinedArea);
		Area randomTarget = target.get(random.nextInt(target.size()));
		
		List<EntityID> path = router.getAStar(location(), 
				randomTarget, router.getNormalCostFunction(), new Point(getMeAsHuman().getX(), getMeAsHuman().getY()));
		
		
		
		sendMove(path);
	}
	
	protected void moveToRefuge() throws ActionCommandException {
		Collection<StandardEntity> refuges = world.getEntitiesOfType(StandardEntityURN.REFUGE);
		
		if (refuges.isEmpty()) return;
		
		move(refuges);
	}
		
	protected void careSelf() throws ActionCommandException {
		if (((Human) me()).getHP() - ((Human) me()).getDamage() * (timestep - timeStep) < 16) {
			moveToRefuge();
		}
	}
	public void setCurrentPosition(Point currentPosition) {
		this.currentPosition = currentPosition;
	}
	
	public Point getOldPosition() {
		return oldPosition;
	}
	public Point getLastPosition() {
		return lastPosition;
	}
	public Point getCurrentPosition() {
		return currentPosition;
	}
	public Road getFireBuildingEntrance() {
		return fireBuildingEntrance;
	}
	public Road getCannotLeaveBuildingEntrance() {
		return cannotLeaveBuildingEntrance;
	}
	public int getTimeStep(){
		return timeStep;
	}
	public boolean canSee(EntityID id) {
		Set<EntityID> ids;
		boolean canSee;

		ids = changeSet.getChangedEntities();
		canSee = ids.contains(id);
		return canSee;
	}
	public List<Human> getVisualHumans(){
		if(visualHumans==null){
			for (EntityID next : getChanged()) {
				StandardEntity entity = world.getEntity(next);
				if (entity instanceof Human) {
				
					visualHumans.add((Human)entity);
				}
			
			}
		}
		return visualHumans;
	}
	public boolean isInRefuge() {
		boolean inRefuge;
		StandardEntity location;

		location = location();
		inRefuge = location instanceof Refuge;
		return inRefuge;
	}
	public Road getEntranceRoad(Building building) {
		for (EntityID next : building.getNeighbours()) {
			StandardEntity entity = world.getEntity(next);
			if (entity instanceof Road) {
				return (Road) entity;
			}
		}
		return null;
	}
	public Road getEntranceOrNearRoad(Building building) {
		for (EntityID next : building.getNeighbours()) {
			StandardEntity entity = world.getEntity(next);
			if (entity instanceof Road) {
				return (Road) entity;
			}
		}////自己所在房屋的一周
		for (EntityID next : building.getNeighbours()) {
			StandardEntity entity = world.getEntity(next);
			Building building1=(Building) entity;
			for (EntityID next1 : building1.getNeighbours()) {
				StandardEntity entity1 = world.getEntity(next);
			if (entity1 instanceof Road) {
				return (Road) entity;
			}
		}
		}////自己所在房屋的二周
			for (EntityID next2 : building.getNeighbours()) {
				StandardEntity entity2 = world.getEntity(next2);
				Building building2=(Building) entity2;
				for (EntityID next3 : building2.getNeighbours()) {
					StandardEntity entity1 = world.getEntity(next3);
					Building building3=(Building) entity1;
					for (EntityID next4 : building3.getNeighbours()) {
						StandardEntity entity3 = world.getEntity(next4);
	               if (entity1 instanceof Road) {
		                    return (Road) entity3;
	                 }
					}
				}////自己所在房屋的三周
			}
			return null;
		}
	
//	public void handleTasks() {
//		
//		boolean executed;
//		executed = false;
//		
//		if (tasks == null)  
//			tasks = getAgentTasks();
//	 
//		for (BasicTask task : tasks) {
//			boolean shouldExecute;
//			// 任务已经被执行过，是否需要重复执行
//			if (executed) {
//				task.taskDone();
//			} else {
////				Date time;
////				long timeDifference;
////				boolean runningLate;
////
////				// 计算时间
////				time = new Date();
////				timeDifference = time.getTime() - decisionStartTime.getTime();
////				runningLate = timeDifference > agentThinkTime
////						* AGENT_THINK_TIME_TOLERANCE;
////
////				// 超出容许时间，当前周期无任务执行
////				if (runningLate) {
////					randomWalkPenalty = DEFAULT_RANDOM_WALK_PENALTY;
////
////					BasicTask lastTask;
////					lastTask = tasks.get(tasks.size() - 1);
////
////					// 如果当前任务不是最后任务
////					if (!task.equals(lastTask)) {
////						continue;
////					}
////				} else if (randomWalkPenalty > 0) {
////
////					BasicTask lastTask;
////					lastTask = tasks.get(tasks.size() - 1);
////
////					// 如果当前任务是系统最后一个任务，随机行走任务
////					if (!task.equals(lastTask)) {
////						continue;
////					} else {
////						randomWalkPenalty--;
////					}
////				}
//
//				shouldExecute = task.shouldExecute();
//				//if(agentType==StandardEntityURN.AMBULANCE_TEAM)
//				//System.out.println(timeStep+" "+me().getID()+"AT tasks "+task );
//				if (shouldExecute) {
//					//state = task.getState();
//					// System.out.println("  time  " + timeStep + "  id  "
//					// + getID() + "   state  " + state);
//					task.execute();
//					executed = true;
//				}
//			}
//		}
//		if (!executed) {
//			System.err.println(this + "Task Not Executed" + "In" + timeStep);
//		}
//
//	}
	//@SuppressWarnings({ "rawtypes" })
	//public abstract List<BasicTask> getAgentTasks();

	
	//-------------------------------------------------------------------------seu message part-----------------------------------------
	public void sendVoiceMessage(Message message, MessagePriority priority) {

		messageController.addMessage(0, message, priority);
	}
	
	public int[] getFirstChannelToSusbscribe() {
		int[] channels;
		channels = new int[1];
		channels[0] = 1;
		return channels;

	}
	
	public int[] getChannelsToSubscribe() {
		List<Integer> channelList;
		int[] channels;
		int max;

		max = config.getIntValue("comms.channels.max.platoon");
		channelList = new ArrayList<Integer>();
		for (MessageType type : getMessagesToListen()) {
			if (channelList.size() >= max) {
				break;
			}
			int channel;
			 
			channel = sayMessageTransfer.getChannel(type);
			if (!channelList.contains(channel)) {
				channelList.add(channel);
			}
		}
		channels = new int[channelList.size()];
		for (int i = 0; i < channels.length; i++) {
			channels[i] = channelList.get(i);
		}
		return channels;
	}
	
	@Override
	public void sendSubscribe(int time, int... channels) {
		 
		super.sendSubscribe(time, channels);
	}
	
	public boolean shouldProcessCommand(Command command) {
		if (command.getAgentID().equals(getID())) {//自己的 
			return false;
		}
		if (getTimeStep() - command.getTime() > IGNORE_COMMANDS_AFTER) {
			return false;
		}
		return true;
	}
	
	@Override
	public E me() {
		return super.me();
	}
	

	public int getNo() {
		if (world == null) {
			return 0;
		}
		List<EntityID> team = world.getTeam();
		if (team.contains(getID())) {
			return team.indexOf(getID());
		} else {
			return 0;
		}
	}
	
	public void sendMessage(Message message, MessagePriority priority) {
		int channel;
	 
		channel = sayMessageTransfer.getChannel(message.getType());
		 
	 
		if (timeStep <= 5)

		{
			if (message instanceof ChannelCondition
					|| message instanceof MessageCount)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount1)
				messageController.addMessage(channel, message,priority );
			if (message instanceof MessageCount2)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount3)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount4)
				messageController.addMessage(channel, message,priority );
			if (message instanceof MessageCount5)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount6)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount7)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount8)
				messageController.addMessage(channel, message, priority);
			if (message instanceof MessageCount9)
				messageController.addMessage(channel, message,priority );

		} else {
			if (channel != 0)
				messageController.addMessage(channel, message, priority);
		}
	}
	
	public List<MessageType> getMessagesToListen() {
        List<MessageType> types = new ArrayList<MessageType>();
        Collections.addAll(types, MessageType.values());
        return types;
    }
	protected void addTeamMembers() {
		agentType = me().getStandardURN();
		world.addTeamMembers(agentType);
	}
	
	public void sendMessage(){
		seuburningBuildings.sendBuildingIsBurningMessage();
		seuextinguishBuildings.sendBuildingIsExtinguishedMessage();
    	seuburiedHumans.sendHumanIsSavedOrDeadMessage();
	 
		seuburiedHumans.sendBuriedHumanSeenHeared();
		seuburningOutBuildings.sendBuildingIsBurnedOutMessage();
	 
		seusearchedBuildings.sendAgentPositionMessage();
		seuwaterPort.sendWaterMessage();
		if(agentType == StandardEntityURN.AMBULANCE_TEAM){
			seuremainCluster.sendRemovedClusterMessage();
			}
	}
	public void sendMessagesForNoRadio(){
		if (me() instanceof Human) {
			sendSpeak(timeStep, voiceChannel, comManager.createVoiceMessage(voiceChannel, changeSet));
		}
		
		for (Port next : comManager.getRadioEventListers()) {
			next.resetCounter();
			for (; next.hasNext(); ) {
				MessageBitSection sec = next.next();
				if (sec != null)
					sec.decrementTTL();
			}
			next.resetCounter();
		}

		for (Port next : comManager.getVoiceEventListeners()) {
			next.resetCounter();
			for (; next.hasNext(); ) {
				MessageBitSection sec = next.next();
				if (sec != null)
					sec.decrementTTL();
			}
			next.resetCounter();
		}

	}
	
	protected void sendMessagesFromQueue() {
		
		 
		Collection<QueueMessage> importantMessages = messageController.getMostImportantMessages();
	   
		if (importantMessages == null) {
			 
		} else {
		 
			for (QueueMessage next : importantMessages) {
				Message message = next.message;
			
				int channel = next.channel;
			 
					if(message==null)  return ;
				 
					sendMessage(message, channel);
		 

			}

		}
 
	}
	
	public void sendMessage(Message message, int channel) {
		int id = sayMessageTransfer.getNextMessageId();
		message.setId(id);
	 
		byte[] bytes = sayMessageTransfer.transmit(message);
		int n=0;
		 
		if(world.isNoRadio())
		  n=2;
		else{
			 n = sayMessageTransfer.getRepeatCount(channel);
			 if(n<=1) n=1;
		}
		 
		for (int i = 0; i < n; i++) {
	 
	 
			sendSpeak(getTimeStep(), channel, bytes);
		 
		}

		sayMessageTransfer.incrementMessageId();
		messageController.clearQueue();
	 
	}
	//yuanc14.9.8
    public boolean isStuck(Human human){
    	Blockade coveringBlockade=getStuckBlockade(world,human);
    	if (coveringBlockade != null) {
    		return true;   	  		
    	}   	
    	return false;
    }
    
    public Blockade getStuckBlockade(SEUWorldModel world, Human human) {
        Blockade coveringBlockade = null;
        if (human != getMeAsHuman() && !human.isPositionDefined()) {
            // Do nothing.
        } else {
            StandardEntity se = world.getEntity(human.getPosition());
            if (se instanceof Road) {
                Blockade blockade;
                Road road = (Road) se;
                Shape shape;
                if (road.isBlockadesDefined()) {
                    for (EntityID id : road.getBlockades()) {
                        blockade = (Blockade) world.getEntity(id);
                        if (blockade != null && blockade.isApexesDefined()) {
                            shape = blockade.getShape();
                            if (shape.contains(human.getX(), human.getY())/*||
                            		blockade.getShape().intersects(getBounds(human, world))*/) {
                                coveringBlockade = blockade;
                                break;
                            }
                        }
                    }
                }
            }

        }
        return coveringBlockade;
    }

    public ChangeSet getChangeSet(){
  	  return this.changeSet;
   }
    
    public SEUSearchedBuildings getSearchedBuildings() {
		return seusearchedBuildings;
	}
    
    public SEUBuriedHumans getBuriedHumans() {
		return seuburiedHumans;
	}
    public static Rectangle getBounds(Human human, SEUWorldModel model) {
		Point p;
		double s;
		Rectangle2D rect;
		s = SEUAgent.AGENT_RADIUS * 2;
		p = new Point(human.getLocation(model).first(),human.getLocation(model).second());
		rect = new Rectangle2D.Double(p.x - s, p.y - s, s * 2, s * 2);
		return rect.getBounds();
	}
    
    public int getAfterShockTime(){
		if(this.aftershocktime<300&&this.aftershocktime!=0){
			setAfterShockTime(aftershocktime);
			
		}else{
		    Collection<Pair<Building, Integer>> samebuildings = new ArrayList<Pair<Building, Integer>>();
		    if(oldbuildings!=null){
			    for(Pair<Building, Integer> b : oldbuildings){
				    if(getObserveBuilding().contains(b.first())){
					    samebuildings.add(b);	
				     } 		
			     }
		    }
		   if(oldbuildings!=null){oldbuildings.clear();
		}
	   try{
		   for(Building b:getObserveBuilding()){
	    	   if(b.isBrokennessDefined()){
	    	      Pair<Building, Integer>pair=new Pair<Building, Integer>(b, b.getBrokenness());
	    	      oldbuildings.add(pair);
	    	    }
	        }
	    }catch(Exception e){
	    	System.out.println(this.getID()+"aftershock!!!!!!!!!!!!!   error");					
	    }
		for(Pair<Building, Integer> building :samebuildings){
			if(building.first().isBrokennessDefined()){
				if(building.first().getBrokenness()>building.second()){			
					setAfterShockTime(getTimeStep());					
					//System.out.println(this.getID()+"aftershock!!!!!!!!!!!!!"+aftershocktime);					
				}else{
					setAfterShockTime(300);
				}			
			}
		}
	}
//		
		return aftershocktime ;
	}
    public void setAfterShockTime(int aftershock) {
		this.aftershocktime = aftershock;
	}
    
    public List<Building> getObserveBuilding() {
		List<Building> building = new ArrayList<Building>();
		for (EntityID e : getChanged()) {
			if(world.getEntity(e) instanceof Building){
			StandardEntity s = world.getEntity(e);
			building.add((Building) s);
			}
		}
		return building;
	}
    
}
