package seu.agent.at;


import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Set;

import rescuecore2.messages.Command;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.BuriednessComparator;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.EntityFreezer;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.EntityFreezer.Freeze_Tab;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.RescueTargetSelector;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.SearchSpaceManager;
import seu.agent.at.Tasks.NewSaveHumanTask;
import seu.agent.at.Tasks.SaveHumanTask;
import seu.agent.at.buriedHuman.BuriedHumanInfoProcesser;
import seu.common.State;
import seu.common.TimeOutException;
import seu.util.EntityIdComparator;



public class AmbulanceTeamAgent extends AbstractAmbulanceTeamAgent {
	public Human targetHuman ;
	public BuriedHumanInfoProcesser BHI_processer;
	public RescueTargetSelector targetSelector;
	public SearchSpaceManager searchSpaceManager;
	public EntityFreezer freezer;
	public EntityID nextPassArea;
	public boolean getBurnInjury;
	public SaveHumanTask saveHumanTask;
	public NewSaveHumanTask atTask;
	@Override
	protected void initialize() {
		super.initialize();
		currentTask=State.NO_TASK;
		targetHuman = null;
		freezer = new EntityFreezer();
		BHI_processer = new BuriedHumanInfoProcesser(world);
		targetSelector = new RescueTargetSelector(world , clusters , assignedClusterIndex , BHI_processer , freezer);
		searchSpaceManager = new SearchSpaceManager(world , clusters , assignedClusterIndex , freezer);
		getBurnInjury = false;
		atTask=new NewSaveHumanTask(this);
		saveHumanTask = new SaveHumanTask(this, clusters , assignedClusterIndex );
	}
	
	@Override
	protected void think(int time, ChangeSet changed, Collection<Command> heard){

		super.think(time, changed, heard);
	}

	@Override
	protected void BeforeAct() throws TimeOutException{
		super.BeforeAct();
		if (timeStep >= world.getConfig().ignoreTime){
//			if(world.isCommunicationLess()){//niu
//			saveHumanTask.update(changeSet);
//			updateForFreezer1();
//			}else{
			updateForFreezer();
			searchSpaceManager.update(changeSet);
			BHI_processer.update();
			targetSelector.update(changeSet , searchSpaceManager.getNeedlessBuildingForRescue() , searchSpaceManager.isAssignedClusterNearlyClear());
			nextPassArea = null;
//			}
		}
	}
	
	@Override
	protected void act() throws ActionCommandException, TimeOutException{
		super.act();
		
//		if(world.isCommunicationLess()){//niu
//				if (me().getBuriedness() > 0){
//					sendRest();
//					}
//		    
//		      if (isStucked(world.me)){
//		    	  sendRest();
//				}
//		     // if(isATCrank()) tryLeaveCrank();//////////////////////////
//			 if(world.getAllRefuges().size()!=0&&getMeAsHuman().getDamage() > 0) { 
//					if (me().getPosition(world) instanceof Refuge)
//						sendRest();
//				}//////////////
//			 
//			if(timeStep > world.getConfig().ignoreTime){
//				if(saveHumanTask.shouldExecute()){
//					saveHumanTask.execute();
//				}
//				}
//		}else{
		if(isBlocked() && location() instanceof Building && !world.getVisualATs().isEmpty()){//mexico2多个at一起出去，互相碰撞。大家都出不去
			int maxid=0;
			for(EntityID eId :world.getVisualATs()){
				if(eId.getValue()>maxid){
					maxid=eId.getValue();
				}
			}
			if(getID().getValue()<maxid){
			//	System.out.println(world.me + "  Time : " + world.getTime() + "   rest!!!!!!!!!!!!!!!!1 " );
			sendRest();
			}
			
			//randomWalk();
		}	
		handletasks();	
//		}
	}
	
	@Override
	protected void AfterAct(){
//		if(world.isCommunicationLess()){//niu
//		saveHumanTask.afterAct();
//		}else{
		lastTask = currentTask;
		targetSelector.afterAct();
//		}
		super.AfterAct();
	}
	
	private void updateForFreezer(){
		freezer.updateFreezingTime();

		if (isBlocked()){

			switch(lastTask){
			case LOADING : 
			case SEARCHING :
				freezer.addNewfreezingStuff(Freeze_Tab.AREA , nextPassArea, 3);
				break;
			case MOVING_TO_HUMAN :
				freezer.addNewfreezingStuff(Freeze_Tab.HUMAN , targetHuman.getID() , 3);
				break;
			    default :
				break;
			}
		}
	}
	private  void updateForFreezer1(){
		freezer.updateFreezingTime();
		if (isBlocked()){
			switch(saveHumanTask.lastState){
			case  LoadingHuman: 
			case MovingToRefuge:
			case SavingMyself:
			case Exploring:
				freezer.addNewfreezingStuff(Freeze_Tab.AREA , saveHumanTask.nextArea, 3);
				break;
			case MovingToHuman:
				freezer.addNewfreezingStuff(Freeze_Tab.HUMAN , saveHumanTask.currentHuman.getID() , 3);
				break;
			default :
				break;
			}
		}
	} 
	protected void handletasks() throws seu.agent.SEUAgent.ActionCommandException{
		atTask.updateCurrentTask();
		atTask.executeCurrentTask();
	}

	@Override
	protected void cantMove() throws seu.agent.SEUAgent.ActionCommandException,
			TimeOutException {
		// TODO Auto-generated method stub
		
	}   
        
}
