  package seu.agent.at.Tasks;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.at.AmbulanceTeamAgent;
import seu.agent.at.AmbulanceTeamsTools.partionTools.Cluster;
import seu.agent.at.AmbulanceTeamsTools.partionTools.Clustering;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.BuriedHumanComparator;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.EntityFreezer;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.EntityFreezer.Freeze_Tab;
import seu.agent.at.AmbulanceTeamsTools.rescueTools.SearchSpaceManager;
//import seu.agent.Ambulance.SEUAmbulanceTeam;
//import seu.agent.Ambulance.Cluster.Cluster;
//import seu.agent.Ambulance.Cluster.Clustering;
//import seu.agent.Ambulance.Tools.BuriedHumanComparator;
//import seu.agent.Ambulance.Tools.ElementWithDistance;
//import seu.agent.Ambulance.Tools.EntityFreezer;
//import seu.agent.Ambulance.Tools.EntityFreezer.Freeze_Tab;
//import seu.agent.Ambulance.Tools.searchingManage;
//import seu.agent.Ambulance.Tools.GeneralSorter;
//import seu.object.SEUWorldModel;
//import seu.utilities.Distance;
//import seu.utilities.EntityIdComparator;
import seu.common.State;
import seu.geom.Distance;
import seu.model.SEUWorldModel;
import seu.util.EntityIdComparator;
public class SaveHumanTask {

	private SEUWorldModel world;
	
	private  AmbulanceTeamAgent agent;
	protected int assignedClusterIndex ;
	private Area currentClusterCenter;
	private int currentClusterIndex;
	private final ArrayList<Cluster> clusters;
	protected HashMap<Integer , Integer> numberBuriedHumanInCluster;
	private Set<EntityID> currentHumans;
	private Set<EntityID> easyHumans;
	private Set<EntityID> allHumans;
	private Set<EntityID> urgentHumans;
	private ArrayList<EntityID> buriedAgents;
	private Set<EntityID> deleteHumans;
	@SuppressWarnings("unused")
	private Collection<StandardEntity> allRefuges;
	private SearchSpaceManager searchManage;
	private boolean nearlyClear;
	private boolean isMore;
	public State currentState=State.Inactive;
	public State lastState;
    public EntityID nextArea;
    public Human currentHuman;
    public Human lastHuman;
    private List<EntityID> path;
    int rescueRange=0;
    boolean searchingOut=false;
    protected int[] firedClusterBuildingSize;
	protected HashMap<EntityID , Integer> clusterIndexOfBuilding;

	
      
	public SaveHumanTask( AmbulanceTeamAgent agent, ArrayList<Cluster> clusters , 
			int assignedClusterIndex ){
		this.world = agent.getModel();
		this.agent= agent;
		this.currentClusterCenter = clusters.get(currentClusterIndex).getCenterEntity();
		this.assignedClusterIndex = assignedClusterIndex;
		this.currentClusterIndex = assignedClusterIndex;
		this.clusters = clusters;
		
		searchManage = new SearchSpaceManager(world , clusters , assignedClusterIndex,agent.freezer);
		currentHumans = new HashSet<EntityID>();
		allHumans = new HashSet<EntityID>();
		easyHumans= new HashSet<EntityID>();
		urgentHumans= new HashSet<EntityID>();
		allRefuges = world.getEntitiesOfType(StandardEntityURN.REFUGE);
		deleteHumans = new HashSet<EntityID>();
		buriedAgents = new ArrayList<EntityID>();
		path=new ArrayList<EntityID>();
		numberBuriedHumanInCluster = new HashMap<Integer , Integer>();
		firedClusterBuildingSize = new int[clusters.size()];
		for(int i=0;i<clusters.size();i++){
			firedClusterBuildingSize[i]=0;
		}
		initializeRescueRange();
		initializeClusterIndexOfBuilding();
	}
	public void initializeClusterIndexOfBuilding(){
		
		clusterIndexOfBuilding = new HashMap<EntityID , Integer>();
		for (Cluster cluster : clusters){
			int clusterIndex = clusters.indexOf(cluster);
			for (EntityID buildingID : cluster.getCluster()){
				clusterIndexOfBuilding.put(buildingID , clusterIndex);
			}
		}
		
		
	}
	
	public void update(ChangeSet changed){
		
		 searchManage.update(changed);
		 updateNumberFiredBuildingsInCluster();/////////
		 this.nearlyClear = searchManage.isAssignedClusterNearlyClear();
		 freezingLoadingATs();
		 updateAllHuman(searchManage.getNeedlessBuildingForRescue());
		 if (allHumans.isEmpty())
			return ;
		updateIsMore();
		updateEasyHuman();
		updateCurrentHuman();
		nextArea=null;
	}
	
	public void updateNumberFiredBuildingsInCluster(){
	if(world.getBurningBuildings().size()!=0&&fireCantControl()>0.30){
		
		for(Building next:world.getBurningBuildings()){
			
			firedClusterBuildingSize[clusterIndexOfBuilding.get(next.getID())] ++ ;
		}
		for(Building next:world.getBurningOutBuildings()){
			firedClusterBuildingSize[clusterIndexOfBuilding.get(next.getID())] ++ ;
		}

	}		

	}
	public int getFiredLessBuildingsIndixOfCluster(){
		
		int indix=-1;
		int firedBuilding=0;
		for(int i=0;i<firedClusterBuildingSize.length;i++){
			if(firedClusterBuildingSize[i]>firedBuilding){
				firedBuilding=firedClusterBuildingSize[i];
				indix=i;
			}
		}
	    return indix;
	}
	
	public double fireCantControl(){
		if(world.getBurningBuildings().size()!=0){	
		return (world.getBurningBuildings().size()+world.getBurningOutBuildings().size())*1.000/world.getBuildings().size();
		}
		return 0;
	}
	
	
	public void freezingLoadingATs(){
		for (EntityID entityID :world.getVisualATs()){
			StandardEntity se = world.getEntity(entityID);
			Human at = (Human)se;
			Human civilian = loadingHuman(at);
			if (civilian != null && ! agent.freezer.containStuff(Freeze_Tab.LOADINGAT , entityID)){
				  agent.freezer.addNewfreezingStuff(Freeze_Tab.LOADINGAT , entityID , (int)getTimeToRefuge(civilian.getID()));
			}
		}
	}
	
	public void updateAllHuman(Set<EntityID> needlessBuildingForRescue){
		allHumans.addAll(world.getBuriedHumans().getTotalBuriedHuman());//agent.getBuriedHumans().getTotalBuriedHuman()
		 
		for (Iterator<EntityID> iterator = allHumans.iterator() ; iterator.hasNext() ;){
			EntityID humanID = iterator.next();
			Human human = (Human) world.getEntity(humanID);
			if (deleteHumans.contains(humanID)){
				if (currentHuman == null){
					iterator.remove();
					continue;
				}
				else if (!currentHuman.getID().equals(humanID)){
					iterator.remove();
					continue;
				}
			}
			if(human.isBuriednessDefined()&&human.getBuriedness()==0){
				iterator.remove();
				if(!deleteHumans.contains(humanID))
					deleteHumans.add(humanID);
				continue;
				
			}
			
			if (!human.isPositionDefined() || human.getPosition() == null){
				
				if (currentHuman != null && currentHuman.getID().equals(humanID))
					currentHuman = null;
				
				iterator.remove();
				continue;
			}
			EntityID posID = human.getPosition();
	
			
			
			if (human.getPosition(world) instanceof Refuge ){
				iterator.remove();
				continue ; 
			}
			
			if (needlessBuildingForRescue.contains(posID)){
				iterator.remove();

				continue;
			}
			Set<EntityID> warmBuildings = agent.freezer.getEntitiesWithTab(Freeze_Tab.WARM_BUILDING);
			if (warmBuildings != null && warmBuildings.contains(posID)){
				iterator.remove();
				continue;
			}
//			if (getDeathTime(human) <= 3){
//				iterator.remove();
//				continue ;
//			}
//			if (getDeathTime(human) <= getTimeToRefuge(humanID)){
//				iterator.remove();
//				continue ;
//			}
		}
	}
	 
	public void updateUrgentHuman(Set<EntityID> needlessBuildingForRescue){
		urgentHumans.addAll(agent.getBuriedHumans().getTotalBuriedHuman());
		for (Iterator<EntityID> iterator = allHumans.iterator() ; iterator.hasNext() ;){
			EntityID humanID = iterator.next();
			Human human = (Human) world.getEntity(humanID);
			if (deleteHumans.contains(humanID)){
				if (currentHuman == null){
					iterator.remove();
					continue;
				}
				else if (!currentHuman.getID().equals(humanID)){
					iterator.remove();
					continue;
				}
			}
			if(human.isBuriednessDefined()&&human.getBuriedness()==0){
				iterator.remove();
				if(!deleteHumans.contains(humanID))
					deleteHumans.add(humanID);
				continue;
				
			}
			
			if (!human.isPositionDefined() || human.getPosition() == null){
				
				if (currentHuman != null && currentHuman.getID().equals(humanID))
					currentHuman = null;
				
				iterator.remove();
				continue;
			}
			EntityID posID = human.getPosition();
			Area pos = (Area)human.getPosition(world);
			
			if (human.getPosition(world) instanceof Refuge ){
				iterator.remove();
				continue ; 
			}
			
			if (needlessBuildingForRescue.contains(posID)){
				iterator.remove();

				continue;
			}
			Set<EntityID> warmBuildings = agent.freezer.getEntitiesWithTab(Freeze_Tab.WARM_BUILDING);
			if (warmBuildings != null && warmBuildings.contains(posID)){
				iterator.remove();
				continue;
			}
			
			int distanceFromCenterToTarget = world.getDistance(pos , currentClusterCenter);
			int distanceToTarget = world.getDistance(pos , agent.getMeAsHuman());
	 
			
			if (distanceFromCenterToTarget > 1.0 * Clustering.MAX_RADIUS||distanceFromCenterToTarget>2*rescueRange){
				iterator.remove();
				continue;
			}
			if (distanceFromCenterToTarget > 2.5 * Clustering.MAX_RADIUS ||distanceToTarget > 1.5 * Clustering.MAX_RADIUS){
				iterator.remove();
				continue;
			}
			if (distanceToTarget>2.0 * Clustering.MAX_RADIUS||distanceToTarget>2*rescueRange){
				iterator.remove();
				continue;
			}
	
		}
		Set<EntityID> freezingHuman = agent.freezer.getEntitiesWithTab(Freeze_Tab.HUMAN);
		if (freezingHuman == null)
			return ;

		urgentHumans.removeAll(freezingHuman);  
		if (urgentHumans.isEmpty()&&agent.getTimeStep()>100){
			 urgentHumans.addAll(freezingHuman);
			 agent.freezer.removeEntityWithTab(Freeze_Tab.HUMAN);
		}
		
		
	}
	
	public void updateCurrentHuman(){
		if (easyHumans.isEmpty()){
			if (nearlyClear || isMore || world.getTime() > 170)
				easyHumans.addAll(allHumans);
			else 
				return ;
		}
		updateNumberInCluster();
		updateCurrentHumanForRescue();
		if (currentHumans.isEmpty()){
			if (nearlyClear || isMore || world.getTime() > 120){
				updateRescueSpace();
				updateCurrentHumanForRescue();
			}
			else 
				return ;
		}
		
	}
	public void updateEasyHuman(){
		easyHumans.addAll(allHumans);
		for (Iterator<EntityID> iterator = easyHumans.iterator() ; iterator.hasNext() ;){
			EntityID humanID = iterator.next();
			if (!canBeRescued(humanID)){
				iterator.remove();
				continue;
			}
			if (shouldRemoveIfEnough(humanID)){
				iterator.remove();
				continue ;
			}
		}
	}
	
	protected boolean canBeRescued(EntityID humanID){
		Human human = (Human)world.getEntity(humanID);
		int minAT = getMinATs(humanID);
		int theNumberOfATNearby = getNearAT(human);
		if (theNumberOfATNearby >= minAT)
			return true;
		else 
			return false;
	}
	protected int getNearAT(Human human){
		float theNumberOfATNearby = 0;
		Set<EntityID> loadingATs = agent.freezer.getEntitiesWithTab(Freeze_Tab.LOADINGAT);
		label : for (StandardEntity at : world.getEntitiesOfType(StandardEntityURN.AMBULANCE_TEAM)){
			Human humanAT = (Human)at;
			if (humanAT.getID().equals(world.me.getID())){
				theNumberOfATNearby += 1;
				continue ;
			}
			if (!humanAT.isPositionDefined())
				continue ;
			if (humanAT.getPosition().equals(world.me.getPosition())){
				theNumberOfATNearby += 1;
				continue ;
			}
		   	else if (world.getDistance(humanAT.getPosition() , human.getPosition()) < Clustering.MAX_RADIUS){
				if (humanAT.isHPDefined() && humanAT.getHP() == 0)
					continue ;
				if (loadingATs != null && loadingATs.contains(at.getID()))
					continue ;
				if (allHumans.contains(humanAT.getID()))
					continue ;
				if (human.getPosition().equals(humanAT.getPosition())){
					theNumberOfATNearby += 1;
					continue ;
				}
				for (EntityID humanID : allHumans){
					Human humanBeingRescued = (Human)world.getEntity(humanID);
					if (humanBeingRescued.getPosition().equals(humanAT.getPosition())){
						theNumberOfATNearby += 0.3;
						continue label;	
					}
				}
				theNumberOfATNearby += 0.7 ;
			}
		}
		return (int)theNumberOfATNearby;
	}
	protected boolean shouldRemoveIfEnough(EntityID humanID){
		Human human = (Human)world.getEntity(humanID);
		HashSet<EntityID> ATAroundVictim = new HashSet<EntityID>();
		HashSet<EntityID> areaAroundVictim = new HashSet<EntityID>();
		int minATToRescue;
		if (human.getURN().equals(StandardEntityURN.CIVILIAN.toString()))
			minATToRescue = getMinATs(humanID);
		else 
			minATToRescue = 4;
		areaAroundVictim.add(human.getPosition());
		if(human.getPosition(world) instanceof Building){
		for (EntityID negID : world.getSeuBuilding(human.getPosition()).getObservableAreas()){
			areaAroundVictim.add(negID);
			Area neg = (Area)world.getEntity(negID);
			if (neg instanceof Building)
				areaAroundVictim.addAll(world.getSeuBuilding(negID).getObservableAreas());
			else
				areaAroundVictim.addAll(world.getSeuRoad(negID).getObservableAreas());
		}
		}else{
			
			for (EntityID negID : world.getSeuRoad(human.getPosition()).getObservableAreas()){
				areaAroundVictim.add(negID);
				Area neg = (Area)world.getEntity(negID);
				if (neg instanceof Building)
					areaAroundVictim.addAll(world.getSeuBuilding(negID).getObservableAreas());
				else
					areaAroundVictim.addAll(world.getSeuRoad(negID).getObservableAreas());
			}
			
			
			
		}
		for (StandardEntity se : world.getEntitiesOfType(StandardEntityURN.AMBULANCE_TEAM)){
			Human at = (Human)se;
			if (deleteHumans.contains(at))
				continue ;
			if (at.isBuriednessDefined() && at.getBuriedness() > 0)
				continue ;
			if (at.isPositionDefined() && areaAroundVictim.contains(at.getPosition()))
				ATAroundVictim.add(at.getID());
		}
		if (ATAroundVictim.size() == minATToRescue && !ATAroundVictim.contains(world.me.getID())){

			return true;
		}
		if (ATAroundVictim.size() > minATToRescue){
			if (!ATAroundVictim.contains(world.me.getID())){

				return true;
			}
			if (currentHuman != null && currentHuman.getID().equals(humanID) && human.getPosition().equals(world.me.getPosition()))
				return false;
 
			return false;
		}
		else 
			return false;
	}
	public void updateIsMore(){
		if (allHumans.size() > 0.57 * world.getAmbulanceTeamIdList().size())
			isMore = true;
		else 
			isMore = false;
		
	}
	public void updateCurrentHumanForRescue(){
	
		buriedAgents.clear();
		if (currentClusterIndex == -1){
			return ;
		}
		
		if(!easyHumans.isEmpty()){
		for (EntityID humanID : easyHumans){
			Human human = (Human)world.getEntity(humanID);
			Area pos = (Area)human.getPosition(world);
			if (!human.getURN().equals(StandardEntityURN.CIVILIAN.toString())){
				 buriedAgents.add(humanID);
				continue;
			}
						
			if (currentHuman != null && easyHumans.contains(currentHuman.getID())){
				currentHumans.add(currentHuman.getID());
				continue;
			}
			
			
			int distanceFromCenterToTarget = world.getDistance(pos , currentClusterCenter);
			int distanceToTarget = world.getDistance(pos , agent.getMeAsHuman());
	 
			
			if (distanceFromCenterToTarget <= 1.0 * Clustering.MAX_RADIUS&&distanceFromCenterToTarget<rescueRange){
				currentHumans.add(humanID);
				continue ;
			}
//			if (distanceFromCenterToTarget <= 1.5 * Clustering.MAX_RADIUS &&  distanceToTarget <= 1 * Clustering.MAX_RADIUS){
//				currentHumans.add(humanID);
//				continue ;
//			}
			
			if (/*distanceToTarget <= 1.0 * Clustering.MAX_RADIUS||*/distanceToTarget<rescueRange){
				currentHumans.add(humanID);
				continue ;
			}
		}
		}
	  /* if (!buriedAgents.isEmpty()){
			for(EntityID next : buriedAgents){
			Human one = (Human)world.getEntity(next);
		     Area pos = (Area)one.getPosition(world);
			int distanceFromCenterToTarget = world.getDistance(pos , currentClusterCenter);
			int distanceToTarget = world.getDistance(pos , agent.getMeAsHuman());
			 
			if (distanceFromCenterToTarget <= 1.0 * Clustering.MAX_RADIUS&&distanceFromCenterToTarget<1.5*rescueRange){
				currentHumans.add(next);
				continue ;
			}
		
			if (distanceToTarget<1.5*rescueRange){
				currentHumans.add(next);
				continue ;
			}
			}
	   }*/
		Set<EntityID> freezingHuman = agent.freezer.getEntitiesWithTab(Freeze_Tab.HUMAN);
		if (freezingHuman == null)
			return ;

		currentHumans.removeAll(freezingHuman); 
		if (currentHumans.isEmpty()&&agent.getTimeStep()>100){
			for (EntityID humanID : freezingHuman){
				if (easyHumans.contains(humanID))
					currentHumans.add(humanID);
			}
			 agent.freezer.removeEntityWithTab(Freeze_Tab.HUMAN);
		}
	}
	
	
	public void updateNumberInCluster(){
		
		for (EntityID humanID : easyHumans){
			int index = Clustering.getCloestClusterForHuman(humanID, clusters, world);
			if (!numberBuriedHumanInCluster.containsKey(index))
				numberBuriedHumanInCluster.put(index , 0);
			numberBuriedHumanInCluster.put(index , numberBuriedHumanInCluster.get(index).intValue() + 1);
		}
		
	}
	
	private void updateRescueSpace(){
		currentClusterIndex = getNewRescueCluster();
		if (currentClusterIndex == -1)
			{
			return ;
			}
		currentClusterCenter = clusters.get(currentClusterIndex).getCenterEntity();
	}
	private int getNewRescueCluster(){
		int newClusterIndex ;
		ArrayList<Cluster> rescueClusters = new ArrayList<Cluster>();
		for (Integer index : numberBuriedHumanInCluster.keySet()){
			if(firedClusterBuildingSize[index]*1.00/clusters.get(index).getCluster().size()<0.7)
			rescueClusters.add(clusters.get(index));
			}
		if(rescueClusters.size()==0){
			for (Integer index : numberBuriedHumanInCluster.keySet()){
				rescueClusters.add(clusters.get(index));
				}
		}
		
		int index = Clustering.getCloestClusterForHuman(world.me.getID() , rescueClusters , world);
		if (index == -1)
			return -1;
		newClusterIndex = clusters.indexOf(rescueClusters.get(index));
		return newClusterIndex;
		 
		}
	
	protected int getMinATs(EntityID humanID){
		Human human = (Human)world.getEntity(humanID);
		int lifeTime = getDeathTime(human);
		int timeOnPath = getTimeToHuman(humanID) + getTimeToRefuge(humanID);
		if (lifeTime <= timeOnPath) 
			return Integer.MAX_VALUE;
		return (int)Math.ceil(human.getBuriedness()*1.0/(lifeTime - timeOnPath)) ;
	}
 
	public  int rescueTime(EntityID humanID){
		Human human = (Human)world.getEntity(humanID);
		int cost;
		int numberOfAT ;
		int visualHealthyATs = world.getVisualHealthyATs().size();
		int minNeededAT ;
	 
		minNeededAT = getMinATs(humanID);
		numberOfAT = Math.max(minNeededAT, visualHealthyATs);
		cost = (int)Math.ceil(human.getBuriedness() * 1.0f / numberOfAT) 
				+ getTimeToHuman(humanID) + getTimeToRefuge(humanID);
		return (int)cost;
	}
 
 
	public int getTimeToHuman(EntityID humanID){////
		Human human = (Human)world.getEntity(humanID);
		for (EntityID atID : world.getAmbulanceTeamIdList()){
			Human at = (Human)world.getEntity(atID);
			if(at.isPositionDefined() && at.getPosition().equals(human.getPosition()))
				return 0;
		}
		double distanceToHuman = 0.0;
		int time ; 
		if (!human.getPosition().equals(world.me.getID()))
			distanceToHuman = Distance.getDistance(world.me.getLocation(world),human.getLocation(world));
		time = (int)Math.ceil(distanceToHuman / 15700); 
		return time;
	}
	 
	public int getTimeToRefuge(EntityID humanID){
		Human human = (Human)world.getEntity(humanID);
		int distanceToRefuge = 0;
		int time;
		if (human instanceof Civilian){
			if (human.getPosition(world) instanceof Area)
				distanceToRefuge = world.getMinDistanceToRefuge(human.getID());
			else 
				distanceToRefuge = world.getMinDistanceToRefuge(agent.getID());
		}
		time = (int)Math.ceil(distanceToRefuge * 1.0/ 15700);
		return time + 2;
	}
 
	public  int freeTime(EntityID humanID)
	{
		Human human=(Human) world.getEntity(humanID);
		int freeTime =getDeathTime(human) - rescueTime(humanID);
		return freeTime;
	}
	
	public Human getTargetHuman(){ 
		if(currentHumans.isEmpty()) return null;
		for (EntityID humanID : currentHumans){
			Human human = (Human)world.getEntity(humanID);
			if (human.getPosition().equals(world.me.getPosition())){
				return human;
			}
		}
		try{
		ArrayList<EntityID> buriedHuman = new ArrayList<EntityID>(currentHumans);
		BuriedHumanSorter sorter = new BuriedHumanSorter();
		Collections.sort(buriedHuman, sorter);
		EntityID rescueID = buriedHuman.get(0);
		if (sorter.getFirst(rescueID) > 1){
			Human targetHuman = (Human)world.getEntity(rescueID);
			return targetHuman;
		}
		
		  Human target=null;
			for (EntityID sh : currentHumans) {
			Human human=(Human) world.getEntity(sh);

			StandardEntity position=world.getEntity(human.getPosition());
					 double minValue = Double.MAX_VALUE;
		 
			if (world.getDistance(agent.getID(),position.getID() ) < minValue) {

			       minValue = world.getDistance(agent.getID(), position.getID() );
			        target =human;
			       }          
			}
			
			return target;
		
		
		/*ArrayList<EntityID> easyRescueHuman = new ArrayList<EntityID>();
		easyRescueHuman.add(rescueID);
		int shortestRescueTime = rescueTime(buriedHuman.get(0));
		for(int index = 1 ; index < buriedHuman.size() ; index++){
			Human nextHuman =  (Human)world.getEntity(buriedHuman.get(index));
			if (divide(freeTime(nextHuman.getID()) , 5) > shortestRescueTime){
				Human targetHuman = (Human)world.getEntity(rescueID);
				return targetHuman;
			}
			int rescueTime = divide(rescueTime(nextHuman.getID()) , 5);
			if(rescueTime < shortestRescueTime){
				shortestRescueTime = rescueTime;
				rescueID = nextHuman.getID();
				easyRescueHuman.clear();
				easyRescueHuman.add(rescueID);
			}
			else if (rescueTime == shortestRescueTime)
				easyRescueHuman.add(nextHuman.getID());
				
		}
		Random random = new Random(world.me.getID().getValue());
		int rescueIndex = random.nextInt(easyRescueHuman.size());
		rescueID = easyRescueHuman.get(rescueIndex);
		Human targetHuman = (Human)world.getEntity(rescueID);
		return targetHuman;*/
		}catch(Exception e){
		//System.out.println("  getTargetHuman is   null ")	;
		}
		
		return null;
	}
	
	private int divide(int value , int precision){
		   if(value%precision>precision/2) return value/precision+1;
		   else return value/precision;
		}

	public Civilian loadingHuman(Human at) {
		for (StandardEntity next : world.getEntitiesOfType(StandardEntityURN.CIVILIAN)) {
			Civilian civilian = (Civilian) next;
			if (civilian.isPositionDefined() && civilian.getPosition().equals(at.getID())) {
				return civilian;
			}
		}
		return null;
	}
	
	public void afterAct(){
     if(agent.getTimeStep()>world.getConfig().ignoreTime+1){
		lastState=currentState;
		lastHuman=currentHuman;
		allHumans.clear();
		currentHumans.clear();
		easyHumans.clear();
		buriedAgents.clear();
		urgentHumans.clear();
		if (!nearlyClear)
			currentClusterIndex = assignedClusterIndex;
     }
	}


	protected void getExpectedState() {       
		
		if (agent.getMeAsHuman().getDamage() > 0) { 
			if(!allRefuges.isEmpty()){
			if (!(agent.getMeAsHuman().getPosition(world) instanceof Refuge)){
				currentHuman = null;
			   currentState= State.SavingMyself;
			return;
			
			  }
			}else{
				 Area position=(Area) agent.getMeAsHuman().getPosition(world);
				if(position instanceof Building&&agent.getMeAsHuman().getBuriedness()==0
						  &&(agent.getTimeStep()>10&&agent.locationHistory.get(agent.getTimeStep()).equals(agent.locationHistory.get(10)))){	
					      currentHuman = null;
					      currentState= State.SavingMyself;
					      System.out.println(agent.getID()+"   no refuge    SavingMyself     time    "+agent.getTimeStep());
					      return;
 
			}
		}
		}
		

		if(lastState==State.RescuingHuman&&lastHuman!=null&&agent.canSee(lastHuman.getID()))	
			if(lastHuman.getBuriedness()==0){
				if(shouldLoadRescuedCivilian(lastHuman)){
					currentHuman=lastHuman;
					currentState= State.LoadingHuman;
		           removeTargetHuman(currentHuman.getID());
		           return;
				}else{
					 removeTargetHuman();   
				}
			}
		
//		else{
//		//if(agent.getID().getValue()==614183319)
//		//System.out.println(agent.getID()+"  111111111111111111    time  "+agent.getTimeStep());
//		Human human1 = getHumanToLoad();                       //wan
//		if (human1 != null) {
//			if(agent.getID().getValue()==614183319)
//			System.out.println(agent.getID()+"  getHumanToLoad    time  "+agent.getTimeStep()+"   humanID   "+human1.getID());
//				if (shouldLoadRescuedCivilian(human1)) {
//					if(agent.getID().getValue()==614183319)
//					System.out.println(agent.getID()+" shouldLoadRescuedCivilian    time  "+agent.getTimeStep()+"   humanID   "+human1.getID());
//					currentHuman = human1;
//					currentState= State.LoadingHuman;
//					removeTargetHuman(human1.getID());
//					return;
//				}else{  
//				//if(agent.getID().getValue()==614183319)
//			       //    System.out.println(agent.getID()+" cant  shouldLoadRescuedCivilian    time  "+agent.getTimeStep()+"   humanID   "+human1.getID());                             
//				if(currentHuman!=null&&human1.getID().equals(currentHuman.getID())) 
//				   removeTargetHuman();   
//				}
//					
//	
//		}
//		}
		
		Human  human = loadingHuman(world.me);       
			if (human != null) {
				if(allRefuges.size()==0&&agent.location()instanceof Road){      
					currentHuman = null;
					currentState= State.UnloadingHuman;
					return;
				} 
				 if(agent.location()instanceof Road&&human.isHPDefined()&&human.getHP()>=10000)
				 { 
					
					 currentHuman = null;
				    currentState=State.UnloadingHuman;
				   return ;
					 
				 }
				if ((!world.isNoRadio())&&human.isHPDefined()&&human.getHP() == 0){///////////////////////////
						 currentHuman = null;
						 currentState=State.UnloadingHuman;
						return ;
					}
				
//				if(agent.isBlocked()||agent.isStuck(agent.getMeAsHuman())){
//					currentHuman = null;
//					currentState= State.UnloadingHuman;
//					return;
//					
//				}
						
				if (agent.isInRefuge()) {
					currentHuman = null;
					currentState= State.UnloadingHuman;
					return;
				} else {
					currentHuman = human;
					currentState= State.MovingToRefuge;
					return;
				}
				
			}

			
			Human  human2 = getHumanToRescue(); ////wan
			if (human2 != null) {
				currentHuman = human2;
				currentState= State.RescuingHuman;
				return;
			}
	
		if (!currentHumans.isEmpty()){
			currentHuman =  getTargetHuman();
			if(currentHuman!=null){
				//System.out.println(agent.getID()+"   .MovingToHuman    time   "+agent.getTimeStep()+"   humanid  "+currentHuman.getID());
				currentState = State.MovingToHuman;
				return ;
			}
		}
		//////////////////////////////////////////////////////////////
	   if(searchManage .isBuildingForSearchEmpty())
		   searchManage.update(agent.getChangeSet());
		if (!searchManage .isBuildingForSearchEmpty()){
			currentState = State.Exploring;
			return ;
		}
		//////////////////////搜完了，远距离救人
//	    if(!urgentHumans.isEmpty()){
//			
//			currentHuman =  getNearestTask();
//			if(currentHuman!=null){
//		  System.out.println(agent.getID()+"   urgentHumans   time   "+agent.getTimeStep()+"   humanid  "+currentHuman.getID());
//				currentState = State.MovingToHuman;
//				return ;
//			}
//		
//		}
		
		

		currentState = State.RescueOver;
		return;
	}
	public boolean shoulLoadHuman(List<EntityID> humans){////humans
		if(humans.isEmpty())  return false;
		List<EntityID>healthyATsInBuilding=new ArrayList<EntityID>(world.getVisualHealthyATs());
		if(!healthyATsInBuilding.contains(agent.getID()))
			healthyATsInBuilding.add(agent.getID());
		Collections.sort(humans , new EntityIdComparator());
		Collections.sort(healthyATsInBuilding, new EntityIdComparator());
		 for(int i=0;i<humans.size();i++){
			 if(healthyATsInBuilding.size()<i) break;
			 
			if(healthyATsInBuilding.get(i).equals(agent.getID())) {
			 Human human=(Human) world.getEntity(humans.get(i));
			  currentHuman=human;
			} 
		 }
		
	  return false;	
	}
 
public boolean shouldExecute() {
	//System.out.println(agent.getID()+" shouldExecute1111111111   time    "+agent.getTimeStep());
 
		
 //searchManage.update(changeSet);
//	update(changeSet);
	getExpectedState();
	if(currentState==State.MovingToHuman){
		StandardEntity position = currentHuman.getPosition(world);
		  path = agent.router.getAStar(agent.getMeAsHuman(), 
				(Area) position, 
				agent.router.getAtCostFunction(searchManage.getMinStaticCost()));
		if (path.size() > 1)
			nextArea = path.get(1);
	 return true;
   }
	if(currentState==State.SavingMyself){
		if(!allRefuges.isEmpty()){
	    path = agent.router.getMultiDest(agent.location(), 
			world.getEntitiesOfType(StandardEntityURN.REFUGE), 
			agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
			new Point(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY()));
	   if (path.size() > 1)
		nextArea = path.get(1);
		}else{///////////////////走到房屋门口
		    Area position=(Area) agent.getMeAsHuman().getPosition(world);
			  if(position instanceof Building&&world.getAllRefuges().isEmpty()&&agent.getMeAsHuman().getBuriedness()==0///////////// 没有refuge时，被救后跑出来
					  &&(agent.getTimeStep()>10&&agent.locationHistory.get(agent.getTimeStep()).equals(agent.locationHistory.get(10)))){
				  Building building=(Building) position;
				  List<Road> entrance=world.getEntrance(building);
				  path = agent.router.getMultiDest(agent.location(), entrance, 
							agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
							new Point(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY()));
		
				      if (path.size() > 1)
						nextArea = path.get(1);
			  }
		}
	   
	   return true;
	}
	if(currentState==State.MovingToRefuge){

		if (!world.getEntitiesOfType(StandardEntityURN.REFUGE).isEmpty()){
		   path = agent.router.getMultiDest(agent.location(), 
					world.getEntitiesOfType(StandardEntityURN.REFUGE), 
					agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
					new Point(agent.getMeAsHuman().getX(), agent.getMeAsHuman().getY()));
			if (path.size() > 1)
				nextArea = path.get(1);

			return true;
		}
		else {
			List<Road> roads = world.getEntrance((Building)world.me.getPosition(world));
			  path = agent.router.getMultiDest(agent.location(), 
					roads, 
					agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
					new Point(agent.getMeAsHuman().getX(), agent.getMeAsHuman().getY()));
			if (path.size() > 1)
				nextArea = path.get(1);
			    return true;
		}
	}
	
	
	if(currentState==State.Exploring){
		
	 path = agent.router.getMultiDest(agent.location(), 
				searchManage.getSearchingDestination(), 
				agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
				new Point(agent.getMeAsHuman().getX(), agent.getMeAsHuman().getY()));
		if (path.size() > 1)
			nextArea = path.get(1);
	    return true;
		  
	}
	
	
	if(currentState==State.RescueOver){
		if (!world.getEntitiesOfType(StandardEntityURN.REFUGE).isEmpty()){
			if (agent.getMeAsHuman().getPosition(world).getURN().equals(StandardEntityURN.REFUGE.toString()))
			    {
				return false;
			    }else {
				 path = agent.router.getMultiDest(agent.location(), 
						world.getEntitiesOfType(StandardEntityURN.REFUGE), 
						agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
						new Point(agent.getMeAsHuman().getX(), agent.getMeAsHuman().getY()));
				if (path.size() > 1)
					nextArea = path.get(1);
				 return true;
			}
		}
		else{
			if (agent.getMeAsHuman().getPosition(world).getURN().equals(StandardEntityURN.ROAD.toString()))
				 return false;
			else{
				List<Road> roads = world.getEntrance((Building)world.me.getPosition(world));
			   path = agent.router.getMultiDest(agent.location(), 
						roads, 
						agent.router.getAtCostFunction(searchManage.getMinStaticCost()) , 
						new Point(agent.getMeAsHuman().getX(), agent.getMeAsHuman().getY()));
				if (path.size() > 1)
					nextArea = path.get(1);
				 return true;
			}
		}
	}
	
	
	if(currentState==State.UnloadingHuman||currentState==State.LoadingHuman) 
		return true;
	
	  return true;
 
}

public void execute() throws ActionCommandException {

	if(currentState==State.SavingMyself){
		agent.sendMove(path);
		
	}
	if(currentState==State.MovingToRefuge){
		agent.sendMove(path);
		
	}
	if(currentState==State.LoadingHuman){	 
		
		agent.load(currentHuman.getID());
	}
	
	if(currentState==State.UnloadingHuman){
		agent.unload();
	}
	if(currentState==State.RescuingHuman){
		//agent.getBuriedHumans().addRescuingHuman(currentHuman.getID());
		agent.getBuriedHumans().addRescuedHuman(currentHuman.getID());
		agent.rescue(currentHuman.getID());
	}
	if(currentState==State.Exploring){
		agent.sendMove(path);
	}
	if(currentState==State.MovingToHuman){
		agent.sendMove(path);
	}	 
	if(currentState==State.RescueOver){
		agent.sendMove(path);
	}	
 	}

private Human getHumanToRescue() {          //选择要救助的受伤最小的人
	List<EntityID> humansAround=new ArrayList<EntityID>(world.getVisualBuriedHuman());
	List<Human> humans;
	humans = new ArrayList<Human>();
	//System.out.println(agent.getID()+"  world.getVisualBuriedHuman().size   "+world.getVisualBuriedHuman().size()+"    timeStep   "+agent.getTimeStep());
	//System.out.println(agent.getID()+"  humansAround.size   "+humansAround.size()+"    timeStep   "+agent.getTimeStep());
	if(!humansAround.isEmpty()){
	for (EntityID humanid : humansAround) {
		Human human=(Human) world.getEntity(humanid);
				
		if (human.isPositionDefined()) {
			EntityID positionId;
			StandardEntity position;

			positionId = human.getPosition();
			position = world.getEntity(positionId);
			if (position instanceof Building||position instanceof Road) { // wan 14.02.20
				if (positionId.equals(agent.getMeAsHuman().getPosition())) {
					if (!(position instanceof Refuge)) { 
							if (human.getBuriedness() > 0) {
								if (human.isHPDefined()) {                  
									if (human.isBuriednessDefined()) {
									if (human.getHP() > 0) {
											if (agent.canSee(human.getID())) {
												if(position instanceof Building){
													Building building =(Building) position;
													if((building.isFierynessDefined()&&(
															building.getFieryness()==2||
															building.getFieryness()==3||
															building.getFieryness()==1))||
															(building.isTemperatureDefined()&&
																	building.getTemperature()>40)){
														
													continue;
													
												}
												}
													
											 humans.add(human);
										}else {
											removeTargetHuman(human.getID());
										}
									} else {

									}
								} else {
								}
							} else {
							}
						} else {
						}
					} else {
					}
				} else {
				}
			} else {
			}
		}
     
	}
	}
		
	if (humans.isEmpty()) {
		return null;
	} else {
		BuriedHumanComparator comparator;
		comparator = new BuriedHumanComparator();     

		Collections.sort(humans, comparator);
		return humans.get(0);
	}
}

private Human getHumanToLoad() {      //得到要装载的人类包括市民
	if(agent.getID().getValue()==614183319)
		System.out.println(agent.getID()+" getHumanToLoad00000000 "+"     time    "+agent.getTimeStep());
	List<EntityID> humanIDs=new ArrayList<EntityID>(world.getVisibleHumansToLoad());
	
	 humanIDs.remove(agent.getID());///////////////////////////////////////////
	if(agent.getID().getValue()==614183319)
		System.out.println(agent.getID()+" getHumanToLoad11111111    "+ humanIDs+"     time    "+agent.getTimeStep());
	for (EntityID humanid : humanIDs) {
		Human human=(Human) world.getEntity(humanid);
		if(human.getStandardURN()==StandardEntityURN.CIVILIAN){
		if (human.isPositionDefined()) {
			EntityID positionId;
			StandardEntity position;

			positionId = human.getPosition();
			position = world.getEntity(positionId);
			if (!(position instanceof Refuge)) {
				if (positionId.equals(agent.getMeAsHuman().getPosition())) {
					if (position instanceof Building||position instanceof Road) {        /// wan 
						return human;
					}
				}
			}
		}
	}
	}
	return null;
}



public boolean shouldLoadRescuedCivilian(Human human){           ////重新定义、
	
	if(allRefuges.size()==0&&agent.location()instanceof Road){        //wan
		return false;
	} 
	 if(agent.location()instanceof Road&&human.isHPDefined()&&human.getHP()>=10000)
	 { 
		 return false;
	 }
	 if (human.isHPDefined()&&human.getHP() == 0){
		 return false;
		}
//	if(agent.isBlocked()||agent.isStuck(agent.getMeAsHuman())){////////////
//		return false;
//			}
	 
//	 if(agent.getTimeStep()<100){
//	if ( humanManege.getDeathTime(human)<= 2){
//			 return false;
//		}
//	if (humanManege.getDeathTime(human)<=  getTimeToRefuge(human.getID())){
//			 return false;
//		}  
//	 }
	List<EntityID> EntityIDs=new ArrayList<EntityID>(world.getVisualHealthyATs()); 
	if(agent.getMeAsHuman().getBuriedness()<=0)
	{
		EntityIDs.remove(agent.getID());
		EntityIDs.add(agent.getID());/////把自己添加进去
		
	}
	
	//System.out.println(agent.getID()+"etVisualHealthyATs    " +EntityIDs.size()+"  time    "+agent.getTimeStep());
	Collections.sort(EntityIDs,	new EntityIdComparator( )); ///////////////wan
	
	
	if (! agent.freezer.containStuff(Freeze_Tab.LOADINGAT , EntityIDs.get(0)))
		 agent.freezer.addNewfreezingStuff(Freeze_Tab.LOADINGAT , EntityIDs.get(0) , getTimeToRefuge(human.getID()));
	
	if(agent.getID().getValue()==EntityIDs.get(0).getValue())
		return true;///////////////wan
	return false;
}

public void removeTargetHuman(){
	deleteHumans.add(currentHuman.getID());
	allHumans.remove(currentHuman.getID());
	easyHumans.remove(currentHuman.getID());
	urgentHumans.remove(currentHuman.getID());
	currentHumans.remove(currentHuman.getID());
	//currentHuman = null;
}
public void removeTargetHuman(EntityID id){
	allHumans.remove(id);
	currentHumans.remove(id);
	easyHumans.remove(id);
	urgentHumans.remove(id);
	deleteHumans.add(id);
}	
  public Human getNearestTask() {
		 Human target=null;
		for (EntityID sh : urgentHumans) {
		Human human=(Human) world.getEntity(sh);

		StandardEntity position=world.getEntity(human.getPosition());
				 double minValue = Double.MAX_VALUE;
	 
		if (world.getDistance(agent.getID(),position.getID() ) < minValue) {

		       minValue = world.getDistance(agent.getID(), position.getID() );
		        target =human;
		       }          
		}
		return target;
	}
  public boolean shouldHelpingRescuing(Human human){
	    Area pos = (Area)human.getPosition(world);
	    int distanceFromCenterToTarget = world.getDistance(pos , currentClusterCenter);
		int distanceToTarget = world.getDistance(pos , agent.getMeAsHuman());

		if (distanceFromCenterToTarget <= 1.0 * Clustering.MAX_RADIUS||distanceFromCenterToTarget<rescueRange){
			return true;
		}
		if (distanceFromCenterToTarget <= 2.5 * Clustering.MAX_RADIUS &&  distanceToTarget <= 1.5 * Clustering.MAX_RADIUS){
			return true;
		}
		if (distanceToTarget <= 1.0 * Clustering.MAX_RADIUS||distanceToTarget<rescueRange){
			return true;
		}
		return false;
  }
  
	private void initializeRescueRange() {
	 
        if (world.isMapSmall()) {
            rescueRange =  world.getConfig().viewDistance * 2;
        } else if (world.isMapMedium()) {
            rescueRange =world.getConfig().viewDistance* 4;
        } else { //if map is huge
            rescueRange = world.getConfig().viewDistance * 6;
        }
	 
    }
	private class BuriedHumanSorter implements Comparator<EntityID>{

		@Override
		public int compare(EntityID humanID1, EntityID humanID2) {
			final int label1 = getFirst(humanID1);
			final int label2 = getFirst(humanID2);
			final int freeTime1 = divide(freeTime(humanID1) , 5);
			final int freeTime2 = divide(freeTime(humanID1) , 5); 
			final int rescueTime1 = divide(rescueTime(humanID1) , 5);
			final int rescueTime2 = divide(rescueTime(humanID2) , 5);
			
			if(label1 > label1)
				return -1;
			else if (label1 < label2)
				return 1;
			else if (freeTime1 < freeTime2)
				return -1;
			else if (freeTime1 > freeTime2)
				return 1;
			else if (rescueTime1 < rescueTime2)
				return -1;
			else if (rescueTime1 > rescueTime2)
				return 1;
			return 0;
		}
		
 
		public int getFirst(EntityID humanID){
			Human human = (Human)world.getEntity(humanID);
				if(human.getURN().equals(StandardEntityURN.AMBULANCE_TEAM.toString()))
				 return 4;
			else if(human.getURN().equals(StandardEntityURN.FIRE_BRIGADE.toString()))
				 return 3;
			else if(human.getURN().equals(StandardEntityURN.POLICE_FORCE.toString()))
				 return 2;
			else 
				 return 1;
		}
	}
	
	 public int getDeathTime(Human human){
	    	if(human.isDamageDefined()&&human.isHPDefined()){
	    		if(human.getDamage()==0) human.setDamage(1);
	    		return (int) (human.getHP()/human.getDamage()*0.8);
	    	}
	    	 else return -1;
	    
	    	
	    }

}
