package seu.agent.fb;

import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.fb.FireBrigadestools.FbUtilities;
//import seu.agent.fb.FireBrigadestools.MRLCluster;
import seu.agent.fb.FireBrigadestools.fireDirectionManager;
import seu.agent.fb.FireBrigadestools.fbTarget.FBTarget;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.MRLCluster;
//import seu.agent.fb.actionStrategy.DefaultFbActionStrategy;

import seu.agent.fb.extinguishtasks.extinguishtask;
import seu.agent.pf.Tasks.PFTarget;
import seu.agent.pf.Tasks.PFTaskRank;
import seu.agent.pf.Tasks.SEUPFTargetType;
import seu.agent.pf.cluster.Cluster;
import seu.agent.pf.cluster.Clustering;
import seu.common.TimeOutException;
import seu.common.clustering.FireCluster;
import seu.common.clustering.NormalBuildingCluster;
import seu.geom.CompositeConvexHull;
import seu.geom.Distance;
import seu.model.AgentConstants;
import seu.model.SEUWorldModel;
import seu.model.object.SEUBuilding;
import seu.model.object.SEURoad;
import seu.model.route.pov.POVRouter;
import seu.standard.DistanceComparator;
import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.AmbulanceCentre;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.FireStation;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Hydrant;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.PoliceOffice;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;

import java.util.Collection;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Hydrant;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.worldmodel.EntityID;

public class FireBrigadeAgent extends AbstractFireBrigadeAgent {
	
	
	private fireDirectionManager directionManager;
	private FbUtilities fbUtil;
	
	private extinguishtask ex;
	
	private Set<Hydrant>latelyFailedHydrant;
	//private Hydrant lastFailHydrant;//niu
	 int maxPower ;
	 int maxTankCapacity ;
	 int capacity ;
	 int refillRate ;
	 int currentWater ;
	 double REFUGE_COEFFICIENT = 0.1;
	 double GAS_STATION_COEFFICIENT = 0.05;
	 Building assignedBuilding;
	 public SEUBuilding target=null;
	public SEUBuilding lastTarget=null;
	public int targettime=0; 
	
	
//partion 	 
	 public Set<EntityID> buildingsInMyPartition=new HashSet<EntityID>();//unsearched buildings
	 public Cluster currentPartition;
	 public List<Cluster> fbPartitions;
	 public int currentPartitionIndex;
	 protected Clustering fbPartitionModel;
	 public int assignedPartitionIndex;
	 public boolean firsttimeextinguish=true;
	 public Collection<StandardEntity> refuges; //available
	 public Set<StandardEntity> forbiddenRefuges=new HashSet<StandardEntity>();
	 public StandardEntity importantrefuge;
	@Override
	protected void initialize() {
		super.initialize();
		this.directionManager = new fireDirectionManager(world);
		this.fbUtil = new FbUtilities(world);
		refuges = world.getEntitiesOfType(StandardEntityURN.REFUGE);
		 maxPower = world.getConfig().maxPower;
		 maxTankCapacity = world.getConfig().maxTankCapacity;
		capacity = (maxTankCapacity > maxPower) ? maxTankCapacity : maxPower;
		 refillRate = world.getConfig().tankRefillRate;
		  assignPartitionToFB();
		 fbPartitionModel=(Clustering)world.getPartitionModel();
		 currentPartition = fbPartitions.get(assignedPartitionIndex);
		//lastFailHydrant=null;
		latelyFailedHydrant=new LinkedHashSet<Hydrant>(3);
		 for(SEUBuilding next:currentPartition.getBuildingList()){
				buildingsInMyPartition.add(next.getId());
			}
			System.out.println(toString()  +"  "+ getID()+ "was connected.  ");

	}

	
	 protected void assignPartitionToFB() {
			Collection<StandardEntity> allFB = world.getEntitiesOfType(StandardEntityURN.FIRE_BRIGADE);
			fbPartitions = fbPartitionModel.KMeansPlusPlus(allFB.size(), world.getZones());
			fbPartitionModel.assignAgentsToClusters(allFB, fbPartitions, world);
			assignedPartitionIndex = fbPartitionModel.getClusterIndexAgentBelongTo(getID(), fbPartitions);
			currentPartitionIndex = assignedPartitionIndex;	
			
		}
	 
	@Override
	protected void BeforeAct() throws TimeOutException {
		super.BeforeAct();
		ex=new extinguishtask((FireBrigadeWorld) world, directionManager, fbUtil);
		 currentWater = me().getWater();
	}
	
	@Override
	protected void act() throws ActionCommandException, TimeOutException {
		
		this.leaveBurningBuilding();
		
		if (isBlocked()) {
			ex.extinguishNearbyWhenStuck();
			randomWalk();
		}
		super.act();
		this.careSelf();
		//this.supplyWater();
	    refillWater();
		//preWater();
	    
//	    if(! ((FireBrigadeWorld)world).finishRetreat && ((FireBrigadeWorld)world).isMapUncontrollable()){//niu 5.23 2015
//	    	//((FireBrigadeWorld)world).getNormalBuildingCluster().findLaegestCluster();
//	    	NormalBuildingCluster largest=getLargestNormalCluster();
//	    	
//	    	if(largest.getConvexHull().getConvexPolygon().contains
//	    			(world.me.getLocation(world).first(),world.me.getLocation(world).second())){
//	    		System.out.println(world.me + "  Time : " + world.getTime() + "  finish retreat " );
//	    		 ((FireBrigadeWorld)world).finishRetreat=true;
//	    	}
//	    	move(largest.getBorderEntities());
//	    	
//	    }else{
		
	     ex.execute();
//	    }
	     
		isThinkTimeOver("after excute");
	    //ex.moveToFires();//need?	
//		if (world.getTime() < Math.min(80, world.getConfig().timestep / 3)
//				|| world.getConfig().timestep - 45 < world.getTime()) {
//			lookupSearchBuildings();
//		}
		
			
			if(world.getTime() < Math.min(80, world.getConfig().timestep / 3)
					|| world.getConfig().timestep - 45 < world.getTime()){
		searchInPartition();
			}
		enterSearchBuildings();
		
		
		randomWalk();
		
	}
	

	
	private void leaveBurningBuilding() throws ActionCommandException{
		StandardEntity entity;
		if (location() instanceof Building && !(location() instanceof Refuge)) {
			Building building = (Building) location();
			if ((building.isFierynessDefined() && building.isOnFire())
					|| ((building.isFierynessDefined() && building.getFieryness() != 8
							&& building.isTemperatureDefined() && building.getTemperature() > 35))) {
				
				
				building.getNeighbours();
				for (EntityID next : building.getNeighbours()) {
					entity = world.getEntity(next);
					if (entity instanceof Building) {
						unlookupedBuildings.remove(entity);
						unenteredBuildings.remove(entity);
					}
				}
				moveToRefuge();
			}
		} else if (location() instanceof Refuge) {
			for (EntityID next : location().getNeighbours()) {
				StandardEntity neig = world.getEntity(next);
				if (neig instanceof Building) {
					Building n_bu = (Building) neig;
					if (n_bu.isFierynessDefined() && n_bu.isTemperatureDefined())
						if (n_bu.getFieryness() != 8 && n_bu.getTemperature() > 35) {
							extinguish(n_bu);
						}
				}
			}
		}
	}
	
	@Override
	protected void careSelf() throws ActionCommandException {
		if (me().getHP() - me().getDamage() * (timestep - timeStep) < 0) {
			

			moveToRefuge();
		}
	}
	
	private void supplyWater() throws ActionCommandException {
		if (!world.getEntitiesOfType(StandardEntityURN.REFUGE).isEmpty())
			supplyWaterInRefuge();
		else if (!world.getEntitiesOfType(StandardEntityURN.HYDRANT).isEmpty())
			supplyWaterInHydrant();
		else
			return;
	}
	
	private void supplyWaterInRefuge() throws ActionCommandException {
		final int maxPower = world.getConfig().maxPower;
		final int maxTankCapacity = world.getConfig().maxTankCapacity;
		final int capacity = (maxTankCapacity > maxPower) ? maxTankCapacity : maxPower;
		final int refillRate = world.getConfig().tankRefillRate;
		final int currentWater = me().getWater();

		if (me().getWater() >= capacity) {
			return;
		}
		
		if (location() instanceof Refuge) {
			if (currentWater + refillRate > capacity) {
				return;
			}
			sendRest();
		}

		if (currentWater <= maxPower / 2.0) {
			
			
			moveToRefuge();
		}
	}
	
	private void supplyWaterInHydrant() throws ActionCommandException {
		final int maxPower = world.getConfig().maxPower;
		final int maxTankCapacity = world.getConfig().maxTankCapacity;
		final int capacity = maxTankCapacity > maxPower ? maxTankCapacity : maxPower;
		final int refillRate = world.getConfig().tankRefillRate;
		final int currentWater = me().getWater();
		
		if (me().getWater() >= capacity) {
			return;
		}
		
		if (location() instanceof Hydrant) {
			if (currentWater + refillRate > capacity) {
				return;
			}
			sendRest();
		}
		
		if (currentWater <= 0) {
			
			
			moveToHydrant();
		}
	}
	
	private void moveToHydrant() throws ActionCommandException {
		Collection<StandardEntity> hydrants = world.getEntitiesOfType(StandardEntityURN.HYDRANT);
		
		for (FireBrigade fb : world.getFireBrigadeList()) {
			if (fb.getID().getValue() == me().getID().getValue())
				continue;
			if (!fb.isPositionDefined())
				continue;
			StandardEntity fbPosition = fb.getPosition(world);
			if (fbPosition instanceof Hydrant)
				hydrants.remove((Hydrant)fbPosition);
		}
		if(getlatelyFailedHydrant()!=null)
			hydrants.removeAll(getlatelyFailedHydrant());
		if (hydrants.isEmpty())
			return;
		move(hydrants);
	}
	
	public void moveToHydrant(Hydrant h) throws ActionCommandException {
		//System.out.print("??????????????????MovingToHydrant");
		move(h);
	}
	@Override
	protected void cantMove() throws ActionCommandException, TimeOutException {
	}
	
	@Override
	protected StandardWorldModel createWorldModel() {
		return new FireBrigadeWorld();
	}
	
	public void preWater() throws ActionCommandException, TimeOutException{
		for(EntityID eid:getVisibleEntities()){
			StandardEntity st=world.getEntity(eid);
			if(st instanceof Building){
				Building b=(Building)st;
				
				if(b instanceof GasStation &&  b.isFierynessDefined() && b.getFieryness()==0
						&& b.getFieryness()!=4){
					
					SEUBuilding target = world.getSeuBuilding(b);
				//	System.out.println("prewater gasstation" + b.getFieryness());				
						if( world.getDistance(target.getId(), getID())<world.getConfig().extinguishableDistance){
						//this.waterPower = agent.calculateWaterPower(target); 
					//	System.out.println("prewater gasstation  500" );	
						//target.setWaterQuantity(target.getWaterQuantity() +500);
						//extinguishTargetAndTimeMap.put(world.getTime(), target);
						extinguish(target.getId(), 500);
						}
					
				}
				if(b instanceof Refuge || b instanceof PoliceOffice
						|| b instanceof FireStation || b instanceof AmbulanceCentre)
					continue;	
				
				
					if( ( world.isMapSmall() && b.getTotalArea()>1500)
							||(world.isMapMedium() && b.getTotalArea()>3000)
							|| (world.isMapHuge() && b.getTotalArea()>4000)
							||(b.getTotalArea()>1500 && b.isTemperatureDefined() && b.getTemperature()>25)
							){//||((world.isCommunicationLess() || ((FireBrigadeWorld)world).isMapUncontrollable())&& b.isTemperatureDefined() && b.getTemperature()>25)
		       
						if( (b.isFierynessDefined() && b.getFieryness()==0)){
						//	System.out.println("prewater large buildings" + b.getTotalArea());
							SEUBuilding target = world.getSeuBuilding(b);
							
							if( world.getDistance(target.getId(), getID())<world.getConfig().extinguishableDistance){
							//this.waterPower = agent.calculateWaterPower(target); 
							//target.setWaterQuantity(target.getWaterQuantity() +500);
							//extinguishTargetAndTimeMap.put(world.getTime(), target);
							extinguish(target.getId(), 500);
							}
							
						}
					}		
					


			}
			}
	}

	
	
	public void refillWater() throws ActionCommandException {
		
		if (location() instanceof Refuge ) {
			if(shouldStayInRefuge()){
			sendRest();
			}else {
				return;
			}
		}else if (location() instanceof Hydrant ) {//niu
			if( shouldStayAtHydrant((Hydrant)(location()))){//visible fb is empty
			//System.out.println("!!!!!!!!!!!!!!!!stay at Hydrant");
				sendRest();
			}else if(currentWater <= maxPower / 2.0) {
				if( !world.getAllRefuges().isEmpty()){
				moveToRefuge();
				}else{
					moveToHydrant();
				}
			}else {
				return;
			}
		}else if (currentWater <= maxPower / 2.0 ) {
			
				if(world.getEntitiesOfType(StandardEntityURN.REFUGE).isEmpty() ){
					//System.out.print("MovingToHydrant");
					moveToHydrant(); 
				}if(world.getEntitiesOfType(StandardEntityURN.HYDRANT).isEmpty()){
					
					moveToRefuge();
				}else{
					//System.out.println("!!!!!!choose Hydrant");
					double r=world.getMinDistanceToRefuge(getID());
					Hydrant h=getNearestHydrant();
					int hdis=world.getDistance(h.getID(), getID());
					if(r>world.getMapDiameter()/3 && r/hdis>2 ){
						//moveToHydrant(h);
						moveToHydrant(); 
					}else{
						//System.out.println("!!!!!!!!!!!!!!!!!MovingToHydrant");
						
						moveToRefuge();
					}
							
				}
			
		} else {
			return;
		}
	
}	
	public boolean shouldStayInRefuge() {//niu
		//if(  world.getTime()>120){//((FireBrigadeWorld)world).isMapUncontrollable()
			
			StandardEntity re=location();
			if(forbiddenRefuges!=null && !refuges.isEmpty() && forbiddenRefuges.contains(re)){
				return false;
			}
			
		
			if(shouldremoverefuge( re)){
//				System.out.println("In time: " + timeStep + ", agent: " + me() 
//						+ " remove refuge when in refuge" + re);
				if(re!=null & refuges.size()>1){
//					System.out.println("In time: " + timeStep + ", agent: " + me() 
//					+ " remove refuge when in refuge" + re);
					forbiddenRefuges.add(re);
					refuges.remove(re);
				}
				if(!refuges.isEmpty())
				return false;
			}
		//}
		
		
		int fbCount=0;
		
		
		    for (StandardEntity standardEntity : world.getFireBrigades()) {
		        FireBrigade fb = (FireBrigade) standardEntity;
		        if (world.isVisible(fb.getID())
		        		&& fb.isPositionDefined()
		        		&& fb.getPosition().equals(me().getPosition())) {
		            fbCount++;
		        }
		    }
	
   int requiredWater = (capacity + refillRate) - (fbCount * refillRate);
   if(requiredWater< capacity * 2 / 3){
    requiredWater = capacity * 2 / 3;
   }
   if(requiredWater>capacity){
	   requiredWater = capacity;
   }
   //System.out.println (me() + "  "  + world.getTime() + " requiredWater "+ requiredWater + " capacity " + capacity );
    if (me().getWater() < requiredWater) {
        
        return true;
    }else{
    	 return false;
    }
}

public boolean shouldStayAtHydrant(Hydrant hydrant) {
	if(me().getWater()<capacity/3 ){
		
		List<EntityID>fbs=world.getVisualFBs();	
//		List<Building>burningBuildings=world.getVisualBurnOutBuildings();
//		if(!burningBuildings.isEmpty()) {
//			//setlastHydrant(hydrant);
//			if(getlatelyFailedHydrant().size()==3){
//				getlatelyFailedHydrant().remove(0);
//			getlatelyFailedHydrant().add(hydrant);
//			}else{
//				getlatelyFailedHydrant().add(hydrant);
//			}
//			return false;
//		}	
		
		if(fbs.isEmpty()){
		return true;
		}else{
			
			for(EntityID f1:fbs){
				if( f1.getValue()<me().getID().getValue()){
					if(getlatelyFailedHydrant().size()==3){
						getlatelyFailedHydrant().remove(0);
					getlatelyFailedHydrant().add(hydrant);
					}else{
						getlatelyFailedHydrant().add(hydrant);
					}
					//setlastHydrant(hydrant);
					
					return false;
					
				}
			}
			return true;
		}
		
	}else{
		
		return false;
	}
}
public Hydrant getNearestHydrant() {//niu
	
	
	Collection<StandardEntity>result=world.getAllHydrants();
	result.removeAll(getlatelyFailedHydrant());
	Hydrant targetHydrant=null;
	//Collections.sort(result, new DistanceComparator(location(), world));
//	for (StandardEntity h : result) {
//		
//		
//		if (canfillinhydrant((Hydrant)h) 
//				
//				&& !getMeAsHuman().getPosition(world).equals(h)) {
//			//dis = temp;
//			
//			targetHydrant =(Hydrant) h;
//			break;
//		
//		}
//	   // }
//	}
	for (FireBrigade fb : world.getFireBrigadeList()) {
		if (fb.getID().getValue() == me().getID().getValue())
			continue;
		if (!fb.isPositionDefined())
			continue;
		StandardEntity fbPosition = fb.getPosition(world);
		if (fbPosition instanceof Hydrant)
			result.remove((Hydrant)fbPosition);
	}
	double dis=Double.MAX_VALUE;
	if(result!=null){
		for(StandardEntity h:result){
			if(world.getDistance(getID(), h.getID())<dis){
				dis=world.getDistance(getID(), h.getID());
				targetHydrant=(Hydrant)h;
			}
		}
	}
	//System.out.println("TARGET  "+target.getID());
	//HydrantInUseMessage hydrantInUseMessage = new HydrantInUseMessage(
	//		target.getID(),timeStep);
	//sendMessage(hydrantInUseMessage,MessagePriority.High);
	//System.out.println("sendHydrantinUseMessage"+target.getID() );
	
	return targetHydrant;
}

//public Hydrant getlastHydrant() {
//	return lastFailHydrant;
//}
//public Hydrant setlastHydrant(Hydrant hydrant) {
//	lastFailHydrant=hydrant;
//	return lastFailHydrant;
//}

public Set<Hydrant>getlatelyFailedHydrant() {
	return latelyFailedHydrant;
}


public boolean canfillinhydrant(Hydrant h) {//比较FB的ID
	
	if (h == null || (getlatelyFailedHydrant()!=null && getlatelyFailedHydrant().contains(h))) {
//		if(getlastHydrant()!=null && h.equals(getlastHydrant())){
//			System.out.println(getID()+"lastfailhydrant"+getlastHydrant());
//		}
		return false;
	}
	
	List<EntityID> entities=h.getNeighbours();
//	
//	List<Building> ebuildings=new ArrayList<Building>();
//	for (EntityID next : entities){
//		StandardEntity e=world.getEntity(next);
//		if(e instanceof Building){
//			Building B=(Building) e;
//			if(((B.isFierynessDefined() && B.getFieryness()<2) ||
//					 B.isFierynessDefined())
//					&& !ebuildings.contains(B)){
//				ebuildings.add(B);
//			}
//		}
//	}
	//if(!ebuildings.isEmpty()){
	try{
		
	for (StandardEntity next : world.getFireBrigades()){
		if(((Human) next).isPositionDefined() && ((Human) next).getPosition(world).equals(h)  
				&& next.getID().getValue()<this.getID().getValue())//wj 
			return false;
				
		}
	}catch(Exception e){}
	return true;
//	}else{
//		return false;
//	}
		
	}

public Building getAssignedBuilding(){
	return assignedBuilding;
}
public  void setAssignedBuilding(Building b){
	assignedBuilding=b;
	
}
public FireCluster findImportantCluster(FireBrigadeWorld world){
	FireCluster target = null;
	List<FireCluster> fcs=world.getFireClusterManager().getClusters();
	if(fcs.isEmpty()) return null;
	@SuppressWarnings("unchecked")
	List<MRLCluster>ccs=world.getClusterManager().getClusters();
	List<Double>Importance=new ArrayList<Double>();
	double max=Double.MIN_VALUE;
	for(FireCluster fc:fcs){
		if ( fc.isDying()) continue;
		double importance=0;
		for(MRLCluster cc: ccs){
			if(cc.getValue()>0){
			Polygon convexPoly = cc.getConvexHullObject().getConvexHullPolygon();	
			double radiusLength = Math.sqrt(Math.pow(convexPoly.getBounds().getHeight(), 2) + Math.pow(convexPoly.getBounds().getWidth(), 2)) / 2;	
			int dis=world.distance(cc.getCenter(),fc.getCenter() )/1000;			
			importance=importance+cc.getValue()*radiusLength-dis;		
			}		
		}
		int disTome=world.distance(fc.getCenter().x,fc.getCenter().y, me().getLocation(world).first(),me().getLocation(world).first())/1000;
		importance=importance-disTome;
		if(importance<=0) importance=0;
		//System.out.println(getID()+"!!!!!!imp!!!!!!!"+importance);
		Importance.add(importance);
	}
	for(int i=0;i<Importance.size();i++ ){
		if(Importance.get(i)>max){
			max=Importance.get(i);
			target=fcs.get(i);
		}
	}
	// System.out.println("important cluster"+target.getId());
	return target;
}


/**
 * Get the nearest location from a list of target location.
 * 
 * @param world
 *            the world model
 * @param locations
 *            a set of target locations
 * @param start
 *            the start point
 * @return the nearest target location
 */
public  EntityID getNearest(SEUWorldModel world, List<EntityID> locations, EntityID start) {
	EntityID result = null;
	double minDistance = Double.MAX_VALUE;
	for (EntityID next : locations) {
		double distance = world.getDistance(start, next);
		if (distance < minDistance) {
			minDistance = distance;
			result = next;
		}
	}
	return result;
}

/**
 * Determines whether a target location is reachable.
 * 
 * @param world
 *            the world model
 * @param router
 *            the router do the path plan tsk
 * @param location
 *            the target location
 * @return true when the target location is reachable. Otherwise, false.
 */
public boolean isReacable(SEUWorldModel world, POVRouter router, EntityID location) {
	
	List<EntityID> path = router.getAStar((Human)world.getMe(), 
			(Area)world.getEntity(location), router.getStrictCostFunction());
	double timeToArrive = router.getRouteCost() / SEUWorldModel.MEAN_VELOCITY_OF_MOVING;
	double euclidDistance = world.getDistance(world.getAgent().getID(), location);
	
	if (path.size() != 0 && timeToArrive < 3 * euclidDistance) {
		return true;
	}
	
	return false;
}

//public NormalBuildingCluster getLargestNormalCluster(){
//	NormalBuildingCluster largestCluster = null;
//		double clusterArea = Double.MIN_VALUE;
//	for(NormalBuildingCluster normalcluster:((FireBrigadeWorld)world).getNormalBuildingCluster().getClusters() ) {
////			int refcount=0;
////			int gascount=0;
////			double area = normalcluster.getBoundingBoxArea();
////			for(EntityID entityid:normalcluster.getAllEntities()){
////				StandardEntity entity=world.getEntity(entityid);
////				if(entity instanceof Refuge)
////					refcount++;
////				if(entity instanceof GasStation
////						&& (world.getSeuBuilding(entityid).getEstimatedFieryness()==0||world.getSeuBuilding(entityid).getEstimatedFieryness()==4))
////					gascount++;
////			}
////			if(refcount!=0)
////				area = area*(1+refcount*0.1);
////			if(gascount!=0)
////				area = area*(1+gascount*0.05);
////			
////			if (area > clusterArea) {
////				clusterArea = area;
////				largestCluster = normalcluster;
////			}
//			
//			double value = 0;
//            int refugeNo = 0;
//            int gasStationNo = 0;
//            for (SEUBuilding building : world.getSeuBuildings()) {
//                if (building.getEstimatedFieryness() == 0 && 
//                		normalcluster.getConvexObject().getConvexHullPolygon().contains(building.getSelfBuilding().getX(), building.getSelfBuilding().getY()) 
//                		) {
//                    if (building.getSelfBuilding() instanceof Refuge) {
////                        value += 1000;
//                        refugeNo++;
//                    } else if (building.getSelfBuilding() instanceof GasStation) {
////                        value += 1000;
//                        gasStationNo++;
//                    } else {
//                        value += building.getSelfBuilding().getTotalArea();
//                    }
//                }
//            }
//
//                value += (refugeNo * REFUGE_COEFFICIENT * value);
//                value += (gasStationNo * GAS_STATION_COEFFICIENT * value);
//           
//            if (clusterArea < value) {
//            	clusterArea = value;
//            	largestCluster = normalcluster;
//            }
//		
//	}
//	return largestCluster;
//}

private void searchInPartition() throws ActionCommandException {

	if(buildingsInMyPartition!=null&&!buildingsInMyPartition.isEmpty()){
		buildingsInMyPartition.removeAll(someoneVisitedArea);
		//buildingsInMyPartition.removeAll(changeSet.getChangedEntities());
		/* Remove all Buildings that is on fire or burnt out.*/
		for (Iterator<EntityID> it = buildingsInMyPartition.iterator(); it.hasNext();) {
			EntityID id = it.next();
			StandardEntity se = world.getEntity(id);
			if (se instanceof Building) {
				Building building = (Building) se;
				if ((building.isFierynessDefined() && building.getFierynessEnum() == Fieryness.BURNT_OUT)
						|| building.isOnFire()) {
					it.remove();
				}
			}
		}
		// if a entrance is blocked, then unsearch all buildings related to this entrance
		for (EntityID next : getChanged()) {
			StandardEntity entity = world.getEntity(next);
			if (!(entity instanceof Road))
				continue;
			SEURoad road = world.getSeuRoad(next);
			
			if (road.isEntrance()) {
				for (Building build : world.getEntrance().getBuilding(road.getSelfRoad())) {
					buildingsInMyPartition.remove(build.getID());
				}
			}
		}
	
		
		
	}
	
	if (!buildingsInMyPartition.isEmpty()) {
		Set<StandardEntity> dest = new HashSet<StandardEntity>(buildingsInMyPartition.size());
		for (EntityID id : buildingsInMyPartition) {
			dest.add(world.getEntity(id));
		}
//		System.out.println("In time: " + timeStep + " Agent: " + me() + " is  search in partion  " + assignedPartitionIndex);


		
		move(dest);
	}
		
}

@Override
protected void moveToRefuge() throws ActionCommandException {
	
	
	
	if (world.getEntitiesOfType(StandardEntityURN.REFUGE).isEmpty()) return;
	
	if( !refuges.isEmpty()){//((FireBrigadeWorld)world).isMapUncontrollable() && world.getTime()>120
		StandardEntity needtoRemoveRefuges = null; 
	for(StandardEntity re:refuges){
		
		if(shouldremoverefuge( re)){
//			System.out.println("In time: " + timeStep + ", agent: " + me() 
//					+ " remove refuge" + re + "refuge size "+world.getEntitiesOfType(StandardEntityURN.REFUGE).size());
		if(re!=null & refuges.size()>1){
	//		System.out.println("In time: " + timeStep + ", agent: " + me() 
	//		+ " remove refuge" + re + "refuge size "+world.getEntitiesOfType(StandardEntityURN.REFUGE).size());
			needtoRemoveRefuges=re;
			forbiddenRefuges.add(re);
			break;
		}
		}
	}
	
	if(needtoRemoveRefuges!=null && refuges.size()>1){//can not remove all refuges
	refuges.remove(needtoRemoveRefuges);//this also remove world.getEntitiesOfType(StandardEntityURN.REFUGE)
	}
	}
		
	
	move(refuges);
	
}

private boolean shouldremoverefuge(StandardEntity re){
	//if( world.getTime()<100){
	if(world.isMapHuge() ){
		return false;
	}
	if(world.isMapMedium() &&  world.getTime()<80){
		return false;
	}
	Collection<StandardEntity> neis=world.getObjectsInRange(re, world.getConfig().viewDistance);
	neis.remove(re);
	int buldingcount=0;
	int burningcount=0;
	for(StandardEntity st :neis){
		
		if(st instanceof Building){
			buldingcount++;
			int fireness=world.getSeuBuilding(st).getEstimatedFieryness();
			if(fireness==1 || fireness==2 || fireness==3 || fireness==8){
				burningcount++;
			}
		}
	}
	
	if(importantrefuge!=null && importantrefuge==re){
		return false;
	}
	if(buldingcount!=0 && (double)(burningcount/buldingcount)>0.8 ){
		
		return true;
	}
	//}
	return false;
}

public  Comparator<Pair<EntityID, Double>> pairComparator = new Comparator<Pair<EntityID, Double>>() {
	/* sorted element in increase order*/
	@Override
	public int compare(Pair<EntityID, Double> o1, Pair<EntityID, Double> o2) {
		double value1 = o1.second();
		double value2 = o2.second();
		if (value1 > value2)
			return 1;
		if (value1 < value2)
			return -1;
		return 0;
	}
};

@Override
public String toString() {
	return "SEU FireBrigade ";
}

}
