package seu.agent.fb.FireBrigadestools.fbTarget;

import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import javolution.util.FastSet;
import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.fb.FireBrigadeAgent;
import seu.agent.fb.FireBrigadeWorld;
import seu.agent.fb.FireBrigadestools.FbUtilities;
import seu.agent.fb.FireBrigadestools.fireDirectionManager;
import seu.common.TimeOutException;
import seu.common.clustering.Cluster;
import seu.common.clustering.FireCluster;
import seu.geom.CompositeConvexHull;
import seu.geom.ConvexObject;
import seu.geom.Distance;
import seu.model.AgentConstants;
import seu.model.object.SEUBuilding;
import seu.model.object.SEURoad;
import seu.model.object.seuZoneEntity.SeuZone;
import seu.model.route.pov.CostFunction;




public class DefultTargetSelector extends targetSelector {
	private static final double MEAN_VELOCITY_DISTANCE = 31445.392;
	protected  FireBrigade me;
	
	public DefultTargetSelector(FireBrigadeWorld world) {
		super(world);
	}

	
	public FBTarget selectTarget(Cluster targetCluster) {
		Pair<Integer, Integer> agentLocation = this.controlledEntity.getLocation(this.world);
		//FireCluster targetCluster = this.world.getFireClusterManager().findNearestCluster(agentLocation);
		FBTarget targetBuilding = null;
		this.lastTarget = this.target;
		this.me = (FireBrigade) world.getMe();
		FireCluster myCluster=null;//niu 14.9.20
		
		if (targetCluster != null) {
			
			if (targetCluster.isDying()) {
				targetBuilding = new FBTarget(targetCluster, null);
			} else {
				/*if (lastTarget != null
						&& targetCluster.getBorderEntities().contains(lastTarget.getSelfBuilding())) {
					targetBuilding = new FireBrigadeTarget(targetCluster, this.lastTarget);
					return targetBuilding;
				}*/
	/*			
//niu  estimate how many fb are needed for the cluster 
				double num=targetCluster.neededAgentsToExtinguish();
				//System.out.println("!!!!!!!!!!!!!!the cluster need  agents"+num);
				//num=Math.ceil(num*1.5);
				 List<EntityID> freeAgents = world.getFreeFireBrigades();
				 int minDistance = Integer.MAX_VALUE;
				 EntityID nearestAgent = null;
			    while (num-- > 0) {
	                for (EntityID agent : freeAgents) {
	                	Pair<Integer, Integer> location=world.getEntity(agent).getLocation(world);
	                	Point position1 = new Point(location.first(), location.second());
	                	Integer dis =(int) Ruler.getDistance(targetCluster.getCenter(), position1);
	                    if (dis != null && dis < minDistance) {
	                        minDistance = dis;
	                        nearestAgent = agent;
	                    }
	                }
	                if (nearestAgent == null) {
	                    break;
	                } else {
	                    
	                    freeAgents.remove(nearestAgent);
	                    minDistance = Integer.MAX_VALUE;
	                    if (nearestAgent.equals(me.getID())) {
	                    	//System.out.println("!!!!!!!!!!!!!!the cluster need this agent"+me.getID());
//	                    	if(agent.getID().getValue()==965801746){
//								System.out.println(world.getTime()+"cluster need me  ");
//								}
	                    	myCluster=targetCluster;
	                    }
	                }
	            }
		*/	    
				
				 
//				targetBuilding = gasStationHander((FireCluster)targetCluster);
//				if (targetBuilding != null) {
//					return targetBuilding;
//				}

				SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings;
				sortedBuildings = this.calculateValue((FireCluster)targetCluster);
				sortedBuildings = fbUtilities.reRankBuildings(sortedBuildings, controlledEntity);

				if (sortedBuildings != null && !sortedBuildings.isEmpty()) {
					if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
						printSortedBuilding(sortedBuildings);
					}
					
					
					this.target = world.getSeuBuilding(sortedBuildings.first().first().first());
					targetBuilding = new FBTarget((FireCluster)targetCluster, this.target);
				}
			}
		} else {
			

		}
		
		return targetBuilding;
	}
	
//	private FBTarget gasStationHander(FireCluster cluster) {
//		Collection<StandardEntity> gasStas = world.getEntitiesOfType(StandardEntityURN.GAS_STATION);
//		Set<SEUBuilding> targetGasStas = new HashSet<SEUBuilding>();
//		
//		Polygon cluster_po = cluster.getConvexObject().getConvexHullPolygon();
//		
//		for (StandardEntity next : gasStas) {
//			GasStation sta = (GasStation) next;
//			
//			if (sta.isFierynessDefined() && sta.getFieryness() >= 1)
//				continue;
//			
//			if  (sta.isTemperatureDefined() && sta.getTemperature() < 25)
//				continue;
//			
//			SEUBuilding seuBu = world.getSeuBuilding(next.getID());
//			if (seuBu.getWaterQuantity() >= 3000)  // two cycles
//				continue;
//			
//			int[] apexs = sta.getApexList();
//			CompositeConvexHull convexHull = new CompositeConvexHull();
//			
//			for (int i = 0; i < apexs.length; i += 2) {
//				convexHull.addPoint(apexs[i], apexs[i + 1]);
//			}
//			
//			Polygon po = convexHull.getConvexPolygon();
//			
//			int dis = (int) Distance.getDistance(cluster_po, po);
//			if (dis <= 5000)
//				targetGasStas.add(world.getSeuBuilding(next.getID()));
//		}
//		
//		if (targetGasStas.contains(lastTarget))
//			return new FBTarget(cluster, lastTarget);
//		
//		SEUBuilding tar = null;
//		double minDistance = Double.MAX_VALUE;
//		for (SEUBuilding next : targetGasStas) {
//			double dis = world.getDistance(next.getId(), controlledEntity.getID());
//			if (dis < minDistance) {
//				minDistance = dis;
//				tar = next;
//			}
//		}
//		
//		if (tar != null) {
//			this.target = tar;
//			return new FBTarget(cluster, tar);
//		} else
//			return null;
//	}
	
//	private void searchZones(SeuZone zone) throws ActionCommandException, TimeOutException {
//		zone.removeVisitedFromUnvisit(lookedBuildings());
//		Set<EntityID> dests = zone.getUnvisitBuildings();
//		if (dests.isEmpty())
//			return;
//		
//		Set<StandardEntity> dest = new HashSet<StandardEntity>(dests.size() * 2);
//		for (EntityID id : dests) {
//			//niu      Buildings in the zone are possibly on fire. when search zones,fbs should 
//			//avoid go into the buildings and got burnt.
//			StandardEntity se =world.getEntity(id);
//			if(se instanceof Building){
//				List<Road>entrances=world.getEntrance((Building)se);
//				if(!entrances.isEmpty()){
//				dest.addAll(entrances);
//				}else{
//					dest.add(world.getEntity(id));
//				}
//			}else{
//			dest.add(world.getEntity(id));
//			}
//		}
//
//		Point selfL = new Point(controlledEntity.getX(), controlledEntity.getY());
//		CostFunction costFun = underlyingAgent.getRouter().getNormalCostFunction();
//		Area loca = (Area) world.getSelfPosition();
//
//		List<EntityID> path = underlyingAgent.getRouter().getMultiDest(loca, dest, costFun, selfL);
//		EntityID destId = path.get(path.size() - 1);
//		double cost = underlyingAgent.getRouter().getRouteCost();
//		double dis = world.getDistance(loca.getID(), destId);
//
//		if (cost > 20 * dis) {
//			zone.removeVisitedFromUnvisit(unreachables(world.getEntity(destId, Area.class)));
//			
//		} else {
//			
//			
//			
//			this.underlyingAgent.sendMove(path);
//		}
//	}
	
	
//	private List<EntityID> lookedBuildings() {
//		List<EntityID> result = new ArrayList<EntityID>();
//		
//		Human agent;
//		for (StandardEntity next : world.getEntitiesOfType(AgentConstants.PLATOONS)) {
//			agent = (Human)next;
//			
//			if (agent.getID().getValue() == underlyingAgent.getID().getValue()) {
//				for (EntityID visible : underlyingAgent.getChanged()) {
//					StandardEntity v_entity = world.getEntity(visible);
//					if (v_entity instanceof Building) {
//						result.add(visible);
//					}
//				}
//			}
//			
//			if (agent.isPositionDefined()) {
//				StandardEntity position = world.getSelfPosition();
//				List<EntityID> visible = null;
//				if (position instanceof Building) {
//					SEUBuilding seu_b = world.getSeuBuilding(position.getID());
//					visible = seu_b.getObservableAreas();
//					result.add(agent.getPosition());
//					
//				}
//				if (position instanceof Road) {
//					SEURoad seu_r = world.getSeuRoad(position.getID());
//					visible = seu_r.getObservableAreas();
//				}
//				
//				if (visible != null) {
//					for (EntityID visible_id : visible) {
//						StandardEntity v_entity = world.getEntity(visible_id);
//						if (v_entity instanceof Building) {
//							result.add(visible_id);
//						}
//					}
//				}
//			}
//		}
//		
//		return result;
//	}
	
//	private Set<EntityID> unreachables(Area area) {
//		Set<EntityID> result = new FastSet<EntityID>();
//		
//		if (area instanceof Building) {
//			for (Road entrance : world.getEntrance().getEntrance((Building)area)) {
//				for (Building next : world.getEntrance().getBuilding(entrance)) {
//					result.add(next.getID());
//				}
//			}
//		} else {
//			List<Building> bu_s = world.getEntrance().getBuilding((Road)area);
//			if (bu_s != null) {
//				for (Building next : bu_s) {
//					result.add(next.getID());
//				}
//			}
//		}
//		
//		return result;
//	}
	
	private void printSortedBuilding(SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings) {
		String str = null;
		for(Pair<Pair<EntityID, Double>, Double> next : sortedBuildings) {
			if (str == null) {
				str = "time = " + world.getTime() + ", " + controlledEntity +", sortedBuilding: [";
			} else {
				str = str + ", ";
			}
			str = str + "(" + next.first().first().getValue() + ", " + next.second() + ")";
		}
		str = str + "]";
		//System.out.println(str);
	}
	
	
//	public SEUBuilding selectTargetWhenStuck(Collection<SEUBuilding> burnBuildings) {
//		if (controlledEntity.getWater() < underlyingAgent.waterPower)
//			return null;
//		
//		if (burnBuildings == null || burnBuildings.isEmpty())
//			return null;
//
//		SEUBuilding targetBuilding = this.getOverallBestBuilding(burnBuildings);
//		return targetBuilding;
//	}

	
//	public SEUBuilding getOverallBestBuilding(Collection<SEUBuilding> burnBuildings) {
//		SortedSet<Pair<EntityID, Double>> sortedSet = new TreeSet<Pair<EntityID, Double>>(FbUtilities.pairComparator);
//		Building building;
//
//		// the border entities of dying fire cluster
//		Set<SEUBuilding> lessValueBuildings = new HashSet<SEUBuilding>();
//		// map border buildings that also contains in fire cluster
//		Set<SEUBuilding> mapBorderBuildings = new HashSet<SEUBuilding>();
//		// all buildings in the main expand direction of each fire cluster
//		Set<SEUBuilding> highValueBuildings = this.buildingClassifier(lessValueBuildings, mapBorderBuildings);
//
//		for (SEUBuilding next : burnBuildings) {
//			building = next.getSelfBuilding();
//			int distance = (int)world.getDistance(underlyingAgent.location(),building) / 1000;
//			// if this building is map border building
//			if (mapBorderBuildings.contains(next)) {
//				switch (next.getEstimatedFieryness()) {
//				case 1:
//					next.BUILDING_VALUE = 50 + distance;
//					break;
//				case 2:
//					next.BUILDING_VALUE = 500 + distance;
//					break;
//				case 3:
//					next.BUILDING_VALUE = 10000 + distance;
//					break;
//				case 4:
//				case 5:
//				case 6:
//				case 7:
//					next.BUILDING_VALUE = 20000 + distance;
//					break;
//				case 8:
//				case 0:
//					next.BUILDING_VALUE = 25000 + distance;
//					break;
//				default:
//					next.BUILDING_VALUE = 25000 + distance;
//					break;
//				}
//				// if (seuBuilding == lastTarget) {
//				// seuBuilding.BUILDING_VALUE /= 1.54;
//				// }
//				// if (world.isMapHuge()) {
//				// seuBuilding.BUILDING_VALUE *= 100;
//				// }
//				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
//						next.BUILDING_VALUE));
//				continue;
//			}
//			// if this building is less value building
//			if (lessValueBuildings.contains(next)) {
//				switch (next.getEstimatedFieryness()) {
//				case 1:
//				case 2:
//					next.BUILDING_VALUE = 50 + distance;
//					break;
//				case 3:
//					next.BUILDING_VALUE = 5000 + distance;
//					break;
//				case 4:
//				case 5:
//				case 6:
//				case 7:
//					next.BUILDING_VALUE = 7000 + distance;
//					break;
//				// case 0:
//				// next.BUILDING_VALUE = 9000 + distance;
//				// break;
//				case 8:
//					next.BUILDING_VALUE = 20000 + distance;
//					break;
//				default:
//					next.BUILDING_VALUE = 9000 + distance;
//					break;
//				}
//				// if (seuBuilding == lastTarget) {
//				// seuBuilding.BUILDING_VALUE /= 1.54;
//				// }
//				// if (world.isMapHuge()) {
//				// seuBuilding.BUILDING_VALUE *= 100;
//				// }
//				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
//						next.BUILDING_VALUE));
//				continue;
//			}
//			// if this building is high value building
//			if (highValueBuildings.contains(next)) {
//				switch (next.getEstimatedFieryness()) {
//				case 1:
//					next.BUILDING_VALUE = 1 + distance;
//					break;
//				case 2:
//					next.BUILDING_VALUE = 25 + distance;
//					break;
//				case 3:
//					double temperature = next.getEstimatedTemperature();
//					next.BUILDING_VALUE = (temperature >= 150) ? 75
//							: 275 - temperature;
//					next.BUILDING_VALUE += distance;
//					break;
//				// case 0:
//				// next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35)
//				// ? 130 : 160;
//				// next.BUILDING_VALUE += distance;
//				// break;
//				case 4:
//					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 40
//							: 80;
//					next.BUILDING_VALUE += distance;
//					break;
//				case 5:
//				case 6:
//					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 75
//							: 95;
//					next.BUILDING_VALUE += distance;
//					break;
//				case 7:
//					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 120
//							: 170;
//					next.BUILDING_VALUE += distance;
//					break;
//				case 8: // Burnt building
//				default:
//					next.BUILDING_VALUE = 15000 + distance;
//					break;
//				}
//				// if (seuBuilding == lastTarget) {
//				// seuBuilding.BUILDING_VALUE /= 1.54;
//				// }
//				// if (world.isMapHuge()) {
//				// seuBuilding.BUILDING_VALUE *= 100;
//				// }
//				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
//						next.BUILDING_VALUE));
//				continue;
//			}
//			// if this is not those three kind of building
//			switch (next.getEstimatedFieryness()) {
//			case 1:
//				next.BUILDING_VALUE = 50 + distance;
//				break;
//			case 2:
//				next.BUILDING_VALUE = 110 + distance;
//				break;
//			case 3:
//				double temperature = next.getEstimatedTemperature();
//				next.BUILDING_VALUE = (temperature >= 150) ? 210
//						: 410 - temperature;
//				next.BUILDING_VALUE += distance;
//				break;
//			// case 0:
//			// next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ?
//			// 190 : 210;
//			// next.BUILDING_VALUE += distance;
//			// break;
//			case 4:
//				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ? 160
//						: 190;
//				next.BUILDING_VALUE += distance;
//				break;
//			case 5:
//			case 6:
//				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ? 200
//						: 240;
//				next.BUILDING_VALUE += distance;
//				break;
//			case 7:
//				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 300
//						: 380 + distance;
//				break;
//			default:
//			case 8: // Burnt Building
//				next.BUILDING_VALUE = 19000 + distance;
//				break;
//			}
//			// if (seuBuilding == lastTarget) {
//			// seuBuilding.BUILDING_VALUE /= 1.54;
//			// }
//			// if (world.isMapHuge()) {
//			// seuBuilding.BUILDING_VALUE *= 100;
//			// }
//			sortedSet.add(new Pair<EntityID, Double>(building.getID(),
//					next.BUILDING_VALUE));
//			continue;
//		}
//
//		if (sortedSet.size() > 0)
//			return world.getSeuBuilding(sortedSet.first().first());
//		else
//			return null;
//	}

	private SortedSet<Pair<Pair<EntityID, Double>, Double>> calculateValue(FireCluster fireCluster) {
		SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings = 
				new TreeSet<Pair<Pair<EntityID, Double>, Double>>(FbUtilities.pairComparator_new);
		
		Set<StandardEntity> borderBuildings = new FastSet<StandardEntity>(fireCluster.getBorderEntities());

		Set<SEUBuilding> inDirectionBuildings;
		Point directionPoint = directionManager.findFarthestPointOfMap(fireCluster, controlledEntity);
		inDirectionBuildings = fireCluster.findBuildingInDirection(directionPoint);

		borderBuildings.removeAll(seuBuildingToEntity(inDirectionBuildings));

		this.calculateValueOfInDirectionBuildings(inDirectionBuildings, sortedBuildings);
		this.calculateValueOfBorderBuildings(borderBuildings, sortedBuildings);
		
		return sortedBuildings;
	}

	private void calculateValueOfInDirectionBuildings(Set<SEUBuilding> inDirectionBuildings,
			SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings) {
		for (SEUBuilding next : inDirectionBuildings) {
			String string = "";
			if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
				string = "time = " + world.getTime() +", inDirection(" + next.getId().getValue() + "): [";
			}
			switch (next.getEstimatedFieryness()) {
			case 0:
				double value_0 = (next.getEstimatedTemperature() >= 35) ? 3 : 20;
				next.BUILDING_VALUE = value_0;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 0 = " + value_0 + ", ";
				}
				break;
			case 1:
				next.BUILDING_VALUE = 1;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 1 = 1, ";
				}
				break;
			case 2:
				next.BUILDING_VALUE = 9;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 2 = 3, ";
				}
				break;
			case 3:
				double estimatedTemperature = next.getEstimatedTemperature();
				double value_3 = (estimatedTemperature >= 150) ? 13 : 17;
				next.BUILDING_VALUE = value_3;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 3 = " + value_3 + ", ";
				}
				break;
			case 4:
				double value_4 = (next.getEstimatedTemperature() >= 35) ? 4 : 25;
				next.BUILDING_VALUE = value_4;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 4 = " + value_4 + ", ";
				}
				break;
			case 5:
			case 6:
				double value_5_6 = (next.getEstimatedTemperature() >= 35) ? 2 : 25;
				next.BUILDING_VALUE = value_5_6;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 5,6 = " + value_5_6 + ", ";
				}
				break;
			case 7:
				double value_7 = (next.getEstimatedTemperature() >= 35) ? 11 : 30;
				next.BUILDING_VALUE = value_7;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 7 = " + value_7 + ", ";
				}
				break;
			case 8:
			default:
				next.BUILDING_VALUE = 120;
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "case 8 = 120, ";
				}
				break;
			}

			/*if (lastTarget != null) {
				double distance = world.getDistance(lastTarget.getId(), next.getId());
				int temp = (int) (distance / MEAN_VELOCITY_DISTANCE);
				next.BUILDING_VALUE += temp;
				
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "toLastTargetValue = " + temp + ", ";
				}
			}*/
			if (lastTarget != null && next.getId() == lastTarget.getId()) {
				next.BUILDING_VALUE *= 0.5;
				
				if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
					string = string + "last target, value * 0.5 = " + next.BUILDING_VALUE + ", ";
				}
			}
			
			if (AgentConstants.PRINT_SORTED_BUILDINGS_FB) {
				string = string + "finalValue = " + next.BUILDING_VALUE + ", ";
			}
			
			Pair<Integer, Integer> selfLocation = world.getControlledEntity().getLocation(world);
			Pair<Integer, Integer> buildingLocation = next.getSelfBuilding().getLocation(world);
			double distance = Distance.getDistance(selfLocation, buildingLocation);
			
			
			Pair<EntityID, Double> pair = new Pair<EntityID, Double>(next.getSelfBuilding().getID(), distance);
			sortedBuildings.add(new Pair<Pair<EntityID, Double>, Double>(pair, next.BUILDING_VALUE));
		}
	}

	private void calculateValueOfBorderBuildings(Set<StandardEntity> borderBuildings,
			SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings) {
		SEUBuilding seuBuilding;
		for (StandardEntity next : borderBuildings) {
			String string = "";
			
			seuBuilding = world.getSeuBuilding(next.getID());

			switch (seuBuilding.getEstimatedFieryness()) {
			case 0:
				boolean flag = seuBuilding.getEstimatedTemperature() >= 35;
				double value_0 = flag ? 7 : 25;
				seuBuilding.BUILDING_VALUE = value_0;
				
				break;
			case 1:
				seuBuilding.BUILDING_VALUE = 5;
				
				break;
			case 2:
				seuBuilding.BUILDING_VALUE = 15;
				
				break;
			case 3:
				double estimatedTemperature = seuBuilding.getEstimatedTemperature();
				double value_3 = estimatedTemperature >= 150 ? 17 : 21;
				seuBuilding.BUILDING_VALUE = value_3;
				
				break;
			case 4:
				double value_4 = (seuBuilding.getEstimatedTemperature() >= 35) ? 4 : 25;
				seuBuilding.BUILDING_VALUE = value_4;
				
				break;
			case 5:
			case 6:
				double value_5_6 = (seuBuilding.getEstimatedTemperature() >= 35) ? 6 : 30;
				seuBuilding.BUILDING_VALUE = value_5_6;
				
				break;
			case 7:
				double value_7 = (seuBuilding.getEstimatedTemperature() >= 35) ? 19 : 35;
				seuBuilding.BUILDING_VALUE = value_7;
				
				break;
			case 8:
			default:
				seuBuilding.BUILDING_VALUE = 100;
				
				break;
			}
			
			/*double advantageRatio = seuBuilding.getAdvantageRatio();
			seuBuilding.BUILDING_VALUE += advantageRatio;
			
			string = string + "advantageRatio = " + advantageRatio + ", ";*/

			if (lastTarget != null) {
				double distance = world.getDistance(lastTarget.getId(), seuBuilding.getId());
				int temp = (int)(distance / MEAN_VELOCITY_DISTANCE);
				seuBuilding.BUILDING_VALUE += temp;
				
				
			}
			
			if (lastTarget != null && seuBuilding.getId() == lastTarget.getId()) {
				seuBuilding.BUILDING_VALUE *= 0.5;
				
			}
			
			
			Pair<Integer, Integer> selfLocation = world.getControlledEntity().getLocation(world);
			Pair<Integer, Integer> buildingLocation = next.getLocation(world);
			double distance = Distance.getDistance(selfLocation, buildingLocation);
			
			
			
			Pair<EntityID, Double> pair = new Pair<EntityID, Double>(next.getID(), distance);
			sortedBuildings.add(new Pair<Pair<EntityID, Double>, Double>(pair, seuBuilding.BUILDING_VALUE));
		}
	}

	/**
	 * Classify buildings.
	 * 
	 * <pre>
	 * 1.lessValueBuildings: the border buildings of dying FireCLuster
	 * 
	 * 2.mapBorderBuildings: the border buildings of map border FireCLuster
	 * 
	 * 3.highValueBuildings: buildings in the expand direction of its FireCluster
	 * 
	 * 4.otherBuildings: the remaining border buildings of FireCluster
	 * </pre>
	 * 
	 * @param lessValue
	 *            a set to store less value buildings
	 * @param mapBorder
	 *            a set to store map border buildings
	 * @return a set of high value buildings
	 */
//	private Set<SEUBuilding> buildingClassifier(Set<SEUBuilding> lessValue, Set<SEUBuilding> mapBorder) {
//		Set<SEUBuilding> highValueBuildings = new HashSet<SEUBuilding>();
//		List<FireCluster> fireClusters = world.getFireClusterManager().getClusters();
//		
//		ConvexObject convexObject;
//		Polygon polygon;
//		SEUBuilding seuBuilding;
//
//		for (FireCluster cluster : fireClusters) {
//			if (cluster == null)
//				continue;
//			if (cluster.isDying()) {
//				for (StandardEntity next : cluster.getBorderEntities())
//					lessValue.add(this.world.getSeuBuilding(next.getID()));
//				continue;
//			}
//			if (cluster.isBorder()) {
//				for (StandardEntity next : cluster.getBorderEntities())
//					mapBorder.add(this.world.getSeuBuilding(next.getID()));
//				continue;
//			}
//			
//			directionManager.findFarthestPointOfMap(cluster, controlledEntity);
//			convexObject = cluster.getConvexObject();
//			if (convexObject == null || convexObject.CENTER_POINT == null
//					|| convexObject.CONVEX_POINT == null || convexObject.getConvexHullPolygon() == null)
//				continue;
//			
//			if (cluster.isOverCenter()) {
//				polygon = convexObject.getDirectionRectangle();
//			} else {
//				polygon = convexObject.getTriangle();
//			}
//			
//			for (StandardEntity next : cluster.getBorderEntities()) {
//				seuBuilding = world.getSeuBuilding(next.getID());
//				int[] vertices = seuBuilding.getSelfBuilding().getApexList();
//				for (int i = 0; i < vertices.length; i += 2) {
//					if (polygon.contains(vertices[i], vertices[i + 1])) {
//						highValueBuildings.add(seuBuilding);
//						break;
//					}
//				}
//			}
//		}
//		
//		return highValueBuildings;
//	}

	/**
	 * Translate a collection of SEUBuilding into a collection of
	 * StandardEntity.
	 * 
	 * @param seuBuildings
	 *            a collection of SEUBuilding will be translated
	 * @return a collection of StandardEntity
	 */
	private Collection<StandardEntity> seuBuildingToEntity(Collection<SEUBuilding> seuBuildings) {
		Collection<StandardEntity> result = new FastSet<StandardEntity>();
		for (SEUBuilding next : seuBuildings)
			result.add(next.getSelfBuilding());
		return result;
	}



}
