package seu.agent.fb.FireBrigadestools.fbTarget;


import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import seu.agent.fb.FireBrigadeWorld;
import seu.common.ConstantComparators;
import seu.common.clustering.Cluster;
import seu.common.clustering.FireCluster;
import seu.model.object.SEUBuilding;

import java.awt.*;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;


public class DirectionBasedTargetSelector14 extends targetSelector {
    public DirectionBasedTargetSelector14(FireBrigadeWorld world) {
        super(world);
        buildingCostComputer = new ZJUBaseBuildingCostComputer(world);
        distanceNormalizer = 31445.392;
    }

    private ZJUBaseBuildingCostComputer buildingCostComputer;
    private double distanceNormalizer;


    @Override
    public FBTarget selectTarget(Cluster targetCluster) {
        FBTarget fireBrigadeTarget = null;

        if (targetCluster != null) {
            SortedSet<Pair<EntityID, Double>> sortedBuildings;
            sortedBuildings = calculateValue((FireCluster) targetCluster);
//            sortedBuildings = fireBrigadeUtilities.reRankBuildings(sortedBuildings);

         

            if (sortedBuildings != null && !sortedBuildings.isEmpty()) {
                lastTarget = target;
                target = world.getSeuBuilding(sortedBuildings.first().first());
                fireBrigadeTarget = new FBTarget(targetCluster,target);
            }
        }

        return fireBrigadeTarget;
    }


    private SortedSet<Pair<EntityID, Double>> calculateValue(FireCluster fireCluster) {

        Set<StandardEntity> borderEntities = fireCluster.getBorderEntities();
        SortedSet<Pair<EntityID, Double>> sortedBuildings = new TreeSet<Pair<EntityID, Double>>(ConstantComparators.DISTANCE_VALUE_COMPARATOR_DOUBLE);
        Set<SEUBuilding> inDirectionBuildings=new HashSet<SEUBuilding>();
        //2014
        try {
			
		
        Point targetPoint = directionManager.findDirectionPointInMap(fireCluster, world.getFireClusterManager().getClusters());
       if(targetPoint!=null)//niu 2015.6.3 handle null pointer
        inDirectionBuildings = fireCluster.findBuildingInDirection(targetPoint);
       
		} catch (Exception e) {
					// TODO: handle exception
			} 
        buildingCostComputer.updateFor(fireCluster, lastTarget);
        if (inDirectionBuildings.isEmpty()) {
            calculateValueForOtherBuildings(sortedBuildings, borderEntities);
        }
        calculateValueForInDirectionBuildings(sortedBuildings, inDirectionBuildings);
        return sortedBuildings;
    }

    private void calculateValueForOtherBuildings(SortedSet<Pair<EntityID, Double>> sortedBuildings, Set<StandardEntity> otherBuildings) {
        for (StandardEntity entity : otherBuildings) {
            SEUBuilding b = world.getSeuBuilding(entity.getID());
            b.BUILDING_VALUE = buildingCostComputer.getCost(b);
            sortedBuildings.add(new Pair<EntityID, Double>(b.getId(), b.BUILDING_VALUE));
        }
    }

    private void calculateValueForInDirectionBuildings(SortedSet<Pair<EntityID, Double>> sortedBuildings, Set<SEUBuilding> highValueBuildings) {
        for (SEUBuilding b : highValueBuildings) {
            b.BUILDING_VALUE = buildingCostComputer.getCost(b);
            sortedBuildings.add(new Pair<EntityID, Double>(b.getId(), b.BUILDING_VALUE));
        }
    }

}