package seu.agent.fb.FireBrigadestools.fbTarget;

import rescuecore2.standard.entities.Area;

import seu.common.clustering.Cluster;
import seu.model.object.SEUBuilding;

/**
 * This class stands for the target of FBs. It encapsulate the target building
 * to extinguish, the best location to extinguish this building and the fire
 * cluster target building belongs to.

 */
public class FBTarget {
	/** Target building to extinguish.*/
	private SEUBuilding seuBuilding;
	/** The fire cluster target building belongs to.*/
	private Cluster cluster;
	/** The best location to extinguish this building.*/
	private Area locationToExtinguish;
	
	public FBTarget(Cluster cluster, SEUBuilding seuBuilding) {
		this.cluster = cluster;
		this.seuBuilding = seuBuilding;
	}
	
	public void setLocationToExtinguish(Area locationToExtinguish) {
		this.locationToExtinguish = locationToExtinguish;
	}
	
	public Area getLocationToExtinguish() {
		return this.locationToExtinguish;
	}
	
	public Cluster getCluster() {
		return this.cluster;
	}
	
	public SEUBuilding getSeuBuilding() {
		return this.seuBuilding;
	}
}
