package seu.agent.fb.FireBrigadestools.fbTarget;

import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.Building;
import rescuecore2.worldmodel.EntityID;
import seu.agent.fb.FireBrigadeWorld;
import seu.common.ConstantComparators;
import seu.common.clustering.Cluster;
import seu.common.clustering.FireCluster;
import seu.model.object.SEUBuilding;

import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;


public class MRLFullyGreedyTargetSelector extends targetSelector {
    public MRLFullyGreedyTargetSelector(FireBrigadeWorld world) {
        super(world);
        this.buildingCostComputer = new ZJUBaseBuildingCostComputer(world);
    }

    private ZJUBaseBuildingCostComputer buildingCostComputer;

    @Override
    public FBTarget selectTarget(Cluster targetCluster) {

        FBTarget fireBrigadeTarget = null;

        if (targetCluster != null) {
            target = calculateValueZJUBase((FireCluster) targetCluster);
            if (target != null) {
                lastTarget = target;
                fireBrigadeTarget = new FBTarget( targetCluster,target);
            }
        }

        return fireBrigadeTarget;

    }

    private SEUBuilding calculateValueZJUBase(FireCluster fireCluster) {
        List<Building> buildings = fireCluster.getBuildings();
        SEUBuilding targetBuilding = null;
        SortedSet<Pair<EntityID, Double>> sortedBuildings = new TreeSet<Pair<EntityID, Double>>(ConstantComparators.DISTANCE_VALUE_COMPARATOR_DOUBLE);
        buildingCostComputer.updateFor(fireCluster, lastTarget);
        
        for (Building building : buildings) {
        	SEUBuilding seuBuilding=world.getSeuBuilding(building);
            if (seuBuilding.isBurning()) {
                seuBuilding.BUILDING_VALUE = buildingCostComputer.getCost(seuBuilding);
                sortedBuildings.add(new Pair<EntityID, Double>(seuBuilding.getId(), seuBuilding.BUILDING_VALUE));
            }
        }

       

        if (sortedBuildings != null && !sortedBuildings.isEmpty()) {
            lastTarget = target;
            target = world.getSeuBuilding(sortedBuildings.first().first());
            targetBuilding = target;
        }

        return targetBuilding;
    }


}
