package seu.agent.fb.FireBrigadestools.fbTarget;


import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.worldmodel.EntityID;
import seu.agent.fb.FireBrigadeAgent;
import seu.agent.fb.FireBrigadeWorld;
import seu.agent.fb.FireBrigadestools.FbUtilities;
import seu.agent.fb.FireBrigadestools.fireDirectionManager;
import seu.model.object.SEUBuilding;

public abstract class targetSelector implements TargetSelectorInterface{

	protected FireBrigadeWorld world;
	protected FireBrigadeAgent underlyingAgent;
	protected FireBrigade controlledEntity;
	protected EntityID agentId;
	
	protected boolean checkFires = false;
	
	/** 
	 * Utility tool class for FB.
	 */
	protected FbUtilities  fbUtilities;
	
	/** 
	 * Direction manager which used to find the expand direction of fire.
	 */
	protected fireDirectionManager directionManager;
	
	/** 
	 * Target for single platoon Agent when each platoon Agent select target separately.
	 */
	protected SEUBuilding target;
	
	/** 
	 * Last cycle's target for single platoon Agent when each platoon select target separately.
	 */
	protected SEUBuilding lastTarget;
	
	public targetSelector(FireBrigadeWorld world) {
		this.world = world;
		this.fbUtilities = new FbUtilities(world);
		this.directionManager = new fireDirectionManager(world);
		this.agentId = world.getControlledEntity().getID();
		
		if (world.getAgent() instanceof FireBrigadeAgent) {
			this.underlyingAgent = (FireBrigadeAgent) world.getAgent();
			this.controlledEntity = (FireBrigade) world.getControlledEntity();
		}
	}
	
}
