package seu.agent.fb.extinguishtasks;

import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import javolution.util.FastSet;
import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.at.AmbulanceTeamsTools.partionTools.Cluster;
import seu.agent.fb.FireBrigadeAgent;
import seu.agent.fb.FireBrigadeWorld;
import seu.agent.fb.FireBrigadestools.FbUtilities;
import seu.agent.fb.FireBrigadestools.fireDirectionManager;
import seu.agent.fb.FireBrigadestools.fbTarget.DefultTargetSelector;
import seu.agent.fb.FireBrigadestools.fbTarget.DirectionBasedTargetSelector14;
import seu.agent.fb.FireBrigadestools.fbTarget.FBTarget;
import seu.agent.fb.FireBrigadestools.fbTarget.MRLFullyGreedyTargetSelector;
import seu.agent.fb.FireBrigadestools.fbTarget.TargetSelectorInterface;
import seu.agent.fb.FireBrigadestools.fbTarget.TargetSelectorType;
import seu.common.TimeOutException;
import seu.common.clustering.FireCluster;
import seu.common.clustering.NormalBuildingCluster;
import seu.geom.CompositeConvexHull;
import seu.geom.Distance;
import seu.model.AgentConstants;
import seu.model.object.SEUBuilding;
import seu.model.object.SEURoad;
import seu.model.object.seuZoneEntity.SeuZone;
import seu.model.route.pov.CostFunction;
import seu.util.Util;

public class extinguishtask {
	protected FireBrigadeWorld world;
	protected fireDirectionManager directionManager;
	protected FbUtilities fbUtil;
	
	protected FireBrigadeAgent underlyingAgent;
	protected StandardEntity controlledEntity;
	protected EntityID agentId;
	
	
	protected FireCluster targetCluster;
	Cluster lastLargest=null;

	//DefultTargetSelector targetselector;

	ExtinguishBehavior extinguishBehavior;
	
	private TargetSelectorType targetSelectorType = TargetSelectorType.FULLY_GREEDY;
	 private TargetSelectorInterface targetSelectorInterface;
	 
	 
	public extinguishtask(FireBrigadeWorld world, 
			fireDirectionManager directionManager, FbUtilities fbUtil) {
		
		this.world = world;
		this.directionManager = directionManager;
		this.fbUtil = fbUtil;
		
		this.underlyingAgent = (FireBrigadeAgent) world.getAgent();
		this.controlledEntity = world.getControlledEntity();
		this.agentId = underlyingAgent.getID();	
		//targetselector = new DefultTargetSelector(this.world);
		setTargetSelectorApproach();
		extinguishBehavior=new ExtinguishBehavior(world);
	}
	

	

	
	public void execute() throws ActionCommandException, TimeOutException {
		if (isTimeToRefreshEstimator())
			FbUtilities.refreshFireEstimator(world);
		FBTarget fbTarget=null;
		Pair<Integer, Integer> agentLocation = this.controlledEntity.getLocation(this.world);
		FireCluster targetCluster=null ;
		
		this.underlyingAgent.lastTarget = this.underlyingAgent.target;
		
		
		if(! ((FireBrigadeWorld)world).finishRetreat && ((FireBrigadeWorld)world).isMapUncontrollable()
				&& !world.isCommunicationLess() ){//niu 5.23 2015 && world.getTime()>100
			if(this.world.getFireClusterManager().getClusters().isEmpty()){
				world.setMapUncontrollable(false);
			}
	    	//NormalBuildingCluster largest= this.underlyingAgent.getLargestNormalCluster();
	    	Cluster largest=world.findLargestCluster();
	    	double mindis=Double.MIN_VALUE;
	    	StandardEntity importantrefuge=null;
	    	for(StandardEntity re:underlyingAgent.refuges){
	    		double disTOr=world.getDistance(agentId, largest.getCenterEntity().getID());
	    		if(disTOr<mindis){
	    			mindis=disTOr;
	    			importantrefuge=re;
	    		}
	    		
	    	}
	    	underlyingAgent.importantrefuge=importantrefuge;
	    	
	    	if(lastLargest!=null){
	    		if(!largest.equals(lastLargest)){
		    		double dis =world.getDistance(lastLargest.getCenterEntity(), largest.getCenterEntity());
		    		if(dis>world.getMapDiameter()/3){// niu ,avoid change "largest" too badly
		    			largest=lastLargest;
		    		}else{
		    			lastLargest=largest;
		    		}
	    		
	    		}
	    	}else{
	    		lastLargest=largest;
	    	}
	    	
	    	if(largest!=null){
	    		StandardEntity st=world.getSelfPosition();
	    		double dis=world.getDistance(st, largest.getCenterEntity());
	    		if(dis<world.getMapDiameter()/6){
//		    		System.out.println(world.me + "  Time : " + world.getTime() + "  finish retreat , cluster center :" + largest.getCentroid()+"     "+ largest.getCenterEntity().getID()
//		    				);
		    		// ((FireBrigadeWorld)world).finishRetreat=true;
		    	}
	    		//System.out.println(world.me + "  Time : " + world.getTime() + "  largets cluster center :" + largest.getCentroid()+"     "+largest.getCenterEntity().getID());	
	    	//Pair<Integer, Integer> center=new Pair<Integer, Integer>((int)largest.getCentroid().getX(),(int)largest.getCentroid().getY());
	    	targetCluster = this.world.getFireClusterManager().findNearestCluster(largest.getCentroid());
	    	}else{
	    		targetCluster = this.world.getFireClusterManager().findNearestCluster(agentLocation);
	    	}
	    }else{
		
		targetCluster = this.world.getFireClusterManager().findNearestCluster(agentLocation);
		}
		
		 if (targetCluster != null) {
			
	            if (!targetCluster.isControllable()&&targetSelectorType.equals(TargetSelectorType.FULLY_GREEDY)) {
	                targetSelectorType = TargetSelectorType.DIRECTION_BASED14;
	                setTargetSelectorApproach();
	               
	            } else if (targetCluster.isControllable() && targetSelectorType.equals(TargetSelectorType.DIRECTION_BASED14)
	            		) {
	                targetSelectorType = TargetSelectorType.FULLY_GREEDY;
	                setTargetSelectorApproach();
	            }  
	            else if (world.isMapUncontrollable()) {
	                targetSelectorType = TargetSelectorType.DIRECTION_BASED14;
	                setTargetSelectorApproach();
	               
	            }
	            
	             
//		 fbTarget = gasStationSelector(targetCluster);
//			if (fbTarget != null) {
//				
//				extinguishBehavior.extinguish(world, fbTarget);
//			}else{
		  fbTarget = this.targetSelectorInterface.selectTarget(targetCluster);
//	         }
			
				if (fbTarget != null) {
				//this.underlyingAgent.target = fbTarget.getSeuBuilding();
					//System.out.println(world.getTime()+"   "+underlyingAgent.getID()+  " this.target " + this.underlyingAgent.target.getId() );
				extinguishBehavior.extinguish(world, fbTarget);
				} else {
					
				}
	        }else{
	        	
				if (this.underlyingAgent.lastTarget != null 
						&& underlyingAgent.targettime>0 && world.getTime()-underlyingAgent.targettime<15) {
					//System.out.println(world.getTime()+"last target"+this.underlyingAgent.lastTarget+"  agent  "+underlyingAgent.getID()+" last target!=null ");
					for (SeuZone next : world.getZones()) {
						// niu search this zone and neighour zones. a simple choose method to avoid all agents search the same zone
						if (next.containtBuilding(this.underlyingAgent.lastTarget.getId())) {
							//System.out.println(world.getTime()+"last target"+this.underlyingAgent.lastTarget+"  agent  "+underlyingAgent.getID()+" zone " + next);
							List<FireBrigade>InZoneFB=new ArrayList<FireBrigade>();
//							for (StandardEntity standardEntity : world.getFireBrigades()) {
//						        FireBrigade fb = (FireBrigade) standardEntity;
//						       
//						        if (fb.isPositionDefined()){
//								 StandardEntity fbPosition = fb.getPosition(world);
//								 int range=world.getConfig().viewDistance;
//								double distance= Distance.getDistance(fbPosition.getLocation(world), next.getZoneCenter());
//								 if (distance<range  && !InZoneFB.contains(fb)) {
//									 InZoneFB.add(fb);
//							        }
//								 
//								 
//						        }
//						        
//						    }

//								EntityID maxFB=((FireBrigade) world.getMe()).getID();
//								if(!world.getVisualFBs().isEmpty()){
//								for(EntityID FB:world.getVisualFBs() ){
//									if(FB.getValue()>maxFB.getValue()){
//										maxFB=FB;
//									}
//								}
//								}
//								if(maxFB.equals(((FireBrigade) world.getMe()).getID())){								
//									

									
							//			System.out.println(world.getTime()+"last target"+this.underlyingAgent.lastTarget+"  agent  "+underlyingAgent.getID()+"search zone  "+ next.getZoneId());
										searchZones(next);
									
									break;
//								}
									
//								else{
//									int ran=new Random().nextInt(neighbourZones.size());
//									System.out.println(world.getTime()+"last target"+lastTarget+"  agent  "+me.getID()+"search neighbour zone  "+ neighbourZones.get(ran).getZoneId());
//									
//									searchZones(neighbourZones.get(ran));
//									break;
//								}				 
							//}		
						}
					}
				} 
	        }
		 
		
		
			
			
		
	}
	
	private boolean isTimeToRefreshEstimator() {
		if (world.getTime() > 120 && world.getTime() % 30 == 0)
			return true;
		return false;
	}


	
	
//	public void moveToFires() throws ActionCommandException {
//		SEUBuilding seuBuilding;
//		//seuBuilding = targetselector.getOverallBestBuilding(Util.burnBuildingToSeuBuilding(world));
//		seuBuilding = targetselector.getOverallBestBuilding(Util.burnBuildingToSeuBuilding(world));
//		if(seuBuilding != null) {
//			List<EntityID> path;
//			path = world.getRouter().getAStar(underlyingAgent.location(), seuBuilding.getSelfBuilding(), 
//					new Point(world.getSelfLocation().first(), world.getSelfLocation().second()));
//

//			
//			int pathSize = path.size();
//			path.remove(pathSize - 1);
//			
//			underlyingAgent.moveOnPlan(path);
//		}
//	}
	
	public void extinguishNearbyWhenStuck() throws ActionCommandException, TimeOutException{
		if (((FireBrigade) this.controlledEntity).getWater() == 0) {
			this.underlyingAgent.lastTarget = this.underlyingAgent.target;
			this.underlyingAgent.target = null;
			return;
		}
		
		Set<SEUBuilding> inRange = FbUtilities.getBuildingInExtinguishableRange(world, agentId);
		List<SEUBuilding> firedBuildings = new ArrayList<SEUBuilding>();
		for (SEUBuilding next : inRange) {
			if (next.getEstimatedTemperature() >= 45)
				firedBuildings.add(next);
		}

		this.underlyingAgent.lastTarget = this.underlyingAgent.target;
		this.underlyingAgent.target = selectTargetWhenStuck(firedBuildings);
		
		
		this.extinguishBehavior.extinguishNearbyWhenStuck(this.underlyingAgent.target);
	}

	private void setTargetSelectorApproach() {

        switch (targetSelectorType) {
           
            case DIRECTION_BASED14:
                targetSelectorInterface = new DirectionBasedTargetSelector14(world);
                break;
            
            case FULLY_GREEDY:
                targetSelectorInterface = new MRLFullyGreedyTargetSelector(world);
                break;
                
            case DEFULT:
                targetSelectorInterface = new DefultTargetSelector(world);
                break;    
           
        }
    }
	
	public FBTarget gasStationSelector(FireCluster cluster) {
		
		Collection<StandardEntity> gasStas = world.getEntitiesOfType(StandardEntityURN.GAS_STATION);
		Set<SEUBuilding> targetGasStas = new HashSet<SEUBuilding>();
		
		Polygon cluster_po = cluster.getConvexObject().getConvexHullPolygon();
		
		for (StandardEntity next : gasStas) {
			GasStation sta = (GasStation) next;
			
			if (sta.isFierynessDefined() && sta.getFieryness() >= 1 
					)//niu&& sta.getFieryness() != 4
				continue;
			
			if  (sta.isTemperatureDefined() && sta.getTemperature() > 25)
				continue;
			
			SEUBuilding seuBu = world.getSeuBuilding(next.getID());
			if (seuBu.getWaterQuantity() >= 5000)  //3000
				continue;
			
			int[] apexs = sta.getApexList();
			CompositeConvexHull convexHull = new CompositeConvexHull();
			
			for (int i = 0; i < apexs.length; i += 2) {
				convexHull.addPoint(apexs[i], apexs[i + 1]);
			}
			
			Polygon po = convexHull.getConvexPolygon();
			
			int dis = (int) Distance.getDistance(cluster_po, po);
			if (dis <= 8000)//5000
				targetGasStas.add(world.getSeuBuilding(next.getID()));
		}
		
		if (targetGasStas.contains(underlyingAgent.lastTarget))
			return new FBTarget(cluster, underlyingAgent.lastTarget);
		
		SEUBuilding tar = null;
		double minDistance = Double.MAX_VALUE;
		for (SEUBuilding next : targetGasStas) {
			double dis = world.getDistance(next.getId(), underlyingAgent.getID());
			if (dis < minDistance && dis/31700<8) {
				minDistance = dis;
				tar = next;
			}
		}
		
		if (tar != null) {
			this.underlyingAgent.target = tar;
			return new FBTarget(cluster, tar);
		} else
			return null;
	}
	
	public SEUBuilding selectTargetWhenStuck(Collection<SEUBuilding> burnBuildings) {
		if (((FireBrigade) this.controlledEntity).getWater() < underlyingAgent.waterPower)
			return null;
		
		if (burnBuildings == null || burnBuildings.isEmpty())
			return null;
		SortedSet<SEUBuilding> inRanges = new TreeSet<SEUBuilding>(new Comparator<SEUBuilding>() {
			
			@Override
			public int compare(SEUBuilding o1, SEUBuilding o2) {
				if (o1.BUILDING_VALUE > o2.BUILDING_VALUE)
					return 1;
				if (o1.BUILDING_VALUE < o2.BUILDING_VALUE)
					return -1;
				return 0;
			}
		});
		
		inRanges.addAll(burnBuildings);
		
		
		SEUBuilding targetBuilding = inRanges.first();
		
		return targetBuilding;
	}
	
	private void searchZones(SeuZone zone) throws ActionCommandException, TimeOutException {
		zone.removeVisitedFromUnvisit(lookedBuildings());
		Set<EntityID> dests = zone.getUnvisitBuildings();
		if (dests.isEmpty())
			return;
		
		Set<StandardEntity> dest = new HashSet<StandardEntity>(dests.size() * 2);
		for (EntityID id : dests) {
			//niu      Buildings in the zone are possibly on fire. when search zones,fbs should 
			//avoid go into the buildings and got burnt.
			StandardEntity se =world.getEntity(id);
			if(se instanceof Building){
				List<Road>entrances=world.getEntrance((Building)se);
				if(!entrances.isEmpty()){
				dest.addAll(entrances);
				}else{
					dest.add(world.getEntity(id));
				}
			}else{
			dest.add(world.getEntity(id));
			}
		}

		Point selfL = new Point(((FireBrigade) world.getMe()).getX(), ((FireBrigade) world.getMe()).getY());
		CostFunction costFun = underlyingAgent.getRouter().getNormalCostFunction();
		Area loca = (Area) world.getSelfPosition();

		List<EntityID> path = underlyingAgent.getRouter().getMultiDest(loca, dest, costFun, selfL);
		EntityID destId = path.get(path.size() - 1);
		double cost = underlyingAgent.getRouter().getRouteCost();
		double dis = world.getDistance(loca.getID(), destId);

		if (cost > 20 * dis) {
			zone.removeVisitedFromUnvisit(unreachables(world.getEntity(destId, Area.class)));
			
		} else {
			
			
			this.underlyingAgent.sendMove(path);
		}
	}
	
	private List<EntityID> lookedBuildings() {
		List<EntityID> result = new ArrayList<EntityID>();
		
		Human agent;
		for (StandardEntity next : world.getEntitiesOfType(AgentConstants.PLATOONS)) {
			agent = (Human)next;
			
			if (agent.getID().getValue() == underlyingAgent.getID().getValue()) {
				for (EntityID visible : underlyingAgent.getChanged()) {
					StandardEntity v_entity = world.getEntity(visible);
					if (v_entity instanceof Building) {
						result.add(visible);
					}
				}
			}
			
			if (agent.isPositionDefined()) {
				StandardEntity position = world.getSelfPosition();
				List<EntityID> visible = null;
				if (position instanceof Building) {
					SEUBuilding seu_b = world.getSeuBuilding(position.getID());
					visible = seu_b.getObservableAreas();
					result.add(agent.getPosition());
					
				}
				if (position instanceof Road) {
					SEURoad seu_r = world.getSeuRoad(position.getID());
					visible = seu_r.getObservableAreas();
				}
				
				if (visible != null) {
					for (EntityID visible_id : visible) {
						StandardEntity v_entity = world.getEntity(visible_id);
						if (v_entity instanceof Building) {
							result.add(visible_id);
						}
					}
				}
			}
		}
		
		return result;
	}
	
	private Set<EntityID> unreachables(Area area) {
		Set<EntityID> result = new FastSet<EntityID>();
		
		if (area instanceof Building) {
			for (Road entrance : world.getEntrance().getEntrance((Building)area)) {
				for (Building next : world.getEntrance().getBuilding(entrance)) {
					result.add(next.getID());
				}
			}
		} else {
			List<Building> bu_s = world.getEntrance().getBuilding((Road)area);
			if (bu_s != null) {
				for (Building next : bu_s) {
					result.add(next.getID());
				}
			}
		}
		
		return result;
	}
}

