  package seu.agent.fb.extinguishtasks;

    
  
  
import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import javolution.util.FastMap;
import javolution.util.FastSet;
import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.AmbulanceCentre;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.FireStation;
import rescuecore2.standard.entities.PoliceOffice;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.fb.FireBrigadeAgent;
import seu.agent.fb.FireBrigadeWorld;
import seu.agent.fb.FireBrigadestools.FbUtilities;
import seu.agent.fb.FireBrigadestools.fbTarget.FBTarget;
//import seu.agent.fb.FireBrigadestools.fbTarget.FireBrigadeTarget;
//import seu.agent.fb.FireBrigadestools.targetSelector.FireBrigadeTarget;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.BuildingFirenessComparator;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.HungarianAssignment;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.MRLCluster;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.Tubao;
import seu.agent.fb.FireBrigadestools.toolsForOldExtinguish.point;
//import seu.agent.fb.extinguishBehavior.DirectionBasedExtinguishBehavior;
import seu.common.TimeOutException;
import seu.common.clustering.FireCluster;
import seu.geom.CompositeConvexHull;
import seu.geom.ConvexObject;
import seu.geom.Distance;
import seu.model.object.SEUBuilding;
import seu.model.object.SEURoad;
import seu.model.object.seuZoneEntity.SeuZone;
import seu.model.route.pov.CostFunction;
import seu.util.Util;
public  class oldExtinguishTask {
	protected FireBrigadeWorld world;
	
	protected  FireBrigade me;
	protected  FireBrigadeAgent agent;
	protected EntityID agentId;
	
	protected SEUBuilding target;
	protected SEUBuilding lastTarget;
	protected FbUtilities  fbUtilities;
	protected FireCluster targetCluster;
	private int waterPower;
//	protected Map<Integer, CSUBuilding> extinguishTargetAndTimeMap = new FastMap<Integer, CSUBuilding>();
	
	private static final double MEAN_VELOCITY_DISTANCE = 31445.392;
 
	protected boolean checkFires = false;
	//private int theta = 30;
	
	//niu 突包算法
	List<Building>importantBuildings=new ArrayList<Building>();
	List<point> tubaodian=new ArrayList<point>();
	List<Building> tubaobuilding=new ArrayList<Building>();
	//civilian cluster
	protected List<MRLCluster> civilianClusters;
	//caculate cost for assignment
	double[][] costMatrix;
	ExtinguishBehavior extinguishBehavior;
	
	public oldExtinguishTask(FireBrigadeAgent fbagent,FireBrigadeWorld world) {
		//super(agent);
		this.world = world;
		this.me = (FireBrigade) world.getMe();
		
		this.agentId = fbagent.getID();
		agent=(FireBrigadeAgent) world.getAgent();
		this.fbUtilities = new FbUtilities(world);
	}
	
	public void execute() throws ActionCommandException, TimeOutException {
		
		
		if (/*world.getTime() > 150 &&*/ world.getTime() % 30 == 0)///更新仿真器world.getTime() > 150   有待测试
		//	world.updateFireEstimator();		
			FbUtilities.refreshFireEstimator(world);	
		//update civiliancluster
		///选择目标
		if (agent.isBlocked()) {
			extinguishNearbyWhenStuck();
			//agent.randomWalk();
			
		}
		preWater();
		//checkgasstation();
		assignBuilding();
		if(agent.getAssignedBuilding()!=null){
//			if(agent.getID().getValue()==965801746){
//			System.out.println(world.getTime()+"assigned building  "+agent.getAssignedBuilding().getID());
//			}
			extinguish(world);
		}else {
		FBTarget fbTarget = selectTarget();
		if (fbTarget != null) {
			extinguish(world, fbTarget);
		} 
		}

		moveToFires();
	
	}
	public void moveToFires() throws ActionCommandException {
		SEUBuilding csuBuilding;
		csuBuilding = getOverallBestBuilding(Util.burnBuildingToSeuBuilding(world));
		
		if(csuBuilding != null) {
			List<EntityID> path;
			path = world.getRouter().getAStar(agent.location(), csuBuilding.getSelfBuilding(), 
					new Point(world.getSelfLocation().first(), world.getSelfLocation().second()));

			int pathSize = path.size();
			path.remove(pathSize - 1);
//			if(agent.getID().getValue()==965801746){
//				System.out.println(world.getTime()+"move to fire   "+csuBuilding.getId());
//				}
			agent.moveOnPlan(path);
		}
	}
	
	 ///////////////被卡时的救火
	public void extinguishNearbyWhenStuck() throws ActionCommandException, TimeOutException{
		if (((FireBrigade) this.me).getWater() == 0) {
			this.lastTarget = this.target;
			this.target = null;
			return;
		}
		
		Set<SEUBuilding> inRange = FbUtilities.getBuildingInExtinguishableRange(world, agentId);
		List<SEUBuilding> firedBuildings = new ArrayList<SEUBuilding>();
		for (SEUBuilding next : inRange) {
			Building b=next.getSelfBuilding();
			if (next.getEstimatedTemperature() >= 25 )
				//	||(world.getTime()>60 && b.getTotalArea()>4000 && !b.isOnFire() && next.getEstimatedTemperature()<4  ))//niu
				firedBuildings.add(next);
		}

		this.lastTarget = this.target;
		this.target = selectTargetWhenStuck(firedBuildings);
		
		this.extinguishBehavior.extinguishNearbyWhenStuck(this.target);
		agent.isThinkTimeOver("extinguishNearbyWhenStuck");
//		
//		if (this.target == null)
//			return;
//		this.waterPower = agent.calculateWaterPower(target);
//		this.target.setWaterQuantity(this.target.getWaterQuantity() + waterPower);
//	//	extinguishTargetAndTimeMap.put(world.getTime(), this.target);
//		
//		this.agent.sendExtinguish(this.target.getId(), waterPower);
//		
		
	}
	//最近道路或非着火房屋
	private StandardEntity chooseBestLocationToExtinguish(FireBrigadeWorld model, FBTarget target, FireBrigade fbAgent) {
		double minDistance = Double.MAX_VALUE;
		double distance;
		Set<EntityID> forbiddenLocations = this.getForbiddenLocation(model, target, fbAgent.getID());
		Set<EntityID> possibleArea = new FastSet<EntityID>();
		StandardEntity locationToExtinguish = null; 
		
		//System.out.println("world.getConfig().extinguishableDistance  "+world.getConfig().extinguishableDistance);
		Collection<EntityID> areaInExtinguishableRange = target.getSeuBuilding().getAreasInExtinguishableRange();
		possibleArea.addAll(areaInExtinguishableRange);
		possibleArea.removeAll(forbiddenLocations);
		
		if (possibleArea.isEmpty())
			possibleArea.addAll(areaInExtinguishableRange);
		StandardEntity possibleRoadToExtinguish =null;//niu
		Set<Building> possibleBuildingsToExtinguish = new FastSet<Building>();
		for (EntityID next : possibleArea) {
			StandardEntity entity = model.getEntity(next);
			if (entity instanceof Road) {
				 distance = model.getDistance(fbAgent.getPosition(), next);
				 List<EntityID>buildingIDs=((Road) entity).getNeighbours();
				 //distance = model.getDistance(target.getCsuBuilding().getId(), entity.getID());
				
				 for(EntityID bid:buildingIDs){//niu to choose border of fire zone
					 if(world.getEntity(bid)instanceof Building){
						 SEUBuilding cb=world.getSeuBuilding(bid);
						 if(cb.getEstimatedFieryness()<1 ){
								if (distance < minDistance) {
									//System.out.println("choose border road to extinguish  ");
									minDistance = distance;
									locationToExtinguish = entity;
								}
						 }
					 }
				 }
				if (distance < minDistance) {
					minDistance = distance;
					//locationToExtinguish = entity;
					possibleRoadToExtinguish=entity;
				}
			} else if (entity instanceof Building) {
				possibleBuildingsToExtinguish.add((Building) entity);
			}
		}
		if (locationToExtinguish == null) {
			if(possibleRoadToExtinguish!=null)
				locationToExtinguish=possibleRoadToExtinguish;
			for (Building next : possibleBuildingsToExtinguish) {
				distance = model.getDistance(fbAgent.getPosition(), next.getID());
				boolean flag = next.isFierynessDefined() &&  next.getFieryness() < 1;
				///distance = model.getDistance(target.getCsuBuilding().getId(), next.getID());
				//boolean flag = next.isFierynessDefined() && next.getFieryness() >= 4 && next.getFieryness() < 1;
				if (distance < minDistance && (!next.isFierynessDefined() || flag)) {
					minDistance = distance;
					locationToExtinguish = next;
				}
			}
		}
		/*lastLoatLocationToGo = locationToExtinguish;
		count = 0;*/
		return locationToExtinguish;
	}
	
	//niu  extinguish fire in range
	public void currentLocationExtinguish() throws ActionCommandException {
		List< Building> InSightBurningBuildings=new ArrayList<Building>();
		for(EntityID eid:agent.getVisibleEntities()){
			StandardEntity st=world.getEntity(eid);
			if(st instanceof Building){
				Building b=(Building)st;

				if(b.isFierynessDefined() && b.getFieryness()>=1 && b.getFieryness()<=3){
					if(!InSightBurningBuildings.contains(b))
						InSightBurningBuildings.add(b);
				}
			}
		}
		//niu. extinguish in sight burning buildings
		if(!InSightBurningBuildings.isEmpty()){
			//System.out.println("extinguish in sight burning buildings  ");
//			if(agent.getID().getValue()==965801746){
//				System.out.println(world.getTime()+" extinguish in sight ");
//				}
			BuildingFirenessComparator comperator;
			comperator = new BuildingFirenessComparator();
			Collections.sort(InSightBurningBuildings,
					comperator);
			Building building = InSightBurningBuildings.get(0);
			SEUBuilding target = world.getSeuBuilding(building);
			
			if(world.getDistance(target.getId(), me.getID())<world.getConfig().extinguishableDistance){
				this.waterPower = FbUtilities.calculateWaterPower(world,target); 
				target.setWaterQuantity(target.getWaterQuantity() + waterPower);
				//extinguishTargetAndTimeMap.put(world.getTime(), target);
				agent.extinguish(target.getId(), waterPower);
			}
		}else {
			SortedSet<SEUBuilding> inRanges = new TreeSet<SEUBuilding>(new Comparator<SEUBuilding>() {
	
				@Override
				public int compare(SEUBuilding o1, SEUBuilding o2) {
					if (o1.BUILDING_VALUE > o2.BUILDING_VALUE)
						return 1;
					if (o1.BUILDING_VALUE < o2.BUILDING_VALUE)
						return -1;
					return 0;
				}
			});
			
			inRanges.addAll(FbUtilities.getBuildingInExtinguishableRange(world, me.getID()));
			
			if (inRanges.isEmpty()){
				
				return;
			}	
			SEUBuilding target = inRanges.first();
		
			if ((target.getEstimatedFieryness() > 0 && target.getEstimatedFieryness() < 4)
					/*||(b instanceof GasStation && !b.isOnFire()) && target.getEstimatedFieryness() < 4*/) {
				//System.out.println("extinguish in !!!!!!!!!!!!!!! range burning buildings  ");
//				if(agent.getID().getValue()==965801746){
//					System.out.println(world.getTime()+" extinguish  in range");
//					}
		
				this.waterPower = FbUtilities.calculateWaterPower(world,target); 
				target.setWaterQuantity(target.getWaterQuantity() + waterPower);
				//extinguishTargetAndTimeMap.put(world.getTime(), target);
				agent.extinguish(target.getId(), waterPower);
			}
		}
		
	}
	 
//着火房屋和附近FB所在位置
	private Set<EntityID> getForbiddenLocation(FireBrigadeWorld model, FBTarget target, EntityID fbAgent) {
		Set<EntityID> forbiddenLocations = new FastSet<EntityID>();
		
		if (target.getCluster() != null) {
			forbiddenLocations.addAll(target.getCluster().getAllEntities());
			// forbiddenLocations.addAll(Util.entityToIds(target.getCluster().getEntities()));
		}
		// forbiddenLocations.addAll(Util.entityToIds(world.getBurningBuildings()));
		forbiddenLocations.addAll(Util.seuBuildingToId(world.getEstimatedBurningBuildings()));
		
		int number = 3;
		if (model.isMapMedium()) number = 10;
		if (model.isMapHuge()) number = 15;
		
		for(EntityID next : model.getFireBrigadeIdList()) {
			// -------------- ?????????????????????????? 
			if (fbAgent.getValue() < next.getValue() 
					&& model.getDistance(fbAgent, next) < model.getConfig().viewDistance
					&& --number < 0) {
				FireBrigade fireBrigade = model.getEntity(next, FireBrigade.class);
				StandardEntity entity = world.getEntity(fireBrigade.getPosition());
				if (entity instanceof Building) {
					SEUBuilding buildingOfNearFb = model.getSeuBuilding(entity.getID());
					forbiddenLocations.addAll(buildingOfNearFb.getObservableAreas());
				} else if (entity instanceof Road) {
					SEURoad roadOfNearFb = model.getSeuRoad(entity.getID());
					forbiddenLocations.addAll(roadOfNearFb.getObservableAreas());
				}
			}
		}
		
		return forbiddenLocations;
	}
	
	public void extinguish(FireBrigadeWorld model, FBTarget fbTarget) throws ActionCommandException, TimeOutException {
		if (fbTarget.getSeuBuilding() == null) {
			searchDyingCluster((FireCluster)fbTarget.getCluster());
			return;
		}
			
		this.target = fbTarget.getSeuBuilding();
		
		EntityID targetId = fbTarget.getSeuBuilding().getId();
		
		int distanceToTarget = model.getDistance(this.agentId, targetId);
		int locationDistanceToTarget = model.getDistance(me.getPosition(), targetId);
		int maxExtinguishDistance;
		
		if (world.isNoRadio()/*target.getSelfBuilding() instanceof GasStation*/) {
			maxExtinguishDistance = model.getConfig().viewDistance;
		} else {
			maxExtinguishDistance = model.getConfig().extinguishableDistance;
		}
		//  System.out.println(agent.getID()+"      111111111111    "+agent.getTimeStep());
		if (distanceToTarget > maxExtinguishDistance && locationDistanceToTarget > maxExtinguishDistance) {
			StandardEntity locationToGo = chooseBestLocationToExtinguish(model, fbTarget, me);
			if (locationToGo != null 
					/*&& underlyingAgent.getRouter().isReachable(locationToGo.getID())*/) {
				List<EntityID> path = agent.getPath(agent.location(), 
						(Area)locationToGo, world.getRouter().getNormalCostFunction());
				if (path != null) {
					if (path.size() > 1) {
//						if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"move to target ro extin  "+locationToGo.getID());
//						}
						this.agent.moveOnPlan(path);
						//System.out.println(agent.getID()+"    22222222222222222    "+agent.getTimeStep());
						
					} else {
						currentLocationExtinguish();
					}
				}
			} else {
//				if(agent.getID().getValue()==965801746){
//					System.out.println(world.getTime()+"no good location  ");
//					}
				currentLocationExtinguish();
			}
			
		} else {
			 //go to another location if possible
			//要注意不要让fb走进房屋
			Set<EntityID> forbiddenLocations = this.getForbiddenLocation(model, fbTarget, agentId);
			if (!forbiddenLocations.isEmpty() && forbiddenLocations.contains( this.agent.location().getID())) {
				StandardEntity newLocation = this.chooseBestLocationToExtinguish(model, fbTarget, me);
				if (newLocation != null) {
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"move to good locayion ro extin  "+newLocation.getID());
//						}
					this.agent.newMove((Area)newLocation, world.getRouter().getNormalCostFunction());
				}
			}
			 
			if (this.me.getWater() != 0  ) {////喷水量进行选择
				if(fbTarget.getSeuBuilding().getEstimatedFieryness()<3){//niu
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"extinguish target   "+fbTarget.getCsuBuilding().getId());
//						}
				
				this.waterPower = FbUtilities.calculateWaterPower(world,fbTarget.getSeuBuilding()); 
				fbTarget.getSeuBuilding().setWaterQuantity(fbTarget.getSeuBuilding().getWaterQuantity() + waterPower);
				//extinguishTargetAndTimeMap.put(world.getTime(), target);
				agent.extinguish(fbTarget.getSeuBuilding().getId(), waterPower);
				}else{
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"can,t extinguish target   ");
//						}
					currentLocationExtinguish();
				}
			}  
		}
		agent.isThinkTimeOver("extinguishTarget");
	}
	
	public void extinguish(FireBrigadeWorld model) throws ActionCommandException, TimeOutException {//niu
				
		int distanceToTarget = model.getDistance(this.agentId, agent.getAssignedBuilding().getID());
		int locationDistanceToTarget = model.getDistance(me.getPosition(), agent.getAssignedBuilding().getID());
		int maxExtinguishDistance=model.getConfig().extinguishableDistance;
		
		//  System.out.println(agent.getID()+"      111111111111    "+agent.getTimeStep());
		if (distanceToTarget > maxExtinguishDistance && locationDistanceToTarget > maxExtinguishDistance) {
			
				List<EntityID> path = agent.getPath(agent.location(), 
						(Area)agent.getAssignedBuilding(), world.getRouter().getNormalCostFunction());
				if (path != null) {
					if (path.size() > 1) {
//						if(agent.getID().getValue()==965801746){
//							System.out.println(world.getTime()+"move to extinguish  "+agent.getAssignedBuilding().getID());
//							}
						this.agent.moveOnPlan(path);
						//System.out.println(agent.getID()+"    22222222222222222    "+agent.getTimeStep());
						
					} else {
						agent.setAssignedBuilding(null);
						currentLocationExtinguish();					
					}
				}	
		} else {
	
			if (this.me.getWater() != 0 ) {////喷水量进行选择
				
				SEUBuilding cb =world.getSeuBuilding(agent.getAssignedBuilding().getID());
				agent.setAssignedBuilding(null);//why????????????????????????????????????/
//				if(agent.getAssignedBuilding()==null){
//				System.out.println("assigned building=null ");
//				}
				if(cb.getEstimatedFieryness()<3){
					
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+" extinguish assigned "+agent.getAssignedBuilding().getID());
//						}
				this.waterPower = FbUtilities.calculateWaterPower(world,cb);
				cb.setWaterQuantity(cb.getWaterQuantity() + waterPower);			
				//extinguishTargetAndTimeMap.put(world.getTime(), fbTarget.getCsuBuilding());
				this.agent.extinguish(cb.getId(), waterPower);
				
				
				
				}else{
					
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"current extinguish  assigned");
//						}
					currentLocationExtinguish();
					
				}
			}  
		}
		agent.isThinkTimeOver("extinguishassignTarget");
	}
	
	private void searchDyingCluster(FireCluster cluster) throws ActionCommandException, TimeOutException {
		 
		cluster.removeFromAllEntities(lookedBuildings());///除去所有FB看到的房屋
		Set<EntityID> dyingClusterEntities = cluster.getAllEntities();

		if (dyingClusterEntities.isEmpty())
			return;

		Set<StandardEntity> dest = new FastSet<StandardEntity>();
		for (EntityID id : dyingClusterEntities) {
			StandardEntity en=world.getEntity(id);
			if(en instanceof Building) {
				Building bu=(Building)en;
				 dest.addAll(world.getEntrance(bu));
			}
		}

		Point selfL = new Point(me.getX(), me.getY());
		CostFunction costFun = agent.getRouter().getNormalCostFunction();
		Area loca = (Area) world.getSelfPosition();

		List<EntityID> path = agent.getRouter().getMultiDest(loca, dest, costFun, selfL);
		EntityID destId = path.get(path.size() - 1);
		double cost = agent.getRouter().getRouteCost();
		double dis = world.getDistance(loca.getID(), destId);

		if (cost > 10 * dis) {
			cluster.removeFromAllEntities(unreachables(world.getEntity(destId, Area.class)));
			 
		} else {
			
			this.agent.sendMove(path);
		}
	}

	private List<EntityID> lookedBuildings() {
		List<EntityID> result = new ArrayList<EntityID>();
		
		Human agent1;
		for (StandardEntity next : world.getAgents()) {
			agent1 = (Human)next;
			
			if (agent1.getID().getValue() == agent.getID().getValue()) {
				for (EntityID visible : agent.getChanged()) {
					StandardEntity v_entity = world.getEntity(visible);
					if (v_entity instanceof Building) {
						result.add(visible);
					}
				}
			}
			
			if (agent1.isPositionDefined()) {
				StandardEntity position = world.getSelfPosition();
				List<EntityID> visible = null;
				if (position instanceof Building) {
					SEUBuilding csu_b = world.getSeuBuilding(position.getID());
					visible = csu_b.getObservableAreas();
					result.add(agent1.getPosition());
					
				}
				if (position instanceof Road) {
					SEURoad csu_r = world.getSeuRoad(position.getID());
					visible = csu_r.getObservableAreas();
				}
				
				if (visible != null) {
					for (EntityID visible_id : visible) {
						StandardEntity v_entity = world.getEntity(visible_id);
						if (v_entity instanceof Building) {
							result.add(visible_id);
						}
					}
				}
			}
		}
		
		return result;
	}
	
	
	private Set<EntityID> unreachables(Area area) {
		Set<EntityID> result = new FastSet<EntityID>();
		
		if (area instanceof Building) {
			for (Road entrance : world.getEntrance((Building)area)) {
				for (Building next : world.getBuilding(entrance)) {
					result.add(next.getID());
				}
			}
		} else {
			List<Building> bu_s = world.getBuilding((Road)area);
			if (bu_s != null) {
				for (Building next : bu_s) {
					result.add(next.getID());
				}
			}
		}
		
		return result;
	}
	/////////////////////////////////////////////////////////////////
	 
	
	public FBTarget selectTarget() throws ActionCommandException, TimeOutException{	
		FireCluster targetCluster=null;
		FireCluster myCluster=null;//niu 14.9.20
		FBTarget targetBuilding = null;	
		this.lastTarget = this.target;
		Pair<Integer, Integer> agentLocation = this.me.getLocation(this.world);
		Point position = new Point(agentLocation.first(), agentLocation.second());
		try{
		if(civilianClusters!=null ){//niu
				if( !civilianClusters.isEmpty() && world.getClusterManager().findMostValueCluster().getValue()>2){
			targetCluster=agent.findImportantCluster(world);
		}
		}
		}catch(Exception e){}
		if(targetCluster==null){
		targetCluster = ( this.world.getFireClusterManager().findNearestCluster(agentLocation));
		}
		if (targetCluster != null) {
			
			if (targetCluster.isDying()) {
				targetBuilding = new FBTarget(targetCluster, null);
			} else {
				// figure out if the cluster need this agent
				double distance = Distance.getDistance(targetCluster.getCenter(), position);
				if(distance>world.getMapDiameter()/3  ){
					double num=targetCluster.neededAgentsToExtinguish();
					//System.out.println("!!!!!!!!!!!!!!the cluster need  agents"+num);
					//num=Math.ceil(num*1.5);
					 List<EntityID> freeAgents = world.getFreeFireBrigades();
					 int minDistance = Integer.MAX_VALUE;
					 EntityID nearestAgent = null;
				    while (num-- > 0) {
		                for (EntityID agent : freeAgents) {
		                	Pair<Integer, Integer> location=world.getEntity(agent).getLocation(world);
		                	Point position1 = new Point(location.first(), location.second());
		                	Integer dis =(int) Distance.getDistance(targetCluster.getCenter(), position1);
		                    if (dis != null && dis < minDistance) {
		                        minDistance = dis;
		                        nearestAgent = agent;
		                    }
		                }
		                if (nearestAgent == null) {
		                    break;
		                } else {
		                    
		                    freeAgents.remove(nearestAgent);
		                    minDistance = Integer.MAX_VALUE;
		                    if (nearestAgent.equals(me.getID())) {
		                    	//System.out.println("!!!!!!!!!!!!!!the cluster need this agent"+me.getID());
//		                    	if(agent.getID().getValue()==965801746){
//									System.out.println(world.getTime()+"cluster need me  ");
//									}
		                    	myCluster=targetCluster;
		                    }
		                }
		            }
				}else{
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"cluster seletted  ");
//						}
					myCluster=targetCluster;
				}
				if(myCluster!=null){
				targetBuilding = gasStationHander(myCluster);////对距离比较近得气站处理
				if (targetBuilding != null) {
					return targetBuilding;
				}

				SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings;
				sortedBuildings = this.calculateValue(myCluster);
				sortedBuildings = fbUtilities.reRankBuildings(sortedBuildings, me);

				if (sortedBuildings != null && !sortedBuildings.isEmpty()) {
					
					
					this.target = world.getSeuBuilding(sortedBuildings.first().first().first());
					targetBuilding = new FBTarget(myCluster, this.target);
//					if(agent.getID().getValue()==965801746){
//						System.out.println(world.getTime()+"target building  "+targetBuilding.getCsuBuilding().getId());
//						}
				}
				}else{
                	
                		//agent.enterSearchBuildings();
                	
                }
			}
		} else {
		
			//search around extinguished zone
			if (lastTarget != null) {
				List<FireBrigade>visibleFB=new ArrayList<FireBrigade>();
				for (StandardEntity standardEntity : world.getFireBrigades()) {
			        FireBrigade fb = (FireBrigade) standardEntity;
			        if ( world.isVisible(fb.getID()) && !visibleFB.contains(fb)) {
			           visibleFB.add(fb);
			        }
			    }
				for (SeuZone next : world.getZones()) {
					// niu search this zone and neighour zones. a simple choose method to avoid all agents search the same zone
					if (next.containtBuilding(lastTarget.getId())) {
//						List<CsuZone> neighbourZones=next.getNeighbourZones();						
//						if(neighbourZones!=null && !neighbourZones.isEmpty())
//						{
							EntityID maxFB=me.getID();
							if(!visibleFB.isEmpty()){
							for(FireBrigade FB:visibleFB ){
								if(FB.getID().getValue()>maxFB.getValue()){
									maxFB=FB.getID();
								}
							}
							}
							if(maxFB.equals(me.getID())){								
								//System.out.println(world.getTime()+"last target"+lastTarget+"  agent  "+me.getID()+"search zone  "+ next.getZoneId());
//								if(agent.getID().getValue()==965801746){
//									System.out.println(world.getTime()+"search zone  ");
//									}
								searchZones(next);
								break;
							}
//							else{
//								int ran=new Random().nextInt(neighbourZones.size());
//								System.out.println(world.getTime()+"last target"+lastTarget+"  agent  "+me.getID()+"search neighbour zone  "+ neighbourZones.get(ran).getZoneId());
//								
//								searchZones(neighbourZones.get(ran));
//								break;
//							}				 
						//}		
					}
				}
			} 
		}
		
		return targetBuilding;
	}
	public void checkgasstation() throws ActionCommandException, TimeOutException{
		//check gasstation
		if(world.getTime()%20==3){
			List<GasStation>gasStations=world.getAllGasStations();
			List<FireBrigade>fbs=world.getFireBrigadeList();
			for(GasStation gs:gasStations){
				SEUBuilding gas =world.getSeuBuilding(gs.getID());
				if(gas.getEstimatedFieryness()==0 ||gas.getEstimatedFieryness()==4){
				for (SeuZone next : world.getZones()) {
					if (next.containtBuilding(gs.getID())) {
						int mindis=Integer.MAX_VALUE;
						EntityID nearestfb =null;
						for(FireBrigade fb:fbs){
							Pair<Integer, Integer> location=fb.getLocation(world);
		                	Point position1 = new Point(location.first(), location.second());
		                	Integer dis =(int) Distance.getDistance(next.getZoneCenter(), position1);
		                    if (dis != null && dis < mindis) {
		                        mindis = dis;
		                        nearestfb = fb.getID();
		                    }
						}
						if(nearestfb!=null && nearestfb.equals(me.getID())){
							//System.out.println("check gasstation"+"  agent  "+me.getID());
							searchZones(next);
						}
					}
					}
				}
			}		
		}
	}
	public void preWater() throws ActionCommandException, TimeOutException{
		for(EntityID eid:agent.getVisibleEntities()){
			StandardEntity st=world.getEntity(eid);
			if(st instanceof Building){
				Building b=(Building)st;
				
				if(b instanceof GasStation &&  (b.isFierynessDefined() && b.getFieryness()==0)){
					
					SEUBuilding target = world.getSeuBuilding(b);
					
					
					if(world.getBurningBuildings().isEmpty() && !world.isNoRadio()){
					List<SEUBuilding>neighbours=target.getRadiationNeighbourBuildings();
					neighbours.add(target);
					for(SEUBuilding nei:neighbours){
						Building b1=nei.getSelfBuilding();
						if(b1 instanceof Refuge || b1 instanceof PoliceOffice
								|| b1 instanceof FireStation || b1 instanceof AmbulanceCentre)
							continue;	
						if(nei.getEstimatedFieryness()<4
								&& world.getDistance(nei.getId(), me.getID())<world.getConfig().extinguishableDistance/3.5){
					//this.waterPower = agent.calculateWaterPower(nei); 
					nei.setWaterQuantity(nei.getWaterQuantity() + 500);
					//extinguishTargetAndTimeMap.put(world.getTime(), target);
					agent.extinguish(nei.getId(),500);
						}
					}
					}else{
						if( world.getDistance(target.getId(), me.getID())<world.getConfig().extinguishableDistance){
						//this.waterPower = agent.calculateWaterPower(target); 
						target.setWaterQuantity(target.getWaterQuantity() +500);
						//extinguishTargetAndTimeMap.put(world.getTime(), target);
						agent.extinguish(target.getId(), 500);
						}
					}
				}
				if(b instanceof Refuge || b instanceof PoliceOffice
						|| b instanceof FireStation || b instanceof AmbulanceCentre)
					continue;	
//				if(b.getTotalArea()>1000 &&  (b.isFierynessDefined() && b.getFieryness()==0) ){//niu pre water large buildings
//							CSUBuilding target = world.getCsuBuilding(b);			
//							this.waterPower = agent.calculateWaterPower(target); 
//							target.setWaterQuantity(target.getWaterQuantity() + waterPower);
//							//extinguishTargetAndTimeMap.put(world.getTime(), target);
//							
//							System.out.println(world.getTime()+"pre water + area "+b.getTotalArea()+"  waterpower" +waterPower
//									+"  tank  "+world.getConfig().maxTankCapacity);
//							agent.sendExtinguish(target.getId(), waterPower);
//				}
try{				
				if(b.getTotalArea()>3000 &&  (b.isFierynessDefined() && b.getFieryness()==0) ){//niu pre water large buildings
//					
					Pair<Integer, Integer> agentLocation = this.me.getLocation(this.world);
					Pair<Integer, Integer> bLocation = this.me.getLocation(this.world);
					FireCluster targetCluster = ( this.world.getFireClusterManager().findNearestCluster(agentLocation));
					if(targetCluster!=null && !targetCluster.isControllable() ){
					//Set<StandardEntity>sts=targetCluster.getBorderEntities();	
						 Polygon polygon = targetCluster.getConvexObject().getConvexHullPolygon();					
						 Point position = new Point( bLocation.first(),  bLocation.second());
					//for(StandardEntity st1:sts){
						//int dis=world.getDistance(b, st1);
						double distance = Distance.getDistance(polygon, position);//到多边形各頂点最小拒离
						if(distance<100000 
								&& world.getDistance(b.getID(), me.getID())<world.getConfig().extinguishableDistance){//time?
							System.out.println("pre water  "+b.getID());
							SEUBuilding target = world.getSeuBuilding(b);			
							//this.waterPower = agent.calculateWaterPower(target); 
							target.setWaterQuantity(target.getWaterQuantity() + 500);
							//extinguishTargetAndTimeMap.put(world.getTime(), target);
							agent.extinguish(target.getId(),500);				
						}
					//}
				}
				
				}
}catch(Exception e){}
			}
			}
	}
	
	@SuppressWarnings("unchecked")
	public Building assignBuilding() throws ActionCommandException, TimeOutException{	

		Building assigned=null;
			if(world.getTime()%10==1 && agent.getAssignedBuilding()==null/*&& !ActLikeCentre*/){		
				//caculate civiliancluster
				 civilianClusters=world.getClusterManager().getClusters();
//				 if(!civilianClusters.isEmpty()){
//				 for(MRLCluster mc:civilianClusters){
//					 System.out.println("civilian clustars "+mc.getValue() +"center"+mc.getCenter());
//				 }
//				 }
				 importantBuildings.clear();
				if( world.getEstimatedBurningBuildings().size()>10){
					importantBuildings=getTubaoBuilding();
				}else{
					try{
					FireCluster targetCluster = ( this.world.getFireClusterManager().findNearestCluster(me.getLocation(world)));
					Set<StandardEntity> borders=targetCluster.getBorderEntities();
					if(borders!=null){
					for(StandardEntity st:borders){
						if(st instanceof Building && !importantBuildings.contains((Building)st))
						importantBuildings.add((Building)st);
						
					}
					}
				}catch(Exception e){}
				}
			
//				if(getCommCondition() == CommunicationCondition.Good ||
//						getCommCondition() == CommunicationCondition.Medium
//						){
//					try{
//				for(Building b:importantBuildings){
//					//发消息,中心匈牙利
//					
//					//System.out.println(getID()+"time  "+timeStep+"importantbuildings   "+ b.getID());
//					SEUBuilding sb=world.getSEUBuilding(b.getID());
//					EntityID location=getLocation(getTimeStep());
//					if(b.isFierynessDefined()){
//					ImportantBuildingsMessage message=new ImportantBuildingsMessage(
//							b.getID(), getID(),location,b.getFieryness(),
//							 getTimeStep());
//					message.setSender(getMeAsHuman().getID());
//					sendMessage(message,
//							MessagePriority.High);
//					//System.out.println("send  ImportantBuildingsMessage "+message.getAgentId()+" bid" +message.getBuildingId());
//					}
//				}
//					}catch(Exception e){}
//				}else{ 
//					//无通信,自己选一个目标 
//					System.out.println("no connection");
//					agents=getNearbyTeamAgents();
//					List<EntityID> bids=new ArrayList<EntityID>();
//					for(Building b:importantBuildings){
//						EntityID bid=b.getID();
//						if(!bids.contains(bid)){
//							bids.add(bid);
//						}
//					}
//					if(!agents.isEmpty()){
//						System.out.println("have teams");
//					costMatrix = makingCostMatrix(bids, agents);//花費矩阵
//					 int[] assignment = computeVectorAssignments(costMatrix);
//					 try{
//					 for(int i=0;i<assignment.length;i++){
//						//输出对应关系反了？
//									 EntityID agentID=null;	
//									 EntityID buildingID=null;
//									 if(assignment[i]!=-1 && assignment[i]<agents.size()){
//									  agentID=agents.get(assignment[i]).getID();	
//									  buildingID=bids.get(i);
//									 }
//							
//									 if(agentID!=null && buildingID!=null){
//									if(agentID.getValue()==getID().getValue()){
//										System.out.println("set target");
//										Building b=(Building)world.getEntity(buildingID);
//										setTarget(b);
//									}
//									 }
//								 }
//					 }catch(Exception e){}
//					}else{
//						//无通信,自己随机选一个目标
//						System.out.println("no teams randomselect");
//					Random rand=new Random();
//					int randNum=rand.nextInt(importantBuildings.size());
//					setTarget(importantBuildings.get(randNum));
//					}
//					
//				}
//			}
			
			//if(ActLikeCentre){
			//if(world.getTime()%10==2 && assignedBuilding==null){//avoid time outof bound
				List<FireBrigade>agents=world.getFireBrigadeList();		
			if( !importantBuildings.isEmpty() ){
				List<EntityID>bIDS=new ArrayList<EntityID>();
				for(Building b:importantBuildings){
					if(!bIDS.contains(b.getID())){
						bIDS.add(b.getID());
					}
				}
				//System.out.println("make cost matrix");
			costMatrix = makingCostMatrix(bIDS, agents);//花費矩阵
			//}
			//if(world.getTime()%10==3 && assignedBuilding==null){//avoid time outof bound
			 int[] assignment = computeVectorAssignments(costMatrix);//与房屋列表对应的FB烈表 
			
			 for(int i=0;i<assignment.length;i++){
	//输出对应关系反了？
				if(agents.get(i).equals(me)){
					agent.setAssignedBuilding(importantBuildings.get(assignment[i]));
					assigned=agent.getAssignedBuilding();
					break;
				}
//				 AssignImportantBuildingsMessage message=new AssignImportantBuildingsMessage (
//						 buildings.get(assignment[i]),transidoldtonew(agents.get(i).getID().getValue()),timeStep);
//				
//				 //System.out.println("send AssignImportantBuildingsMessage!!!   bID "+
//				// message.getBuildingId()+" AID "+	agents.get(i).getID()); 
//				 message.setSender(getMeAsHuman().getID());
//				 sendMessage(message, MessagePriority.High);
				 
			 }
//			centers.clear();
//			radius.clear();
//			values.clear();
			}
			}	
			agent.isThinkTimeOver("assignTarget");
			return assigned;
			
	}
	
	private FBTarget gasStationHander(FireCluster cluster) {
		Collection<StandardEntity> gasStas = world.getEntitiesOfType(StandardEntityURN.GAS_STATION);
		Set<SEUBuilding> targetGasStas = new HashSet<SEUBuilding>();
		
		Polygon cluster_po = cluster.getConvexObject().getConvexHullPolygon();
		
		for (StandardEntity next : gasStas) {
			GasStation sta = (GasStation) next;
			
			if (sta.isFierynessDefined() && sta.getFieryness() >= 1)
				continue;
			
			if(world.getBorderBuildings().contains(sta))//niu
				continue;
				
			if  (sta.isTemperatureDefined() && sta.getTemperature() < 25)
				continue;
			
			SEUBuilding csuBu = world.getSeuBuilding(next.getID());
			if (csuBu.getWaterQuantity() >= 3000)  // two cycles
				continue;
			
			int[] apexs = sta.getApexList();
			CompositeConvexHull convexHull = new CompositeConvexHull();
			
			for (int i = 0; i < apexs.length; i += 2) {
				convexHull.addPoint(apexs[i], apexs[i + 1]);
			}
			
			Polygon po = convexHull.getConvexPolygon();
			
			int dis = (int) Distance.getDistance(cluster_po, po);
			if (dis <= 5000)
				targetGasStas.add(world.getSeuBuilding(next.getID()));
		}
		
		if (targetGasStas.contains(lastTarget))
			return new FBTarget(cluster, lastTarget);
		
		SEUBuilding tar = null;
		double minDistance = Double.MAX_VALUE;
		for (SEUBuilding next : targetGasStas) {
			double dis = world.getDistance(next.getId(), me.getID());
			if (dis < minDistance) {
				minDistance = dis;
				tar = next;
			}
		}
		
		if (tar != null) {
			this.target = tar;
			return new FBTarget(cluster, tar);
		} else
			return null;
	}
	
	private void searchZones(SeuZone zone) throws ActionCommandException, TimeOutException {
		zone.removeVisitedFromUnvisit(lookedBuildings());////出去所有人看到的房屋
		Set<EntityID> dests = zone.getUnvisitBuildings();
		if (dests.isEmpty())
			return;
		
		Set<StandardEntity> dest = new HashSet<StandardEntity>(dests.size() * 2);
		for (EntityID id : dests) {///////////////////吧目的底换成路
			StandardEntity pos=world.getEntity(id);
			  if(pos instanceof Building){
				 Building  buil=(Building)pos;
			    dest.addAll(world.getEntrance(buil));
			 }
		}

		Point selfL = new Point(me.getX(), me.getY());
		CostFunction costFun = agent.getRouter().getNormalCostFunction();
		Area loca = (Area) world.getSelfPosition();

		List<EntityID> path = agent.getRouter().getMultiDest(loca, dest, costFun, selfL);
		EntityID destId = path.get(path.size() - 1);
		double cost = agent.getRouter().getRouteCost();
		double dis = world.getDistance(loca.getID(), destId);

		if (cost > 20 * dis) {
			zone.removeVisitedFromUnvisit(unreachables(world.getEntity(destId, Area.class)));
			
		} else {
			
			this.agent.sendMove(path);
		}
	}

	
	public SEUBuilding selectTargetWhenStuck(Collection<SEUBuilding> burnBuildings) {
		if (me.getWater() < agent.waterPower)
			return null;
		
		if (burnBuildings == null || burnBuildings.isEmpty())
			return null;

		SEUBuilding targetBuilding = this.getOverallBestBuilding(burnBuildings);
		return targetBuilding;
	}

	public SEUBuilding getOverallBestBuilding(Collection<SEUBuilding> burnBuildings) {
		SortedSet<Pair<EntityID, Double>> sortedSet = new TreeSet<Pair<EntityID, Double>>(agent.pairComparator);
		Building building;

		// the border entities of dying fire cluster
		Set<SEUBuilding> lessValueBuildings = new HashSet<SEUBuilding>();
		// map border buildings that also contains in fire cluster
		Set<SEUBuilding> mapBorderBuildings = new HashSet<SEUBuilding>();
		// all buildings in the main expand direction of each fire cluster
		Set<SEUBuilding> highValueBuildings = this.buildingClassifier(lessValueBuildings, mapBorderBuildings);

		for (SEUBuilding next : burnBuildings) {
			building = next.getSelfBuilding();
			int distance = (int)world.getDistance(agent.location(),building) / 1000;
			// if this building is map border building
			if (mapBorderBuildings.contains(next)) {
				switch (next.getEstimatedFieryness()) {
				case 1:
					next.BUILDING_VALUE = 50 + distance;
					break;
				case 2:
					next.BUILDING_VALUE = 500 + distance;
					break;
				case 3:
					next.BUILDING_VALUE = 10000 + distance;
					break;
				case 4:
				case 5:
				case 6:
				case 7:
					next.BUILDING_VALUE = 20000 + distance;
					break;
				case 8:
				case 0:
					next.BUILDING_VALUE = 25000 + distance;
					break;
				default:
					next.BUILDING_VALUE = 25000 + distance;
					break;
				}
				// if (csuBuilding == lastTarget) {
				// csuBuilding.BUILDING_VALUE /= 1.54;
				// }
				// if (world.isMapHuge()) {
				// csuBuilding.BUILDING_VALUE *= 100;
				// }
				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
						next.BUILDING_VALUE));
				continue;
			}
			// if this building is less value building
			if (lessValueBuildings.contains(next)) {
				switch (next.getEstimatedFieryness()) {
				case 1:
				case 2:
					next.BUILDING_VALUE = 50 + distance;
					break;
				case 3:
					next.BUILDING_VALUE = 5000 + distance;
					break;
				case 4:
				case 5:
				case 6:
				case 7:
					next.BUILDING_VALUE = 7000 + distance;
					break;
				// case 0:
				// next.BUILDING_VALUE = 9000 + distance;
				// break;
				case 8:
					next.BUILDING_VALUE = 20000 + distance;
					break;
				default:
					next.BUILDING_VALUE = 9000 + distance;
					break;
				}
				// if (csuBuilding == lastTarget) {
				// csuBuilding.BUILDING_VALUE /= 1.54;
				// }
				// if (world.isMapHuge()) {
				// csuBuilding.BUILDING_VALUE *= 100;
				// }
				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
						next.BUILDING_VALUE));
				continue;
			}
			// if this building is high value building
			if (highValueBuildings.contains(next)) {
				switch (next.getEstimatedFieryness()) {
				case 1:
					next.BUILDING_VALUE = 1 + distance;
					break;
				case 2:
					next.BUILDING_VALUE = 25 + distance;
					break;
				case 3:
					double temperature = next.getEstimatedTemperature();
					next.BUILDING_VALUE = (temperature >= 150) ? 75
							: 275 - temperature;
					next.BUILDING_VALUE += distance;
					break;
				// case 0:
				// next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35)
				// ? 130 : 160;
				// next.BUILDING_VALUE += distance;
				// break;
				case 4:
					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 40
							: 80;
					next.BUILDING_VALUE += distance;
					break;
				case 5:
				case 6:
					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 75
							: 95;
					next.BUILDING_VALUE += distance;
					break;
				case 7:
					next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 120
							: 170;
					next.BUILDING_VALUE += distance;
					break;
				case 8: // Burnt building
				default:
					next.BUILDING_VALUE = 15000 + distance;
					break;
				}
				// if (csuBuilding == lastTarget) {
				// csuBuilding.BUILDING_VALUE /= 1.54;
				// }
				// if (world.isMapHuge()) {
				// csuBuilding.BUILDING_VALUE *= 100;
				// }
				sortedSet.add(new Pair<EntityID, Double>(building.getID(),
						next.BUILDING_VALUE));
				continue;
			}
			// if this is not those three kind of building
			switch (next.getEstimatedFieryness()) {
			case 1:
				next.BUILDING_VALUE = 50 + distance;
				break;
			case 2:
				next.BUILDING_VALUE = 110 + distance;
				break;
			case 3:
				double temperature = next.getEstimatedTemperature();
				next.BUILDING_VALUE = (temperature >= 150) ? 210
						: 410 - temperature;
				next.BUILDING_VALUE += distance;
				break;
			// case 0:
			// next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ?
			// 190 : 210;
			// next.BUILDING_VALUE += distance;
			// break;
			case 4:
				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ? 160
						: 190;
				next.BUILDING_VALUE += distance;
				break;
			case 5:
			case 6:
				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 150) ? 200
						: 240;
				next.BUILDING_VALUE += distance;
				break;
			case 7:
				next.BUILDING_VALUE = (next.getEstimatedTemperature() >= 35) ? 300
						: 380 + distance;
				break;
			default:
			case 8: // Burnt Building
				next.BUILDING_VALUE = 19000 + distance;
				break;
			}
			// if (csuBuilding == lastTarget) {
			// csuBuilding.BUILDING_VALUE /= 1.54;
			// }
			// if (world.isMapHuge()) {
			// csuBuilding.BUILDING_VALUE *= 100;
			// }
			sortedSet.add(new Pair<EntityID, Double>(building.getID(),
					next.BUILDING_VALUE));
			continue;
		}

		if (sortedSet.size() > 0)
			return world.getSeuBuilding(sortedSet.first().first());
		else
			return null;
	}

	private SortedSet<Pair<Pair<EntityID, Double>, Double>> calculateValue(FireCluster fireCluster) {
		SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings = 
				new TreeSet<Pair<Pair<EntityID, Double>, Double>>(pairComparator_new);
		
		Set<StandardEntity> borderBuildings = new FastSet<StandardEntity>(fireCluster.getBorderEntities());

		Set<SEUBuilding> inDirectionBuildings;
		Point directionPoint =findFarthestPointOfMap(fireCluster, me);
		inDirectionBuildings = fireCluster.findBuildingInDirection(directionPoint);

		borderBuildings.removeAll(seuBuildingToEntity(inDirectionBuildings));

		this.calculateValueOfInDirectionBuildings(inDirectionBuildings, sortedBuildings);
		this.calculateValueOfBorderBuildings(borderBuildings, sortedBuildings);
		
		return sortedBuildings;
	}

	private void calculateValueOfInDirectionBuildings(Set<SEUBuilding> inDirectionBuildings,
			SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings) {
		for (SEUBuilding next : inDirectionBuildings) {
			switch (next.getEstimatedFieryness()) {
			case 0:
				double value_0 = (next.getEstimatedTemperature() >= 35) ? 3 : 20;
				next.BUILDING_VALUE = value_0;
				 
				break;
			case 1:
				next.BUILDING_VALUE = 1;
				 
				break;
			case 2:
				next.BUILDING_VALUE = 9;
				 
				break;
			case 3:
				double estimatedTemperature = next.getEstimatedTemperature();
				double value_3 = (estimatedTemperature >= 150) ? 13 : 17;
				next.BUILDING_VALUE = value_3;
				 
				break;
			case 4:
				double value_4 = (next.getEstimatedTemperature() >= 35) ? 4 : 25;
				next.BUILDING_VALUE = value_4;
				 
				break;
			case 5:
			case 6:
				double value_5_6 = (next.getEstimatedTemperature() >= 35) ? 2 : 25;
				next.BUILDING_VALUE = value_5_6;
				 
				break;
			case 7:
				double value_7 = (next.getEstimatedTemperature() >= 35) ? 11 : 30;
				next.BUILDING_VALUE = value_7;
				 
				break;
			case 8:
			default:
				next.BUILDING_VALUE = 120;
				 
				break;
			}
			if (lastTarget != null && next.getId() == lastTarget.getId()) {
				next.BUILDING_VALUE *= 0.5;
		 
			}
		
			Pair<Integer, Integer> selfLocation = world.getMe().getLocation(world);
			Pair<Integer, Integer> buildingLocation = next.getSelfBuilding().getLocation(world);
			double distance =Distance.getDistance(selfLocation, buildingLocation);
			
			Pair<EntityID, Double> pair = new Pair<EntityID, Double>(next.getSelfBuilding().getID(), distance);
			sortedBuildings.add(new Pair<Pair<EntityID, Double>, Double>(pair, next.BUILDING_VALUE));
		}
	}

	private void calculateValueOfBorderBuildings(Set<StandardEntity> borderBuildings,
			SortedSet<Pair<Pair<EntityID, Double>, Double>> sortedBuildings) {
		SEUBuilding csuBuilding;
		for (StandardEntity next : borderBuildings) {
			
			csuBuilding = world.getSeuBuilding(next.getID());

			switch (csuBuilding.getEstimatedFieryness()) {
			case 0:
				boolean flag = csuBuilding.getEstimatedTemperature() >= 35;
				double value_0 = flag ? 7 : 25;
				csuBuilding.BUILDING_VALUE = value_0;
				break;
			case 1:
				csuBuilding.BUILDING_VALUE = 5;
				break;
			case 2:
				csuBuilding.BUILDING_VALUE = 15;
				break;
			case 3:
				double estimatedTemperature = csuBuilding.getEstimatedTemperature();
				double value_3 = estimatedTemperature >= 150 ? 17 : 21;
				csuBuilding.BUILDING_VALUE = value_3;
				break;
			case 4:
				double value_4 = (csuBuilding.getEstimatedTemperature() >= 35) ? 4 : 25;
				csuBuilding.BUILDING_VALUE = value_4;
				break;
			case 5:
			case 6:
				double value_5_6 = (csuBuilding.getEstimatedTemperature() >= 35) ? 6 : 30;
				csuBuilding.BUILDING_VALUE = value_5_6;
				break;
			case 7:
				double value_7 = (csuBuilding.getEstimatedTemperature() >= 35) ? 19 : 35;
				csuBuilding.BUILDING_VALUE = value_7;
				break;
			case 8:
			default:
				csuBuilding.BUILDING_VALUE = 100;
				break;
			}
			

			if (lastTarget != null) {
				double distance = world.getDistance(lastTarget.getId(), csuBuilding.getId());
				int temp = (int)(distance / MEAN_VELOCITY_DISTANCE);
				csuBuilding.BUILDING_VALUE += temp;
			}
			
			if (lastTarget != null && csuBuilding.getId() == lastTarget.getId()) {
				csuBuilding.BUILDING_VALUE *= 0.5;
			}
			
			
			Pair<Integer, Integer> selfLocation = world.getMe().getLocation(world);
			Pair<Integer, Integer> buildingLocation = next.getLocation(world);
			double distance =Distance.getDistance(selfLocation, buildingLocation);
			
			
			Pair<EntityID, Double> pair = new Pair<EntityID, Double>(next.getID(), distance);
			sortedBuildings.add(new Pair<Pair<EntityID, Double>, Double>(pair, csuBuilding.BUILDING_VALUE));
		}
	}

	/**
	 * Classify buildings.
	 * 
	 * <pre>
	 * 1.lessValueBuildings: the border buildings of dying FireCLuster
	 * 
	 * 2.mapBorderBuildings: the border buildings of map border FireCLuster
	 * 
	 * 3.highValueBuildings: buildings in the expand direction of its FireCluster
	 * 
	 * 4.otherBuildings: the remaining border buildings of FireCluster
	 * </pre>
	 * 
	 * @param lessValue
	 *            a set to store less value buildings
	 * @param mapBorder
	 *            a set to store map border buildings
	 * @return a set of high value buildings
	 */
	private Set<SEUBuilding> buildingClassifier(Set<SEUBuilding> lessValue, Set<SEUBuilding> mapBorder) {
		Set<SEUBuilding> highValueBuildings = new HashSet<SEUBuilding>();
		List<FireCluster> fireClusters = world.getFireClusterManager().getClusters();
		
		ConvexObject convexObject;
		Polygon polygon;
		SEUBuilding csuBuilding;

		for (FireCluster cluster : fireClusters) {
			if (cluster == null)
				continue;
			if (cluster.isDying()) {
				for (StandardEntity next : cluster.getBorderEntities())
					lessValue.add(this.world.getSeuBuilding(next.getID()));
				continue;
			}
			if (cluster.isBorder()) {
				for (StandardEntity next : cluster.getBorderEntities())
					mapBorder.add(this.world.getSeuBuilding(next.getID()));
				continue;
			}
			
			findFarthestPointOfMap(cluster, me);
			convexObject = cluster.getConvexObject();
			if (convexObject == null || convexObject.CENTER_POINT == null
					|| convexObject.CONVEX_POINT == null || convexObject.getConvexHullPolygon() == null)
				continue;
			
			if (cluster.isOverCenter()) {
				polygon = convexObject.getDirectionRectangle();
			} else {
				polygon = convexObject.getTriangle();
			}
			
			for (StandardEntity next : cluster.getBorderEntities()) {
				csuBuilding = world.getSeuBuilding(next.getID());
				int[] vertices = csuBuilding.getSelfBuilding().getApexList();
				for (int i = 0; i < vertices.length; i += 2) {
					if (polygon.contains(vertices[i], vertices[i + 1])) {
						highValueBuildings.add(csuBuilding);
						break;
					}
				}
			}
		}
		
		return highValueBuildings;
	}

	/**
	 * Translate a collection of CSUBuilding into a collection of
	 * StandardEntity.
	 * 
	 * @param csuBuildings
	 *            a collection of CSUBuilding will be translated
	 * @return a collection of StandardEntity
	 */
	private Collection<StandardEntity> seuBuildingToEntity(Collection<SEUBuilding> csuBuildings) {
		Collection<StandardEntity> result = new FastSet<StandardEntity>();
		for (SEUBuilding next : csuBuildings)
			result.add(next.getSelfBuilding());
		return result;
	}
	 public Point findFarthestPointOfMap(FireCluster fireCluster, FireBrigade fbAgent) {
	        math.geom2d.Point2D fireClusterCenter = new math.geom2d.Point2D(fireCluster.getCenter());
	        math.geom2d.Point2D[] points = new math.geom2d.Point2D[4];
	        points[0] = new math.geom2d.Point2D(0, 0);
	        points[1] = new math.geom2d.Point2D(0, world.getMapHeight());
	        points[2] = new math.geom2d.Point2D(world.getMapWidth(), 0);
	        points[3] = new math.geom2d.Point2D(world.getMapWidth(), world.getMapHeight());


	        math.geom2d.Point2D farthestPointOfMap = 
	        		Util.findFarthestPoint(fireCluster.getConvexObject().getConvexHullPolygon(), points);

	        math.geom2d.Point2D targetPoint = 
	        		new math.geom2d.Point2D(farthestPointOfMap.getX(), farthestPointOfMap.getY());

	        double degree = 0;
	        while (degree < 360) {
	            if (fireCluster.haveBuildingInDirectionOf(new Point((int) targetPoint.getX(), 
	            		(int) targetPoint.getY()))) {
	                break;
	            }
	            targetPoint = targetPoint.rotate(fireClusterCenter, 
	            		Math.toRadians((fbAgent.getID().getValue() % 2) == 0 ? 30 : -30));
	            degree += 30;
	        }
	        return new Point((int) targetPoint.getX(), (int) targetPoint.getY());
	    }
	
	 public List<Building> getTubaoBuilding(){//niu 14.2.27凸包
			//System.out.println("time"+timeStep+"tubaokeishi!!!   ");
			
			tubaodian.clear();
			tubaobuilding.clear();		
//			List<Building>  allBurningBuildingsInPartions;
//			allBurningBuildingsInPartions = getBurningBuildingsInPartions();
			Set <SEUBuilding>  allBurningBuildings=world.getEstimatedBurningBuildings();
			List<point> fire = new ArrayList<point>();
			for(SEUBuilding cb: allBurningBuildings){
				//if(b.getFieryness()<=3){//niu14.3.27 
				Building b=cb.getSelfBuilding();
					float x=b.getLocation(world).first();
					float y=b.getLocation(world).second();
					point p=new point();
					p.x=x;
					p.y=y;
					fire.add(p);
					//System.out.println("tubaodian:   "+p.x+" "+ p.y);
				//}
				}
						
				Tubao tu=new Tubao(fire);
				List<point> tubao1=tu.getTubaoPoint();//调用凸包算法
				for(point tp:tubao1){//加到tubaodian列表
					//System.out.println("tubaodian!!!!!:   "+tp.x+tp.y);
					tubaodian.add(tp);
				}
			
			for(point tp: tubaodian){//图包房屋没有？？？
				//System.out.println("suantubaofangwu   ");				
				Collection<StandardEntity>st=world.getObjectsInRange((int)tp.x, (int)tp.y, 10000);
				for(StandardEntity e:st){
					if(e instanceof Building){
						SEUBuilding sb=world.getSeuBuilding(e.getID());						
						if((sb.getEstimatedFieryness()==1 || sb.getEstimatedFieryness()==0)
								&& !world.getBorderBuildings().contains(e)){
						//System.out.println("tubaofangwu   "+e.getID());
							
						tubaobuilding.add((Building)e);
						break;
						}
					}
						}
			}
			
			//System.out.println(timeStep+""+ getID()+"tubaodaxiao" + tubaobuilding.size()   );
			return tubaobuilding;
		}
	 //niu. caculate cost matrix to accomplish assignment
	 public double[][] makingCostMatrix( List<EntityID> buildings,  List<FireBrigade> agents) {
	        int n = agents.size();
	        int m = buildings.size();
	       // System.out.println("huafei");
	        double[][] costMatrix = new double[n][m];
	        
	        //Fieryness f=StandardEntityConstants.Fieryness.HEATING;
	        try{
	        for (int i = 0; i < n; i++) {
	        	StandardEntity location=agents.get(i).getPosition(world);
	            for (int j = 0; j < m; j++) {
	            	
	                double distance=world.getDistance(location.getID(), buildings.get(j))/1000;
	                Building b=(Building)world.getEntity(buildings.get(j));
	                SEUBuilding sb =world.getSeuBuilding(b.getID());
	                
	                int centerX=(int)world.getBounds().getCenterX();
	    			int centerY=(int)world.getBounds().getCenterY();
	    			double distance1=world.distance(centerX, centerY, b.getX(),b.getY())/1000;//distance from the center of the map
	           
	    			int dis = Integer.MAX_VALUE;
	    			GasStation dangerGas=null;
	    			for (GasStation h : world.getAllGasStations()) {
	    				SEUBuilding cb =world.getSeuBuilding(((Building)h).getID());
//	    				if(world.getBorderBuildings().contains(h)){
//	    					System.out.println("border gas"+h.getID());
//	    				}
	    				if((cb.getEstimatedFieryness()<1 || cb.getEstimatedFieryness()==4)
	    						&& !world.getBorderBuildings().contains(h)){
	    				int temp = world.getDistance(b.getID(), h.getID());
	    				if (temp < dis) {
	    					dis = temp;
	    					dangerGas=h;
	    				}
	    				}
	    			}
	    			dis=dis/1000;
	    			int fe=1;
	    			
	    			if(sb.getEstimatedFieryness()==0){
	    				fe=100;
	    			}
	    			if(sb.getEstimatedFieryness()==1){
	    				fe=10;
	    			}
	    			double buildingimportance=fe*b.getTotalArea()/100;
	    			if( dis<80){
	    				System.out.println("cost near gas "+dangerGas.getID());
	    				buildingimportance=buildingimportance+100-dis;
	    				
	    			}
	    			//importance affected by civilians
	    			  for (StandardEntity entity : world.getCivilians()) {
	  	                Civilian civilian = (Civilian) entity;
	  	                if (civilian.isPositionDefined() && sb.getRadiationNeighbourBuildings().contains(civilian.getPosition())) {
	  	                	System.out.println("civilian  val"+10);
	  	                	buildingimportance=buildingimportance+10;
	  	                }
	  	            }
	    			//importance affected by clusters
	    			for(MRLCluster cc:civilianClusters){
	    			if(cc!=null && cc.getValue()>1){
	    				//System.out.println("civilianClusters exist  val"+cc.getValue());
	    				Point cp=cc.getCenter();
	    				Collection<StandardEntity>entities=world.getObjectsInRange(cp.x, cp.y, 10000);
	    				StandardEntity se=null;
	    				for(StandardEntity e:entities){
	    					if(e instanceof Area){
	    						se=e;
	    					}
	    				}
	    				int disfromcluster=world.getDistance(se.getID(), sb.getId())/1000;
	    				if(disfromcluster<cc.getValue()*10 ||disfromcluster<80){
	    					System.out.println("civilianClusters effect  val"+cc.getValue());
	    					buildingimportance=buildingimportance+20*cc.getValue();
	    				}
	            }
	    			}
	                costMatrix[i][j] = buildingimportance/distance1/distance;
	                //System.out.println("cost"+i+"  "+j+costMatrix[i][j]);
	            }
	        }
	        }catch(Exception e){
	        	
	        }


	        return costMatrix;
	    }
	 
	    public int[] computeVectorAssignments(double[][] costMatrix) {
	        HungarianAssignment hungarianAssignment = new HungarianAssignment(costMatrix);
	        int[] temp = hungarianAssignment.execute();
	        
	        int[] result = null;
	        List<Integer> tempList = new ArrayList<Integer>();

	        if (temp != null) {
	            for (int i : temp) {
	                if (i != -1) {
	                	
	                    tempList.add(i);
	                }
	            }

	            result = new int[tempList.size()];
//	            System.out.println("temp length "+temp.length+"tempList.size() ??"+tempList.size()
//	            		+"agents length"+agents.size()+"buildings length"+buildings.size()); 
	            try{
	            for(int i=0;i<tempList.size();i++){
	            	
	            	result[i]=tempList.get(i);
	            	//System.out.println("shishenme ??  "+"  i="+i+" templist i="+tempList.get(i)+" bid "+buildings.get(tempList.get(i))+" aid "+agents.get(i)); 
	            }
	            }catch(Exception e){}


	        }
	//对应于智能体列表的房屋序号列表（如第1个智能体分配给第x个房屋）
	        return result;
	      
	    }
	    
	    public 	SEUBuilding getBestBuilding(List<SEUBuilding> burningBuildings) {//unused
	    	SEUBuilding best = null;
	        double maxVal = Double.MIN_VALUE;
	        for (SEUBuilding b : burningBuildings) {

	            double val = (b.getBuildingAreaTempValue() * 1) + (b.getBuildingRadiation() * 2) - (b.getNeighbourRadiation() * 1);
//	                   if (preTargetBuilding != null && b.equals(preTargetBuilding)) {
//	                       val *= 1.2;
//	                   }
	            int civCount = 0;

	            for (StandardEntity entity : world.getCivilians()) {
	                Civilian civilian = (Civilian) entity;
	                if (civilian.isPositionDefined() && b.getRadiationNeighbourBuildings().contains(civilian.getPosition())) {
	                    civCount++;
	                }
	            }
//	            for (EntityID id : world.getBuried()) {
//	                Human human = (Human) world.getEntity(id);
//	                if (human.isPositionDefined() && b.getRadiationNeighbourBuildings().contains(human.getPosition())) {
//	                    civCount += 2;
//	                }
//	            }

	            val += val * (((double) civCount * 5) / 100.0);
	            if (val > maxVal) {
	                maxVal = val;
	                best = b;
	            }
	        }
	        return best;
	    }
	    
	    public  Comparator<Pair<Pair<EntityID, Double>, Double>> pairComparator_new = 
	    		new Comparator<Pair<Pair<EntityID, Double>, Double>>() {
	    	
	    	@Override
	    	public int compare(Pair<Pair<EntityID, Double>, Double> o1, Pair<Pair<EntityID, Double>, Double> o2) {
	    		if (o1.second().doubleValue() > o2.second().doubleValue())
	    			return 1;
	    		if (o1.second().doubleValue() < o2.second().doubleValue())
	    			return -1;
	    		
	    		if (o1.second().doubleValue() == o2.second().doubleValue()) {
	    			if (o1.first().second().doubleValue() > o2.first().second().doubleValue()) {
	    				return 1;
	    			}
	    			if (o1.first().second().doubleValue() < o2.first().second().doubleValue()) {
	    				return -1;
	    			}
	    			
	    			if (o1.first().second().doubleValue() == o2.first().second().doubleValue()) {
	    				return -1;
	    			}
	    		}
	    		
	    		return 0;
	    	}
	    };

}
