package seu.agent.pf;

import java.awt.Point;
import java.awt.Shape;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import rescuecore2.misc.Pair;
import rescuecore2.misc.geometry.GeometryTools2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.messages.AKClearArea;
import rescuecore2.standard.messages.StandardMessageURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.pf.PFLastTaskType.PFClusterLastTaskEnum;
import seu.agent.pf.Tasks.ClearTools;
import seu.agent.pf.Tasks.HelpOtherTask;
import seu.agent.pf.Tasks.HelpSelfTask;
import seu.agent.pf.Tasks.PFState;
import seu.agent.pf.Tasks.PFTarget;
import seu.agent.pf.Tasks.PFTaskRank;
import seu.agent.pf.Tasks.SEUPFLastTaskType.PFPartitionLastTaskEnum;
import seu.agent.pf.Tasks.SearchTask;
import seu.agent.pf.cluster.Cluster;
import seu.agent.pf.cluster.Clustering;
import seu.common.BasicTask;
import seu.common.TimeOutException;
import seu.geom.Distance;
import seu.model.AgentConstants;
import seu.model.BuriedHumans;
import seu.model.object.SEUBuilding;
import seu.model.object.SEUBuriedHumans;
import seu.model.object.SEUEdge;
import seu.model.object.SEURoad;
import seu.model.object.seuZoneEntity.SeuZone;
import seu.model.route.pov.CostFunction;
import seu.model.route.pov.POVRouter;
import seu.standard.DistanceComparator;




public class PoliceForceAgent extends AbstractPoliceForceAgent {
	private Set<Cluster> cantWorkClusters;
	private Map<EntityID, Pair<EntityID, Integer>> pfMap;
	public Set<Road> buriedEntrances;
	public PFTarget lastPFTarget=null;
	public ClearTools clearTools;
	public Map<EntityID,Integer> visitedStuckedAgents=new HashMap<EntityID,Integer>();
	public Set<Human> nearStuckedAgents = new HashSet<Human>();
	public Map<EntityID,EntityID> firstStuckAgents=new HashMap<EntityID,EntityID>();
	public Set<Road> needCheckEntranceSet;
	public Set<Road> nearEntrances = new HashSet<Road>();
	public Set<Road> entrancesOfBurningRegion;
	public Set<EntityID> visitedEntrances = new HashSet<EntityID>();
	public Set<Refuge> needCheckRefugeSet;	
	public Set<Human> nearBuriedAgents = new HashSet<Human>();
	public Set<Refuge> nearRefuges = new HashSet<Refuge>();
	public List<Road> borderRoad=new ArrayList<Road>();//yuanc14.10.10
	public Set<GasStation> needCheckGasSatationSet=new HashSet<GasStation>();
	public Set<GasStation> nearGasStations = new HashSet<GasStation>();
	public Set<EntityID> visitedGasStations = new HashSet<EntityID>();
	public POVRouter search;
	public List<Blockade> observableBlockades=new ArrayList<Blockade>();
	public PFState selfState;
	public PFPartitionLastTaskEnum partitionLastTaskType;
	public Set<Building> hadSearchBuringBuildings;
	public List<EntityID> lastCyclePath = null;
	public Set<EntityID> visitedRefuges = new HashSet<EntityID>();
	public Set<EntityID> visitedBuriedAgent = new HashSet<EntityID>();
	public PFLastTaskTarget taskTarget;
	public Map<EntityID,EntityID> firstBuriedAgents=new HashMap<EntityID,EntityID>();
	public List<Civilian> observableStuckedCivilians=new ArrayList<Civilian>();
	public List<Human> observableStuckedAgents=new ArrayList<Human>();	
	public List<Road> observableRoads=new ArrayList<Road>();
	public List<Building> observableBuildings=new ArrayList<Building>();
	public List<Civilian> observableCivilians=new ArrayList<Civilian>();
	public List<Human> observableAgents=new ArrayList<Human>();	
	public List<Human> observableBuriedAgents=new ArrayList<Human>();
	public List<Refuge> observableRefuges=new ArrayList<Refuge>();
	public List<Road> observableEntrances=new ArrayList<Road>();
	public List<GasStation> observableGasStations=new ArrayList<GasStation>();
	public Set<Human> cantWorkPF=new HashSet<Human>();
	public boolean searchBurningFlag;
	public int buildingCount;
	public Set<EntityID> buildingsInMyPartition=new HashSet<EntityID>();
	public Set<EntityID> roadsInMyPartition=new HashSet<EntityID>();
	public Cluster currentPartition;
	public List<Cluster> pfPartitions;
	protected Clustering pfPartitionModel;
	public int assignedPartitionIndex;
	public int currentPartitionIndex;
	protected List<BasicTask> tasks;
	public List<Civilian> observableBuriedCivilians=new ArrayList<Civilian>();
	int afterShockTime=300;
	int stuckKeepTime=3;
    public	boolean clearFireFlag=true;

	
	@Override
	protected void initialize() {
		super.initialize();		
		this.needToExpandClusters = new ArrayList<Cluster>(clusters);
		this.expandedClusters = new ArrayList<Cluster>();
		currentCluster = clusters.get(currentClusterIndex);
		expandedClusters.add(currentCluster);
		needToExpandClusters.remove(currentCluster);
		taskTarget = new PFLastTaskTarget();
		
		traversalCriticalAreas = new HashSet<Area>(currentCluster.getCriticalAreas());
		
		clusterLastTaskType = PFClusterLastTaskEnum.NO_TAST;	
		nearBurningBuildings = new HashSet<Building>();
		hadSearchBuringBuildings = new HashSet<Building>();
		entrancesOfBurningZone = new HashSet<Road>();
		searchBurningFlag = true;
		buildingCount = 0;
		for (SeuZone zone : currentCluster.getZoneList()) {
			buildingCount += zone.size();
		}
		//clearStrategy=new ClearStrategy(world);
		cantWorkClusters = new HashSet<Cluster>();
		pfMap = new HashMap<EntityID, Pair<EntityID, Integer>>();	
		buriedEntrances = new HashSet<Road>();		
		search = world.getRouter();
		initializeVisualBuings();		
		pfPartitionModel=(Clustering)world.getPartitionModel();
		assignPartitionToPF();
		initFirstAgentPosition();
		clearTools=new ClearTools(world);
		currentPartition = pfPartitions.get(currentPartitionIndex);
		taskTarget = new PFLastTaskTarget();
		needCheckEntranceSet = new HashSet<Road>(currentPartition.getEntranceList());
		needCheckRefugeSet = new HashSet<Refuge>(currentPartition.getRefugeList());
		if(currentPartition.getRefugeList().isEmpty()){
			needCheckRefugeSet.addAll(getNextCluster().getRefugeList());//
		}
		for(SEUBuilding next:currentPartition.getBuildingList()){
			buildingsInMyPartition.add(next.getId());
		}
		for(Road next:currentPartition.getRoadList()){
			roadsInMyPartition.add(next.getID());
		}
		partitionLastTaskType = PFPartitionLastTaskEnum.NO_TAST;	
		nearBurningBuildings = new HashSet<Building>();
		hadSearchBuringBuildings = new HashSet<Building>();
		entrancesOfBurningRegion = new HashSet<Road>();
		
	//	visitedRefuges = new HashSet<EntityID>();
		System.out.println(toString()  +"  "+ getID()+ "was connected.  ");
	}

	@Override
	protected void BeforeAct() throws TimeOutException {
		super.BeforeAct();
		if(getTimeStep()>world.getConfig().ignoreTime){
			Pair<Integer, Integer> currentLocation = locationHistory.get(getTimeStep());		
			Point currentPoint=new Point(currentLocation.first(),currentLocation.second());
			setCurrentPosition(currentPoint);
			updateNearAgent();		
			updatePfCannotToWork();
			updateObservableEntities();
			updateAfterShockTask();		
		}
		world.getCriticalArea().update(router);
		updatePfCannotToWork();
	}

	@Override
	protected void act() throws ActionCommandException, TimeOutException {

		this.handleTasks();
	}

	/**
	 * If a pf finished its current cluster, then move to next one.
	 */
	public void expandCluster() {
		Cluster nextClusterPF = getNextCluster();
		if (nextClusterPF == null) {
		//	System.out.println("can't find next cluster");
		} else {
			expandedClusters.add(nextClusterPF);
			needToExpandClusters.remove(nextClusterPF);
			currentCluster = nextClusterPF;
			currentClusterIndex = clusters.indexOf(currentCluster);

			needCheckRefugeSet.addAll(nextClusterPF.getRefugeList());
			needCheckEntranceSet.addAll(nextClusterPF.getEntranceList());

			for (SeuZone zone : nextClusterPF.getZoneList()) {
				buildingCount += zone.size();
			}

			searchBurningFlag = true;
		}
	}

	private Cluster getNextCluster() {
		
		ArrayList<Cluster> canToWorkClusters = new ArrayList<Cluster>();
		canToWorkClusters.addAll(clusters);
		canToWorkClusters.removeAll(cantWorkClusters);
		for (Cluster next : cantWorkClusters) {
			if (expandedClusters.contains(next)) {
				continue;
			}
			Cluster closestCluster = Clustering.getClosestCluster(canToWorkClusters, next);
			if (closestCluster.equals(currentCluster)) {
				return closestCluster;
			}
		}
		return Clustering.getClosestCluster(needToExpandClusters, currentCluster);
		
	}

	private void updatePfCannotToWork() {
		this.cantWorkClusters.clear();
		
		Set<EntityID> buriedID = world.getBuriedHumans().getTotalBuriedHuman();
		for (EntityID entityID : buriedID) {
			StandardEntity se = world.getEntity(entityID);
			if (se instanceof PoliceForce) {
				int indexOfCluster = Clustering.getClusterIndexAgentBelongTo(entityID, clusters);
				cantWorkClusters.add(clusters.get(indexOfCluster));
			}
		}

		Collection<StandardEntity> pfSet = world.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);

		for (StandardEntity next : pfSet) {
			Human human = (Human) next;
			StandardEntity position = world.getEntity(human.getPosition());
			if (position instanceof Human) {
				int indexOfCluster = Clustering.getClusterIndexAgentBelongTo(next.getID(), clusters);
				cantWorkClusters.add(clusters.get(indexOfCluster));
			} else if (position instanceof Area) {
				Pair<EntityID, Integer> positionPair = pfMap.get(next);

				if (positionPair == null) {
					positionPair = new Pair<EntityID, Integer>(position.getID(), new Integer(1));
				} else {
					if (position.getID().getValue() == positionPair.first().getValue()) {
						positionPair = new Pair<EntityID, Integer>(
								positionPair.first(), positionPair.second() + 1);

						if (position instanceof Building) {// include refuge
							if (positionPair.second() >= 5) {
								int indexOfCluster = Clustering
										.getClusterIndexAgentBelongTo(next.getID(), clusters);
								cantWorkClusters.add(clusters.get(indexOfCluster));
							}
							
						}else if (positionPair.second() >= 35) {// 35 should be change
							int indexOfCluster = Clustering
									.getClusterIndexAgentBelongTo(next.getID(), clusters);
							cantWorkClusters.add(clusters.get(indexOfCluster));
						}
					} else {
						positionPair = new Pair<EntityID, Integer>(position.getID(), new Integer(1));
					}
				}
				pfMap.put(next.getID(), positionPair);
			}
		}
	}

	
	public SeuZone getBurningZone() {
		if (hadSearchBuringBuildings.size() >= buildingCount) {
			// had done the burning building
			return null;
		}
		nearBurningBuildings.clear();
		nearBurningBuildings.addAll(world.getBurningBuildings());
		nearBurningBuildings.removeAll(hadSearchBuringBuildings);
		
		Cluster initiCluster = clusters.get(assignedClusterIndex);
		
		FOR: for (Iterator<Building> itor = nearBurningBuildings.iterator(); itor.hasNext(); ) {
			Building building = itor.next();
			
			if (initiCluster.containtBuilding(building.getID())) {
				continue FOR;
			}
			
			for (Integer next : initiCluster.getNeighbours()) {
				Cluster cluster = clusters.get(next.intValue());
				if (cluster.containtBuilding(building.getID())) {
					continue FOR;
				}
			}
			
			itor.remove();
		}

		if (nearBurningBuildings.isEmpty())
			return null;
		
		CostFunction costFunc = router.getPfCostFunction();
		Point selfL = new Point(((Human) me()).getX(), ((Human) me()).getY());
		List<EntityID> pathList = router.getMultiAStar(location(), nearBurningBuildings, costFunc, selfL);

		EntityID destination = pathList.get(pathList.size() - 1);
		SeuZone searchZone = world.getZones().getBuildingZone(destination);
		
		return searchZone;
	}
	public SeuZone getNearBurningZone() {
		if (hadSearchBuringBuildings.size() >= buildingCount) {
			// had done the burning building
			return null;
		}
		nearBurningBuildings.clear();
		nearBurningBuildings.addAll(world.getBurningBuildings());
		nearBurningBuildings.removeAll(hadSearchBuringBuildings);
		
		Cluster initiCluster = clusters.get(assignedClusterIndex);
		
		FOR: for (Iterator<Building> itor = nearBurningBuildings.iterator(); itor.hasNext(); ) {
			Building building = itor.next();
			
			if (initiCluster.containtBuilding(building.getID())) {
				continue FOR;
			}
			
			for (Integer next : initiCluster.getNeighbours()) {
				Cluster cluster = clusters.get(next.intValue());
				if (cluster.containtBuilding(building.getID())) {
					continue FOR;
				}
			}
			
			itor.remove();
		}

		if (nearBurningBuildings.isEmpty()){
			return null;
			}
		List<SeuZone> zones=new ArrayList<SeuZone>();
		for(Building b:nearBurningBuildings){
			zones.add( world.getZones().getBuildingZone(b.getID()));
		}
		SeuZone targetZone=null;
		Double dis=Double.MAX_VALUE; 
		for(SeuZone zone:zones){
			if(getCurrentPosition().distance(zone.getZoneCenter())<dis){	
				dis=getCurrentPosition().distance(zone.getZoneCenter());
				targetZone=zone;
			}
		}
		
		return targetZone;
	}
	/**
	 * Get all entrance of a zone, excluding those entrances whose all
	 * beighbours are buildings.
	 * 
	 * @param zone
	 *            the target zone
	 * @return the entrance of target zone
	 */
	public Set<Road> getEntranceOfZone(SeuZone zone) {
		Set<Road> entrancesOfZone = zone.getAllEntranceRoad();
		List<EntityID> neighbours;
		for (Road road : entrancesOfZone) {
			neighbours = road.getNeighbours();
			int roadFlag = 0;
			for (EntityID entityID : neighbours) {
				if (world.getEntity(entityID) instanceof Road) {
					roadFlag = 1;
					break;
				}
			}
			if (roadFlag == 0) {
				entrancesOfZone.remove(road);
			}
		}
		return entrancesOfZone;
	}

	

	@Override
	protected void cantMove() throws SEUAgent.ActionCommandException {
		// TODO Auto-generated method stub
	}
	
	public List<EntityID> getPathToBlockade( Blockade target,List<EntityID>lastCyclePath) {
    	List<EntityID> path = new ArrayList<EntityID>();
		if (!target.isPositionDefined()){
			path.add(world.getSelfPosition().getID());
		}else{
			EntityID blo_A = target.getPosition();
			int b_index = getIndexInPath(lastCyclePath, blo_A);
			if (b_index < lastCyclePath.size()) {
				for (int i = 0; i <= b_index; i++)
					path.add(lastCyclePath.get(i));
			}
			if (path.isEmpty()) {
				path.add(world.getSelfPosition().getID());
			}
		}		
	    return path;
    }
	
	public int getIndexInPath(List<EntityID> path, EntityID location) {
		int index = 0;
		for (EntityID next : path) {
			if (location.getValue() == next.getValue())
				break;
			index++;
		}
		return index;
	}
	
	public void sendClearArea( int destX, int destY) throws ActionCommandException{
		send(new AKClearArea(getID(), getTimeStep(), destX, destY));
		throw new ActionCommandException(StandardMessageURN.AK_CLEAR);
	}
	
	public void sendClearPFTarget(PFTarget pfTarget) throws ActionCommandException{
		lastPFTarget=pfTarget;
		clearTools.clearTarget(pfTarget);
		updatePFTarget();
	}

	public void updatePFTarget(){
		if(lastPFTarget!=null){
			if(lastPFTarget.isDone()){
				switch(lastPFTarget.getTargetType()){
				   case STUCK_HUMAN_IN_ROAD:{				   
					   Human human=world.getEntity(lastPFTarget.getID(), Human.class);
					   if(human instanceof Civilian) break;
					   visitedStuckedAgents.put(lastPFTarget.getID(), getTimeStep());
					   nearStuckedAgents.remove(human);
					   world.getStuckedAgents().remove(lastPFTarget.getID());	
					   firstStuckAgents.remove(human.getID());
					   break;
				   }
				   case FIRST_STUCKED_AGENT:{
					   Human human=world.getEntity(lastPFTarget.getID(), Human.class);
					   if(human instanceof Civilian) break;
					   visitedStuckedAgents.put(lastPFTarget.getID(), getTimeStep());
					   nearStuckedAgents.remove(human);
					   world.getStuckedAgents().remove(lastPFTarget.getID());
					   firstStuckAgents.remove(human.getID());
					   break;
				   }
				   case BLOCKADE_HUMAN_IN_BUILDING:{
					   Human human=world.getEntity(lastPFTarget.getID(), Human.class);
					   nearStuckedAgents.remove(human);
					   world.getStuckedAgents().remove(lastPFTarget.getID());	
					   visitedStuckedAgents.put(lastPFTarget.getID(), getTimeStep());
					   if(lastPFTarget.getClearArea()!=null){
						   needCheckEntranceSet.remove((Road)lastPFTarget.getClearArea());
						   nearEntrances.remove((Road)lastPFTarget.getClearArea());
						   entrancesOfBurningRegion.remove((Road)lastPFTarget.getClearArea());
						   visitedEntrances.add(lastPFTarget.getClearArea().getID());
					   }					   
					   break;
				   }
				   case FIRST_BURIED_AGENT:
                   case BURIED_HUMAN_IN_BUILDING:{
                	   Human human=world.getEntity(lastPFTarget.getID(), Human.class);
                	   nearBuriedAgents.remove(human);
                	   firstBuriedAgents.remove(human.getID());
                	   world.getBuriedHumans().getTotalBuriedHuman().remove(lastPFTarget.getID());
                	   visitedBuriedAgent.add(lastPFTarget.getID());
                	   if(lastPFTarget.getClearArea()!=null){
						   needCheckEntranceSet.remove((Road)lastPFTarget.getClearArea());
						   nearEntrances.remove((Road)lastPFTarget.getClearArea());
						   entrancesOfBurningRegion.remove((Road)lastPFTarget.getClearArea());
						   visitedEntrances.add(lastPFTarget.getClearArea().getID());
					   }					   
					   break;
				   }
                   case BLOCKADE_REFUGE:
                   case SELF_HELP: {
					   Refuge refuge=world.getEntity(lastPFTarget.getID(), Refuge.class);
                	   needCheckRefugeSet.remove(refuge);
                	   visitedRefuges.add(lastPFTarget.getID());
                	   nearRefuges.remove(refuge);
                	   if(lastPFTarget.getClearArea()!=null){
						   needCheckEntranceSet.remove((Road)lastPFTarget.getClearArea());
						   nearEntrances.remove((Road)lastPFTarget.getClearArea());
						   entrancesOfBurningRegion.remove((Road)lastPFTarget.getClearArea());
						   visitedEntrances.add(lastPFTarget.getClearArea().getID());
					   }
					   break;
				   }
                   case BLOCKADE_BUILDING:{
					   break;
				   }
                   case CLEAR_PATH:{
					   
					   break;
				   }
                   case BLOCKADE_ENTRANCE:
                   case BURNING_BUILDING_ENTRANCE:{
                	       Road road=(Road)world.getEntity(lastPFTarget.getID());
               		     
						   boolean a=needCheckEntranceSet.remove(road);
						  
						   boolean c=nearEntrances.remove(road);
						  
						   borderRoad.remove(road);
						   visitedEntrances.add(road.getID());
						 
						   boolean b=entrancesOfBurningRegion.remove(road);
						 
					   break;
				   }
                   
                   case BLOCKADE_GASSTATION:{
					   GasStation gasStation=world.getEntity(lastPFTarget.getID(), GasStation.class);
					   if(lastPFTarget.getClearArea()!=null){
						   needCheckEntranceSet.remove((Road)lastPFTarget.getClearArea());
						   nearEntrances.remove((Road)lastPFTarget.getClearArea());
						   entrancesOfBurningRegion.remove((Road)lastPFTarget.getClearArea());
						   visitedEntrances.add(lastPFTarget.getClearArea().getID());
						   
					   }
					   needCheckGasSatationSet.remove(gasStation);
					   nearGasStations.remove(gasStation);
					   visitedGasStations.add(lastPFTarget.getID());
					   break;
				   }
                   default:{
                   }
				}
			}
		}
	}
	
	public List<EntityID> getPathToAreaInNormal(Area targetArea){
		CostFunction costFunc = search.getPfCostFunction();
		Point selfL = new Point(me().getX(), me().getY());
		return search.getAStar(location(), targetArea, costFunc, selfL);	
	}
	public void sendClearID(EntityID target) throws ActionCommandException {
		sendClear( getTimeStep(),target);
		throw new ActionCommandException(StandardMessageURN.AK_CLEAR);
	}
	  public List<Blockade> getObservableBlockades(){
	    	return observableBlockades;
	    }
	  
	  public List<EntityID> getPathToRoadsInNormal(List<Road> targetAreas){
			CostFunction costFunc = search.getPfCostFunction();
			Point selfL = new Point(me().getX(), me().getY());
			return search.getMultiAStar(location(), targetAreas, costFunc, selfL);	
		}
	  
	  public boolean isInMyPartition(EntityID entityID){
	    	if(buildingsInMyPartition.contains(entityID)){
	    		return true;
	    	}
	    	if(roadsInMyPartition.contains(entityID)){
	    		return true;
	    	}
	    	return false;
	    }
	  @SuppressWarnings({ "rawtypes" })
		public List<BasicTask> getAgentTasks() {
			// TODO Auto-generated method stub
			List<BasicTask> tasks= new ArrayList<BasicTask>();
			tasks.add(new HelpSelfTask(this));
			tasks.add(new HelpOtherTask(this));
			tasks.add(new SearchTask(this));
			return tasks;
		}
	  public void handleTasks() throws ActionCommandException, TimeOutException {
			
			if (tasks == null)  
				tasks = getAgentTasks();
		 
			for (BasicTask task : tasks) {		 
					task.execute()		 ;
			}

		}	
	  
	  protected void assignPartitionToPF() {
			Collection<StandardEntity> allPF = world.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);
			pfPartitions = pfPartitionModel.KMeansPlusPlus(allPF.size(), world.getZones());
			pfPartitionModel.assignAgentsToClusters(allPF, pfPartitions, world);
			assignedPartitionIndex = pfPartitionModel.getClusterIndexAgentBelongTo(getID(), pfPartitions);
			currentPartitionIndex = assignedPartitionIndex;	
			
		}
	  private void initFirstAgentPosition(){
			Human human;
			for (StandardEntity entity : world.getAgents()) {
	            human = (Human) entity;
	            if (human.getPosition(world) instanceof Road&&!(human instanceof PoliceForce)) {
	            	firstStuckAgents.put(entity.getID(), human.getPosition());
	            }
	            if (human.getPosition(world) instanceof Building&&human.getID()!=getID()) {
	             	firstBuriedAgents.put(human.getID(),human.getPosition());
	            }
			}
		}
	  public void updateObservableEntities(){
	    	observableBlockades.clear();
	    	observableRoads.clear();
	    	observableBuildings.clear();
	    	observableCivilians.clear();
	    	observableAgents.clear();
	    	observableGasStations.clear();
	    	observableRefuges.clear();
	    	observableStuckedAgents.clear();
	    	observableBuriedAgents.clear();
	    	observableStuckedCivilians.clear();
	    	observableBuriedCivilians.clear();
	    	observableEntrances.clear();
	    	
	    	for(EntityID next:changeSet.getChangedEntities()){
	    		StandardEntity nextEntity=world.getEntity(next);
	    		if(nextEntity instanceof Blockade){
	    			Blockade blockade=(Blockade)nextEntity;
	    			observableBlockades.add(blockade);
	    		}
	            if(nextEntity instanceof Road){
	            	SEURoad road = world.getSeuRoad(nextEntity);
					if (!road.isEntrance())
						continue;
					if (road.getSelfRoad().isBlockadesDefined() && road.getSelfRoad().getBlockades().size() > 0)
						continue;	
				
					if (road.isNeedlessToClear()){
						needCheckEntranceSet.remove(road.getSelfRoad());
					    nearEntrances.remove(road.getSelfRoad());
					    entrancesOfBurningRegion.remove(road.getSelfRoad());
					    visitedEntrances.add(road.getId());
					}				
	    			
	    		}
	            if(nextEntity instanceof Building){
	    			if(nextEntity instanceof Refuge){
	    				if (visitedRefuges.contains(nextEntity.getID())) {
	    					nearRefuges.remove((Refuge)nextEntity);
	    					continue;
	    				}else{
	    					if(isNeedClearBuilding((Building)nextEntity)){
	    						nearRefuges.add((Refuge) nextEntity);
	    	    				observableRefuges.add((Refuge) nextEntity);
	    	    				continue;
	    					}else{
	    						visitedRefuges.add(next);
	    						nearRefuges.remove((Refuge)nextEntity);
	        					continue;
	    					}
	    				}    				
	    			}else if(nextEntity instanceof GasStation){
	                	if (visitedGasStations.contains(nextEntity.getID())) {
	    					nearGasStations.remove((GasStation)nextEntity);
	    					needCheckGasSatationSet.remove((GasStation)nextEntity);
	    					continue;
	    				}else{
	    					if(isNeedClearBuilding((Building)nextEntity)){
	    						nearGasStations.add((GasStation) nextEntity);
	    						observableGasStations.add((GasStation) nextEntity);
	    	    				continue;
	    					}else{
	    						visitedGasStations.add(next);
	    						nearGasStations.remove((GasStation)nextEntity);
	    						needCheckGasSatationSet.remove((GasStation)nextEntity);
	        					continue;
	    					}
	    				}
	    			}else{
	    				
	    			
	    				
	    			}
	    			Building building=(Building)nextEntity;
	    			if (!building.isFierynessDefined())
						continue;
					if (building.getFieryness() == 8 || building.getFieryness() == 7 || building.getFieryness() == 3) {
						List<Road> entrances=world.getEntrance(building);					
						if(entrances!=null&&!entrances.isEmpty()){
							for(Road road:entrances){
							   needCheckEntranceSet.remove(road);
							   entrancesOfBurningRegion.remove(road);
						       nearEntrances.remove(road);
						       entrancesOfBurningRegion.remove(road);
						       visitedEntrances.add(road.getID());
							}
						}
					}
	                
	    		}
	                    
	            if(nextEntity instanceof Human){
	            	Human human = (Human) nextEntity;
	            	if(!human.isHPDefined()||human.getHP()<=0) continue;
	            	if(nextEntity instanceof Civilian){
	            		if(human.getPosition(world) instanceof Human){
	            			continue;
	            		}
	                    Area humanArea=(Area)human.getPosition(world);
	                    if(humanArea!=null){
	                    	if(humanArea instanceof Road){
	                    		if(humanArea.getID().getValue()==location().getID().getValue()){
	                    				if(human.isDamageDefined()&&human.getDamage()>0){
	                    					if(isBlockadeContainOrIntsect(human)){
	                    						observableStuckedCivilians.add((Civilian)human);
	                    					}
	                    				}                  			
	                    		}
	                    	}else if(humanArea instanceof Building){
	                    		
	                    	}
	                    }else{                   	                   
	                    }
	           		}else{      
	           			if(human.getID().getValue()==getID().getValue()) continue;	
	           			StandardEntity loca = human.getPosition(world);      
	           			if(loca instanceof Road){
	           				if(isBlockadeContainOrIntsect(human)&&!(human instanceof PoliceForce)){
	           					if(!visitedStuckedAgents.keySet().contains(human.getID())){
	            					observableStuckedAgents.add(human);
	            					nearStuckedAgents.add(human);
	           					}
	           					
	        				}else if(!isBlockadeContainOrIntsect(human)){
	        					observableStuckedAgents.remove(human);
	        					nearStuckedAgents.remove(human);        					
	        				}
	           			}else if(loca instanceof Building&&!(loca instanceof Refuge)){
	           				if(human.isBuriednessDefined() && human.getBuriedness()==0 && 
	           						human.isPositionDefined()&&!(human instanceof PoliceForce)){
	           					List<Road> entrances=world.getEntrance((Building)loca);
	               				if(entrances!=null&&!entrances.isEmpty()){
	               					for(Road next1:entrances){
	               						if(isVisible(next1)){
	               							SEURoad seuRoad=world.getSeuRoad(next1.getID());
	               							if(!seuRoad.isNeedlessToClear()&&
	               									!visitedStuckedAgents.keySet().contains(human.getID())){
	               							
	               								observableStuckedAgents.add(human);
	               	        					nearStuckedAgents.add(human);
	               								break;
	               							}else{
	               								observableStuckedAgents.remove(human);
	               								nearStuckedAgents.remove(human);
	               								break;
	               							}
	               						}
	               					}
	               				}else{
	               					nearStuckedAgents.remove(human);
	              				}            				
	           				}          				
	           			}          			
	           			if (visitedBuriedAgent.contains(nextEntity.getID())) {
	    					nearBuriedAgents.remove((Human)nextEntity);
	    					continue;
	    				}          			
	    				if (human.isBuriednessDefined() && human.getBuriedness() > 0 && human.isPositionDefined()) {   					
	    					if (loca instanceof Building) {
	    						if(!visitedBuriedAgent.contains(human.getID())){
	    						nearBuriedAgents.add(human);
	    						observableBuriedAgents.add(human);
	    						}
	    					}
	    				}   				
	           		}
	    		}           
	    	}
	   
	    }
	  
		private void updateNearAgent() {
			if (location() instanceof Refuge) {
				visitedRefuges.add(location().getID());
				nearRefuges.remove((Refuge) location());
				needCheckRefugeSet.remove((Refuge) location());
			}
			
			FOR:for (Iterator<Human> itor = nearBuriedAgents.iterator(); itor.hasNext(); ) {
				Human human = itor.next();			
				if (!human.isPositionDefined()) {		
					visitedBuriedAgent.add(human.getID());
					itor.remove();
					continue;
				}			
				StandardEntity loca = human.getPosition(world);
				if (!(loca instanceof Building)) {				
					visitedBuriedAgent.add(human.getID());
					itor.remove();
					continue;
				}		
				Building building = (Building) loca;			
				for (Road next : world.getEntrance(building)) {
				    if (!isVisible(next.getID())) continue;  
					SEURoad road = world.getSeuRoad(next.getID());
					if (road.isNeedlessToClear()) {						
						visitedBuriedAgent.add(human.getID());
						itor.remove();
						continue FOR;
					}
				}
			}
		    FOR:for (Iterator<Human> itor = nearStuckedAgents.iterator(); itor.hasNext(); ) {
			   Human human = itor.next();			
			   if (!human.isPositionDefined()) {
				   itor.remove();
				   continue;
			   }			
			   StandardEntity loca = human.getPosition(world);
			 
			   if (!isVisible(loca.getID())) continue; 
			   if (loca instanceof Road){
			   SEURoad road = world.getSeuRoad(loca.getID());
			   if (road.isNeedlessToClear()) {		
					   continue FOR;
				   }
			   }
			   if(visitedStuckedAgents.containsKey(human.getID())){
				   itor.remove();
				   continue FOR;
			   }
			   if(loca instanceof Building){
				   List<Road> roads = world.getEntrance((Building) loca);
				   if(roads!=null&&!roads.isEmpty()){
					   for(Road next:roads){
						   SEURoad road = world.getSeuRoad(next.getID());
						   if (road.isNeedlessToClear()) {		
								   itor.remove();
								   continue FOR;
							   } 
					   }
				   }else{
					   itor.remove();
					   continue FOR;
				   }
			   }
		    }	
			if(!visitedStuckedAgents.isEmpty()){
				for (Iterator<Map.Entry<EntityID, Integer>> itor = visitedStuckedAgents.entrySet().iterator(); itor.hasNext(); ) {
					Map.Entry<EntityID, Integer> entry=itor.next();
					if(getTimeStep()-entry.getValue()>stuckKeepTime){
						itor.remove();
					}			
				}
			}	
		}
		
		private void updateAfterShockTask(){
			if(getTimeStep()<10) return;
			if(afterShockTime!=300) return;
			if(getAfterShockTime()>0&&getAfterShockTime()<300){
				afterShockTime=getAfterShockTime();
				//println("happen AfterShock");
				if(getTimeStep()==afterShockTime){
				visitedRefuges.clear();
				if(!expandedClusters.isEmpty()){
					for(Cluster next:expandedClusters){
						needCheckEntranceSet.addAll(next.getEntranceList());
						needCheckRefugeSet.addAll(next.getRefugeList());
					}
				}
				
				Human human;
				for (StandardEntity entity : world.getAgents()) {
		            human = (Human) entity;
		            if (human.getPosition(world) instanceof Building&&human.getID()!=getID()) {
		             	firstBuriedAgents.put(human.getID(),human.getPosition());
		            }
				}
			}
		}
	}	
		public boolean isNeedClearBuilding(Building building){
	    	List<Road> entrances=world.getEntrance(building);
	    	if(entrances==null||entrances.isEmpty()){
	    		return false;
	    	}else{
	    		for(Road next:entrances){ 			
	    			if(next.isBlockadesDefined()&&next.getBlockades().isEmpty()){
	    				return false;
	    			}
	    			if(!(building instanceof Refuge)){
	    				SEURoad road = world.getSeuRoad(next);
	        			if(road.isNeedlessToClear()){
	        				return false;
	        			}
	    			}   			
	    		}
	    	}
	    	return true;
	    }
		
		public boolean isBlockadeContainOrIntsect(Human human){
	    	Blockade blockade = getContainOrinsectBlockade(human);                  
	        if(blockade!=null){
	        	return true;
	        }
	    	return false;
	    }
		
		public Blockade getContainOrinsectBlockade( Human human) {
	        Blockade coveringBlockade = null;
	        
	        if (human != getMeAsHuman() && !human.isPositionDefined()) {
	            // Do nothing.
	        } else {
	            StandardEntity se = world.getEntity(human.getPosition());
	            if (se instanceof Road) {
	                Blockade blockade;
	                Road road = (Road) se;
	                Shape shape;
	                if (road.isBlockadesDefined()) {
	                    for (EntityID id : road.getBlockades()) {
	                        blockade = (Blockade) world.getEntity(id);
	                        if (blockade != null && blockade.isApexesDefined()) {
	                            shape = blockade.getShape();
	                            if (shape.contains(human.getX(), human.getY())||
	                            		blockade.getShape().intersects(getBounds(human, world))) {
	                                coveringBlockade = blockade;
	                                break;
	                            }
	                        }
	                    }
	                }
	            }

	        }
	        return coveringBlockade;
	    }
		
	public boolean isInFire(EntityID e){
		StandardEntity entity=world.getEntity(e);
		if(entity instanceof Building){
			Building building=(Building)entity;
			if(building.isFierynessDefined()&&building.getFieryness()>0){
				return true;
			}else{
				for(EntityID next:building.getNeighbours()){
					StandardEntity s=world.getEntity(e);
					if(s instanceof Building){
						Building bu=(Building)entity;
						if(bu.isFierynessDefined()&&bu.getFieryness()>0){
							return true;
						}
					}
				}
				
			}
			
		}else if(entity instanceof Road){
			for(EntityID next:((Road) entity).getNeighbours()){
				StandardEntity s=world.getEntity(e);
				if(s instanceof Building){
					Building building=(Building)entity;
					if(building.isFierynessDefined()&&building.getFieryness()>0){
						return true;
					}
				}
			}
			
		}else if(entity instanceof Human){
			EntityID area=((Human)entity).getPosition();
			StandardEntity a=world.getEntity(area);
			if(a instanceof Building){
				Building building=(Building)a;
				if(building.isFierynessDefined()&&building.getFieryness()>0){
					return true;
				}else{
					for(EntityID next:building.getNeighbours()){
						StandardEntity s=world.getEntity(e);
						if(s instanceof Building){
							Building bu=(Building)entity;
							if(bu.isFierynessDefined()&&bu.getFieryness()>0){
								return true;
							}
						}
					}
					
				}
				
			}else if(a instanceof Road){
				for(EntityID next:((Road) a).getNeighbours()){
					StandardEntity s=world.getEntity(e);
					if(s instanceof Building){
						Building building=(Building)entity;
						if(building.isFierynessDefined()&&building.getFieryness()>0){
							return true;
						}
					}
				}
				
			}
			
		}
		
		return false;
		
	}
	
	public void finishCurrent() {
		if(lastPFTarget!=null&&lastPFTarget.getID()!=null){			
			if(!lastPFTarget.isDone()){
				if(isInFire(lastPFTarget.getID())){
	System.out.println(getTimeStep()+"   "+getID()+"search finish"+lastPFTarget.getID());

					lastPFTarget.setDone();
					updatePFTarget();	
				}
			}
		}	
	}
		
	@Override
	public String toString() {
		return "SEU PoliceForce ";
	}
}
