package seu.agent.pf.Tasks;

import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;



import javolution.util.FastSet;
import rescuecore2.misc.Pair;
import rescuecore2.misc.geometry.GeometryTools2D;
import rescuecore2.misc.geometry.Line2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.misc.geometry.Vector2D;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.standard.messages.StandardMessageURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.SEUAgent.ActionCommandException;
import seu.agent.pf.PoliceForceAgent;
import seu.geom.Distance;
import seu.geom.GeomUtil;
import seu.model.SEUWorldModel;
import seu.model.object.SEUBlockade;
import seu.model.object.SEUEdge;
import seu.model.object.SEURoad;
import seu.model.route.pov.CostFunction;
import seu.standard.DistanceComparator;
import seu.util.MultiBlockDistanceComparator;
import seu.util.Util;



public class ClearTools {
    private SEUWorldModel world;
    PoliceForceAgent agent;
    int maxClearDistance;    
    int clearRadius;
    int extinguishableDistance;
    public static final int AGENT_SIZE = 1000;
    private static final int SECURE_RANGE = 300;
    public static final int AGENT_PASSING_THRESHOLD = 725;
    private Line2D lastClearLine;
    private Line2D lastGuideline;
    private List<EntityID> lastLineAreas;
    private EntityID lastTarget;
    private boolean wasOnBlockade = false;
    private boolean clearBlockadesOnWay = true;
    private List<EntityID> lastClearPath=new ArrayList<EntityID>();
    private PFTarget pfTarget;
    
    protected int lastClearDest_x = -1, lastClearDest_y = -1;
	protected int count = 0, lock = 4;

    public ClearTools(SEUWorldModel world) {
        this.world = world;
        agent=(PoliceForceAgent) world.getAgent();
        maxClearDistance = world.getConfig().repairDistance;
        clearRadius=world.getConfig().repairRad;
        extinguishableDistance=world.getConfig().extinguishableDistance;
    }
    
    
    
    public void clearTarget(PFTarget target1) throws ActionCommandException{
    	pfTarget=target1;
    	if(pfTarget==null||pfTarget.getID()==null) return;
    	StandardEntity targetEntity=world.getEntity(pfTarget.getID());
    	if(targetEntity==null){
    		pfTarget.setDone();
    	    return;
    	}
    	if(pfTarget.getTargetType()==SEUPFTargetType.STUCK_HUMAN_IN_ROAD||
    			pfTarget.getTargetType()==SEUPFTargetType.FIRST_STUCKED_AGENT){
    		Human targetHuman=(Human)targetEntity;
    		Area targetArea=(Area)targetHuman.getPosition(world);			  		
    		if(targetArea==null){   			
    			pfTarget.setDone();   			
				return;
    		}
    		if(targetArea instanceof Road){
    			if(pfTarget.getBuilding()==null){
    				Road r=(Road)targetArea;
    				if(world.isEntrance(r)){    					
    					pfTarget.setBuilding(world.getBuilding(r));
    				}				
    			}
    		}
    		if(targetArea instanceof Building){
    			Building b=(Building)targetArea;    			
    			if(pfTarget.getBuilding()!=null&&!pfTarget.getBuilding().isEmpty()){    				
        			if(pfTarget.getBuilding().contains(b)){       				
        				List<Road> r=world.getEntrance(b);
        				if(r!=null&!r.isEmpty()){
        					targetArea=r.get(0);
        					Area agentArea=agent.location();
        					if(agentArea.getID().getValue()==targetArea.getID().getValue()){
        			         					
        						if(agentArea.isBlockadesDefined()&&!agentArea.getBlockades().isEmpty()){
        					    	Blockade targetBlockade=getClosestBlockadeInCurrentLocation();
        					    	if(targetBlockade!=null){                    		
        					    		clearBlockadeID(targetBlockade);
        					    	}
        					    }           					
        						pfTarget.setDone();
        				    	pfTarget.setClearArea(targetArea);
        				    	return;				
        					}else{     						
        						List<EntityID> clearPath=agent.getPathToAreaInNormal(targetArea);
        						if(clearPath!=null&&clearPath.size()>1){
        							clearPathInProcess(clearPath);    	
        						}       										
        					}
        				}
        			}
        		} 
    		
				pfTarget.setDone();
				return;
    		}
    		
    		if(agent.isVisible(targetArea.getID())){
				if(!agent.isVisible(targetHuman)){
					pfTarget.setDone();
					return;
				}
    		}
    		
    			if(targetArea instanceof Road){
    				Area agentPos=agent.location();
    				if(agentPos.getID().getValue()==targetArea.getID().getValue()){
    					
    					clearStuckedHuman(targetHuman);
    					/*if(agent.isVisible(targetHuman)&&agent.isBlockadeContainOrIntsectOrNear(targetHuman)){
    			    		Blockade coveringBlockade=agent.getContainOrinsectOrNearBlockade(targetHuman);
    			    		if(coveringBlockade!=null){
    			    			
    			    		}
    					}*/
    					pfTarget.setDone();					
		    			return;
    				}else{
    					List<EntityID> path=null;
    					if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
    						path=pfTarget.getClearPath();
    					}else{
    						path=agent.getPathToAreaInNormal(targetArea);
    					}
    					if(path!=null&&!path.isEmpty()){
    					
    						clearPathInProcess(path);   
    					}else{
    	    				pfTarget.setDone();
    		    			return;
    					}   					 					
    				}
    			}else{
    				pfTarget.setDone();
	    			return;
    			}
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_HUMAN_IN_BUILDING||
    			pfTarget.getTargetType()==SEUPFTargetType.BURIED_HUMAN_IN_BUILDING||
    			pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_BUILDING||      			
    			pfTarget.getTargetType()==SEUPFTargetType.FIRST_BURIED_AGENT){		
    		Building targetBuilding=null;    		   		
    		if(targetEntity instanceof Human){    			
    			StandardEntity e1=((Human)targetEntity).getPosition(world);
    			if(e1 instanceof Building){
    				targetBuilding=(Building)e1;
    				if(pfTarget.getRoad()==null){   	    			  					    					
    	    			pfTarget.setRoad(world.getEntrance(targetBuilding));				 	    			
    	    		}
    			}else{   				
    	    		if(e1 instanceof Road){
    	    			Road r=(Road)e1;
    	    			if(pfTarget.getRoad()!=null&&!pfTarget.getRoad().isEmpty()){
    	        			if(pfTarget.getRoad().contains(r)){
    	        				Area targetArea=r;
    	        				Area agentArea=agent.location();
    	        				if(agentArea.getID().getValue()==targetArea.getID().getValue()){
    	        					if(agentArea.isBlockadesDefined()&&!agentArea.getBlockades().isEmpty()){
    	        					    Blockade targetBlockade=getClosestBlockadeInCurrentLocation();
    	        					    if(targetBlockade!=null){                    		
    	        					    	clearBlockadeID(targetBlockade);
    	        					    }
    	        					}				
    	        					pfTarget.setDone();
    	        				    pfTarget.setClearArea(targetArea);
    	        				    return;				
    	        				}else{
    	        					List<EntityID> clearPath=agent.getPathToAreaInNormal(targetArea);
    	        					if(clearPath!=null&&clearPath.size()>1){
    	        						clearPathInProcess(clearPath);    	
    	        					}       										
    	        				}
    	        		   }
    	        	   } 
    	    	   }
        		   pfTarget.setDone();
        		   return;
    			}    			
    		}else if(targetEntity instanceof Building){
    			targetBuilding=(Building)targetEntity;
    		}else{
    			pfTarget.setDone();
    			return;
    		}
    		Area targetArea=null;
			Area agentArea=agent.location();   		
			List<EntityID> clearPath=new ArrayList<EntityID>();
    		if(pfTarget.getClearArea()!=null){
    			targetArea=pfTarget.getClearArea();
    			clearPath=agent.getPathToAreaInNormal(targetArea);
    		}else{
    			List<EntityID> path=null;
    			if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
    				path=pfTarget.getClearPath();
    			}else{
    				path=agent.getPathToAreaInNormal(targetBuilding);
    			} 				
    			if(path==null||path.isEmpty()){
    				pfTarget.setDone();								
    				return;
    			}else{
    				if(path.size()==1){
    					if(agent.location().getID().getValue()==path.get(0).getValue()){							
    						pfTarget.setDone();								
    						return;
    					}else{
    						pfTarget.setDone();	
    						return;
    					}
    				}
    			}   							
    			int index=0;
    			for(index=path.size()-2;index>=0;index--){
    				Area pathArea=world.getEntity(path.get(index), Area.class);
    				if(pathArea instanceof Building){						
    					continue;
    				}else if(pathArea instanceof Road){
    					break;
    				}
    			}				
    			if(index>=0&&index<=path.size()-2){
    				for(int i=0;i<=index;i++){
    					clearPath.add(path.get(i));
    				}
    				targetBuilding=world.getEntity(path.get(index+1), Building.class);
    				targetArea=world.getEntity(clearPath.get(clearPath.size()-1),Area.class);
    				pfTarget.setClearArea(targetArea);
    			}else{
    				pfTarget.setDone();
    				return;
    			}   			
    		}				

			if(agentArea.getID().getValue()==targetArea.getID().getValue()){
				if(agentArea.isBlockadesDefined()&&!agentArea.getBlockades().isEmpty()){
			    	Blockade targetBlockade=getClosestBlockadeInCurrentLocation();
			    	if(targetBlockade!=null){                    		
			    		clearBlockadeID(targetBlockade);
			    	}
			    }				
				pfTarget.setDone();
		    	pfTarget.setClearArea(targetArea);
		    	return;
		    	
				
			}else{
				clearPathInProcess(clearPath);    					
			}
			  		
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_REFUGE){
    		Building targetBuilding=(Building)targetEntity;
    		Area targetArea=null;
			Area agentArea=agent.location();
			List<EntityID> clearPath=new ArrayList<EntityID>();
    		if(pfTarget.getClearArea()!=null){
    			targetArea=pfTarget.getClearArea();
    			clearPath=agent.getPathToAreaInNormal(targetArea);
    		}else{
    			List<EntityID> path=null;
    			if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
    				path=pfTarget.getClearPath();
    			}else{
    				path=agent.getPathToAreaInNormal(targetBuilding);
    			} 				
    			if(path==null||path.isEmpty()){
    				pfTarget.setDone();								
    				return;
    			}else{
    				if(path.size()==1){
    					if(agent.location().getID().getValue()==path.get(0).getValue()){							
    						pfTarget.setDone();								
    						return;
    					}else{
    						pfTarget.setDone();	
    						return;
    					}
    				}
    			}   							
    			int index=0;
    			for(index=path.size()-2;index>=0;index--){
    				Area pathArea=world.getEntity(path.get(index), Area.class);
    				if(pathArea instanceof Building){						
    					continue;
    				}else if(pathArea instanceof Road){
    					break;
    				}
    			}				
    			if(index>=0&&index<=path.size()-2){
    				for(int i=0;i<=index;i++){
    					clearPath.add(path.get(i));
    				}
    				targetBuilding=world.getEntity(path.get(index+1), Building.class);
    				targetArea=world.getEntity(clearPath.get(clearPath.size()-1),Area.class);
    				pfTarget.setClearArea(targetArea);
    			}else{
    				pfTarget.setDone();
    				return;
    			}   			
    		}

    		
			if(agentArea.getID().getValue()==targetArea.getID().getValue()){
			    if(agentArea.isBlockadesDefined()&&!agentArea.getBlockades().isEmpty()){
			    	Blockade targetBlockade=getClosestBlockadeInCurrentLocation();
			    	if(targetBlockade!=null){
			    		clearBlockadeID(targetBlockade);
			    	}
			    }else{
			    	SEURoad seuRoad=world.getSeuRoad(targetArea);
	    			if(!seuRoad.isNeedlessToClear()){	    					    			
	    				Blockade targetBlockade=getClosestBlockade();
	    				if(targetBlockade!=null){
	    					if(isInClearRange(targetBlockade)){
	    						Point2D myPoint = new Point2D(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY());
	    						Point clearPoint=getClosestPointToBlock(targetBlockade, agent.getCurrentPosition());
	    						Point2D clearPoint1=new Point2D(clearPoint.getX(), clearPoint.getY());
	    						Line2D me2nextAC = new Line2D(myPoint,clearPoint1);
	    						 me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);
	    						agent.sendClearArea((int)me2nextAC.getEndPoint().getX(), (int)me2nextAC.getEndPoint().getY());
	    					}	    	    					
	    				}
	    			}
			    }
			    pfTarget.setDone();
		    	pfTarget.setClearArea(targetArea);
		    	return;    
			}else{					
				clearPathInProcess(clearPath);    					
			}
			
    		
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.CLEAR_PATH){
    		List<EntityID> clearPath=new ArrayList<EntityID>();
    		Area targetArea;
    		if(pfTarget.isOnClearPath()){
    			clearPath=pfTarget.getClearPath();
    			targetArea=world.getEntity(pfTarget.getID(), Area.class);
    		}else{
    			targetArea=world.getEntity(pfTarget.getClearPath().get(0), Area.class);
    			clearPath=agent.getPathToAreaInNormal(targetArea);
    		}
    		if(clearPath!=null&&!clearPath.isEmpty()&&targetArea!=null){
    			Area agentArea=agent.location();
    			if(agent.isVisible(targetArea.getID())){
					if(!isNeedClearRoad((Road)targetArea)){
						pfTarget.setDone();   
	    				pfTarget.setClearArea(targetArea);
	    				return;
					}
				}
    			if(agentArea.getID().getValue()==targetArea.getID().getValue()){
    				if(targetArea instanceof Road){
    					clearRoad((Road)targetArea);
        				if(pfTarget.isOnClearPath()){
        					pfTarget.setDone();
        					return;
        				}else{
        					pfTarget.setOnClearPath();
        					clearTarget(pfTarget);
        				}
    				}else{
    					pfTarget.setDone();
    					return;
    			
    				}
    			}else{
    				clearPathInProcess(clearPath);
    			}
    		}else{
    			pfTarget.setDone();
    			return;
    		}
    		
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_ENTRANCE){
    		Area targetArea=(Area)targetEntity;
    		if(targetArea instanceof Road){
				Area agentArea=agent.location();
               Road   entrance=(Road)targetArea;
				if(agentArea.getID().getValue()==targetArea.getID().getValue()){
		            List<Building>bs=new ArrayList<Building>();
		            List<Building>buildings=new ArrayList<Building>();
		            if(world.isEntrance(entrance)){
					buildings=world.getBuilding(entrance);
					}
					for(Building b:buildings){
						if(buildingHasHuman(b)){
							bs.add(b);
						}
					}
				//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman"+bs);

					if(!bs.isEmpty()){
					//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman"+bs);

					     if(agentArea.isBlockadesDefined()&&!agentArea.getBlockades().isEmpty()){
                        	Blockade targetBlockade=getClosestBlockadeInCurrentLocation();
                    	    if(targetBlockade!=null){
                   // 			System.out.println(agent.getTimeStep()+"   "+agent.getID()+"entrance"+targetBlockade.getID());

                    	    	clearBlockadeID(targetBlockade);
                    	    }
                        }
					}
					pfTarget.setDone();
            		return;
      
				}else{
					List<EntityID> path=new ArrayList<EntityID>();
					if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
						path=pfTarget.getClearPath();
					}else{
						path=agent.getPathToAreaInNormal(targetArea);
					}
					if(path!=null&&!path.isEmpty()){
					
						clearPathInProcess(path);    	
					}else{
						pfTarget.setDone();
		    			return;
					}
									
				}
			}else{
				pfTarget.setDone();
    			return;
			}
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BURNING_BUILDING_ENTRANCE||
    			pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_GASSTATION){
    		Area targetArea=(Area)targetEntity;
    		if(targetArea instanceof Building){
    			if(pfTarget.getClearArea()!=null){
    				targetArea=pfTarget.getClearArea();
    			}else{
    				Building targetBuilding=(Building)targetArea;
        			List<Road> entrances=world.getEntrance(targetBuilding);
        			if(entrances!=null&&!entrances.isEmpty()){
        				pfTarget.setClearArea(entrances.get(0));
        				targetArea=entrances.get(0);
        			}else{
        				Collection<StandardEntity> rounds=world.getObjectsInRange(targetBuilding, extinguishableDistance);
        				if(rounds!=null&&!rounds.isEmpty()){
        					for(StandardEntity s1:rounds){
        						if(s1 instanceof Road){
        							pfTarget.setClearArea((Area)s1);
        							targetArea=(Area)s1;
        							break;
        						}
        					}
        					pfTarget.setDone();
        	    			return;
        				}else{
        					pfTarget.setDone();
        	    			return;
        				}
        			}
    			}   			
    		}
    		Area agentArea=agent.location();
    		if(agentArea.getID().getValue()==targetArea.getID().getValue()){			
				pfTarget.setDone();
				pfTarget.setClearArea(targetArea);
    			return;
    		}else{
    			List<EntityID> path=null;
    			if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
    				path=pfTarget.getClearPath();
    			}else{
    				path=agent.getPathToAreaInNormal(targetArea);
    			} 				
    			if(path==null||path.isEmpty()){
    				pfTarget.setDone();	
    				pfTarget.setClearArea(targetArea);
    				return;
    			}else{
    				if(path.size()==1){
    					pfTarget.setDone();
    					pfTarget.setClearArea(targetArea);
    	    			return;
    				}else{
    					clearPathInProcess(path);
    				}
    			}
    		}   		   	
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.SELF_HELP){
    		Building targetBuilding=(Building)targetEntity;
    		List<EntityID> path=null;
			if(pfTarget.getClearPath()!=null&&!pfTarget.getClearPath().isEmpty()){
				path=pfTarget.getClearPath();
			}else{
				CostFunction costFunc = agent.search.getNormalCostFunction();
				Point selfL = agent.getCurrentPosition();
				path = agent.search.getAStar(agent.location(), targetBuilding, costFunc, selfL);
			} 
			if(path==null||path.isEmpty()){
				pfTarget.setDone();								
				return;
			}else{
				if(path.size()==1){
					if(agent.location().getID().getValue()==path.get(0).getValue()){
						pfTarget.setDone();								
						return;
					}else{
						pfTarget.setDone();
						return;
					}
				}else{
					clearPathInProcess(path);
				}
			}
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.RANDOMWALK){
    		Area targetArea=world.getEntity(pfTarget.getID(), Area.class);
    		if(agent.location().getID().getValue()==targetArea.getID().getValue()){
    			pfTarget.setDone();
    			return;
    		}else{
    			List<EntityID> path=agent.getPathToAreaInNormal(targetArea);
    			if(path!=null&&!path.isEmpty()){
    				clearPathInProcess(path);
    			}else{
    				pfTarget.setDone();
        			return;
    			}
    			
    		}
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BURNNING_BUILDING){
    		
    	}else if(pfTarget.getTargetType()==SEUPFTargetType.BLOCKADE_CIVILIAN_IN_ROAD){
    		
    	}
    }
    
    private boolean isInClearRange(Human targetHuman){
    	Point targetPoint=new Point(targetHuman.getX(),targetHuman.getY());
    	Point agentPoint=agent.getCurrentPosition();
    	double dis=Distance.getDistance(agentPoint, targetPoint);
    	return dis<maxClearDistance-500;
    }
    
    public void clearPointInCurrentRoad1(Point2D targetPoint) throws ActionCommandException{
    	Area agentArea=agent.location();
    	Point2D agentPoint=new Point2D(agent.getCurrentPosition().getX(),agent.getCurrentPosition().getY());
    	double dis=Distance.getDistance(agentPoint, targetPoint);
    	if(dis<maxClearDistance-500){
    		Line2D me2nextAC = new Line2D(agentPoint,targetPoint);
			me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);
			agent.sendClearArea((int)me2nextAC.getEndPoint().getX(), (int)me2nextAC.getEndPoint().getY());    		
    	}else{
    		Line2D targetLine=new Line2D(agentPoint,targetPoint);
    		Line2D checkLine=GeomUtil.clipLine(targetLine, maxClearDistance-500);
    		Line2D clearLine=GeomUtil.clipLine(targetLine, maxClearDistance);
    		Pair<Line2D, Line2D> clearLengthLines = GeomUtil.clearLengthLines(GeomUtil.clearAreaRectangle(agentPoint, checkLine.getEndPoint(), clearRadius), clearRadius);
            double distance = (clearRadius -AGENT_SIZE * 0.5) / 2;
            Pair<Line2D, Line2D> clearSecureLines = getClearSecureLines(clearLengthLines.first(), clearLengthLines.second(), clearRadius, distance);
            List<Area> areasSeenInPath=new ArrayList<Area>();
            areasSeenInPath.add(agentArea);
            if (anyBlockadeIntersection(areasSeenInPath, checkLine, true) || 
            		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.first(), true) || 
            		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.second(), true)) {
            	agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
            }else {
            	int x = (int) clearLine.getEndPoint().getX();
                int y = (int) clearLine.getEndPoint().getY();
                List<EntityID> path=new ArrayList<EntityID>();
                path.add(agentArea.getID());               
                agent.sendMove( path, x, y);
            }
            
    	}
    }
    
  
    public void clearPathInProcess1(List<EntityID> clearpath) throws ActionCommandException{
		if(clearpath==null||clearpath.size()<=1){
			
			return;
		}else{
			  int indexInPath=0;
			  int i;
			  List<EntityID> clearpath1=new ArrayList<EntityID>();	
			  clearpath1.add(clearpath.get(0));
			  for(i=1;i<=clearpath.size()-2;i++){
				  if(isBuildingEntrance(clearpath.get(i))){
			           if(world.getEntity(clearpath.get(i-1), Area.class).getNeighbours().contains(clearpath.get(i+1))){
			        	   continue;
				         
			           }
		           } 
				  clearpath1.add(clearpath.get(i));
			  }
			  clearpath1.add(clearpath.get(i));
			  clearpath=clearpath1;
//			
	           EntityID next = clearpath.get(indexInPath+1);
	           Area nextArea = world.getEntity(next, Area.class);
	           Area thisArea = world.getEntity(clearpath.get(indexInPath),Area.class);
	           Area finishArea=world.getEntity(clearpath.get(clearpath.size()-1), Area.class);
	           Point2D myPoint = new Point2D(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY());
	           Edge edge2next = thisArea.getEdgeTo(nextArea.getID()); 	           
	           Edge edge2next1=nextArea.getEdgeTo(thisArea.getID());
	           double dis=Distance.getDistance(edge2next.getStart(), edge2next.getEnd());
	           
	           
	           Point2D nextACenter = GeomUtil.getMiddle(edge2next.getLine());//wujie
	           Line2D me2nextAC = new Line2D(myPoint,nextACenter);
	           Point2D areaCenter=new Point2D(thisArea.getX(),thisArea.getY());
	           Line2D this2nextAC=new Line2D(areaCenter,nextACenter);
	           Point2D closetoline=GeometryTools2D.getClosestPoint(this2nextAC, myPoint);
	           Line2D  thline=new Line2D(myPoint, closetoline);
	           Line2D clearthline=GeomUtil.clipLine(thline, GeomUtil.lineLength(thline)+agent.AGENT_RADIUS*2);
	           Line2D chthline=GeomUtil.clipLine(clearthline, GeomUtil.lineLength(thline));
	           Point2D clPoint = clearthline.getEndPoint();
	           me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);	//yuan
	           Line2D checkLine = GeomUtil.clipLine(me2nextAC, GeomUtil.lineLength(me2nextAC)-500);//yuanc14.10.5
	           Point2D clearPoint = me2nextAC.getEndPoint();
               List<EntityID> blks1 = nextArea.getBlockades();
	           List<EntityID> blks2 = thisArea.getBlockades();
	           Set<Point2D> intersections1 = new HashSet<Point2D>();
		       List<Polygon> blockadePolygon=new ArrayList<Polygon>();
		       Point cs = new Point((int)chthline.getOrigin().getX(),(int)chthline.getOrigin().getY());
		       Point ct = new Point((int)chthline.getEndPoint().getX(),(int)chthline.getEndPoint().getY());
		       Point co = new Point((int)checkLine.getOrigin().getX(),(int)checkLine.getOrigin().getY());
		       Point ce = new Point((int)checkLine.getEndPoint().getX(),(int)checkLine.getEndPoint().getY());
		       Polygon blkPoly = new Polygon();
		       if(GeomUtil.lineLength(thline)>agent.AGENT_RADIUS*2){
			       intersections1.clear();
	 		       blockadePolygon.clear();		 				
			       if(blks2!=null&&!blks2.isEmpty()){ 					
	 			       for(EntityID id :blks2){		 				
	 				       Blockade blk = world.getEntity(id, Blockade.class);
	 				       blkPoly = GeomUtil.getPolygon(blk.getApexes());
	 				       blockadePolygon.add(blkPoly);
	 				       intersections1.addAll(GeomUtil.intersections(blkPoly, chthline));				
	 			       }
			       }
			       if((intersections1==null||intersections1.isEmpty())&&!isPolygonContainPoint(blockadePolygon,cs)&&!isPolygonContainPoint(blockadePolygon,ct)){//移动
				       List<EntityID> closepath=new ArrayList<EntityID>();
				       closepath.add(thisArea.getID());
				       
		    	       agent.sendMove(closepath,(int)closetoline.getX(), (int)closetoline.getY());
			       }else{
			    	   
			    	  
			    	   agent.sendClearArea((int)clPoint.getX(), (int)clPoint.getY());
			       }				
	          }else{
	    	      intersections1.clear();	
	    	      blockadePolygon.clear();
		          if(!(blks1==null||blks1.isEmpty())){			
		              for(EntityID id :blks1){
			             Blockade blk = world.getEntity(id, Blockade.class);
			             blkPoly = GeomUtil.getPolygon(blk.getApexes());
			             blockadePolygon.add(blkPoly);
			             intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));			
		              }
		          }else{
		        	  if(nextArea instanceof Building){
		        		  
		        	  }
		          }
		          if(!(blks2==null||blks2.isEmpty())){
		             for(EntityID id :blks2){
			             Blockade blk = world.getEntity(id, Blockade.class);
			             blkPoly = GeomUtil.getPolygon(blk.getApexes());
			             blockadePolygon.add(blkPoly);
			             intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));				
		             }
		          }else{
		        	  
		          }
		          if((intersections1==null||intersections1.isEmpty())&&!isPolygonContainPoint(blockadePolygon,co)&&!isPolygonContainPoint(blockadePolygon,ce)){//移动		       
	                  if(GeomUtil.lineLength(me2nextAC)<=world.getDistance(thisArea.getID(), finishArea.getID())){		        	  
	                	  clearPoint=GeometryTools2D.getClosestPoint(this2nextAC, clearPoint);
	                	 
	                	  agent.sendMove(clearpath,(int)clearPoint.getX(),(int)clearPoint.getY());
	                  }else{	
	                	  
	        	          agent.sendMove(clearpath,(int)finishArea.getX(),(int)finishArea.getY());
	        	      }		
		          }else{	
		        	 
		        	   
	                   agent.sendClearArea((int)clearPoint.getX(),(int)clearPoint.getY()); 			  
	              }
	         }
		}
    }

   
    public void clearPathInProcess3(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.size()<=1){
			return;
		}   	 	
    	
    	EntityID targetID=path.get(path.size()-1);
        StandardEntity target = world.getEntity(targetID);     
        Point2D targetPoint = GeomUtil.getPoint(target.getLocation(world));
        Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());                    
        
        
        List<Line2D> guideLineList = new ArrayList<Line2D>();
        Area sourceArea = world.getEntity(path.get(0), Area.class);
        Point2D firstPoint = GeomUtil.getPoint(sourceArea.getLocation(world));
        if (path.size() > 1) {
            Edge edgeTo = ((Area) world.getSelfPosition()).getEdgeTo(path.get(1));
            if (edgeTo != null) {
                Point2D mid1 = GeomUtil.getMiddle(edgeTo.getLine());               
                Line2D agentEdgeLine = new Line2D(agentPosition, mid1);
                Line2D agentAreaLine = new Line2D(agentPosition, firstPoint);
                Line2D areaEdgeLine = new Line2D(firstPoint, mid1);
                double theta = GeomUtil.angleBetween2Lines(agentAreaLine, areaEdgeLine);
                double alpha = GeomUtil.angleBetween2Lines(agentAreaLine, agentEdgeLine);
                if (alpha < 80 && theta > 80) {
                    firstPoint = agentPosition;
                }
            }
        }
        Area area;
        Edge edge;
        Line2D guideLine1;
        for (int i = 0; i < path.size() - 1; i++) {
            EntityID id = path.get(i);
            area = world.getEntity(id, Area.class);
            edge = area.getEdgeTo(path.get(i + 1));
            if (edge == null) {
                break;
            }
            Point2D middle = GeomUtil.getMiddle(edge.getLine());
            guideLine1 = new Line2D(firstPoint, middle);
            guideLineList.add(guideLine1);
            firstPoint = middle;
        }
        if(target instanceof Road){
        	guideLine1 = new Line2D(firstPoint, targetPoint);
            guideLineList.add(guideLine1);
        }              
        
        double secureAngle = 30d;
        Line2D guideLine = guideLineList.get(0);
        Line2D targetGuideLine= guideLine;
        List<EntityID> areasInTargetGuideLine = new ArrayList<EntityID>();
        areasInTargetGuideLine.add(path.get(0));
        double angle;
        List<Line2D> tempGuidelines = new ArrayList<Line2D>();
        boolean firsLine = true;
        for (int i = 1; i < guideLineList.size(); i++) {
            guideLine = guideLineList.get(i);
            angle = GeomUtil.angleBetween2Lines(targetGuideLine, guideLine);
            double distance = (GeomUtil.lineLength(targetGuideLine) + GeomUtil.lineLength(guideLine));
            double distanceCost = 1 - (GeomUtil.lineLength(guideLine) / distance);//area distance cost (cost < 1)
            if ((firsLine && distance < maxClearDistance / 5) || angle < (secureAngle * distanceCost)) {
                Vector2D newDirection = targetGuideLine.getDirection().add(guideLine.getDirection());
                targetGuideLine = new Line2D(targetGuideLine.getOrigin(), newDirection);
                tempGuidelines.add(targetGuideLine);
                if (path.size() > i) {
                    areasInTargetGuideLine.add(path.get(i));
                }
            } else {
                break;
            }
            firsLine = false;
        }
        for (int j = 0; j < tempGuidelines.size(); j++) {
        	Line2D line1 = tempGuidelines.get(j);
            double a = GeomUtil.angleBetween2Lines(line1, targetGuideLine);
            double dist = GeomUtil.lineLength(line1) * Math.sin(Math.toRadians(a));
            if (dist > world.getConfig().repairRad) {
                targetGuideLine = line1;
                break;
            }
            
        }
        
             
        List<Area> areasSeenInPath = getAreasSeenInPath(path);
        Line2D clearLine = getTargetClearLine(areasSeenInPath, maxClearDistance-500, targetGuideLine);
        Pair<Line2D, Line2D> clearSecureLines=null;
        if(clearLine==null){
        }else{
        	 Pair<Line2D, Line2D> clearLengthLines = GeomUtil.clearLengthLines(GeomUtil.clearAreaRectangle(agentPosition, clearLine.getEndPoint(), clearRadius), clearRadius);
             double distance = (clearRadius -AGENT_SIZE * 0.5) / 2;
             clearSecureLines = getClearSecureLines(clearLengthLines.first(), clearLengthLines.second(), clearRadius, distance);
        }
       
        List<EntityID> thisRoadPath = new ArrayList<EntityID>();
        thisRoadPath.add(world.getSelfPosition().getID());       
        if (clearLine!=null&&(anyBlockadeIntersection(areasSeenInPath, clearLine, true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.first(), true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.second(), true))) {
        	int x = (int) clearLine.getEndPoint().getX();
            int y = (int) clearLine.getEndPoint().getY();
            wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
            lastClearLine = clearLine;
        	agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
        }else{         
        	if(wasOnBlockade&&lastClearLine!=null){ 
        		int x = (int) lastClearLine.getEndPoint().getX();
                int y = (int) lastClearLine.getEndPoint().getY();
                lastClearLine = null;
                agent.sendMove( thisRoadPath, x, y);
        	}else if(targetGuideLine!=null){
        		Point2D nearestIntersect = anyBlockadeIntersection(targetGuideLine,areasInTargetGuideLine);
        		if (nearestIntersect != null) {
        			int dist = GeomUtil.distance(agentPosition, nearestIntersect);
                    clearLine = new Line2D(agentPosition, nearestIntersect);
                    clearLine = GeomUtil.clipLine(clearLine, maxClearDistance - clearRadius - SECURE_RANGE);
                    int x = (int) clearLine.getEndPoint().getX();
                    int y = (int) clearLine.getEndPoint().getY();
                    lastClearLine = clearLine;
                    wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
                    if (dist < maxClearDistance - clearRadius - SECURE_RANGE) {
                    	agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
                    } else {
                        agent.sendMove(thisRoadPath, (int) nearestIntersect.getX(), (int) nearestIntersect.getY());
                    }
        		}else{
        			agent.sendMove(path);
        		}  		             
        	}
        	lastClearLine=null;
        }
    }
    
    public void clearPathInProcess4(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.size()<=1){
			return;
		}
    	Point2D agentPoint = GeomUtil.getPoint(world.getSelfLocation()); 
		int pathLength = path.size();
		StandardEntity currentEntity = world.getEntity(world.getSelfPosition().getID());
		if (!(currentEntity instanceof Area)) return;
		Area currentArea = (Area) currentEntity;		
		double minDistance = Double.MAX_VALUE;
		Blockade nearestBlockade = null;
		int indexInPath=0;
		EntityID nextAreaID = path.get(indexInPath + 1);
		Area nextArea = world.getEntity(nextAreaID, Area.class);
		Edge dirEdge=currentArea.getEdgeTo(nextAreaID);
		if (dirEdge == null){
			return;
		}
		Point2D dirPoint = GeomUtil.getMiddle(dirEdge.getLine());
		Set<Blockade> needClearBlockades = GeomUtil.getBlockadesBetweenPoints(currentArea, nextArea, agentPoint, dirPoint,world);
		minDistance = Double.MAX_VALUE;
		nearestBlockade = null;
		if(!needClearBlockades.isEmpty()){
			for (Blockade bloc : needClearBlockades) {
				double dis = getDistanceTo(bloc, agent.getCurrentPosition());
				if (dis < minDistance) {
					minDistance = dis;
					nearestBlockade = bloc;
				}
			}	
			if (nearestBlockade != null) {
			
				directionClear(nearestBlockade, dirPoint, nextArea,path);
			} 
		}		
		for (int i = indexInPath + 1; i <= indexInPath + 5; i++) {
			if (pathLength >i + 1) {
				StandardEntity entity_1 = world.getEntity(path.get(i));
				StandardEntity entity_2 = world.getEntity(path.get(i + 1));			
				if (entity_1 instanceof Area && entity_2 instanceof Area) {
					Area next_a_1 = (Area) entity_1;
					Area next_a_2 = (Area) entity_2;
					dirEdge=next_a_1.getEdgeTo(next_a_2.getID());
					if (dirEdge == null){
						return;
					}
					dirPoint = GeomUtil.getMiddle(dirEdge.getLine());															
					needClearBlockades = GeomUtil.getBlockadesBetweenPoints(next_a_1, next_a_2, agentPoint, dirPoint,world);									
					minDistance = Double.MAX_VALUE;
					nearestBlockade = null;
					if(!needClearBlockades.isEmpty()){
						for (Blockade bloc : needClearBlockades) {
							double dis = getDistanceTo(bloc, agent.getCurrentPosition());
							if (dis < minDistance) {
								minDistance = dis;
								nearestBlockade = bloc;
							}
						}					
						if (nearestBlockade != null) {	
							
							directionClear(nearestBlockade, dirPoint, next_a_2,path);
						}
					}					
				}
			}
		}
		agent.sendMove(path);
    }
    
    public void clearPathInProcess2(List<EntityID> clearpath) throws ActionCommandException {
    	    EntityID next = clearpath.get(1);
    	    Area finishArea=world.getEntity(clearpath.get(clearpath.size()-1), Area.class);
		    Area nextArea = world.getEntity(next, Area.class);
		    Area currentPostion=agent.location();
		    Point2D myPoint = new Point2D(agent.getMeAsHuman().getLocation(world).first(),agent.getMeAsHuman().getLocation(world).second());
		    Edge edge2next = currentPostion.getEdgeTo(nextArea.getID());
		    Point2D nextACenter = new Point2D((edge2next.getStartX() + edge2next.getEndX())/2.0,
					(edge2next.getStartY() + edge2next.getEndY())/2.0) ;
		    Line2D me2nextAC = new Line2D(myPoint,nextACenter);
		    me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);	
		    Point2D clearPoint = me2nextAC.getEndPoint();
		    Line2D checkLine = GeomUtil.clipLine(me2nextAC, GeomUtil.lineLength(me2nextAC)-500);
			List<EntityID> blks1 = nextArea.getBlockades();
			List<EntityID> blks2 = currentPostion.getBlockades();
			List<Point2D> intersections1 = new ArrayList<Point2D>();
			List<Polygon> blockadePolygon=new ArrayList<Polygon>();
			Point co = new Point((int)checkLine.getOrigin().getX(),(int)checkLine.getOrigin().getY());
			Point ce = new Point((int)checkLine.getEndPoint().getX(),(int)checkLine.getEndPoint().getY());
			Polygon blkPoly = new Polygon();
			if(!(blks1==null||blks1.isEmpty()))
			for(EntityID id :blks1)
			{
				Blockade blk = world.getEntity(id, Blockade.class);
				blkPoly = GeomUtil.getPolygon(blk.getApexes());	
				intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));
				
			}
			if(!(blks2==null||blks2.isEmpty()))
			for(EntityID id :blks2)
			{
				Blockade blk = world.getEntity(id, Blockade.class);
				blkPoly = GeomUtil.getPolygon(blk.getApexes());
				blockadePolygon.add(blkPoly);
				intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));				
			}
			if(intersections1.isEmpty()&&!isPolygonContainPoint(blockadePolygon,co)&&!isPolygonContainPoint(blockadePolygon,ce)){//移动
				 if(GeomUtil.lineLength(me2nextAC)<=world.getDistance(currentPostion.getID(), finishArea.getID())){		        	  
               	  agent.sendMove(clearpath,(int)clearPoint.getX(),(int)clearPoint.getY());
                 }else{	
       	          agent.sendMove(clearpath,(int)finishArea.getX(),(int)finishArea.getY());
       	      }		
							
			}else{			  				
			    agent.sendClearArea((int)clearPoint.getX(),(int)clearPoint.getY());			  
			}		   
    }
    
    public void clearPathInProcess(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.size()<=1){
			return;
		}
    	 int j;
		  List<EntityID> noEntrancePath=new ArrayList<EntityID>();	
		  noEntrancePath.add(path.get(0));
		  for(j=1;j<=path.size()-2;j++){
			  if(isBuildingEntrance(path.get(j))){
		           if(world.getEntity(path.get(j-1), Area.class).getNeighbours().contains(path.get(j+1))){
		        	   continue;
			      
		           }
	           } 
			  noEntrancePath.add(path.get(j));
		  }
		  noEntrancePath.add(path.get(j));
    	List<EntityID> seePath=new ArrayList<EntityID>();
    	for(EntityID next:noEntrancePath){
    		if(agent.isVisible(next)){
    			seePath.add(next);
    		}  		
    	}
    	Point2D agentPoint=GeomUtil.getPoint(world.getSelfLocation());
    	int length=seePath.size();
    	if(length<noEntrancePath.size()){
    		seePath.add(noEntrancePath.get(length));
    	}
    	length=seePath.size();
    	if(length>1){
    		for(int i=0;i<length-1;i++){
    			Area firstArea=world.getEntity(seePath.get(i), Area.class);
    			Area nextArea=world.getEntity(seePath.get(i+1), Area.class);
    			Edge intesectEdge=firstArea.getEdgeTo(nextArea.getID());
    			if(intesectEdge==null){
    				return;
    			}
    			Point2D nextPoint=GeomUtil.getMiddle(intesectEdge.getLine());
    			Set<Blockade> needClearBlockades = GeomUtil.getBlockadesBetweenPoints(firstArea, nextArea, agentPoint, nextPoint,world);
    			if(needClearBlockades!=null&&!needClearBlockades.isEmpty()){
    				Comparator<Blockade>  comparator=new MultiBlockDistanceComparator(world, agent.getCurrentPosition());
    				SortedSet<Blockade> sort = new TreeSet<Blockade>(comparator);
    				sort.addAll(needClearBlockades);
    				Blockade targetBlockade=sort.first(); 				
    				if (!agent.isVisible(targetBlockade.getID())) {	
    					List<EntityID> movePath = agent.getPathToBlockade(targetBlockade,seePath);			
    					Point2D movePoint = GeomUtil.getMovePoint(targetBlockade, nextPoint,world);
    					if (movePoint != null) {  						
    						agent.sendMove( movePath, (int)movePoint.getX(), (int)movePoint.getY());
    					} else {
    						agent.sendMove(movePath, targetBlockade.getX(), targetBlockade.getY());
    					}		
    				}
    				Line2D me2nextAC = new Line2D(agentPoint,nextPoint);
    				Line2D clearLine=GeomUtil.clipLine(me2nextAC, maxClearDistance);
    				Line2D checkLine=GeomUtil.clipLine(me2nextAC, maxClearDistance-500);
    				Point2D clearPoint=clearLine.getEndPoint();
    				double dis=GeomUtil.lineLength(me2nextAC);
    				if(dis<maxClearDistance-500){ 
    					agent.sendClearArea((int)clearPoint.getX(),(int) clearPoint.getY());
    				}else{  					
    					Road blockadeInRoad = (Road)world.getEntity(targetBlockade.getPosition());		
        				Set<Blockade> blockadeInClearRange = GeomUtil.getBlockadesBetweenPoints(blockadeInRoad, nextArea, agentPoint, checkLine.getEndPoint(),world);
        				if(!blockadeInClearRange.isEmpty()){
        					agent.sendClearArea((int)clearPoint.getX(),(int) clearPoint.getY());
        				}else{
        					List<EntityID> movePath = agent.getPathToBlockade(targetBlockade,noEntrancePath);						
        					Point2D movePoint = GeomUtil.getMovePoint(targetBlockade, nextPoint,world);
        					if (movePoint != null) {
        						agent.sendMove(movePath, (int)movePoint.getX(), (int)movePoint.getY());
        					} else {
        						agent.sendMove(movePath, (int)nextPoint.getX(), (int)nextPoint.getY());
        					}
        				}
    				}    				    				   				
    			}
    		}   		
    	}
    	Area finishArea=world.getEntity(seePath.get(length-1), Area.class);
		agent.sendMove(seePath, finishArea.getX(), finishArea.getY());
    }
    
    private void directionClear(Blockade target, Point2D dirPoint, Area next_A,List<EntityID> clearPath) throws ActionCommandException {		
		if (!agent.isVisible(target.getID())) {								
			List<EntityID> path = agent.getPathToBlockade(target,clearPath);			
			Point2D movePoint = GeomUtil.getMovePoint(target, dirPoint,world);
			if (movePoint != null) {
				if(agent.getID().getValue()==976941733){
				}
				agent.sendMove( path, (int)movePoint.getX(), (int)movePoint.getY());
			} else {
				if(agent.getID().getValue()==976941733){
				}
				agent.sendMove(path, target.getX(), target.getY());
			}			
		}
		int x=world.getSelfLocation().first();
		int y=world.getSelfLocation().second();
		double dis_to_dir = Math.hypot(dirPoint.getX() - x, dirPoint.getY() - y);
		Vector2D v = new Vector2D(dirPoint.getX() - x, dirPoint.getY() - y);
		v = v.normalised().scale(Math.min(dis_to_dir, maxClearDistance-500));
		Point2D t_dir_p = new Point2D(x + v.getX(), y + v.getY());		
		Road road = (Road)world.getEntity(target.getPosition());		
		Set<Blockade> t_bloc = GeomUtil.getBlockadesBetweenPoints(road, next_A, new Point2D(x, y), t_dir_p,world);
		if (t_bloc.size() > 0) {
			if (dis_to_dir < maxClearDistance) {
				v = v.normalised().scale(maxClearDistance);
			} else {
				v = v.normalised().scale(dis_to_dir);
			}			
			int destX = (int) (x + v.getX()), destY = (int) (y + v.getY());
			if (lastClearDest_x == destX && lastClearDest_y == destY) {
				if (count >= lock) {				
					List<EntityID> path = agent.getPathToBlockade(target,clearPath);					
					lastClearDest_x = -1;
					lastClearDest_y = -1;
					count = 0;
					agent.sendMove(path, destX, destY);				
				} else {
					count++;
				}
			} else {
				count = 0;
				lastClearDest_x = destX;
				lastClearDest_y = destY;
			}
			lastClearDest_x = destX;
			lastClearDest_y = destY;
			if(agent.getID().getValue()==976941733){
			}
			agent.sendClearArea(destX, destY);
		} else {				
			List<EntityID> path = agent.getPathToBlockade(target,clearPath);						
			Point2D movePoint = GeomUtil.getMovePoint(target, dirPoint,world);
			if (movePoint != null) {
				if(agent.getID().getValue()==976941733){
				}
				agent.sendMove(path, (int)movePoint.getX(), (int)movePoint.getY());
			} else {
				if(agent.getID().getValue()==976941733){
				}
				agent.sendMove(path, (int)dirPoint.getX(), (int)dirPoint.getY());
			}
		}
	}

    

	
    
    
    
   


    public void clearTarget(EntityID targetID) throws ActionCommandException{
    	if(targetID==null) return;
    	StandardEntity targetEntity=world.getEntity(targetID);
    	if(targetEntity==null) return;
    	List<EntityID> path=null;
    	if(targetEntity instanceof Human){
			Area position=(Area)world.getEntity(((Human) targetEntity).getPosition());
			path=agent.getPathToAreaInNormal(position);
			if(position instanceof Building){//
				int last=path.size()-1;
				path.remove(last);
			}  			   			
		}
		if(targetEntity instanceof Building){
			path=agent.getPathToAreaInNormal((Area)targetEntity);
			int last=path.size()-1;
			path.remove(last);
		}
		if(targetEntity instanceof Road){
			path=agent.getPathToAreaInNormal((Area)targetEntity);
		}
		if(path==null||path.isEmpty()) return ;
		
		if(agent.location() instanceof Building){
			leaveBuilding(path, (Building)agent.location());
		}
		
    	if(targetEntity instanceof Human){
    		Area position=(Area)world.getEntity(((Human) targetEntity).getPosition());
    		if(position==null) return;   
    		if(position instanceof Building){
    			clearWay(path,position.getID());
    		}else if(position instanceof Road){
    			if(agent.isVisible(position)&&agent.isVisible(targetEntity)){
        			if(position.getID()==path.get(path.size()-1)){
        				if(path.size()>1){
        					clearWay(path,targetID);
        				}else if(path.size()==1){
        					if(agent.location().getID()==position.getID()){
        						clearStuckedHuman((Human)targetEntity);
        					}else{
        						return;
        					}
            			}
        			}else{
        				return;
        			}
        		}else if(agent.isVisible(position)||agent.isVisible(targetEntity)){
        			return;
        		}else{
        			if(path.size()>1){
        				clearWay(path,targetID);
        			}else if(path.size()==1){
        				return;
        			}
        		}
    		}    				    		
    	}
    	if(targetEntity instanceof Refuge){
    		if(path.size()>1){
    			clearWay(path,targetID);
    		}else if(path.size()==1){
    			Road road=(Road)targetEntity;
    			if(road.isBlockadesDefined()&&road.getBlockades().size()>0){
    				Blockade blockade=getClosestBlockadeInRoad(road);
    				if(blockade!=null){
    					clearBlockadeID(blockade);
    				}
    			}
    		}    		
    	}
    	if(targetEntity instanceof Building){
    		clearWay(path,targetID);
    	}
    	if(targetEntity instanceof Road){
    		if(path.size()>1){
    			clearWay(path,targetID);
    		}else if(path.size()==1){
    			clearRoad((Road)targetEntity);
    		}
    	}						
    }
    
    
    private void clearPath(List<EntityID> path, EntityID targetID) throws ActionCommandException {
    	if(targetID==null) return;
    	StandardEntity targetEntity=world.getEntity(targetID);
    	if(targetEntity==null) return;
    	if(path==null||path.isEmpty()){
    		if(targetEntity instanceof Human){
    			Area position=(Area)world.getEntity(((Human) targetEntity).getPosition());
    			path=agent.getPathToAreaInNormal(position);
    			if(position instanceof Building){//
    				int last=path.size()-1;
    				path.remove(last);
    			}  			   			
    		}
    		if(targetEntity instanceof Building){
    			path=agent.getPathToAreaInNormal((Area)targetEntity);
    			int last=path.size()-1;
				path.remove(last);
    		}
    		if(targetEntity instanceof Road){
    			path=agent.getPathToAreaInNormal((Area)targetEntity);
    		}
    	}
    	if(path==null||path.isEmpty()) return ;
    	
    	if(targetEntity instanceof Human){
    		Area position=(Area)world.getEntity(((Human) targetEntity).getPosition());
    		if(position==null) return;   
    		if(position instanceof Building){
    			clearWay(path,position.getID());
    		}else if(position instanceof Road){
    			if(agent.isVisible(position)&&agent.isVisible(targetEntity)){
        			if(position.getID().getValue()==path.get(path.size()-1).getValue()){
        				if(path.size()>1){
        					clearWay(path,targetID);
        				}else if(path.size()==1){
        					if(agent.location().getID().getValue()==position.getID().getValue()){
        						clearStuckedHuman((Human)targetEntity);
        					}else{
        						return;
        					}
            			}
        			}else{
        				return;
        			}
        		}else if(agent.isVisible(position)||agent.isVisible(targetEntity)){
        			return;
        		}else{
        			if(path.size()>1){
        				clearWay(path,targetID);
        			}else if(path.size()==1){
        				return;
        			}
        		}
    		}    				    		
    	}
    	if(targetEntity instanceof Refuge){
    		if(path.size()>1){
    			clearWay(path,targetID);
    		}else if(path.size()==1){
    			Road road=(Road)targetEntity;
    			if(road.isBlockadesDefined()&&road.getBlockades().size()>0){
    				Blockade blockade=getClosestBlockadeInRoad(road);
    				if(blockade!=null){
    					clearBlockadeID(blockade);
    				}
    			}
    		}    		
    	}
    	if(targetEntity instanceof Building){
    		clearWay(path,targetID);
    	}
    	if(targetEntity instanceof Road){
    		if(path.size()>1){
    			clearWay(path,targetID);
    		}else if(path.size()==1){
    			clearRoad((Road)targetEntity);
    		}
    	}						
    }
    
    public void sendClearPath(List<EntityID> path) throws ActionCommandException{ 		
		Pair<Integer, Integer> lastPosition = agent.locationHistory.get(agent.getTimeStep() - 1);
		Pair<Integer, Integer> currentPosition = agent.locationHistory.get(agent.getTimeStep());		
		StandardEntity cur_entity = world.getEntity(world.getSelfPosition().getID());
        int indexInPath = getIndexInPath(path, cur_entity.getID());
	    Area finishArea=world.getEntity(path.get(path.size()-1),Area.class);     
  	    Blockade targetBlockade;
  	    if(indexInPath==path.size()){
            return;
        }	  
 		if(agent.location().getID().getValue() == path.get(path.size()-1).getValue()){							 
 		 	if((agent.location().getBlockades()!=null)&&(!agent.location().getBlockades().isEmpty())){
 		 		targetBlockade=getClosestBlockadeInCurrentLocation();
 		 		Point point = GeomUtil.getPosition(agent.getMeAsHuman(),world);
 		 	 	int dis = Distance.getDistanceToBlock(targetBlockade, point);
		 	 	if(dis>maxClearDistance){		 	 				
		 	 		agent.sendMove(path,targetBlockade.getX(),targetBlockade.getY());
	 	 		}
 		 			agent.sendClearID(targetBlockade.getID());
 		 		}else{ 
                    return;
 			    } 				   			   
 		   }else{
 		           if(path==null||path.isEmpty()){
 			           agent.randomWalk();
 				       return;
 		           } 		 
 		           List<EntityID> clearpath = path;          
 		           if(clearpath.size()-indexInPath>2){ 
 			           if(isBuildingEntrance(clearpath.get(indexInPath+1))){
 				           if(world.getEntity(agent.location().getID(), Area.class).getNeighbours().contains(clearpath.get(indexInPath+2))){
	 				           clearpath.remove(clearpath.get(indexInPath+1));
	 			           }
 			           }
 		           }        
 		           EntityID next = clearpath.get(indexInPath+1);
 		           Area nextArea = world.getEntity(next, Area.class);
 		           Area thisArea = world.getEntity(clearpath.get(indexInPath),Area.class);
 		           Point2D myPoint = new Point2D(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY());
 		           Edge edge2next = thisArea.getEdgeTo(nextArea.getID()); 		   
 		           Point2D nextACenter = GeomUtil.getMiddle(edge2next.getLine());//wujie
 		           Line2D me2nextAC = new Line2D(myPoint,nextACenter);
 		           Point2D areaCenter=new Point2D(thisArea.getX(),thisArea.getY());
 		           Line2D this2nextAC=new Line2D(areaCenter,nextACenter);
 		           Point2D closetoline=GeometryTools2D.getClosestPoint(this2nextAC, myPoint);
 		           Line2D  thline=new Line2D(myPoint, closetoline);
 		           Line2D clearthline=GeomUtil.clipLine(thline, GeomUtil.lineLength(thline)+agent.AGENT_RADIUS*2);
 		           Line2D chthline=GeomUtil.clipLine(clearthline, GeomUtil.lineLength(thline));
 		           Point2D clPoint = clearthline.getEndPoint();
 		           me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);	//yuan
 		           Line2D checkLine = GeomUtil.clipLine(me2nextAC, GeomUtil.lineLength(me2nextAC)*0.9);//yuan
 		           Point2D clearPoint = me2nextAC.getEndPoint();
 	               List<EntityID> blks1 = nextArea.getBlockades();
 		           List<EntityID> blks2 = thisArea.getBlockades();
   		           List<Point2D> intersections1 = new ArrayList<Point2D>();
 			       List<Polygon> blockadePolygon=new ArrayList<Polygon>();
 			       Point cs = new Point((int)chthline.getOrigin().getX(),(int)chthline.getOrigin().getY());
 			       Point ct = new Point((int)chthline.getEndPoint().getX(),(int)chthline.getEndPoint().getY());
 			       Point co = new Point((int)checkLine.getOrigin().getX(),(int)checkLine.getOrigin().getY());
 			       Point ce = new Point((int)checkLine.getEndPoint().getX(),(int)checkLine.getEndPoint().getY());
 			       Polygon blkPoly = new Polygon();
 			       if(GeomUtil.lineLength(thline)>agent.AGENT_RADIUS*2){
 				       intersections1.clear();
		 		       blockadePolygon.clear();		 				
 				       if(blks2!=null&&!blks2.isEmpty()){ 					
 		 			       for(EntityID id :blks2){		 				
 		 				       Blockade blk = world.getEntity(id, Blockade.class);
 		 				       blkPoly = GeomUtil.getPolygon(blk.getApexes());
 		 				       blockadePolygon.add(blkPoly);
 		 				       intersections1.addAll(GeomUtil.intersections(blkPoly, chthline));				
 		 			       }
 				       }
 	 			       if((intersections1==null||intersections1.isEmpty())&&!isPolygonContainPoint(blockadePolygon,cs)&&!isPolygonContainPoint(blockadePolygon,ct)){//移动
 	 				       List<EntityID> closepath=new ArrayList<EntityID>();
 					       closepath.add(thisArea.getID());
 	  		    	       agent.sendMove(closepath,(int)closetoline.getX(), (int)closetoline.getY());
 	 			       }else{
 					       agent.sendClearArea( (int)clPoint.getX(), (int)clPoint.getY());
 	 			       }				
  		          }else{
  		    	      intersections1.clear();	
  		    	      blockadePolygon.clear();
 			          if(!(blks1==null||blks1.isEmpty())){			
 			              for(EntityID id :blks1){
 				             Blockade blk = world.getEntity(id, Blockade.class);
 				             blkPoly = GeomUtil.getPolygon(blk.getApexes());
 				             blockadePolygon.add(blkPoly);
  				             intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));			
 			              }
 			          }
 			          if(!(blks2==null||blks2.isEmpty())){
 			             for(EntityID id :blks2){
 				             Blockade blk = world.getEntity(id, Blockade.class);
 				             blkPoly = GeomUtil.getPolygon(blk.getApexes());
 				             blockadePolygon.add(blkPoly);
 				             intersections1.addAll(GeomUtil.intersections(blkPoly, checkLine));				
 			             }
 			          }
 			          if((intersections1==null||intersections1.isEmpty())&&!isPolygonContainPoint(blockadePolygon,co)&&!isPolygonContainPoint(blockadePolygon,ce)){//移动		       
		                  if(GeomUtil.lineLength(me2nextAC)<=world.getDistance(thisArea.getID(), finishArea.getID())){		        	  
		        	          agent.sendMove(clearpath,(int)clearPoint.getX(),(int)clearPoint.getY());
		                  }else{		        	  
		        	          agent.sendMove(clearpath,(int)finishArea.getX(),(int)finishArea.getY());}		
 			          }else{			  
 		                  agent.sendClearArea((int)clearPoint.getX(),(int)clearPoint.getY()); 			  
 		              }
		         }
          }
    }

    private boolean isPolygonContainPoint(List<Polygon> blockadePolygon,Point point){
		if(blockadePolygon==null){ return false;}
		else{
			for(Polygon next:blockadePolygon){
				if(next.contains(point)) return true;
			}
		}
		return false;
	}

    private boolean isBuildingEntrance(EntityID entityId) {
    	Area area = (Area) world.getEntity(entityId);
    	List<EntityID> neighbors = area.getNeighbours();
    	for (EntityID next : neighbors) {
    		StandardEntity entity = world.getEntity(next);
    		if (entity instanceof Building) {    				
    			return true;
    		}
    	}
    	return false;
    }	

	private void clearPath(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.isEmpty()) return;
    	int index=getIndexInPath(path, agent.getMeAsHuman().getPosition());
    	List<EntityID> newPath=new ArrayList<EntityID>();
    	if(index==path.size()){
    		if(path.size()==1){
    			Area target=(Area)world.getEntity(path.get(0));
    			if(target instanceof Building) return;
    			if(target instanceof Road){
    				path=agent.getPathToAreaInNormal(target);
    				if(path==null||path.isEmpty()) return;
    			}
    		}else if(path.size()>1){
    			Area agentPos=agent.location();
    			Area startArea=(Area)world.getEntity(path.get(0));
    			Area targetArea=(Area)world.getEntity(path.get(path.size()-1));   			
    			double startDis=Distance.getDistance(agentPos, startArea);
    			double targetDis=Distance.getDistance(agentPos, targetArea);
    			if(startDis>targetDis){ 	
    				startArea=targetArea;
    			}
    			newPath=agent.getPathToAreaInNormal(startArea);
				if(newPath==null||newPath.isEmpty()) return;
				for(int i=path.size()-1;i>=0;i--){
					newPath.add(path.get(i));
				}  				
				path=newPath;
    		}
    	}
    	index=getIndexInPath(path, agent.getMeAsHuman().getPosition());
    	if(index==path.size()) return;
        if(index==path.size()-1){
    		Area target=(Area)world.getEntity(path.get(0));
			if(target instanceof Building) return;
			if(target instanceof Road){
				clearRoad((Road)target);
			} 		
    	}else if(index<path.size()-1){
    		Line2D clearLine;
    		EntityID targetID=path.get(path.size()-1);    
        	Line2D guideLine;
        	List<EntityID> guideLineAreas;
        	Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());
            StandardEntity target = world.getEntity(targetID);
        	if (!targetID.equals(lastTarget) || lastGuideline == null || !lastLineAreas.contains(world.getSelfPosition().getID())) {
                Point2D targetPoint = GeomUtil.getPoint(target.getLocation(world));
                List<Line2D> pathGuidelines = getPathGuidelines(path, targetPoint);
                if (/*path.isEmpty() || */pathGuidelines.isEmpty()) {
                    guideLine = new Line2D(agentPosition, targetPoint);
                } else {
                    guideLine = getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).first();
                    lastLineAreas=getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).second();
                }
            } else {
                guideLine = lastGuideline;
            }
            lastGuideline = guideLine;       
            lastTarget = targetID ;   
            List<Area> areasSeenInPath = getAreasSeenInPath(path);
            clearLine = getTargetClearLine(areasSeenInPath, maxClearDistance, guideLine);
            Pair<Line2D, Line2D> clearSecureLines = null;
            if (clearLine != null) {
                Pair<Line2D, Line2D> clearLengthLines = GeomUtil.clearLengthLines(GeomUtil.clearAreaRectangle(agentPosition, clearLine.getEndPoint(), clearRadius), clearRadius);
                double distance = (clearRadius -AGENT_SIZE * 0.5) / 2;
                clearSecureLines = getClearSecureLines(clearLengthLines.first(), clearLengthLines.second(), clearRadius, distance);
            }
            List<EntityID> thisRoadPath = new ArrayList<EntityID>();
            thisRoadPath.add(world.getSelfPosition().getID());
            if (clearLine != null &&(anyBlockadeIntersection(areasSeenInPath, clearLine, true) || 
            		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.first(), true) || 
            		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.second(), true))) {
                lastClearLine = clearLine;
                wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
                agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
            } else {
                if (wasOnBlockade && lastClearLine != null) {
                    int x = (int) lastClearLine.getEndPoint().getX();
                    int y = (int) lastClearLine.getEndPoint().getY();
                    lastClearLine = null;
                    agent.sendMove( thisRoadPath, x, y);
                } else if (clearBlockadesOnWay && guideLine != null) {
                    Point2D nearestIntersect = anyBlockadeIntersection(guideLine,lastLineAreas);
                    if (nearestIntersect != null) {
                        int dist = GeomUtil.distance(agentPosition, nearestIntersect);
                        clearLine = new Line2D(agentPosition, nearestIntersect);
                        clearLine = GeomUtil.clipLine(clearLine, maxClearDistance - clearRadius - SECURE_RANGE);
                        lastClearLine = clearLine;
                        wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
                        if (dist < maxClearDistance - clearRadius - SECURE_RANGE) {
                            agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
                        } else {
                            agent.sendMove(thisRoadPath, (int) nearestIntersect.getX(), (int) nearestIntersect.getY());
                        }
                    }
                }
                lastClearLine = null;
            }
    	}
    	
    }
    
    private void clearWay(List<EntityID> path, EntityID targetID) throws ActionCommandException {
    	Line2D clearLine;
    	Line2D guideLine = getTargetGuideline(path, maxClearDistance, targetID);
        lastGuideline = guideLine;       
        lastTarget = targetID;
        
        List<Area> areasSeenInPath = getAreasSeenInPath(path);
        clearLine = getTargetClearLine(areasSeenInPath, maxClearDistance, guideLine);
        Pair<Line2D, Line2D> clearSecureLines = null;
        Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());
        if (clearLine != null) {
            Pair<Line2D, Line2D> clearLengthLines = GeomUtil.clearLengthLines(GeomUtil.clearAreaRectangle(agentPosition, clearLine.getEndPoint(), clearRadius), clearRadius);
            double distance = (clearRadius -AGENT_SIZE * 0.5) / 2;
            clearSecureLines = getClearSecureLines(clearLengthLines.first(), clearLengthLines.second(), clearRadius, distance);
        }
        List<EntityID> thisRoadPath = new ArrayList<EntityID>();
        thisRoadPath.add(world.getSelfPosition().getID());
        if (clearLine != null &&(anyBlockadeIntersection(areasSeenInPath, clearLine, true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.first(), true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.second(), true))) {
            lastClearLine = clearLine;
            wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
            agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
        } else {
            if (wasOnBlockade && lastClearLine != null) {
                int x = (int) lastClearLine.getEndPoint().getX();
                int y = (int) lastClearLine.getEndPoint().getY();
                lastClearLine = null;
                agent.sendMove( thisRoadPath, x, y);
            } else if (clearBlockadesOnWay && guideLine != null) {
                Point2D nearestIntersect = anyBlockadeIntersection(guideLine,lastLineAreas);
                if (nearestIntersect != null) {
                    int dist = GeomUtil.distance(agentPosition, nearestIntersect);
                    clearLine = new Line2D(agentPosition, nearestIntersect);
                    clearLine = GeomUtil.clipLine(clearLine, maxClearDistance - clearRadius - SECURE_RANGE);
                    lastClearLine = clearLine;
                    wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
                    if (dist < maxClearDistance - clearRadius - SECURE_RANGE) {
                        agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
                    } else {
                        agent.sendMove(thisRoadPath, (int) nearestIntersect.getX(), (int) nearestIntersect.getY());
                    }
                }
            }
            lastClearLine = null;
        }
    }
    
    private void clearPathForFireBuilding(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.isEmpty()) return;
    	
    	if(path.size()==1){
    		
    	}else{
    		
    	}
    }
    
    private void clearPathForSearching(List<EntityID> path) throws ActionCommandException {
    	if(path==null||path.isEmpty()) return;
    	
    	if(path.size()==1){
    		
    	}else{
    		
    	}
    }
    
    private void leaveBuilding(List<EntityID> path,Building building) throws ActionCommandException{
    	int index=path.indexOf(building);
    	if(index<path.size()-1){
    		Area nextArea=(Area)world.getEntity(path.get(index+1));
    		for(EntityID next:building.getNeighbours()){
    			if(next==nextArea.getID()){
    				if(nextArea instanceof Road){
    					SEURoad road=world.getSeuRoad(next);
    	    			Edge edge=building.getEdgeTo(next);
    	    			SEUEdge SEUEdge=road.getSEUEdge(edge);
    	    			Point2D middle=new Point2D((edge.getEndX()+edge.getStartX())/2,
    	    					(edge.getEndX()+edge.getStartX())/2);
    	    			if(SEUEdge.isPassable()){
    	    				agent.sendMove(nextArea, (int)middle.getX(), (int)middle.getY());
    	    			}else{
    	    				Blockade blockade=getClosestBlockadeInRoad(road.getSelfRoad());
    	    				clearBlockadeID(blockade);
    	    			}   	    			   	    			
    	    		}
    				if(nextArea instanceof Building){
    					Edge edge=building.getEdgeTo(next);
    					Point2D middle=new Point2D((edge.getEndX()+edge.getStartX())/2,
    	    					(edge.getEndX()+edge.getStartX())/2);
    					agent.sendMove(nextArea, (int)middle.getX(), (int)middle.getY());
    				}
    			}
    		}  		
    	}
    	for(EntityID next:building.getNeighbours()){
    		Area nextArea=(Area)world.getEntity(next);
    		if(nextArea instanceof Road){
				SEURoad road=world.getSeuRoad(next);
    			Edge edge=building.getEdgeTo(next);
    			SEUEdge SEUEdge=road.getSEUEdge(edge);
    			Point2D middle=new Point2D((edge.getEndX()+edge.getStartX())/2,
    					(edge.getEndX()+edge.getStartX())/2);
    			if(SEUEdge.isPassable()){
    				agent.sendMove(nextArea, (int)middle.getX(), (int)middle.getY());
    			}else{
    				Blockade blockade=getClosestBlockadeInRoad(road.getSelfRoad());
    				clearBlockadeID(blockade);
    			}   	    			   	    			
    		}
    	}
    	for(EntityID next:building.getNeighbours()){
    		Area nextArea=(Area)world.getEntity(next);
    		if(nextArea instanceof Building){
				Edge edge=building.getEdgeTo(next);
				Point2D middle=new Point2D((edge.getEndX()+edge.getStartX())/2,
    					(edge.getEndX()+edge.getStartX())/2);
				agent.sendMove(nextArea, (int)middle.getX(), (int)middle.getY());
			}
    	}
    }
    
    private void clearStuckedHuman(Human human) throws ActionCommandException{
    	if(agent.isVisible(human)){
    		StandardEntity s=human.getPosition(world);
    		if(s instanceof Road){
    			Road r=(Road)s;
    			if(r.isBlockadesDefined()&&!r.getBlockades().isEmpty()){				
    				List<Blockade> bs=getBlockades(r);;
    				Point position = new Point(human.getX(),human.getY());
    				MultiBlockDistanceComparator comparator = new MultiBlockDistanceComparator(world, position);
    				Collections.sort(bs, comparator);
    				Blockade b=bs.get(0);
    				clearBlockadeID(b);
    			}
    		}
    	}
    	
    	
    	/*if(agent.isVisible(human)&&agent.isBlockadeContainOrIntsectOrNear(human)){
    		Blockade coveringBlockade=agent.getContainOrinsectOrNearBlockade(human);
    		if(coveringBlockade!=null){
    			int rapairRate=world.getConfig().repairRate;
        		int area=coveringBlockade.getRepairCost();
        		int dis=0;
        		if(area<rapairRate){
        			clearBlockadeID(coveringBlockade);
        		}else if(area<rapairRate*2){
        			dis=GeomUtil.distance(human.getLocation(world), agent.getMeAsHuman().getLocation(world));
        			if(dis<maxClearDistance-500){  
        				Point2D myPoint = new Point2D(agent.getMeAsHuman().getX(),agent.getMeAsHuman().getY());
						Point2D clearPoint=new Point2D(human.getX(), human.getY());
						Line2D me2nextAC = new Line2D(myPoint,clearPoint);
						me2nextAC = GeomUtil.clipLine(me2nextAC, maxClearDistance);
						agent.sendClearArea((int)me2nextAC.getEndPoint().getX(), (int)me2nextAC.getEndPoint().getY());
        			}else{
        				clearBlockadeID(coveringBlockade);
        			}
        		}else{        
        			Point2D humanPosition=new Point2D(human.getX(),human.getY());
        			clearPointInCurrentRoad1(humanPosition);       	
        		}
    		}  		
    	}else{

    	}*/
    }
    
    private void clearRoad(Road road) throws ActionCommandException{
    	if(road.isBlockadesDefined()&&road.getBlockades().size()>0){
    		SEURoad seuRoad=world.getSeuRoad(road.getID());
    		if(!seuRoad.isNeedlessToClear()){
    			for (SEUEdge next : seuRoad.getSeuEdges()) {
    				if (!next.isPassable()){
    					clearPointInCurrentRoad1(next.getMiddlePoint());
    				}  					
    			}
    		}
    		
    	}
    }
    
    private boolean isNeedClearRoad(Road road){
    	if(!road.isBlockadesDefined()||road.getBlockades().isEmpty()) return false;
    	SEURoad seuRoad=world.getSeuRoad(road.getID());
    	if(seuRoad.isNeedlessToClear()){
    		return false;
    	}else{
    		for (SEUEdge next : seuRoad.getSeuEdges()) {
				if (!next.isPassable()){
					return true;
				}  					
			}
    	}
    	return true;
    }
    
    private void clearPointInCurrentRoad(Point2D targetPoint) throws ActionCommandException{    	    	
    	List<Area> areasSeenInPath=new ArrayList<Area>();
		areasSeenInPath.add(agent.location());
		Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());
		Line2D guideLine=new Line2D(agentPosition,targetPoint);
		List<EntityID> areaInLine=new ArrayList<EntityID>();
		areaInLine.add(agent.location().getID());
		lastGuideline = guideLine;     
		lastLineAreas=areaInLine;
		Line2D clearLine = getTargetClearLine(areasSeenInPath, maxClearDistance, guideLine);
		Pair<Line2D, Line2D> clearSecureLines = null;    		       
        if (clearLine != null) {
            Pair<Line2D, Line2D> clearLengthLines = GeomUtil.clearLengthLines(GeomUtil.clearAreaRectangle(agentPosition, clearLine.getEndPoint(), clearRadius), clearRadius);
            double distance = (clearRadius -AGENT_SIZE * 0.5) / 2;
            clearSecureLines = getClearSecureLines(clearLengthLines.first(), clearLengthLines.second(), clearRadius, distance);
        }
        List<EntityID> thisRoadPath = new ArrayList<EntityID>();
        thisRoadPath.add(world.getSelfPosition().getID());
        if (clearLine != null &&(anyBlockadeIntersection(areasSeenInPath, clearLine, true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.first(), true) || 
        		anyBlockadeIntersection(areasSeenInPath, clearSecureLines.second(), true))) {
            lastClearLine = clearLine;
            wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
            agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
        } else {
            if (wasOnBlockade && lastClearLine != null) {
                int x = (int) lastClearLine.getEndPoint().getX();
                int y = (int) lastClearLine.getEndPoint().getY();
                lastClearLine = null;
                agent.sendMove( thisRoadPath, x, y);
            } else if (clearBlockadesOnWay && guideLine != null) {
            	Point2D nearestIntersect = anyBlockadeIntersection(guideLine,lastLineAreas);
                if (nearestIntersect != null) {
                    int dist = GeomUtil.distance(agentPosition, nearestIntersect);
                    clearLine = new Line2D(agentPosition, nearestIntersect);
                    clearLine = GeomUtil.clipLine(clearLine, maxClearDistance - clearRadius - SECURE_RANGE);
                    lastClearLine = clearLine;
                    wasOnBlockade = isOnBlockade(clearLine.getEndPoint(), areasSeenInPath);
                    if (dist < maxClearDistance - clearRadius - SECURE_RANGE) {
                        agent.sendClearArea( (int) clearLine.getEndPoint().getX(), (int) clearLine.getEndPoint().getY());
                    } else {
                        agent.sendMove(thisRoadPath, (int) nearestIntersect.getX(), (int) nearestIntersect.getY());
                    }
                }
            }
            lastClearLine = null;
        }
    }

    private List<Line2D> getPathGuidelines(List<EntityID> path, Point2D destinationPoint) {
        List<Line2D> guideLineList = new ArrayList<Line2D>();
        if (path == null) {
            return null;
        }
        Area sourceArea;
        if (path.isEmpty()) {
            sourceArea = world.getEntity(world.getSelfPosition().getID(), Area.class);
        } else {
            sourceArea = world.getEntity(path.get(0), Area.class);
            if (!world.getSelfPosition().getID().equals(sourceArea.getID())) {
                throw new IllegalArgumentException();
            }
        }
     
        Point2D firstPoint = GeomUtil.getPoint(sourceArea.getLocation(world));
        if (path.size() > 1) {
            Edge edgeTo = ((Area) world.getSelfPosition()).getEdgeTo(path.get(1));
            if (edgeTo != null) {
                Point2D mid1 = GeomUtil.getMiddle(edgeTo.getLine());
                Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());//current agent location
                Line2D agentEdgeLine = new Line2D(agentPosition, mid1);
                Line2D agentAreaLine = new Line2D(agentPosition, firstPoint);
                Line2D areaEdgeLine = new Line2D(firstPoint, mid1);
                double theta = GeomUtil.angleBetween2Lines(agentAreaLine, areaEdgeLine);
                double alpha = GeomUtil.angleBetween2Lines(agentAreaLine, agentEdgeLine);
                if (alpha < 80 && theta > 80) {
                    firstPoint = agentPosition;
                }
            }
        }
        Area area;
        Edge edge;
        Line2D guideLine;
        for (int i = 0; i < path.size() - 1; i++) {
            EntityID id = path.get(i);
            area = world.getEntity(id, Area.class);
            edge = area.getEdgeTo(path.get(i + 1));
            if (edge == null) {
                break;
            }
            Point2D middle = GeomUtil.getMiddle(edge.getLine());
            guideLine = new Line2D(firstPoint, middle);
            guideLineList.add(guideLine);
            firstPoint = middle;
        }

      
        Point2D lastPoint;
        if (destinationPoint == null) {
            Area lastArea = world.getEntity(path.get(path.size() - 1), Area.class);
            lastPoint = GeomUtil.getPoint(lastArea.getLocation(world));
        } else {
            lastPoint = destinationPoint;
        }

        if (firstPoint.equals(lastPoint)) {
          
        } else {
            guideLine = new Line2D(firstPoint, lastPoint);
            guideLineList.add(guideLine);
        }

        return guideLineList;
    }


   
    private Pair<Line2D,List<EntityID>> getTargetGuideLine(List<Line2D> guideLines, List<EntityID> path, EntityID target, double clearDistance) {
        if (guideLines.isEmpty()) {
            return null;
        }
        
        double secureAngle = 30d;
        Line2D guideLine = guideLines.get(0);
        Line2D targetGuideLine= guideLine;
        List<EntityID> areas = new ArrayList<EntityID>();
        areas.add(path.get(0));
        double angle;
        List<Line2D> tempGuidelines = new ArrayList<Line2D>();
        boolean firsLine = true;
        for (int i = 1; i < guideLines.size(); i++) {
            guideLine = guideLines.get(i);
            angle = GeomUtil.angleBetween2Lines(targetGuideLine, guideLine);
            double distance = (GeomUtil.lineLength(targetGuideLine) + GeomUtil.lineLength(guideLine));
            double distanceCost = 1 - (GeomUtil.lineLength(guideLine) / distance);//area distance cost (cost < 1)
            if ((firsLine && distance < clearDistance / 5) || angle < (secureAngle * distanceCost)) {
                Vector2D newDirection = targetGuideLine.getDirection().add(guideLine.getDirection());
                targetGuideLine = new Line2D(targetGuideLine.getOrigin(), newDirection);
                tempGuidelines.add(targetGuideLine);
                if (path.size() > i) {
                    areas.add(path.get(i));
                }
                
            } else {
                break;
            }
            firsLine = false;
        }
        
        for (int j = 0; j < tempGuidelines.size(); j++) {
           
        	Line2D line1 = tempGuidelines.get(j);
            double a = GeomUtil.angleBetween2Lines(line1, targetGuideLine);
            double dist = GeomUtil.lineLength(line1) * Math.sin(Math.toRadians(a));
            if (dist > world.getConfig().repairRad) {
                targetGuideLine = line1;
                break;
            }
        }
        Pair<Line2D,List<EntityID>> targetpair=new Pair<Line2D,List<EntityID>>(targetGuideLine, areas);
        return targetpair;
    }

   
    private boolean isInAnyBlockade(Point2D point2D, Road road) {
        if (!road.isBlockadesDefined() || road.getBlockades().isEmpty()) {
            return false;
        }

        Blockade blockade;
        for (EntityID blockadeID : road.getBlockades()) {
            blockade = world.getEntity(blockadeID, Blockade.class);
            Polygon polygon = GeomUtil.getPolygon(blockade.getApexes());
            if (polygon.contains(point2D.getX(), point2D.getY())) {
                return true;
            }
        }
        return false;
    }

    private boolean isOnBlockade(Point2D point2D, List<Area> areas) {
        Blockade blockade;
        Polygon polygon;
        for (Area area : areas) {
            if (!area.isBlockadesDefined()) {
                continue;
            }
            for (EntityID blockadeID : area.getBlockades()) {
                blockade = world.getEntity(blockadeID, Blockade.class);
                polygon = GeomUtil.getPolygon(blockade.getApexes());
                if (polygon.contains(point2D.getX(), point2D.getY())) {
                    return true;
                }

            }
        }
        return false;
    }

   
    private boolean anyBlockadeIntersection(Area area, Line2D targetLine) {
        if (!(area instanceof Road) || targetLine == null) {
            return false;
        }
        SEURoad mrlRoad = world.getSeuRoad(area.getID());
        for (SEUBlockade mrlBlockade : mrlRoad.getSeuBlockades()) {
            if (GeomUtil.hasIntersection(mrlBlockade.getPolygon(), targetLine)) {
                return true;
            }
        }
        return false;
    }

   
    private List<Point2D> blockadesIntersections(Area area, Line2D targetLine) {
        if (!(area instanceof Road) || targetLine == null) {
            return new ArrayList<Point2D>();
        }
        List<Point2D> points = new ArrayList<Point2D>();
        SEURoad mrlRoad = world.getSeuRoad(area.getID());
        for (SEUBlockade mrlBlockade : mrlRoad.getSeuBlockades()) {
            points.addAll(GeomUtil.intersections(mrlBlockade.getPolygon(), targetLine));
        }
        return points;
    }

   
   
    private boolean shouldCheckForBlockadesOnWay(List<EntityID> pathToGo, EntityID target) {
        boolean shouldCheck = false;
        Set<SEUBlockade> obstacles_MrlBlockades = new HashSet<SEUBlockade>();
        
        SEUEdge sourceEdge = null;
        Pair<Integer, Integer> nextMiddlePoint = null;
        Pair<Integer, Integer> sourceMiddlePoint = null;
        if (pathToGo.isEmpty()) {
            shouldCheck = false;
        } else if (pathToGo.size() == 1) {
            if (world.getEntity(pathToGo.get(0)) instanceof Road) {
                Road road = (Road) world.getEntity(pathToGo.get(0));
               
                if (road.isBlockadesDefined()) {
                    if (world.getEntity(target) instanceof Human) {
                        Human human = (Human) world.getEntity(target);
                        if (GeomUtil.isOnBlockade(world, human) || GeomUtil.isNearBlockade(world, human)) {
                            shouldCheck = true;
                        } else {
                            shouldCheck = false;
                        }

                    } else {
                        Building building = (Building) world.getEntity(target);
                        Set<Edge> edges =getEdgesBetween((Area) world.getEntity(pathToGo.get(0)), building);
                        if (edges != null && !edges.isEmpty()) {
                            Edge edge = edges.iterator().next();
                            int middleX = (edge.getStartX() + edge.getEndX()) / 2;
                            int middleY = (edge.getStartY() + edge.getEndY()) / 2;

                            for (EntityID blockadeEntityID : road.getBlockades()) {
                                if (GeomUtil.findDistanceTo((Blockade) world.getEntity(blockadeEntityID), middleX, middleY) <AGENT_SIZE) {
                                    shouldCheck = true;
                                } else {
                                    shouldCheck = false;
                                }
                            }

                        }
                    }


                } else {
                    shouldCheck = true;
                }

            }
        } else {
            int j;
            EntityID sourceAreaID = null;
            EntityID nextAreaID = null;
            Area sourceArea = null;
            Area nextArea = null;
            Set<Edge> edgeSet;
            SEURoad mrlRoad = null;
            SEUEdge nextEdge = null;
            List<EntityID> neighbours;
            for (int i = 0; i < pathToGo.size() - 1; i++) {
                j = i + 1;
                sourceAreaID = pathToGo.get(i);
                nextAreaID = pathToGo.get(j);
                sourceArea = world.getEntity(sourceAreaID, Area.class);
                nextArea = world.getEntity(nextAreaID, Area.class);
                if (sourceArea instanceof Road) {
                    mrlRoad = world.getSeuRoad(sourceAreaID);
                    Edge edge = sourceArea.getEdgeTo(nextArea.getID());
                    if (edge != null) {
                        nextEdge = mrlRoad.getSEUEdge(edge);
                    	
                        nextMiddlePoint = new Pair<Integer, Integer>((int) nextEdge.getMiddlePoint().getX(), (int) nextEdge.getMiddlePoint().getY());
                        if (sourceEdge == null) {

                            if (world.getSelfPosition().equals(sourceArea)) {
                                obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, world.getSelfLocation(), nextMiddlePoint));
                            } else {
                                obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceArea.getLocation(world), nextMiddlePoint));
                            }
                        } else {
                            sourceMiddlePoint = new Pair<Integer, Integer>((int) sourceEdge.getMiddlePoint().getX(), (int) sourceEdge.getMiddlePoint().getY());
                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceMiddlePoint, nextMiddlePoint));
                        }

                        if (!obstacles_MrlBlockades.isEmpty()) {
                            shouldCheck = true;
                        }
                    }
                    if (shouldCheck) {
                        break;
                    }
                    sourceEdge = nextEdge;
                } else {
                    if (nextArea instanceof Road) {
                        mrlRoad = world.getSeuRoad(nextAreaID);
                        neighbours = sourceArea.getNeighbours();
                        for (EntityID neighbourID : neighbours) {
                            
                            if (pathToGo.contains(neighbourID) && pathToGo.indexOf(neighbourID) > pathToGo.indexOf(sourceAreaID)) {
                                edgeSet = getEdgesBetween(sourceArea, nextArea);
                                for (Edge edge : edgeSet) {
                                    nextEdge = mrlRoad.getSEUEdge(edge);
                                    nextMiddlePoint = new Pair<Integer, Integer>((int) nextEdge.getMiddlePoint().getX(), (int) nextEdge.getMiddlePoint().getY());
                                    if (sourceEdge == null) {

                                        if (world.getSelfPosition().equals(sourceArea)) {
                                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, world.getSelfLocation(), nextMiddlePoint));
                                        } else {
                                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceArea.getLocation(world), nextMiddlePoint));
                                        }
                                    } else {
                                        sourceMiddlePoint = new Pair<Integer, Integer>((int) sourceEdge.getMiddlePoint().getX(), (int) sourceEdge.getMiddlePoint().getY());
                                        obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceMiddlePoint, nextMiddlePoint));
                                    }

                                    if (!obstacles_MrlBlockades.isEmpty()) {
                                        shouldCheck = true;
                                    }
                                }

                                if (shouldCheck) {
                                    break;
                                }

                            }
                        }

                        if (shouldCheck) {
                            break;
                        }

                        edgeSet =getEdgesBetween(sourceArea, nextArea);
                        nextEdge = null;
                        if (edgeSet.iterator().hasNext()) {
                            nextEdge = mrlRoad.getSEUEdge(edgeSet.iterator().next());
                        }
                        sourceEdge = nextEdge;
                    } else {
                        sourceEdge = null;
                    }
                }
            }

            
            if (!shouldCheck) {


               
                if (nextArea instanceof Road) {
                    
                    Human human = (Human) world.getEntity(target);
                    Set<SEUBlockade> mrlBlockades = getRoadObstacles(world.getSeuRoad(nextArea.getID()), human.getLocation(world), new Pair<Integer, Integer>((int) sourceEdge.getMiddlePoint().getX(), (int) sourceEdge.getMiddlePoint().getY()));
                    if (mrlBlockades != null && !mrlBlockades.isEmpty()) {
                        shouldCheck = true;
                    }
                } else {

                    
                }

            }
        }


        return shouldCheck;
    }
    
    private Set<Edge> getEdgesBetween(Area area1, Area area2) {
        Set<Edge> edgesBetween = new HashSet<Edge>();
        if (!area1.getNeighbours().contains(area2.getID()))
            return edgesBetween;
        for (Edge edge : area1.getEdges()) {
            if (edge.isPassable() && edge.getNeighbour().equals(area2.getID())) {
                edgesBetween.add(edge);
            }
        }
        return edgesBetween;
    }
    
   
    private boolean isInClearRange(Blockade target) {
        return GeomUtil.findDistanceTo(target, world.getSelfLocation().first(), 
        		world.getSelfLocation().second()) < maxClearDistance-500;
    }

    private Pair<Blockade, Integer> getNearestBlockade(Set<Blockade> blockades) {

        if (blockades == null || blockades.isEmpty()) {
            return null;
        }

        int x = world.getSelfLocation().first();
        int y = world.getSelfLocation().second();


        int minDistance = Integer.MAX_VALUE;
        Pair<Blockade, Integer> nearestBlockadePair = new Pair<Blockade, Integer>(blockades.iterator().next(), 0);
        int tempDistance;
        for (Blockade blockade : blockades) {
            tempDistance = GeomUtil.findDistanceTo(blockade, x, y);
            if (tempDistance < minDistance) {
                minDistance = tempDistance;
                nearestBlockadePair = new Pair<Blockade, Integer>(blockade, minDistance);
            }
        }

        return nearestBlockadePair;
    }

   
    private Set<SEUBlockade> getRoadObstacles(SEURoad mrlRoad, Pair<Integer, Integer> firstPoint, Pair<Integer, Integer> secondPoint) {
        Set<SEUBlockade> obstacles = new HashSet<SEUBlockade>();
        for (SEUBlockade blockade : mrlRoad.getSeuBlockades()) {
            Point2D sourcePoint = GeomUtil.getPoint(firstPoint);
            Point2D endPoint = GeomUtil.getPoint(secondPoint);
            if (blockade.getPolygon().contains(firstPoint.first(), firstPoint.second()) || GeomUtil.intersections(blockade.getPolygon(), new Line2D(sourcePoint, endPoint)).size() > 0
                    || GeomUtil.findDistanceTo(blockade.getSelfBlockade(), firstPoint.first(), firstPoint.second()) < 500
                    || GeomUtil.findDistanceTo(blockade.getSelfBlockade(), secondPoint.first(), secondPoint.second()) < 500) {
                obstacles.add(blockade);
            }
        }

        return obstacles;
    }


    private List<Blockade> getBlockadesInRange(Pair<Integer, Integer> targetLocation, List<Blockade> list, int range) {
        List<Blockade> blockades = new ArrayList<Blockade>();
        for (Blockade blockade : list) {
            if (GeomUtil.findDistanceTo(blockade, targetLocation.first(), targetLocation.second()) < range) {
                blockades.add(blockade);
            }
        }
        return blockades;
    }
  
    
    private Set<Blockade> getBlockadesInRange(Road road, Set<Blockade> blockadeSeen) {
        Set<Blockade> blockadeSet = new FastSet<Blockade>();
        for (Blockade blockade : blockadeSeen) {
            for (Edge edge : road.getEdges()) {
                if (edge.isPassable() && GeomUtil.findDistanceTo(blockade, road.getX(), road.getY()) < 1200) {
                    blockadeSet.add(blockade);
                }

            }
        }
        return blockadeSet;
    }

   
    private Set<Blockade> getTargetRoadBlockades(Road road) {
        Set<Blockade> blockades = new FastSet<Blockade>();
        if (world.isVisible(road.getID())&& road.isBlockadesDefined()) {
            for (EntityID entityID : road.getBlockades()) {
                blockades.add((Blockade) world.getEntity(entityID));
            }
        }
        return blockades;
    }

   
    private Pair<Line2D, Line2D> getClearSecureLines(Line2D clearLine1, Line2D clearLine2, double clearRadius, double distance) {
        Line2D l1, l2;
        double x1, y1, x2, y2;
        Point2D origin1, endPoint1;
        Point2D origin2, endPoint2;
        double ratio = distance / (clearRadius * 2);
        double minX1, maxX1, minY1, maxY1;
        double minX2, maxX2, minY2, maxY2;

        origin1 = clearLine1.getOrigin();
        endPoint1 = clearLine1.getEndPoint();
        origin2 = clearLine2.getOrigin();
        endPoint2 = clearLine2.getEndPoint();

        minX1 = Math.min(origin1.getX(), origin2.getX());
        maxX1 = Math.max(origin1.getX(), origin2.getX());
        minY1 = Math.min(origin1.getY(), origin2.getY());
        maxY1 = Math.max(origin1.getY(), origin2.getY());
        minX2 = Math.min(endPoint1.getX(), endPoint2.getX());
        maxX2 = Math.max(endPoint1.getX(), endPoint2.getX());
        minY2 = Math.min(endPoint1.getY(), endPoint2.getY());
        maxY2 = Math.max(endPoint1.getY(), endPoint2.getY());

        x1 = ratio * (maxX1 - minX1);
        y1 = ratio * (maxY1 - minY1);
        x2 = ratio * (maxX2 - minX2);
        y2 = ratio * (maxY2 - minY2);

        Point2D p1 = new Point2D(
                origin1.getX() == maxX1 ? maxX1 - x1 : minX1 + x1,
                origin1.getY() == maxY1 ? maxY1 - y1 : minY1 + y1);
        Point2D p2 = new Point2D(
                endPoint1.getX() == maxX2 ? maxX2 - x2 : minX2 + x2,
                endPoint1.getY() == maxY2 ? maxY2 - y2 : minY2 + y2);
        l1 = new Line2D(p1, p2);


        p1 = new Point2D(
                origin2.getX() == maxX1 ? maxX1 - x1 : minX1 + x1,
                origin2.getY() == maxY1 ? maxY1 - y1 : minY1 + y1);
        p2 = new Point2D(
                endPoint2.getX() == maxX2 ? maxX2 - x2 : minX2 + x2,
                endPoint2.getY() == maxY2 ? maxY2 - y2 : minY2 + y2);
        l2 = new Line2D(p1, p2);
        l1 = GeomUtil.clipLine(l1, GeomUtil.lineLength(l1) - world.getConfig().repairRad / 2 + 100, true);
        l2 = GeomUtil.clipLine(l2, GeomUtil.lineLength(l2) - world.getConfig().repairRad / 2 + 100, true);
        return new Pair<Line2D, Line2D>(l1, l2);
    }
    
   
    
   
    private Line2D getTargetGuideline(List<EntityID> path, double range, EntityID targetID) {
        if (path == null || range <= 0 || targetID == null) {
            return null;
        }
        Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());
        StandardEntity target = world.getEntity(targetID);
        Line2D guideLine = null;
        
        if (path.size() == 1) {
            if (target instanceof Building&&!(target instanceof Refuge)) {
                Set<Edge> edges = getEdgesBetween((Area) world.getEntity(path.get(0)), (Area) target);
                if (edges != null && !edges.isEmpty()) {
                    Edge edge = edges.iterator().next();
                    int middleX = (edge.getStartX() + edge.getEndX()) / 2;
                    int middleY = (edge.getStartY() + edge.getEndY()) / 2;
                    Point2D targetPoint = new Point2D(middleX, middleY);
                    List<Line2D> pathGuidelines = getPathGuidelines(path, targetPoint);
                    if (pathGuidelines.isEmpty()) {
                        guideLine = new Line2D(agentPosition, targetPoint);
                    } else {
                    	guideLine = getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).first();
                        lastLineAreas=getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).second();
                    }
                }
            }
        } else if (!targetID.equals(lastTarget) || lastGuideline == null || !lastLineAreas.contains(world.getSelfPosition().getID())) {
            Point2D targetPoint = GeomUtil.getPoint(target.getLocation(world));
            List<Line2D> pathGuidelines = getPathGuidelines(path, targetPoint);
            if (/*path.isEmpty() || */pathGuidelines.isEmpty()) {
                guideLine = new Line2D(agentPosition, targetPoint);
            } else {
            	guideLine = getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).first();
                lastLineAreas=getTargetGuideLine(pathGuidelines, path, targetID, maxClearDistance).second();
            }
        } else {
            guideLine = lastGuideline;
        }
        return guideLine;
    }
    
    private List<Area> getAreasSeenInPath(List<EntityID> path) {
        List<Area> areasSeenInPath = new ArrayList<Area>();
        Area area;
        for (EntityID id : path) {
            area = world.getEntity(id, Area.class);
            if (agent.getChanged().contains(id)) {
                areasSeenInPath.add(area);
            } else {
                break;
            }
        }
        return areasSeenInPath;
    }
    
    private Line2D getTargetClearLine(List<Area> areasSeenInPath, double range, Line2D guideLine) {
        Point2D agentPosition = GeomUtil.getPoint(world.getSelfLocation());

        if (!isNeedToClear(agentPosition, areasSeenInPath, guideLine)) {
            return null;
        }
        return getClearLine(agentPosition, guideLine, range);
    }
    
    private boolean isNeedToClear(Point2D agentLocation, List<Area> areasSeenInPath, Line2D guideLine) {
        if (guideLine == null) {
            return false;
        }
        if (GeomUtil.distance(guideLine, agentLocation) > AGENT_SIZE) {
            return true;
        }
        for (Area area : areasSeenInPath) {
            if (area.isBlockadesDefined()) {
                for (EntityID blockID : area.getBlockades()) {
                    Blockade blockade = world.getEntity(blockID, Blockade.class);
                    if (blockade != null) {
                        Polygon blockadePoly = GeomUtil.getPolygon(blockade.getApexes());
                        if (!GeomUtil.isPassable(blockadePoly, guideLine, AGENT_PASSING_THRESHOLD)) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
    
    private Line2D getClearLine(Point2D agentPosition, Line2D guideLine, double range) {
        Line2D targetLine = new Line2D(agentPosition, guideLine.getDirection());
        return GeomUtil.clipLine(targetLine, range - 300);
    }

    private boolean anyBlockadeIntersection(Collection<Area> areasSeenInPath, Line2D targetLine, boolean secure) {
        Line2D line;
        if (secure) {
            double length = GeomUtil.lineLength(targetLine);
            double secureSize = 510 + SECURE_RANGE;
            if (length - secureSize <= 0) {           
                return false;
            }
            line = GeomUtil.improveLine(targetLine, -secureSize);
        } else {
            line = targetLine;
        }
        for (Area area : areasSeenInPath) {
            if (anyBlockadeIntersection(area, line)) {
                return true;
            }
        }
        return false;
    }
    
    private Point2D anyBlockadeIntersection(Line2D guideLine,List<EntityID> lineAreas) {
        List<Area> areas = new ArrayList<Area>();
        for (StandardEntity entity : world.getEntities(lineAreas)) {
            areas.add((Area) entity);
        }
        Point2D nearestPoint = null;
        Point2D agentLocation = GeomUtil.getPoint(world.getSelfLocation());
        int minDist = Integer.MAX_VALUE;
        for (Area area : areas) {

            List<Point2D> intersects = blockadesIntersections(area, guideLine);
            for (Point2D point2D : intersects) {
                int dist = GeomUtil.distance(point2D, agentLocation);
                if (dist < minDist) {
                    minDist = dist;
                    nearestPoint = point2D;
                }
            }
        }
        return nearestPoint;
    }
    
    public int getIndexInPath(List<EntityID> path, EntityID location) {
		int index = 0;
		for (EntityID next : path) {
			if (location.getValue() == next.getValue())
				break;
			index++;
		}
		return index;
	}
	
    Blockade getNearestBlockade() {
		Set<Blockade> blockades = new HashSet<Blockade>();
		StandardEntity entity = null;
		for (EntityID next : agent.getChanged()) {
			entity = world.getEntity(next);		
			if (entity instanceof Blockade) {
				Blockade bloc = (Blockade) entity;
//				if (bloc.isApexesDefined() && bloc.getApexes().length < 6)
//					continue;                    //wujie 2015.6
				blockades.add(bloc);
			}
		}
		if(blockades.isEmpty()){
			System.out.println("  blockades.isEmpty() 1");
		}
		Blockade nearestBlockade = null;
		double minDistance = maxClearDistance;
		for (Blockade next : blockades) {
			double distance = getDistanceTo(next,agent.getCurrentPosition());
			if (distance < minDistance) {
				nearestBlockade = next;
				minDistance = distance;
			}
		}		
		return nearestBlockade;
	}
	
	private List<EntityID> getPathToBlockade(List<EntityID> lastPath, Blockade blockade) {
		int current_L_I=getIndexInPath(lastPath, world.getSelfPosition().getID());
		List<EntityID> path = new ArrayList<EntityID>();
		if (!blockade.isPositionDefined()){					
			path.add(world.getSelfPosition().getID());
			return path;
		}			
		EntityID blo_A = blockade.getPosition();
		int b_index = getIndexInPath(lastPath, blo_A);				
		if (b_index < lastPath.size()) {
			for (int i = current_L_I; i <= b_index; i++)
				path.add(lastPath.get(i));
		}
		if (path.isEmpty()) {		
			path.add(world.getSelfPosition().getID());
		}
		return path;
	}
	
	public void clearBlockadeID(Blockade target) throws ActionCommandException {
		double distance = getDistanceTo(target,agent.getCurrentPosition());
		if (distance < maxClearDistance -500/*&& agent.isVisible(target)*/) {
			agent.sendClearID(target.getID());
		} else {	
			Area road=(Area)world.getEntity(target.getPosition());
			List<EntityID> path =agent.getPathToAreaInNormal(road);		
			if (path.size() > 0) {	
				agent.sendMove( path, target.getX(), target.getY());
			}else{
			//	System.out.println(agent.getID()+"  "+agent.getTimeStep()+"  "+target.getID()+"   有问题");
			}
		}
	}
	
	
	public void clearBlockadeArea(int x,int y,List<EntityID> path) throws ActionCommandException {
		Point dirPoint=new Point(x,y);
		double distance = Distance.getDistance(dirPoint,agent.getCurrentPosition());
		if (distance < maxClearDistance-500 /*&& agent.isVisible(target)*/) {
			
			agent.sendClearArea(x,y);
		} else {		
			if (path.size() > 0) {	
			
				agent.sendMove( path, x, y);
			}else{
			}
		}
	}
	
	public double getDistanceTo(Blockade b, Point p) {
		if(p!=null){
		Polygon bloc_pol = Util.getPolygon(b.getApexes());	
		return Distance.getDistance(bloc_pol, p);
		}else{
			return 100000;
		}
	}
	
	public Point getClosestPointToBlock(Blockade b,Point p) {	
		return getClosestPointToBlock(b,p.x,p.y);
	}
	
	public Point getClosestPointToBlock(Blockade b, int x, int y) {		
		List<Line2D> lines = GeometryTools2D.pointsToLines(GeometryTools2D.vertexArrayToPoints(b.getApexes()), true);
		double best = Double.MAX_VALUE;
		Point2D origin = new Point2D(x, y);
		Point p;
		Point2D bestPoint = null;
		for (Line2D next : lines) {
			Point2D closest = GeometryTools2D.getClosestPointOnSegment(next,origin);
			double d = GeometryTools2D.getDistance(origin, closest);
			if (d < best) {
				best = d;
				bestPoint = closest;
			}
		}
		p = new Point((int) bestPoint.getX(), (int) bestPoint.getY());
		return p;
	}
	
	private Blockade getClosestBlockade() {
		Blockade target;
		Point position = agent.getCurrentPosition();
		MultiBlockDistanceComparator comparator = new MultiBlockDistanceComparator(world, position);
		List<Blockade> blockades = agent.getObservableBlockades();
		if (blockades.isEmpty()) {
			return null;
		}
		Collections.sort(blockades, comparator);
		target = blockades.get(0);
		return target;
	}
	
	
	
	
	
	public Blockade getClosestBlockadeInCurrentLocation() {
		Human human;
		Area area;
		Road road;
		Blockade target;
		human = agent.getMeAsHuman();
		area = (Area) human.getPosition(world);
		if (area instanceof Road) {
			road = (Road) area;
			target = getClosestBlockadeInRoad(road);
		} else {
			target = null;
		}
		return target;
	}
	
	private Blockade getClosestBlockadeInRoad(Road road) {
		List<Blockade> blockades;
		Blockade target;
		Point position = agent.getCurrentPosition();
		MultiBlockDistanceComparator comparator = new MultiBlockDistanceComparator(world, position);
		if (!road.isBlockadesDefined()) {
			return null;
		}
		blockades =getBlockades(road);
		if (blockades.isEmpty()) {
			return null;
		}
		Collections.sort(blockades, comparator);
		target = blockades.get(0);
		return target;
	}
	
	public List<Blockade> getBlockades(Road road) {
		List<EntityID> blockadeIds;
		List<Blockade> blockades;
		if (road.isBlockadesDefined()) {
			blockadeIds = road.getBlockades();
			blockades = new ArrayList<Blockade>();
			for (EntityID id : blockadeIds) {
				Blockade blockade = world.getEntity(id, Blockade.class);
				blockades.add(blockade);
			}
			return blockades;
		} else {
			return null;
		}
	}
	
	private List<EntityID> getPathToClosestBlockedRoad() {		
		List<Road> blockedRoads = getBlockedRoads();		
		return agent.getPathToRoadsInNormal(blockedRoads);
	}
	
	private Blockade getTargetBlockade(Area area, int maxDistance) {
		if (!area.isBlockadesDefined()) {
			return null;
		}
		List<EntityID> ids = area.getBlockades();
		Point agentPoint =agent.getCurrentPosition();
		for (EntityID next : ids) {
			Blockade b = (Blockade) world.getEntity(next);
			double d;
			d = Distance.getDistanceToBlock(b, agentPoint);
			if (maxDistance < 0 || d < maxDistance) {
				return b;
			}
		}
		return null;
	}

	public List<Blockade> getBlockades() {
		List<Road> roads;
		List<Blockade> blockades;
		roads = world.getEntitiesOfType(Road.class, StandardEntityURN.ROAD);
		blockades = new ArrayList<Blockade>();
		for (Road road : roads) {
			if (road.isBlockadesDefined()) {
				List<EntityID> blockadeIds;
				blockadeIds = road.getBlockades();
				for (EntityID id : blockadeIds) {
					Blockade blockade = world.getEntity(id, Blockade.class);
					blockades.add(blockade);
				}
			}
		}
		return blockades;
	}
	
	private List<Road> getBlockedRoads() {
		List<Road> targets = new ArrayList<Road>();
		for (StandardEntity next : world
				.getEntitiesOfType(StandardEntityURN.ROAD)) {
			Road r = (Road) next;
			if (r.isBlockadesDefined() && !r.getBlockades().isEmpty()) {
				targets.add(r);
			}
		}
		Collections.sort(targets, new DistanceComparator(agent.location(), world));
		return targets;
	}
	
	private void clearAroundTarget(Pair<Integer, Integer> targetLocation) throws ActionCommandException {
        List<Blockade> blockadesAround = getBlockadesInRange(targetLocation, agent.getObservableBlockades(), 1000);
        if (!blockadesAround.isEmpty()) {
            for (Blockade blockade : blockadesAround) {
                if (isInClearRange(blockade)) {
                    agent.sendClearID( blockade.getID());
                }
            }
        }
    }
	
	private Set<Blockade> getBlockadesOnWay(List<EntityID> pathToGo, Set<Road> roadsSeen, EntityID target) {
        Set<SEUBlockade> obstacles_MrlBlockades = new HashSet<SEUBlockade>();
        Set<Blockade> blockades = new FastSet<Blockade>();
        SEUEdge sourceEdge = null;
        Pair<Integer, Integer> nextMiddlePoint;
        Pair<Integer, Integer> sourceMiddlePoint;
        List<EntityID> seenPath = new ArrayList<EntityID>();
        int count = 0;
        for (EntityID entityID : pathToGo) {
            if (world.getEntity(entityID) instanceof Road) {
                if (!roadsSeen.contains(world.getEntity(entityID, Road.class))) {
                    if (pathToGo.size() > count) {
                        seenPath.add(pathToGo.get(count));
                    }
                    break;
                }
            }
            count++;
            seenPath.add(entityID);
        }
        if (seenPath.isEmpty()) {
            
        } else if (seenPath.size() == 1) {
            if (world.getEntity(seenPath.get(0)) instanceof Road) {
                if (target != null) {
                    blockades =getTargetRoadBlockades((Road) world.getEntity(seenPath.get(0)));
                } else {
                    blockades = getBlockadesInRange(world.getSelfLocation(), 500 * 2);
                }
            }
        } else {
            int j;
            EntityID sourceAreaID;
            EntityID nextAreaID;
            Area sourceArea;
            Area nextArea = null;
            Set<Edge> edgeSet;
            SEURoad mrlRoad;
            SEUEdge nextEdge = null;
            List<EntityID> neighbours;
            for (int i = 0; i < seenPath.size() - 1; i++) {
                j = i + 1;
                sourceAreaID = seenPath.get(i);
                nextAreaID = seenPath.get(j);
                sourceArea = world.getEntity(sourceAreaID, Area.class);
                nextArea = world.getEntity(nextAreaID, Area.class);
                if (sourceArea instanceof Road) {
                    mrlRoad = world.getSeuRoad(sourceAreaID);
                    edgeSet = getEdgesBetween(sourceArea, nextArea);
                    for (Edge edge : edgeSet) {
                        nextEdge = mrlRoad.getSEUEdge(edge);
                        nextMiddlePoint = new Pair<Integer, Integer>((int) nextEdge.getMiddlePoint().getX(), (int) nextEdge.getMiddlePoint().getY());
                        if (sourceEdge == null) {

                            if (world.getSelfPosition().equals(sourceArea)) {
                                obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, world.getSelfLocation(), nextMiddlePoint));
                            } else {
                                obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceArea.getLocation(world), nextMiddlePoint));
                            }
                        } else {
                            sourceMiddlePoint = new Pair<Integer, Integer>((int) sourceEdge.getMiddlePoint().getX(), (int) sourceEdge.getMiddlePoint().getY());
                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceMiddlePoint, nextMiddlePoint));
                        }
                    }
                    sourceEdge = nextEdge;
                } else {
                    if (nextArea instanceof Road) {
                        mrlRoad = world.getSeuRoad(nextAreaID);
                        neighbours = sourceArea.getNeighbours();
                        for (EntityID neighbourID : neighbours) {
                            if (pathToGo.contains(neighbourID) && pathToGo.indexOf(neighbourID) > pathToGo.indexOf(sourceAreaID)) {
                                edgeSet = getEdgesBetween(sourceArea, nextArea);
                                for (Edge edge : edgeSet) {
                                    nextEdge = mrlRoad.getSEUEdge(edge);
                                    nextMiddlePoint = new Pair<Integer, Integer>((int) nextEdge.getMiddlePoint().getX(), (int) nextEdge.getMiddlePoint().getY());
                                    if (sourceEdge == null) {

                                        if (world.getSelfPosition().equals(sourceArea)) {
                                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, world.getSelfLocation(), nextMiddlePoint));
                                        } else {
                                            obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceArea.getLocation(world), nextMiddlePoint));
                                        }
                                    } else {
                                        sourceMiddlePoint = new Pair<Integer, Integer>((int) sourceEdge.getMiddlePoint().getX(), (int) sourceEdge.getMiddlePoint().getY());
                                        obstacles_MrlBlockades.addAll(getRoadObstacles(mrlRoad, sourceMiddlePoint, nextMiddlePoint));
                                    }
                                }
                            }
                        }
                        edgeSet = getEdgesBetween(sourceArea, nextArea);
                        nextEdge = null;
                        if (edgeSet.iterator().hasNext()) {
                            nextEdge = mrlRoad.getSEUEdge(edgeSet.iterator().next());
                        }
                        sourceEdge = nextEdge;
                    } else {
                        sourceEdge = null;
                    }
                }
            }
            if (nextArea instanceof Road) {
                blockades = getTargetRoadBlockades((Road) nextArea);
            }
        }
        for (SEUBlockade blockade : obstacles_MrlBlockades) {
            blockades.add(blockade.getSelfBlockade());
        }
        return blockades;
    }

    private Set<Blockade> getBlockadesInRange(Pair<Integer, Integer> position, int range) {
        Set<Blockade> blockadeSet = new FastSet<Blockade>();
        for (Blockade blockade : agent.getObservableBlockades()) {
            if (blockade.getShape().contains(position.first(), position.second()) || GeomUtil.findDistanceTo(blockade, position.first(), position.second()) < range) {
                blockadeSet.add(blockade);
            }
        }
        return blockadeSet;
    }
    private Boolean buildingHasHuman(Building b){//wujie 2015.6
    	StandardEntity entity = null;
    	for(EntityID next:agent.getChanged()){
		//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman---true--human"+next);

    		entity=world.getEntity(next);
    		if(entity instanceof Human){
    			
    			EntityID area=((Human)entity).getPosition();
			//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman---true--entity"+entity);
			//	System.out.println(area + " " +b.getID());

    			if(area.equals(b.getID())){
				///	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman---true"+b);

    				return true;
    			}
    		}
    	}	
		//System.out.println(agent.getTimeStep()+"   "+agent.getID()+"buildinghashuman---false"+b);

    	return false;
    }
}
