package seu.agent.pf.Tasks;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Observable;
import java.util.Set;
import java.util.SortedSet;
import java.util.Stack;
import java.util.TreeSet;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.pf.PFLastTaskTarget;
import seu.agent.pf.PoliceForceAgent;
import seu.agent.pf.Tasks.SEUPFLastTaskType.PFPartitionLastTaskEnum;
import seu.agent.pf.cluster.Cluster;
import seu.agent.SEUAgent.ActionCommandException;
import seu.common.BasicTask;
import seu.geom.Distance;
import seu.model.BuriedHumans;
import seu.model.SEUWorldModel;
import seu.model.object.SEUBuilding;
import seu.model.object.SEUBuriedHumans;
import seu.model.object.SEURoad;
import seu.model.object.seuZoneEntity.SeuZone;
import seu.model.route.pov.POVRouter;
import seu.standard.DistanceComparator;
import seu.util.HumanDistanceComparator;
import seu.util.StandardEntityIDComparator;


public class HelpOtherTask extends BasicTask<PoliceForceAgent>{

	POVRouter search;	
	public Set<Road> entrancesOfBurningRegion;
	public Set<Building> hadSearchBuringBuildings;
	public Set<Road> needCheckEntranceSet;
	public Set<Road> buriedEntrances;
	public ClearTools clearTools;
	public List<EntityID> lastCyclePath ;
	public Set<Refuge> nearRefuge ;
	public Set<EntityID> visitedRefuges ;
	public Set<Human> NearBuriedAgent;
	public Set<EntityID> visitedBuriedAgent;
	public PFPartitionLastTaskEnum partitionLastTaskType;
	public PFLastTaskTarget taskTarget;
	public Set<Refuge> needCheckRefugeSet;
	public Map<EntityID,EntityID> firstStuckAgents;
	public Map<EntityID,EntityID> firstBuriedAgents;	
	public PFTarget lastPFTarget;
	public List<Building> visualBurningBuliding=new ArrayList<Building>();
	SEUWorldModel world;
	int clearDistance=0;
	int extinguishableDistance;
	public Map<EntityID,List<EntityID>> roadToBuildings;
	
	public HelpOtherTask(PoliceForceAgent agent) {
		super(agent);
		world=agent.getModel();
		roadToBuildings=new HashMap<EntityID,List<EntityID>>();
		clearDistance=world.getConfig().repairDistance;
		extinguishableDistance=world.getConfig().extinguishableDistance;	
		search=agent.search;				
		entrancesOfBurningRegion=agent.entrancesOfBurningRegion;
		hadSearchBuringBuildings=agent.hadSearchBuringBuildings;		
		needCheckEntranceSet=agent.needCheckEntranceSet;
		buriedEntrances=agent.buriedEntrances;		
		clearTools=agent.clearTools;
		lastCyclePath=agent.lastCyclePath;
		nearRefuge=agent.nearRefuges;
		visitedRefuges=agent.visitedRefuges;
		NearBuriedAgent=agent.nearBuriedAgents;
		visitedBuriedAgent=agent.visitedBuriedAgent;
		partitionLastTaskType=agent.partitionLastTaskType;
		taskTarget=agent.taskTarget;
		needCheckRefugeSet=agent.needCheckRefugeSet;
		firstStuckAgents=agent.firstStuckAgents;
		firstBuriedAgents=agent.firstBuriedAgents;
		lastPFTarget=agent.lastPFTarget;
	}


	@Override
	public void execute() throws ActionCommandException {
		//clearBurningBuildingInPartition1();//yuanc14.10.10
		
		finishTaskSameToOthers();
		clearFireToRefuge();//wujie 2015.6
		clearObservableTask();
		clearNearTask();
		//agent.finishCurrent();
		clearAllTargetTask();
		
	}
//	int count=0;
	public void clearFireToRefuge()throws ActionCommandException{//wujie 2015.6
		if(agent.lastPFTarget!=null&&agent.lastPFTarget.getID()!=null){			
			if(agent.lastPFTarget.getTaskRank()==PFTaskRank.SELFHELP){
				if(!agent.lastPFTarget.isDone()){					
						if(!agent.visitedRefuges.contains(agent.lastPFTarget.getID())){
							agent.sendClearPFTarget(agent.lastPFTarget);
							}else{
								agent.lastPFTarget.setDone();
								agent.updatePFTarget();
				}					
			}
		}
	}
		if(!agent.currentPartition.getRefugeList().isEmpty()){
			return;
		}
//		if(count>0){
//			return;
//		}
		if(world.getAllRefuges()==null||world.getAllRefuges().isEmpty()){
			return;
		}
			if(getVisualBurningBuildings()!=null&&!getVisualBurningBuildings().isEmpty()){
				List<Building> burningBuildings=new ArrayList<Building>();
				burningBuildings.addAll(getVisualBurningBuildings());
				Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
				Collections.sort(burningBuildings, comparator);
				try{
				Comparator<StandardEntity> comparator1=new DistanceComparator(burningBuildings.get(0),world);
				Collections.sort(world.getAllRefuges(), comparator1);
				}catch(Exception e){}
				if(agent.visitedRefuges.contains(world.getAllRefuges().get(0).getID())){
					return ;
				}
				PFTarget target=new PFTarget(world.getAllRefuges().get(0).getID(),SEUPFTargetType.BLOCKADE_REFUGE);
				target.setTaskRank(PFTaskRank.SELFHELP);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearFireToRefuge"+target.getID());
				agent.sendClearPFTarget(target);
		//		count++;
			}
		}	
	
	private void clearObservableTask() throws ActionCommandException{		
		if(agent.lastPFTarget!=null&&agent.lastPFTarget.getID()!=null){			
			if(agent.lastPFTarget.getTaskRank()==PFTaskRank.OBSERVABLE){
				if(!agent.lastPFTarget.isDone()){					
					StandardEntity target=world.getEntity(agent.lastPFTarget.getID());
					if(agent.observableStuckedCivilians.contains(target)||
							agent.observableStuckedAgents.contains(target)||
							agent.observableBuriedAgents.contains(target)||
							agent.observableRefuges.contains(target)||
							agent.observableEntrances.contains(target)||
							agent.observableGasStations.contains(target)){
						agent.sendClearPFTarget(agent.lastPFTarget);
					}else{
						agent.lastPFTarget.setDone();
						agent.updatePFTarget();
					}					
				}
			}
		}		
		
		int rank=0;
		
		if(agent.observableStuckedCivilians!=null&&!agent.observableStuckedCivilians.isEmpty()){
			Comparator<StandardEntity> comparator=new StandardEntityIDComparator();
			Collections.sort(agent.observableStuckedCivilians, comparator);
		
			List<Civilian> observableStuckedCivilians1=new ArrayList<Civilian>();
			for(Civilian next:agent.observableStuckedCivilians){
				observableStuckedCivilians1.add(next);
			}
		
				/*if(rank<stuckAgentSelectRank){
					continue;
				}*/
				PFTarget target=new PFTarget(observableStuckedCivilians1.get(0).getID(),SEUPFTargetType.STUCK_HUMAN_IN_ROAD);
				target.setTaskRank(PFTaskRank.OBSERVABLE);
				agent.lastPFTarget=target;
			//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableStuckedCivilians"+target.getID());
				agent.sendClearPFTarget(target);
				
		}
		if(agent.observableStuckedAgents!=null&&!agent.observableStuckedAgents.isEmpty()){
			Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(agent.observableStuckedAgents, comparator);
			
			
			List<Human> observableStuckedAgents1=new ArrayList<Human>();
			for(Human next:agent.observableStuckedAgents){
				if(agent.visitedBuriedAgent.contains(next.getID())){
					StandardEntity location = world.getEntity(next.getPosition());
					if (location instanceof Building){
						continue;
					}else{
					observableStuckedAgents1.add(next);}	
					}else{
					observableStuckedAgents1.add(next);}	
			}			
			   if(observableStuckedAgents1!=null&&!observableStuckedAgents1.isEmpty()){
				StandardEntity hu_posi_e = world.getEntity(observableStuckedAgents1.get(0).getPosition());
				if (hu_posi_e instanceof Road) {
					PFTarget target=new PFTarget(observableStuckedAgents1.get(0).getID(),SEUPFTargetType.STUCK_HUMAN_IN_ROAD);
					target.setTaskRank(PFTaskRank.OBSERVABLE);
					agent.lastPFTarget=target;
					agent.sendClearPFTarget(target);
				}else if(hu_posi_e instanceof Building){
					PFTarget target=new PFTarget(observableStuckedAgents1.get(0).getID(),SEUPFTargetType.BLOCKADE_HUMAN_IN_BUILDING);
					target.setTaskRank(PFTaskRank.OBSERVABLE);
					agent.lastPFTarget=target;
			//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableStuckedAgents"+target.getID());
					agent.sendClearPFTarget(target);
				}
			   }
			
		}
		if(agent.observableBuriedAgents!=null&&!agent.observableBuriedAgents.isEmpty()){
			Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(agent.observableBuriedAgents, comparator);
			
			List<Human> observableBuriedAgents1=new ArrayList<Human>();
			for(Human next:agent.observableBuriedAgents){
				if(!agent.visitedBuriedAgent.contains(next.getID()))
				observableBuriedAgents1.add(next);
			}
		   if(observableBuriedAgents1!=null&&!observableBuriedAgents1.isEmpty()){
				PFTarget target=new PFTarget(observableBuriedAgents1.get(0).getID(),SEUPFTargetType.BURIED_HUMAN_IN_BUILDING);
				target.setTaskRank(PFTaskRank.OBSERVABLE);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableBuriedAgents"+target.getID());
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"visitedburied"+agent.visitedBuriedAgent);

				agent.sendClearPFTarget(target);
				}
			
		}
		
		if(agent.observableRefuges!=null&&!agent.observableRefuges.isEmpty()){
			
			List<Refuge> observableRefuges1=new ArrayList<Refuge>();
			for(Refuge next:agent.observableRefuges){
				if(!agent.visitedRefuges.contains(next.getID())){
				observableRefuges1.add(next);}
			}
			if(observableRefuges1!=null&&!observableRefuges1.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(observableRefuges1, comparator);
			
				PFTarget target=new PFTarget(observableRefuges1.get(0).getID(),SEUPFTargetType.BLOCKADE_REFUGE);
				target.setTaskRank(PFTaskRank.OBSERVABLE);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableRefuges"+target.getID());
				agent.sendClearPFTarget(target);
			}
		}
		if(agent.observableEntrances!=null&&!agent.observableEntrances.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(agent.observableEntrances, comparator);
			
			List<Road> observableEntrances1=new ArrayList<Road>();
			for(Road next:agent.observableEntrances){
				observableEntrances1.add(next);
			}
			
				PFTarget target=new PFTarget(observableEntrances1.get(0).getID(),SEUPFTargetType.BLOCKADE_ENTRANCE);
				target.setTaskRank(PFTaskRank.OBSERVABLE);
				agent.lastPFTarget=target;
	//			System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableEntrances"+target.getID());
				agent.sendClearPFTarget(target);
			
		}
//		if(agent.observableGasStations!=null&&!agent.observableGasStations.isEmpty()){
//			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
//			Collections.sort(agent.observableGasStations, comparator);
//			
//			
//			List<GasStation> observableGasStations1=new ArrayList<GasStation>();
//			for(GasStation next:agent.observableGasStations){
//				observableGasStations1.add(next);
//			}
//			for(GasStation next:observableGasStations1){
//				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BLOCKADE_GASSTATION);
//				target.setTaskRank(PFTaskRank.OBSERVABLE);
//				agent.lastPFTarget=target;
//				System.out.println(agent.getTimeStep()+"   "+agent.getID()+"observableGasStations");
//				agent.sendClearPFTarget(target);
//			}
//		}
	}
	
	private void clearNearTask() throws ActionCommandException{
		if(agent.lastPFTarget!=null&&agent.lastPFTarget.getID()!=null){			
			if(agent.lastPFTarget.getTaskRank()==PFTaskRank.NEAR){
				if(!agent.lastPFTarget.isDone()){					
					StandardEntity target=world.getEntity(agent.lastPFTarget.getID());
					if(agent.nearStuckedAgents.contains(target)||
							agent.nearBuriedAgents.contains(target)||
							agent.nearRefuges.contains(target)||
							agent.nearEntrances.contains(target)||
							agent.nearGasStations.contains(target)){
						agent.sendClearPFTarget(agent.lastPFTarget);
					}else{
						agent.lastPFTarget.setDone();
						agent.updatePFTarget();
					}					
				}
			}
		}
		if(agent.nearStuckedAgents!=null&&!agent.nearStuckedAgents.isEmpty()){
			Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
			SortedSet<Human> sort = new TreeSet<Human>(comparator);
			sort.addAll(agent.nearStuckedAgents);
			
			List<Human> nearStuckedAgents1=new ArrayList<Human>();
			for(Human next:sort){
				nearStuckedAgents1.add(next);
			}
			
				StandardEntity hu_posi_e = world.getEntity(nearStuckedAgents1.get(0).getPosition());
				if (hu_posi_e instanceof Road) {
					PFTarget target=new PFTarget(nearStuckedAgents1.get(0).getID(),SEUPFTargetType.STUCK_HUMAN_IN_ROAD);
					target.setTaskRank(PFTaskRank.NEAR);
					agent.lastPFTarget=target;
					agent.sendClearPFTarget(target);
				}else if(hu_posi_e instanceof Building){
					PFTarget target=new PFTarget(nearStuckedAgents1.get(0).getID(),SEUPFTargetType.BLOCKADE_HUMAN_IN_BUILDING);
					target.setTaskRank(PFTaskRank.NEAR);
					agent.lastPFTarget=target;
			//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"nearStuckedAgents"+target.getID());

					agent.sendClearPFTarget(target);
				}
		}
		if(agent.nearBuriedAgents!=null&&!agent.nearBuriedAgents.isEmpty()){
			Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
			SortedSet<Human> sort = new TreeSet<Human>(comparator);
			sort.addAll(agent.nearBuriedAgents);
			
			
			List<Human> nearBuriedAgents1=new ArrayList<Human>();
			for(Human next:sort){
				nearBuriedAgents1.add(next);
			}
				PFTarget target=new PFTarget(nearBuriedAgents1.get(0).getID(),SEUPFTargetType.BURIED_HUMAN_IN_BUILDING);
				target.setTaskRank(PFTaskRank.NEAR);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"nearBuriedAgents"+target.getID());

				agent.sendClearPFTarget(target);
			
		}
if(agent.nearRefuges!=null&&!agent.nearRefuges.isEmpty()){
			
			List<Refuge> nearRefuges1=new ArrayList<Refuge>();
			for(Refuge next:agent.nearRefuges){
				if(!agent.visitedRefuges.contains(next.getID())){
					nearRefuges1.add(next);}
			}
			if(nearRefuges1!=null&&!nearRefuges1.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(nearRefuges1, comparator);
			
				PFTarget target=new PFTarget(nearRefuges1.get(0).getID(),SEUPFTargetType.BLOCKADE_REFUGE);
				target.setTaskRank(PFTaskRank.OBSERVABLE);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"nearRefuges"+target.getID());
				agent.sendClearPFTarget(target);
			}
		}

//		if(agent.nearRefuges!=null&&!agent.nearRefuges.isEmpty()){
//			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
//			SortedSet<StandardEntity> sort = new TreeSet<StandardEntity>(comparator);
//			sort.addAll(agent.nearRefuges);
//			
//			
//			List<Refuge> nearRefuges1=new ArrayList<Refuge>();
//			for(Refuge next:agent.nearRefuges){
//				nearRefuges1.add(next);
//			}
//				PFTarget target=new PFTarget(nearRefuges1.get(0).getID(),SEUPFTargetType.BLOCKADE_REFUGE);
//				target.setTaskRank(PFTaskRank.NEAR);
//				agent.lastPFTarget=target;
//				System.out.println(agent.getTimeStep()+"   "+agent.getID()+"nearRefuges"+target.getID());
//
//				agent.sendClearPFTarget(target);
//			
//		}
		if(agent.nearEntrances!=null&&!agent.nearEntrances.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			SortedSet<StandardEntity> sort = new TreeSet<StandardEntity>(comparator);
			sort.addAll(agent.nearEntrances);
			
			
			List<Road> nearEntrances1=new ArrayList<Road>();
			for(StandardEntity next:sort){
				nearEntrances1.add((Road)next);
			}
			
				PFTarget target=new PFTarget(nearEntrances1.get(0).getID(),SEUPFTargetType.BLOCKADE_ENTRANCE);
				target.setTaskRank(PFTaskRank.NEAR);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"nearEntrances"+target.getID());

				agent.sendClearPFTarget(target);
			
		}
//		if(agent.nearGasStations!=null&&!agent.nearGasStations.isEmpty()){
//			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
//			SortedSet<StandardEntity> sort = new TreeSet<StandardEntity>(comparator);
//			sort.addAll(agent.nearGasStations);
//		
//			
//			List<GasStation> nearGasStations1=new ArrayList<GasStation>();
//			for(StandardEntity next:sort){
//				nearGasStations1.add((GasStation)next);
//			}
//			for(GasStation next:nearGasStations1){
//				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BLOCKADE_GASSTATION);
//				target.setTaskRank(PFTaskRank.NEAR);
//				agent.lastPFTarget=target;
//				agent.sendClearPFTarget(target);
//			}
//		}
	}
	
	private void continuewLastPFTargetTask() throws ActionCommandException{
		if(agent.lastPFTarget!=null&&agent.lastPFTarget.getID()!=null){
			agent.sendClearPFTarget(agent.lastPFTarget);
		}
	}
	
	private void clearAllTargetTask() throws ActionCommandException{
		if(agent.lastPFTarget!=null&&agent.lastPFTarget.getID()!=null){			
			if(agent.lastPFTarget.getTaskRank()==PFTaskRank.ALL){
				if(!agent.lastPFTarget.isDone()){				
					StandardEntity target=world.getEntity(agent.lastPFTarget.getID());
					if(agent.needCheckRefugeSet.contains(target)||
							world.getBuriedHumans().getTotalBuriedHuman().contains(agent.lastPFTarget.getID())||
							world.getStuckedAgents().contains(agent.lastPFTarget.getID())||
							agent.needCheckGasSatationSet.contains(target)||
							agent.entrancesOfBurningRegion.contains(target)||
							agent.firstBuriedAgents.containsKey(agent.lastPFTarget.getID())||
							agent.firstStuckAgents.containsKey(agent.lastPFTarget.getID())){
						agent.sendClearPFTarget(agent.lastPFTarget);
					}else{
						if(agent.lastPFTarget.getTargetType()==SEUPFTargetType.BURNING_BUILDING_ENTRANCE){
							agent.clearFireFlag=false;
						}
						agent.lastPFTarget.setDone();
						agent.updatePFTarget();
					}					
				}
			}
		}
		clearRefugeInPartition();
		clearToFire();
		//clearToFireBoder();
		
		clearAllStuckAgent();	
		clearAllBuriedAgent();
	//	clearGasStationInPartition();//yuanc14.10.10
		//clearImportBuild();
		//clearBurningBuildingInPartition1();//yuanc14.10.10
		
		clearFirstPosition();     
		clearBuriedCiviliansInPartition();
		//clearBurningBuildingInPartition();//2015.6.14
	}
	
	private void clearRefugeInPartition() throws ActionCommandException{
		if(agent.needCheckRefugeSet!=null&&!agent.needCheckRefugeSet.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			SortedSet<StandardEntity> sort = new TreeSet<StandardEntity>(comparator);
			sort.addAll(agent.needCheckRefugeSet);
		
			List<Refuge> needCheckRefugeSet1=new ArrayList<Refuge>();
			for(StandardEntity next:sort){
				needCheckRefugeSet1.add((Refuge)next);
			}
		
				PFTarget target=new PFTarget(needCheckRefugeSet1.get(0).getID(),SEUPFTargetType.BLOCKADE_REFUGE);
				target.setTaskRank(PFTaskRank.ALL);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearRefugeInPartition"+target.getID());

				agent.sendClearPFTarget(target);
			
		}
	}
	
	private void clearAllBuriedAgent() throws ActionCommandException {
		Collection<StandardEntity> PFEntity = world.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);
		List<Human> pfs = new ArrayList<Human>();
		for (StandardEntity next : PFEntity) {
			if(!agent.cantWorkPF.contains((Human)next)){
				pfs.add((Human)next);
			}			
		}
		
		//SEUBuriedHumans buriedHumanFactory = agent.getBuriedHumans();
		BuriedHumans buriedHumanFactory = world.getBuriedHumans();
		if(buriedHumanFactory.getTotalBuriedHuman().isEmpty()){
			return;
		}
		List<Human> buriedAgents = new ArrayList<Human>();
		List<EntityID> buriedAgentsID=new ArrayList<EntityID>();
		for(EntityID next : buriedHumanFactory.getTotalBuriedHuman()){
			buriedAgentsID.add(next);
		}
		for (EntityID next : buriedAgentsID) {
			StandardEntity entity = world.getEntity(next);
			if(entity==null){
				buriedHumanFactory.getTotalBuriedHuman().remove(next);
				continue;
			}
			if (!(entity instanceof Human)){
				buriedHumanFactory.getTotalBuriedHuman().remove(next);
				continue;
			}
			if (entity instanceof Civilian){
				buriedHumanFactory.getTotalBuriedHuman().remove(next);
				continue;		
			}
			final Human human = (Human) entity;
			if (agent.visitedBuriedAgent.contains(human.getID())) {
				buriedHumanFactory.getTotalBuriedHuman().remove(human.getID());
				//	buriedAgents.remove(human.getID());
					continue;
				}
				StandardEntity location = world.getEntity(human.getPosition());
				if (!(location instanceof Building)){
					buriedHumanFactory.getTotalBuriedHuman().remove(human.getID());
			//		buriedAgents.remove(human.getID());
					continue;
				}
			Comparator<Human> comparator=new HumanDistanceComparator(human, world);
			Collections.sort(pfs, comparator);			
			if(pfs.size()>=3){
				StandardEntity first = pfs.get(0);
			    StandardEntity second = pfs.get(1);
				StandardEntity third = pfs.get(2);		
				if (first.equals(agent.getMeAsHuman()) || second.equals(agent.getMeAsHuman()) || third.equals(agent.getMeAsHuman())) {
					buriedAgents.add(human);
				}
			}else{
				buriedAgents.add(human);
			}
		
		}
		
		if(buriedAgents.isEmpty()){
			return;
		}
		
		Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
		Collections.sort(buriedAgents, comparator);
		
	//for (Human human: buriedAgents) {
//			if (agent.visitedBuriedAgent.contains(human.getID())) {
//				buriedHumanFactory.getTotalBuriedHuman().remove(human.getID());
//				continue;
//			}
//			StandardEntity location = world.getEntity(human.getPosition());
//			if (!(location instanceof Building)){
//				buriedHumanFactory.getTotalBuriedHuman().remove(human.getID());
//				continue;
//			}
//			
			PFTarget target=new PFTarget(buriedAgents.get(0).getID(),SEUPFTargetType.BURIED_HUMAN_IN_BUILDING);
			target.setTaskRank(PFTaskRank.ALL);
			agent.lastPFTarget=target;
		//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearAllBuriedAgent"+target.getID());
		//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"visitedburied"+agent.visitedBuriedAgent);

			agent.sendClearPFTarget(target);
	//	}				
	}
	
	private void clearAllStuckAgent() throws ActionCommandException {		
		Collection<StandardEntity> PFEntity = world.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);		
		List<Human> pfs = new ArrayList<Human>();
		for (StandardEntity next : PFEntity) {
			if(!agent.cantWorkPF.contains((Human)next)){
				pfs.add((Human)next);
			}
		}
        if(world.getStuckedAgents().isEmpty()){
        	return;
        }
        List<EntityID> stuckedAgents=new ArrayList<EntityID>();
        for(EntityID next : world.getStuckedAgents()){
        	stuckedAgents.add(next);
        }
		List<Human> closetHuman = new ArrayList<Human>();
		for (EntityID next : stuckedAgents) {
			StandardEntity s=world.getEntity(next);
			if(s==null){
				world.getStuckedAgents().remove(next);
				continue;
			}
			if(!(s instanceof Human)||s instanceof Civilian){
				world.getStuckedAgents().remove(next);
				continue;
			}
			if (next.getValue() == agent.getMeAsHuman().getID().getValue()){
				world.getStuckedAgents().remove(next);
				continue;
			}
			if (world.getPoliceForceIdList().contains(next)){
				world.getStuckedAgents().remove(next);
				continue;
			}
			final Human stuckHuman = (Human)world.getEntity(next);
			if (agent.visitedBuriedAgent.contains(stuckHuman.getID())) {
				StandardEntity location = world.getEntity(stuckHuman.getPosition());
				if (location instanceof Building){
					world.getStuckedAgents().remove(next);
					continue;
				}
			}
			Comparator<Human> comparator=new HumanDistanceComparator(stuckHuman, world);
			Collections.sort(pfs, comparator);			
			if(pfs.size()>=3){
				StandardEntity first = pfs.get(0);
			    StandardEntity second = pfs.get(1);
				StandardEntity third = pfs.get(2);		
				if (first.equals(agent.getMeAsHuman()) || second.equals(agent.getMeAsHuman()) || third.equals(agent.getMeAsHuman())) {
					closetHuman.add(stuckHuman);
				}
			}else{
				closetHuman.add(stuckHuman);
			}		
		}
		if(closetHuman.isEmpty()){
		}else{
		}
		if(!closetHuman.isEmpty()){
			Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(closetHuman, comparator);
				StandardEntity hu_posi_e = world.getEntity(closetHuman.get(0).getPosition());
				if (hu_posi_e instanceof Road) {
					PFTarget target=new PFTarget(closetHuman.get(0).getID(),SEUPFTargetType.STUCK_HUMAN_IN_ROAD);
					target.setTaskRank(PFTaskRank.ALL);
					agent.lastPFTarget=target;
			//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearAllStuckAgent--road"+target.getID());

					agent.sendClearPFTarget(target);
				}else if(hu_posi_e instanceof Building){
					PFTarget target=new PFTarget(closetHuman.get(0).getID(),SEUPFTargetType.BLOCKADE_HUMAN_IN_BUILDING);
					target.setTaskRank(PFTaskRank.ALL);
					agent.lastPFTarget=target;
			//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearAllStuckAgent--building"+target.getID());

					agent.sendClearPFTarget(target);
				}
		}						
	}
	
	private void clearGasStationInPartition() throws ActionCommandException{
		if(agent.needCheckGasSatationSet!=null&&!agent.needCheckGasSatationSet.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			SortedSet<StandardEntity> sort = new TreeSet<StandardEntity>(comparator);
			sort.addAll(agent.needCheckGasSatationSet);
		
			List<GasStation> needCheckGasSatationSet1=new ArrayList<GasStation>();
			for(StandardEntity next:sort){
				needCheckGasSatationSet1.add((GasStation)next);
			}
			for(GasStation next:needCheckGasSatationSet1){
				//agent.println("分区内气站");
				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BLOCKADE_GASSTATION);
				target.setTaskRank(PFTaskRank.ALL);
				agent.lastPFTarget=target;
			//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearGasStationInPartition"+target.getID());

				agent.sendClearPFTarget(target);
			}
		}
	}
	
	private void clearBurningBuildingInPartition() throws ActionCommandException {
		if (!agent.searchBurningFlag) {
			return;
		}	
		if (agent.entrancesOfBurningRegion.size() == 0) {
			
			SeuZone searchRegion = agent.getBurningZone();
			if (searchRegion == null) {
				return;
			}		
			if (agent.hadSearchBuringBuildings.size() >= agent.buildingCount) {
				agent.searchBurningFlag = false;
				return;
			}
			agent.entrancesOfBurningRegion = agent.getEntranceOfZone(searchRegion);
			for (SEUBuilding Building : searchRegion.getBuldingsInRegion()) {
				agent.hadSearchBuringBuildings.add(Building.getSelfBuilding());
				Building bu = Building.getSelfBuilding();
				if (!bu.isFierynessDefined())
					continue;
				if (bu.getFieryness() == 8 || bu.getFieryness() == 7 || bu.getFieryness() == 3) {
					agent.entrancesOfBurningRegion.removeAll(world.getEntrance(bu));
				}
			}
			agent.needCheckEntranceSet.removeAll(agent.entrancesOfBurningRegion);
			agent.nearEntrances.removeAll(agent.entrancesOfBurningRegion);
			if(!agent.entrancesOfBurningRegion.isEmpty()){
				List<Road> r1=new ArrayList<Road>();
				for(Road next:agent.entrancesOfBurningRegion){
					r1.add(next);
				}
				Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
				Collections.sort(r1, comparator);				
				if(searchRegion.getBuldingsInRegion().size()<5){
					agent.needCheckEntranceSet.clear();
					agent.needCheckEntranceSet.add(r1.get(0));
				}else{
					agent.needCheckEntranceSet.clear();
					agent.needCheckEntranceSet.add(r1.get(0));
					agent.needCheckEntranceSet.add(r1.get(r1.size()-1));
				}
			}			
		}
		
		if(!agent.entrancesOfBurningRegion.isEmpty()){
			
			List<Road> entrancesOfBurningRegion1=new ArrayList<Road>();
			for(Road next:agent.entrancesOfBurningRegion){
				entrancesOfBurningRegion1.add(next);
			}		
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			Collections.sort(entrancesOfBurningRegion1, comparator);
			for(Road next:entrancesOfBurningRegion1){
				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BURNING_BUILDING_ENTRANCE);
				target.setTaskRank(PFTaskRank.ALL);//yuanc14.10.5
				agent.lastPFTarget=target;
				agent.sendClearPFTarget(target);
			}
		}else{
			clearBurningBuildingInPartition();
		}
	}
	private void clearFirstPosition() throws ActionCommandException{
	
		clearFirstStuckedAgent();
		clearFirstBuriedAgent();
	}
	
	private void clearFirstBuriedAgent() throws ActionCommandException{
		List<Human> needCheckFirstPos=new ArrayList<Human>();
		Iterator<Map.Entry<EntityID, EntityID>> it = agent.firstBuriedAgents.entrySet().iterator();  
        while(it.hasNext()){           
            EntityID next=it.next().getKey();  
            Human human=(Human)world.getEntity(next);
			EntityID currentPos=human.getPosition();
			if(currentPos!=null && agent.firstBuriedAgents.get(next)!=null && currentPos.getValue()==agent.firstBuriedAgents.get(next).getValue()){
				if(agent.isInMyPartition(currentPos)){
					if(!agent.visitedBuriedAgent.contains(human.getID())){
					needCheckFirstPos.add(human);
					}
				}
			}else{
				it.remove();
				agent.firstBuriedAgents.remove(next);
			}
        }  
              if(!needCheckFirstPos.isEmpty()){
        	Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
        	Collections.sort(needCheckFirstPos, comparator);
        
        		PFTarget target=new PFTarget(needCheckFirstPos.get(0).getID(),SEUPFTargetType.FIRST_BURIED_AGENT);
        		target.setTaskRank(PFTaskRank.ALL);
        		agent.lastPFTarget=target;
			//	System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearFirstBuriedAgent"+target.getID());

				agent.sendClearPFTarget(target);
        	}
        
	}
	
	private void clearFirstStuckedAgent() throws ActionCommandException{
		List<Human> needCheckFirstPos=new ArrayList<Human>();
		Iterator<Map.Entry<EntityID, EntityID>> it = agent.firstStuckAgents.entrySet().iterator();  
        while(it.hasNext()){           
            EntityID next=it.next().getKey();  
            Human human=(Human)world.getEntity(next);
			EntityID currentPos=human.getPosition();
			if(currentPos!=null && agent.firstBuriedAgents.get(next)!=null &&currentPos.getValue()==agent.firstStuckAgents.get(next).getValue()){
				if(agent.isInMyPartition(currentPos)){
					needCheckFirstPos.add(human);
				}
			}else{
				it.remove();
				agent.firstStuckAgents.remove(next);
			}
        }  
             if(!needCheckFirstPos.isEmpty()){
        	Comparator<Human> comparator=new HumanDistanceComparator(agent.getMeAsHuman(),world);
        	Collections.sort(needCheckFirstPos, comparator);
        	
        		PFTarget target=new PFTarget(needCheckFirstPos.get(0).getID(),SEUPFTargetType.FIRST_STUCKED_AGENT);
        		target.setTaskRank(PFTaskRank.ALL);
        		agent.lastPFTarget=target;
        		
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearFirstStuckedAgent"+target.getID());
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"needCheckFirstPos"+needCheckFirstPos);

				agent.sendClearPFTarget(target);
        	}
        
	}
	
	private void clearBuriedCiviliansInPartition() throws ActionCommandException {
		//SEUBuriedHumans buriedHumanFactory = agent.getBuriedHumans();
		BuriedHumans buriedHumanFactory = world.getBuriedHumans();
		Set<EntityID> buriedHumans = buriedHumanFactory.getTotalBuriedHuman();
		if(buriedHumans.isEmpty()){
			return;
		}
		
		
		
		agent.buriedEntrances.clear();
		List<EntityID> buriedAgentsID=new ArrayList<EntityID>();
		for(EntityID next : buriedHumanFactory.getTotalBuriedHuman()){
			buriedAgentsID.add(next);
		}
		for (EntityID entityID : buriedAgentsID) {
			StandardEntity SE = world.getEntity(entityID);
			if(SE==null){
				buriedHumanFactory.getTotalBuriedHuman().remove(entityID);
				continue;
			}
			if (!(SE instanceof Human)){
				buriedHumanFactory.getTotalBuriedHuman().remove(entityID);
				continue;
			}
			Human human = (Human) SE;
			EntityID positionID = human.getPosition();
			StandardEntity positionSE = world.getEntity(positionID);		
			if (!(positionSE instanceof Building)){
				buriedHumanFactory.getTotalBuriedHuman().remove(entityID);
				continue;
			}
			Building building = (Building) positionSE;
			if (agent.currentPartition.containtBuilding(entityID)) {
				for (Road road : world.getEntrance(building)) {
					if (agent.needCheckEntranceSet.contains(road))
						agent.buriedEntrances.add(road);
				}
			}
		}
		if(agent.buriedEntrances.isEmpty()){
		}else{
		}
		if(!agent.buriedEntrances.isEmpty()){
			Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
			List<Road> buriedEntrances0=new ArrayList<Road>();
			for(Road entrance :buriedEntrances){
				buriedEntrances0.add(entrance);
			}
			Collections.sort(buriedEntrances0, comparator);
			
			
			List<Road> buriedEntrances1=new ArrayList<Road>();
			for(Road next:agent.buriedEntrances){
				buriedEntrances1.add(next);
			}
			for(Road next:buriedEntrances1){
				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BURIED_HUMAN_IN_BUILDING);
				target.setTaskRank(PFTaskRank.ALL);
				//System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearBuriedCiviliansInPartition"+target.getID());

				agent.sendClearPFTarget(target);
			}
		}
	}
	
	public boolean isNeedCheckFirstPos(){
		if(world.isNoRadio()||world.isCommunicationLow()){
			return true;
		}
		return false;
	}
	
	private Map<EntityID,Integer> atSamePositionTime=new HashMap<EntityID,Integer>();
	int sameTimeTolerant=5; 
	int stuckAgentSelectRank=1;
	private void finishTaskSameToOthers(){
		List<EntityID> visiblePFs=world.getVisualPFs();
		if(!atSamePositionTime.isEmpty()){
			for(EntityID next:atSamePositionTime.keySet()){
				if(!visiblePFs.contains(next)){
					atSamePositionTime.put(next, 0);
				}
			}
		}
		if(visiblePFs!=null&&!visiblePFs.isEmpty()){			
			for(EntityID next:visiblePFs){
				if(next.getValue()==agent.getID().getValue()) continue;
				if(atSamePositionTime.containsKey(next)){
					if(agent.lastPFTarget!=null&&(agent.lastPFTarget.getTaskRank()==PFTaskRank.OBSERVABLE||
							agent.lastPFTarget.getTaskRank()==PFTaskRank.NEAR)){
						int a=atSamePositionTime.get(next);
						atSamePositionTime.put(next, a+1);
					}					
				}else{
					atSamePositionTime.put(next, 1);
				}
			}
		}else{
			atSamePositionTime.clear();
		}
		boolean isRankIncrease=false;
		if(!atSamePositionTime.isEmpty()){
			for(EntityID next:atSamePositionTime.keySet()){
				int a=atSamePositionTime.get(next);
				if(a>=sameTimeTolerant){
					if(agent.lastPFTarget!=null&&(agent.lastPFTarget.getTaskRank()==PFTaskRank.OBSERVABLE||
							agent.lastPFTarget.getTaskRank()==PFTaskRank.NEAR)){
						if(agent.getID().getValue()>next.getValue()){
							agent.lastPFTarget.setDone();
							agent.updatePFTarget();
							stuckAgentSelectRank+=1;
							isRankIncrease=true;
						}
					}
				}
			}			
		}
		if(!isRankIncrease){
			stuckAgentSelectRank=1;
		}
	}
	
	private void clearBorderBuiding() throws ActionCommandException {
		if(agent.borderRoad.isEmpty()){
		List<BurningBuildingCluster> burningBuildingClusters=getBurningBuildingCluster();
		if(!burningBuildingClusters.isEmpty()){
			BurningBuildingCluster targetCluster=burningBuildingClusters.get(0);
			Point p=targetCluster.getCenterPoint();
			if(p==null) return;
			//yuan14.10.10
			double targetDis=Distance.getDistance(p, agent.getCurrentPosition());
			for(int i=1;i<burningBuildingClusters.size();i++){
				Point p1=burningBuildingClusters.get(i).getCenterPoint();
				if(p1==null) continue;
				double dis=Distance.getDistance(p1, agent.getCurrentPosition());
				if(targetDis>dis){
					targetCluster=burningBuildingClusters.get(i);
					targetDis=dis;
				}
			}
			List<Building> borderBuilding=targetCluster.getBorderBurningBuilding();
			if(!borderBuilding.isEmpty()){
				List<Road> targerRoads=new ArrayList<Road>();
				//agent.println(" 获取边界房屋"+borderBuilding);
				Cluster initiCluster = agent.pfPartitions.get(agent.assignedPartitionIndex);
				For:for(Building next:borderBuilding){
					List<Road> entrances=world.getEntrance(next);
					if(entrances==null||entrances.isEmpty()) {							
						continue;
					}
					if(next.isFierynessDefined()&&next.getFieryness()>=3){
						continue;
					}
					if(initiCluster.containtBuilding(next.getID())){						
						Road targetRoad=entrances.get(0);
						if(agent.visitedEntrances.contains(targetRoad.getID())){					
							continue;
						}
						targerRoads.add(targetRoad);
						//targerBuildings.add(next);
						continue;
					}
					for (Integer next1 : initiCluster.getNeighbours()) {
						Cluster cluster = agent.pfPartitions.get(next1.intValue());
						if (cluster.containtBuilding(next.getID())) {							
							Road targetRoad=entrances.get(0);
							if(agent.visitedEntrances.contains(targetRoad.getID())){				
								continue For;
							}
							targerRoads.add(targetRoad);
							continue For;
						}
					}	
				}
				if(targerRoads.size()<=5&&!targerRoads.isEmpty()){
					agent.borderRoad.addAll(targerRoads);									
					//agent.println(" 获取分区内边界房屋"+targerRoads);
					Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(), world);
					Collections.sort(agent.borderRoad, comparator);
					/*List<Building> bs=new ArrayList<Building>();
					for(Building next:agent.borderBuilding){
						
					}
					Building targetBuilding=agent.borderBuilding.get(0);
					for(Building building:targerBuildings){
						
					}*/
					
				}
			}
			
			}
		}
		if(!agent.borderRoad.isEmpty()){
			List<Road> bs=new ArrayList<Road>();
			for(Road next:agent.borderRoad){
				bs.add(next);
			}
			for(Road next:bs){
		
				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BLOCKADE_ENTRANCE);
				target.setTaskRank(PFTaskRank.ALL);//yuanc14.10.5
				agent.lastPFTarget=target;
	//			System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearBorderBuiding"+target.getID());

				agent.sendClearPFTarget(target);
			}
		}
	}
	
	
	private void clearToFireBoder() throws ActionCommandException {
		if(agent.getTimeStep()<150){
			return;
		}
		if(!agent.isInMyPartition(agent.location().getID())){
			return;
		}
		agent.borderRoad.clear();
		List<BurningBuildingCluster> burningBuildingClusters=getBurningBuildingCluster();
		if(!burningBuildingClusters.isEmpty()){
			BurningBuildingCluster targetCluster=burningBuildingClusters.get(0);
			Point p=targetCluster.getCenterPoint();
			if(p==null) return;
			double targetDis=Distance.getDistance(p, agent.getCurrentPosition());
			for(int i=1;i<burningBuildingClusters.size();i++){
				Point p1=burningBuildingClusters.get(i).getCenterPoint();
				if(p1==null) continue;
				double dis=Distance.getDistance(p1, agent.getCurrentPosition());
				if(targetDis>dis){
					targetCluster=burningBuildingClusters.get(i);
					targetDis=dis;
				}
			}
			List<Building> borderBuilding=targetCluster.getBorderBurningBuilding();
			if(!borderBuilding.isEmpty()){
				List<Road> targerRoads=new ArrayList<Road>();
				Cluster initiCluster = agent.pfPartitions.get(agent.assignedPartitionIndex);
				For:for(Building next:borderBuilding){
					List<Road> entrances=world.getEntrance(next);
					if(entrances==null||entrances.isEmpty()) {							
						continue;
					}
					if(next.isFierynessDefined()&&next.getFieryness()>=3){
						continue;
					}
					if(initiCluster.containtBuilding(next.getID())){						
						Road targetRoad=entrances.get(0);
						if(agent.visitedEntrances.contains(targetRoad.getID())){					
							continue;
						}
						targerRoads.add(targetRoad);
						continue;
					}
					for (Integer next1 : initiCluster.getNeighbours()) {
						Cluster cluster = agent.pfPartitions.get(next1.intValue());
						if (cluster.containtBuilding(next.getID())) {							
							Road targetRoad=entrances.get(0);
							if(agent.visitedEntrances.contains(targetRoad.getID())){				
								continue For;
							}
							targerRoads.add(targetRoad);
							continue For;
						}
					}	
				}
				if(!targerRoads.isEmpty()){
					agent.borderRoad.addAll(targerRoads);									
					//agent.println(" 获取分区内边界房屋"+targerRoads);
					Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(), world);
					Collections.sort(agent.borderRoad, comparator);
					/*List<Building> bs=new ArrayList<Building>();
					for(Building next:agent.borderBuilding){
						
					}
					Building targetBuilding=agent.borderBuilding.get(0);
					for(Building building:targerBuildings){
						
					}*/
					
				}
			}
			
			}
		
		if(!agent.borderRoad.isEmpty()){
			List<Road> bs=new ArrayList<Road>();
			for(Road next:agent.borderRoad){
				bs.add(next);
			}
			for(Road next:bs){
		
				PFTarget target=new PFTarget(next.getID(),SEUPFTargetType.BLOCKADE_ENTRANCE);
				target.setTaskRank(PFTaskRank.ALL);
				agent.lastPFTarget=target;
		//		System.out.println(agent.getTimeStep()+"   "+agent.getID()+"clearToFireBoder");

				agent.sendClearPFTarget(target);
			}
		}
	}
	private void clearToFire() throws ActionCommandException {
		
		if(agent.getTimeStep()>100){
			return;
		}
		if(agent.clearFireFlag==false){
			return;
		}
		for(EntityID e:agent.location().getNeighbours()){
			StandardEntity entity=world.getEntity(e);
			if(entity instanceof Building){
				Building building=(Building)entity;
				if(building.isFierynessDefined()&&(building.getFieryness()!=0)){
					agent.clearFireFlag=false;
					return;
				}
			}
		}		
			SeuZone targetRegion = agent.getNearBurningZone();
			if (targetRegion == null) {
				return;
			}		
			if(agent.getEntranceOfZone(targetRegion)!=null&&!agent.getEntranceOfZone(targetRegion).isEmpty()){
				List<Road> r1=new ArrayList<Road>();
				for(Road next:agent.getEntranceOfZone(targetRegion)){
					r1.add(next);
				}
				Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
				Collections.sort(r1, comparator);
				agent.entrancesOfBurningRegion.addAll(agent.getEntranceOfZone(targetRegion));
				agent.needCheckEntranceSet.remove(r1.get(0));
				agent.nearEntrances.remove(r1.get(0));
				PFTarget target=new PFTarget(r1.get(0).getID(),SEUPFTargetType.BURNING_BUILDING_ENTRANCE);
				target.setTaskRank(PFTaskRank.ALL);//yuanc14.10.5
				agent.lastPFTarget=target;
//				System.out.println(agent.getTimeStep()+"   "+agent.getID()+"cleartofire"+target.getID());

				agent.sendClearPFTarget(target);
			}				
	}
	private List<BurningBuildingCluster> getBurningBuildingCluster(){
		List<BurningBuildingCluster> burningBuildingClusters=new ArrayList<BurningBuildingCluster>();
		if(!world.getBurningBuildings().isEmpty()){
			List<SeuZone> burningRegions=new ArrayList<SeuZone>();
			for(Building next:world.getBurningBuildings()){			
				SeuZone region=world.getZones().getBuildingZone(next.getID());
				if(region!=null&&!burningRegions.contains(region)){
					burningRegions.add(region);
				}
			}
			if(!burningRegions.isEmpty()){				
				burningBuildingClusters=createBurningBuildingCluster(burningRegions);
			}
			
		}
		return burningBuildingClusters;
	}
	
	public List<BurningBuildingCluster> createBurningBuildingCluster(List<SeuZone> regions){
		List<BurningBuildingCluster> a=new ArrayList<BurningBuildingCluster>();
		SeuZone firstRegion=regions.get(0);		
		regions.remove(0);
		List<SeuZone> neighbourRegions=new ArrayList<SeuZone>();
		Stack<SeuZone> stack = new Stack<SeuZone>();
		stack.add(firstRegion);
		do{
			SeuZone region1=stack.pop();
			neighbourRegions.add(region1);
			for(int i=0;i<regions.size();i++){
				SeuZone nextRegion=regions.get(i);
				if(region1.isNeighbourRegion(nextRegion)){
					if(!neighbourRegions.contains(nextRegion)){
						neighbourRegions.add(nextRegion);
						stack.add(nextRegion);
					}
				}
			}
			for(SeuZone next:neighbourRegions){
				int i=-1;
				for(int j=0;j<regions.size();j++){
					if(next.equals(regions.get(j))){
						i=j;						
						break;
					}
				}
				if(i!=-1){
					regions.remove(i);
				}
			}			
		}while(!stack.isEmpty());
		BurningBuildingCluster b=new BurningBuildingCluster(neighbourRegions,world);
		a.add(b);
		if(regions.isEmpty()) return a;
		else{
			List<BurningBuildingCluster> c=createBurningBuildingCluster(regions);
			a.addAll(c);
			return a;
		}
		
	}
	
	public List<Building> getVisualBurningBuildings(){
		for (EntityID next : agent.getChanged()) {
			 StandardEntity entity =world.getEntity(next);
		if (entity instanceof Building) {
				Building building = (Building) entity;	
				if (building.isOnFire()) {				
					if (agent.getTimeStep() < 20) {			
						visualBurningBuliding.add(building);					
					}
				} else visualBurningBuliding.remove(building);			
			}			
			}	
		 return visualBurningBuliding;
		 
	 }
//	private void clearImportBuild() throws ActionCommandException{
//		//if(world.importantRoad.isEmpty()) return;
//		List<Road> needCheckImportanceRoad=new ArrayList<Road>();
//		Iterator<Road> it = world.importantRoad.iterator();  
//        while(it.hasNext()){           
//            Road next=it.next();                         
//            if(next!=null){
//				if(agent.isInMyPartition(next.getID())){
//					if(agent.visitedEntrances.contains(next.getID())){
//						it.remove();
//						continue;
//					}
//					needCheckImportanceRoad.add(next);
//				}else{
//				    it.remove();
//			    }
//            }else{
//			    it.remove();
//		    }
//       }   
//        if(!needCheckImportanceRoad.isEmpty()){
//        	Comparator<StandardEntity> comparator=new DistanceComparator(agent.getMeAsHuman(),world);
//        	Collections.sort(needCheckImportanceRoad, comparator);
//        	for(Road next:needCheckImportanceRoad){     
//
//        		PFTarget target=new PFTarget(next.getID(),PFTargetType.BLOCKADE_ENTRANCE);
//        		target.setTaskRank(PFTaskRank.ALL);
//        		agent.lastPFTarget=target;
//				agent.sendClearPFTarget(target);
//        	}
//        }
//	}


}
