package seu.agent.pf.Tasks;


public enum PFState {
	 WORKING(0),
	    RESTING(1),
	    BURIED(2),
	    DEAD(3),
	    STUCK(4),
	    THINKING(5),
	    HURT(6),
	    SEARCHING(7);
	 

	    public int index;

	    private PFState(int index) {
	        this.index = index;
	    }

	    public static PFState getState(int typeIndex) {
	        PFState state;

	        if (typeIndex < values().length) {
	            state = values()[typeIndex];
	        } else {
	            state = null;
	        }
	        return state;
	    }

	    public static PFState indexToEnum(int index) {
	        for (PFState state : PFState.values()) {
	            if (state.ordinal() == index)
	                return state;
	        }
	        return null;
	    }

	    public static int getStateBitNum() {
	        int res = 1;
	        int size = PFState.values().length - 1;
	        while ((size >>= 1) != 0)
	            res++;
	        return res;
	    }

}
