package seu.agent.pf.Tasks;

import java.util.List;
import java.util.Map;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Road;
import rescuecore2.worldmodel.EntityID;

public class PFTarget {
	
    private EntityID id=null;
    private Area clearArea=null;
    private SEUPFTargetType targetType=null;
    private List<EntityID> clearPath=null;
    private boolean isOnTargetPath;
    private boolean isDone;
    private PFTaskRank taskRank=null;
    
    private List<Building> buildings=null;
    private List<Road> roads=null;
    
    public PFTarget(EntityID id, Area clearID, SEUPFTargetType targetType) {
        this.id = id;
        this.clearArea = clearID;
        this.targetType = targetType;
        isDone=false;
    }

    
    public PFTarget(EntityID id,SEUPFTargetType importanceType) {
        this.id = id;
        this.targetType = importanceType;
        isDone=false;
    }
    
 
    public PFTarget(EntityID id,List<EntityID> clearPath,SEUPFTargetType importanceType) {
    	this.id = id;
    	this.clearPath = clearPath;
        this.targetType = importanceType;
        isDone=false;
        isOnTargetPath=false;
    }

    public EntityID getID() {
        return id;
    }

    public Area getClearArea() {
        return clearArea;
    }
    
    public void setClearArea(Area clearArea){
    	this.clearArea=clearArea;
    }

    public SEUPFTargetType getTargetType() {
        return targetType;
    }   
    
    public boolean isDone(){
    	return isDone;
    }
    
    public void setDone(){
    	isDone=true;
    }
    
    public List<EntityID> getClearPath(){
    	return clearPath;
    }
    
    public boolean isOnClearPath(){
    	return isOnTargetPath;
    }
    
    public void setOnClearPath(){
    	isOnTargetPath=true;
    }
    
    public void setTaskRank(PFTaskRank taskRank){
    	this.taskRank=taskRank;
    }
    
    public PFTaskRank getTaskRank(){
    	return taskRank;
    }
    
    public void setBuilding(List<Building> building){
    	this.buildings=building;
    }
    
    public List<Building> getBuilding(){
    	return buildings;
    }
    
    public void setRoad(List<Road> road){
    	this.roads=road;
    }
    
    public List<Road> getRoad(){
    	return roads;
    }
    
}
