//package seu.agent.pf.cluster;
//
//import java.awt.Point;
//import java.awt.Polygon;
//import java.util.ArrayList;
//import java.util.Collection;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Set;
//
//import javolution.util.FastSet;
//import rescuecore2.standard.entities.Road;
//import rescuecore2.worldmodel.EntityID;
//import seu.geom.CompositeConvexHull;
//import seu.geom.Distance;
//import seu.model.SEUWorldModel;
//import seu.model.object.SEUBuilding;
//
//public class Region  implements Comparable<Region>{
//	private int id;
//	private SEUWorldModel world;
//	private Polygon regionPolygon;
//	private Point centerPoint;
//	private double distanceToMapCenter;
//	private double radiusLength;
//	private int buildingCount = 0;
//	private List<Region> neighbourRegions = new ArrayList<Region>();
//	private List<Integer> neighbourRegionIds = new ArrayList<Integer>();
//	private Set<EntityID> unvisitBuildings = new HashSet<EntityID>();
//	private Set<EntityID> unclearedEntrances = new HashSet<EntityID>();
//	private Set<EntityID> buriedHumans = new FastSet<EntityID>();
//	private double totalInitialFuel = 0.0d;
//	private double totalGroundArea = 0.0d;
//	private double totalArea = 0.0d;	
//	private double localValue;
//	private double globalValue;
//	private double regionValue;	
//	private Set<EntityID> surroundingRoad = new FastSet<EntityID>();
//	private Set<Road> allEntranceRoad = null;	
//	int belongPfClusterIndex = -1;
//	private List<SEUBuilding> buildingsInRegion;
//	private Set<Road> roadsInRegion;
//	
//	public Region(SEUWorldModel world, int id) {
//		this.world = world;
//		this.id = id;
//		buildingsInRegion=new ArrayList<SEUBuilding>();
//		roadsInRegion=new HashSet<Road>();
//	}
//	
//	public void initialiseRegion() {
//		calculateCenterPoint();
//		createRegionPolygon();
//		
//		for (SEUBuilding next : buildingsInRegion) {
//			unvisitBuildings.add(next.getId());
//		}
//		
//		for (Road next : getAllEntranceRoad()) {
//			unclearedEntrances.add(next.getID());
//		}
//	}
//	
//	private void calculateCenterPoint() {
//		centerPoint = new Point();
//		for (SEUBuilding next : buildingsInRegion) {
//			centerPoint.x += next.getSelfBuilding().getX();
//			centerPoint.y += next.getSelfBuilding().getY();
//		}
//		
//		int count = buildingsInRegion.size();
//		if (count != 0) {
//			centerPoint.x /= count;
//			centerPoint.y /= count;
//			
//			Point mapCenter = world.getMapCenterPoint();
//			distanceToMapCenter = Distance.getDistance(centerPoint, mapCenter);
//		}
//	}
//	
//	private void createRegionPolygon() {
//		try {
//			CompositeConvexHull convexHull = new CompositeConvexHull();
//			for (SEUBuilding next : buildingsInRegion) {
//				int[] apexList = next.getSelfBuilding().getApexList();
//				for (int i = 0; i < apexList.length; i = i + 2) {
//					convexHull.addPoint(apexList[i], apexList[i + 1]);
//				}
//			}
//			regionPolygon = convexHull.getConvexPolygon();
//			
//			radiusLength = Math.hypot(regionPolygon.getBounds().getWidth(), regionPolygon.getBounds().getHeight());
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		
//		radiusLength /= 2.0;
//	}
//
//	@Override
//	public int compareTo(Region o) {
//		if (this.regionValue > o.getRegionValue())
//			return -1;
//		
//		if (this.regionValue < o.getRegionValue())
//			return 1;
//		
//		return 0;
//	}
//	
//	public boolean addBuilding(SEUBuilding building) {
//		totalArea += building.getSelfBuilding().getTotalArea();
//		totalGroundArea += building.getSelfBuilding().getGroundArea();
//		totalInitialFuel += building.getInitialFuel();
//		buildingCount ++;
//		
//		return buildingsInRegion.add(building);
//	}
//	
//	public Polygon getRegionPolygon() {
//		return regionPolygon;
//	}
//	
//	public Point getRegionCenter() {
//		return centerPoint;
//	}
//	
//	public double getTotalInitialFuel() {
//		return totalInitialFuel;
//	}
//	
//	public double getTotaoGroundArea() {
//		return totalGroundArea;
//	}
//	
//	public double getTotalArea() {
//		return totalArea;
//	}
//	
//		public double getTotalGroundArea() {
//			return totalGroundArea;
//		}
//	
//	public int getRegionId() {
//		return this.id;
//	}
//	
//	public List<Region> getNeighbourRegions() {
//		return neighbourRegions;
//	}
//	
//	//yuanc14.10.10
//	public boolean isNeighbourRegion(Region region){
//		return neighbourRegions.contains(region);
//	}
//	
//	public void addNeighbourRegionIds(Integer zoneId) {
//		if (!neighbourRegionIds.contains(zoneId))
//			neighbourRegionIds.add(zoneId);
//	}
//	
//	public void addNeighbourRegion(Region zone) {
//		if (zone == null)
//			return;
//		if (!neighbourRegions.contains(zone))
//			neighbourRegions.add(zone);
//	}
//	
//	public List<Integer> getNeighbourRegionIds() {
//		return neighbourRegionIds;
//	}
//	
//	public double getRegionValue() {
//		return this.regionValue;
//	}
//	
//	public double getLocalValue() {
//		return this.localValue;
//	}
//	
//	public double getGlobalValue() {
//		return this.globalValue;
//	}
//	
//	public int getBuildingCount() {
//		return this.buildingCount;
//	}
//	
//	public void setRadiusLength(double radiusLength) {
//		this.radiusLength = radiusLength;
//	}
//	
//	public double getRadiusLength() {
//		return this.radiusLength;
//	}
//	
//	public void addSurroundingRoad(Road road) {
//		surroundingRoad.add(road.getID());
//	}
//	
//	public Set<Road> getRoadsInRegion(){
//		return roadsInRegion;
//	}
//	
//	public void addSurroundingRoad(EntityID road) {
//		surroundingRoad.add(road);
//	}
//	
//	public Set<EntityID> getSurroundingRoad() {
//		return surroundingRoad;
//	}
//	
//	public double getDistanceToMapCenter() {
//		return this.distanceToMapCenter;
//	}
//	
//	public Set<Road> getAllEntranceRoad() {
//		if (allEntranceRoad == null) {
//			allEntranceRoad = new FastSet<Road>();
//			for (SEUBuilding next : buildingsInRegion) {
//				allEntranceRoad.addAll(world.getEntrance(next.getSelfBuilding()));
//			}
//		}
//		
//		return allEntranceRoad;
//	}
//	
//	public Set<EntityID> getUnvisitBuildings() {
//		return unvisitBuildings;
//	}
//	
//	public void removeVisitedFromUnvisit(Collection<EntityID> visited) {
//		this.unvisitBuildings.removeAll(visited);
//	}
//	
//	public Set<EntityID> getBuriedHumans() {
//		return this.buriedHumans;
//	}
//	
//	public void addBuriedHuman(EntityID... humans) {
//		for (EntityID next : humans) {
//			this.buriedHumans.add(next);
//		}
//	}
//	
//	
//	public boolean isAllEntranceCleared() {
//		return this.unclearedEntrances.isEmpty();
//	}
//	
//	public boolean containtBuilding(EntityID id) {
//		return buildingsInRegion.contains(world.getSeuBuilding(id));
//	}
//	
//	public SEUWorldModel getWorld() {
//		return world;
//	}
//
//	public void setWorld(SEUWorldModel world) {
//		this.world = world;
//	}
//	
//	public void setBelongPfClusterIndex(int pfClusterIndex) {
//		this.belongPfClusterIndex = pfClusterIndex;
//	}
//	
//	public int getBelongPfClusterIndex() {
//		return this.belongPfClusterIndex;
//	}
//	
//	public List<SEUBuilding> getBuldingsInRegion(){
//		return buildingsInRegion;
//	}
//	
//	public void removeBuilding(SEUBuilding building1){
//		buildingsInRegion.remove(building1);
//	}
//
//	public int size() {
//		// TODO Auto-generated method stub
//		return buildingsInRegion.size();
//	}
//
//	public SEUBuilding getBuilding(int i) {
//		// TODO Auto-generated method stub
//		return buildingsInRegion.get(i);
//	}
//}
