package seu.common;

import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.SEUAgent.ActionCommandException;
import seu.common.State;
import seu.model.SEUWorldModel;


public abstract class BasicTask<T extends SEUAgent<? extends StandardEntity>> {

	public T agent;
	public State state;



	// 返回当前任务状态
	public State getState() {
		
		return state;
	}
	
	public BasicTask(T agent) {
		this.agent = agent;
		state = State.Inactive;
	}
//
//	public abstract void taskDone();
//
//	public abstract boolean shouldExecute();

	public abstract void execute() throws ActionCommandException, TimeOutException;
	

	// 获得智能体的World Model
	public SEUWorldModel getModel() {
		return agent.getModel();
	}

	/*public AbstractSearch getSearch() {
		return agent.getSearch();
	}*/

	@Override
	public String toString() {
		return getClass().getName() + "(" + state + ")";
	}

}
