package seu.message;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.PriorityQueue;

import seu.agent.SEUAgent;
import seu.message.Type.Message;

public class MessageController {

	Comparator<QueueMessage> comparator;
	PriorityQueue<QueueMessage> queue;//优先級
    private SEUAgent agent;
	public MessageController(SEUAgent agent) {
		this.agent=agent;
		comparator = new QueueMessageComparator();
		queue = new PriorityQueue<QueueMessage>(10, comparator);
	}

	public void addMessage(int channel, Message message,
			MessagePriority importance) {
		QueueMessage queueMessage = new QueueMessage(channel, message,
				importance);
		queue.add(queueMessage);
	}

	public Collection<QueueMessage> getMostImportantMessages() {
		if (!queue.isEmpty()) {
			Collection<QueueMessage> result = new ArrayList<QueueMessage>();
			while (!queue.isEmpty()) {
				result.add(queue.poll());//poll=get+remove
				
			}
			return result;
		} else {
			return null;
		}
	}

	public void clearQueue() {
		queue.clear();
	}

	public int queueSize() {
		return queue.size();
	}
	public void updateQueue(){
		Collection<QueueMessage> remove = new ArrayList<QueueMessage>();
		if (!queue.isEmpty()) {
			for(QueueMessage next:queue)
			{
			if(agent.getTimeStep()-next.message.getReceivedStep()<5)	
				remove.add(next);
			}	
			queue.removeAll(remove);	
		}
		
		
	}
}
