package seu.message;


import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import rescuecore2.config.Config;
import seu.agent.SEUAgent;
import seu.message.Type.BlankMessage;
import seu.message.Type.Message;
import seu.message.Type.MessageType;


public class MessageTranslator {

	public static final int DEFAULT_REPEAT_COUNT = 1;
	public static final int MAX_MESSAGE_ID = 255;
	public static int isTestPeriod = 0;

	private final int byteRepeatCount;
	private int nextMessageId;
	private final Config config;
	private Map<MessageType, Integer> channelMap;
	private HashMap<Integer, Integer> repeatCounts;
	private int Reapeat;
     private SEUAgent agent;
	
	public MessageTranslator(SEUAgent agent,Config config) {
		this(config, DEFAULT_REPEAT_COUNT);
		this.agent=agent;
	}


	public MessageTranslator(Config config, int repeatCount) {
		channelMap= new HashMap<MessageType,Integer>();
		repeatCounts = new HashMap<Integer, Integer>();
		this.setReapeat(1);
		this.byteRepeatCount = repeatCount;
		this.config = config;

		
		setRepeatCounts();

	}

	public int calculateRepeat(double probability) {
		probability = probability / 100;
		if (probability == 1) {
			return 1;
		}
		double top = Math.log(1 - CONFIDENCE);
		double bottom = Math.log(1 - probability);

		int n = (int) (Math.ceil(top / bottom));
		if (n >= 10)
			n = 10;
		if (n <= 1)
			n = 1;

		return n;

	}

	private void setTempChannelMap() {
		int n;
		Map<MessageType, Integer> map;

	
		n = getChannelCount(); 
		
		map = new HashMap<MessageType, Integer>();
		map.put(MessageType.ChannelCondition, 1);
		if (n == 2) {
			map.put(MessageType.MessageCount1, 1);

		} else if (n == 3) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);

		} else if (n == 4) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);

		} else if (n == 5) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
		} else if (n == 6) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
		} else if (n == 7) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
		} else if (n == 8) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
			map.put(MessageType.MessageCount7, 7);
		} else if (n == 9) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
			map.put(MessageType.MessageCount7, 7);
			map.put(MessageType.MessageCount8, 8);
		} else if (n == 10) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
			map.put(MessageType.MessageCount7, 7);
			map.put(MessageType.MessageCount8, 8);
			map.put(MessageType.MessageCount9, 9);

		} else if (n == 11) {
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
			map.put(MessageType.MessageCount7, 7);
			map.put(MessageType.MessageCount8, 8);
			map.put(MessageType.MessageCount9, 9);
			map.put(MessageType.MessageCount10, 10);

		} else // No Radio Channel can be used
		{
			map.put(MessageType.MessageCount1, 1);
			map.put(MessageType.MessageCount2, 2);
			map.put(MessageType.MessageCount3, 3);
			map.put(MessageType.MessageCount4, 4);
			map.put(MessageType.MessageCount5, 5);
			map.put(MessageType.MessageCount6, 6);
			map.put(MessageType.MessageCount7, 7);
			map.put(MessageType.MessageCount8, 8);
			map.put(MessageType.MessageCount9, 9);
			map.put(MessageType.MessageCount10, 10);
			// System.err.println("!!!!!!!!!!! The number of channels are more than 11 !!!!!!!!!!!");

		}
		channelMap = map;

	}

	public byte[] transmit(Message message) {

		byte[] bytes = message.convertToByteArray();

		if (byteRepeatCount == 1) {
			return bytes;
		}
		// byte[] repeatedBytes = getRepeatedBytes(bytes, byteRepeatCount);

		// return repeatedBytes;

		return bytes;
	}

	public byte[] transmit(byte[] message) {
		return message;
	}


	public Message receive(byte[] bytes) throws IOException,
	ClassNotFoundException {
		
    if (bytes == null || bytes.length == 0) {


	   return new BlankMessage();
     }

     
      Message message = Message.getMessage(bytes);
    return message;

}


	public byte[] getNonRepeatedBytes(byte[] msg) {
		return getNonRepeatedBytes(msg, byteRepeatCount);
	}

	public static byte[] getNonRepeatedBytes(byte[] bytes, int repeatCount) {
		repeatCount = 1;// it must be 1
		if (repeatCount == 1) {
			return bytes;
		}
		byte[] realMessage = new byte[bytes.length / repeatCount];
		for (int i = 0; i < realMessage.length; i++) {
			byte[] temp = new byte[repeatCount];
			for (int j = 0; j < temp.length; j++) {
				int k = i + j * realMessage.length;
				temp[j] = bytes[k];
			}
			realMessage[i] = getCorrectByte(temp);
		}
		return realMessage;
	}

	public static byte getCorrectByte(byte[] bytes) {
		int BYTE_SIZE = 8;
		byte b = 0;
		int base = 1;
		for (int i = 0; i < BYTE_SIZE; i++) {
			int value = 0;
			for (int j = 0; j < bytes.length; j++) {
				if (bytes[j] % 2 != 0) {
					value++;
				}
				bytes[j] = (byte) (bytes[j] >>> 1);
			}
			if (value > bytes.length / 2) {
				b += base;
			}
			base *= 2;
		}
		return b;
	}

	protected static byte[] getRepeatedBytes(byte[] bytes, int repeatCount) {
		byte[] repeatedBytes = new byte[bytes.length * repeatCount];
		for (int i = 0; i < repeatCount; i++) {
			for (int j = 0; j < bytes.length; j++) {
				int k = i * bytes.length + j;
				repeatedBytes[k] = bytes[j];
			}
		}
		return repeatedBytes;
	}

	protected byte[] getRepeatedBytes(byte[] bytes) {
		return getRepeatedBytes(bytes, byteRepeatCount);
	}

	public static final String COMMUNICATIONS_KEY = "comms";
	public static final String CHANNELS_KEY = "channels";
	public static final String NOISE_KEY = "noise";
	public static final String USE_KEY = "use";
	public static final String PROBABILITY_KEY = "p";
	public static final String COUNT_KEY = "count";
	public static final String BANDWITH_KEY = "bandwidth";

	public int getNumofPlatoon() 
	{
		String key = COMMUNICATIONS_KEY + "." + CHANNELS_KEY + ".max.platoon";
		int n = config.getIntValue(key);
		return n;
	}

	public int getChannelCount() {
		String key = COMMUNICATIONS_KEY + "." + CHANNELS_KEY + "." + COUNT_KEY;
		int n = config.getIntValue(key);
		return n;
	}

	public double getBandWith(int channel) {
		String key = COMMUNICATIONS_KEY + "." + CHANNELS_KEY + "." + channel
				+ "." + BANDWITH_KEY;
		double n = config.getFloatValue(key);
		return n;
	}

	protected double getNoise(int channel, String ioType, String noiseType) {
		String key = COMMUNICATIONS_KEY + "." + CHANNELS_KEY + "." + channel
				+ "." + NOISE_KEY + "." + ioType + "." + noiseType;
		String useKey = key + "." + USE_KEY;
		try {
			boolean hasNoise = config.getBooleanValue(useKey);
			if (hasNoise) {
				String probabilityKey = key + "." + PROBABILITY_KEY;
				double p = config.getFloatValue(probabilityKey);
				return p;
			}
		} catch (Exception e) {

		}
		return 0.0;
	}

	public static final String INPUT_KEY = "input";
	public static final String OUTPUT_KEY = "output";
	public static final String DROPOUT_KEY = "dropout";
	public static final String FAILURE_KEY = "failure";

	protected double getTotalNoise(int channel) {
		String[] ioTypes = { INPUT_KEY, OUTPUT_KEY };
		String[] noiseTypes = { DROPOUT_KEY, FAILURE_KEY };
		double sum = 1;
		for (String ioType : ioTypes) {
			for (String noiseType : noiseTypes) {
				double p = getNoise(channel, ioType, noiseType);
				if (p > 0)
					sum = sum * (1 - p);
			}
		}

		return 1 - sum;
	}

	public int getRepeatCount(int channel) {
		return repeatCounts.get(channel);
	}

	public static final double CONFIDENCE = 0.8;

	private int calculateRepeatCount(double probability) {
		if (probability == 0) {
			return 1;
		}
		double top = Math.log(1 - CONFIDENCE);
		double bottom = Math.log(probability);

		int n = (int) (Math.ceil(top / bottom));
		if (n >= 10)
			n = 10;
		// System.out.println("sendCounter:"+n);

		return n;
	}

	private void setRepeatCounts() {
	
		int n = getChannelCount();
		for (int i = 0; i < n; i++) {
			double p = getTotalNoise(i);
			int repeat = calculateRepeatCount(p);
			repeatCounts.put(i, repeat);
		}
	}

	private void setFinalRepeatCounts(int[] rankChannel,
			int[] channelConditionList) {
		repeatCounts = new HashMap<Integer, Integer>();
		int n = getChannelCount();
		for (int i = 0; i < n - 1; i++) {

			int temp = rankChannel[i] - 1;
			if (temp < 0)
				temp = 0;
			repeatCounts.put(rankChannel[i], channelConditionList[temp]);

		}
		repeatCounts.put(0, 2);
	}

	public void incrementMessageId() {
		nextMessageId = (nextMessageId + 1) % (MAX_MESSAGE_ID + 1);
	}

	public int getNextMessageId() {
		return nextMessageId;
	}

	public void setChannelMap(int[] channelRank, int[] channelConditionList,int[] channelRealConditionList
			,int m) {
		int n;
		channelMap.clear();
		int k;
		n = getChannelCount();
         if(n==1||m==0)
         {
        	 setNoRadioChannelMap();
        	 return;
        	 
         }
        	 
         if(n==6&&m==1){  
        	 setChannelMap_1();
        	 return;
        	 
         }
         
		int i, j;
		int[] rankChannel = new int[21];
		for (i = 0; i < n - 1; i++) {
			int point = 0;
			for (j = 0; j < n - 1; j++) {
				if (channelRank[j] == i) {
					rankChannel[i] = j;
				}
			}

		}
		for (i = 0; i < rankChannel.length; i++) {
			rankChannel[i] += 1;
		}
	
		  if(m>4) m=4;
		  if(m==4){
			  if(n>=5)setChannelMap_4(rankChannel);
			  if(n==4)setChannelMap_3(rankChannel);
			  if(n==3)setChannelMap_2(rankChannel);
			  if(n==2) setChannelMap_1(rankChannel);
			  if(n==1) setNoRadioChannelMap();
		  }else if (m == 3) {

			 if(n>=4)setChannelMap_3(rankChannel);
			 if(n==3)setChannelMap_2(rankChannel);
		     if(n==2)setChannelMap_1(rankChannel);
		     if(n==1) setNoRadioChannelMap();
			 
		} else if (m == 2) {
			 if(n>=3) setChannelMap_2(rankChannel);
			 if(n==2) setChannelMap_1(rankChannel);
			 if(n==1) setNoRadioChannelMap();
		} else if(m==1)
		{
			
			if(n>=2) setChannelMap_1(rankChannel);
            if(n==1) setNoRadioChannelMap();
		}
		 
	}


	
	public void setChannelMap() {
		int m=getNumofPlatoon();
		channelMap.clear();
		int n = getChannelCount();
         if(n==1||m==0)
         {
        	 setNoRadioChannelMap();
        	 return; 
         }
        	 
         if(n==6&&m==1){ 
        	 setChannelMap_1();
        	 return;
        	 
         }
         if(agent.isLimited){
        	 setChannelMap_Limited();
        	 return;
         }
		  if(m>4) m=4;
		  if(m==4){
			  if(n>=5)setChannelMap_4();
			  if(n==4)setChannelMap_3();
			  if(n==3)setChannelMap_2();
			  if(n==2) setChannelMap_1();
			  if(n==1) setNoRadioChannelMap();
		  }else if (m == 3) {

			 if(n>=4)setChannelMap_3();
			 if(n==3)setChannelMap_2();
		     if(n==2)setChannelMap_1();
		     if(n==1) setNoRadioChannelMap();
			 
		} else if (m == 2) {
			 if(n>=3) setChannelMap_2();
			 if(n==2) setChannelMap_1();
			 if(n==1) setNoRadioChannelMap();
		} else if(m==1)
		{
			
			if(n>=2) setChannelMap_1();
            if(n==1) setNoRadioChannelMap();
		}
		 
	}

	
	 private void setChannelMap_Limited(){
		    channelMap.put(MessageType.BuildingIsBurningMessage,1);
			channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,0);
			channelMap.put(MessageType.AgentPositionMessage,0);
			channelMap.put(MessageType.WaterMessage,1);
			channelMap.put(MessageType.HumanIsSavedOrDeadMessage,0);
			channelMap.put(MessageType.BuildingIsExtinguishedMessage,1);
			channelMap.put(MessageType.RescuingMessage,0);
			channelMap.put(MessageType.BuildingIsBurnedOutMessage,0);
			channelMap.put(MessageType.RemovedClusterMessage,0);
			channelMap.put(MessageType.CriticalAreaisClearedMessage,0); 
	 }
	

    private void setNoRadioChannelMap(){
    	channelMap.put(MessageType.BuildingIsBurningMessage,0);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,0);
		channelMap.put(MessageType.AgentPositionMessage,0);
		channelMap.put(MessageType.WaterMessage,0);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,0);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,0);
		channelMap.put(MessageType.RescuingMessage,0);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,0);
		channelMap.put(MessageType.RemovedClusterMessage,0);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,0);
	 
	 
    }
	
	private void setChannelMap_1(){
		  
		channelMap.put(MessageType.BuildingIsBurningMessage,1);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,1);
		channelMap.put(MessageType.AgentPositionMessage,1);
		channelMap.put(MessageType.WaterMessage,1);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,1);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,1);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,1);
		channelMap.put(MessageType.RemovedClusterMessage,1);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,1);
		
	}
	
	private void setChannelMap_1(int rankChannel[]){
	
		channelMap.put(MessageType.BuildingIsBurningMessage,rankChannel[0]);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,rankChannel[0]);
		channelMap.put(MessageType.AgentPositionMessage,rankChannel[0]);
		channelMap.put(MessageType.WaterMessage,rankChannel[0]);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,rankChannel[0]);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,rankChannel[0]);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,rankChannel[0]);
		channelMap.put(MessageType.RemovedClusterMessage,rankChannel[0]);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,rankChannel[0]);
		
	}

	private void setChannelMap_2(int rankChannel[]){
		channelMap.put(MessageType.BuildingIsBurningMessage,rankChannel[0]);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,rankChannel[0]);
		channelMap.put(MessageType.WaterMessage,rankChannel[0]);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,rankChannel[0]);
		
		channelMap.put(MessageType.AgentPositionMessage,rankChannel[1]);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,rankChannel[1]);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,rankChannel[1]);
		channelMap.put(MessageType.RemovedClusterMessage,rankChannel[1]);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,rankChannel[1]);
		
	}

	
	private void setChannelMap_2(){
		channelMap.put(MessageType.BuildingIsBurningMessage,1);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,1);
		channelMap.put(MessageType.WaterMessage,1);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,1);
		
		channelMap.put(MessageType.AgentPositionMessage,2);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,2);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,2);
		channelMap.put(MessageType.RemovedClusterMessage,2);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,2);
		
	}
	 
	private void setChannelMap_3(int rankChannel[]){
		channelMap.put(MessageType.BuildingIsBurningMessage,rankChannel[0]);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,rankChannel[0]);
		channelMap.put(MessageType.WaterMessage,rankChannel[0]);
		
		
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,rankChannel[1]);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,rankChannel[1]);
		channelMap.put(MessageType.AgentPositionMessage,rankChannel[1]);
		
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,rankChannel[2]);
		channelMap.put(MessageType.RemovedClusterMessage,rankChannel[2]);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,rankChannel[2]);
		
	}
	
	private void setChannelMap_3(){
		channelMap.put(MessageType.BuildingIsBurningMessage,1);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,1);
		channelMap.put(MessageType.WaterMessage,1);
		
		
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,2);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,2);
		channelMap.put(MessageType.AgentPositionMessage,2);

		channelMap.put(MessageType.BuildingIsBurnedOutMessage,3);
		channelMap.put(MessageType.RemovedClusterMessage,3);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,3);
		
	}
	private void setChannelMap_4(int rankChannel[]){
		channelMap.put(MessageType.BuildingIsBurningMessage,rankChannel[0]);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,rankChannel[0]);
		channelMap.put(MessageType.AgentPositionMessage,rankChannel[1]);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,rankChannel[1]);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,rankChannel[2]);
		channelMap.put(MessageType.WaterMessage,rankChannel[2]);
		channelMap.put(MessageType.RescuingMessage,rankChannel[2]);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,rankChannel[3]);
		channelMap.put(MessageType.RemovedClusterMessage,rankChannel[3]);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,rankChannel[3]);
		
	}
	private void setChannelMap_4(){
		channelMap.put(MessageType.BuildingIsBurningMessage,1);
		channelMap.put(MessageType.HumanisBuriedfromChangesetorVoiceMessage,1);
		channelMap.put(MessageType.AgentPositionMessage,2);
		channelMap.put(MessageType.BuildingIsExtinguishedMessage,2);
		channelMap.put(MessageType.HumanIsSavedOrDeadMessage,3);
		channelMap.put(MessageType.WaterMessage,3);
		channelMap.put(MessageType.RescuingMessage,3);
		channelMap.put(MessageType.BuildingIsBurnedOutMessage,4);
		channelMap.put(MessageType.RemovedClusterMessage,4);
		channelMap.put(MessageType.CriticalAreaisClearedMessage,4);
		
	}

	public int getChannel(MessageType messageType) {
		Integer no;

		no = channelMap.get(messageType);
		if (no == null) {
			return 1;
		} else {
			return no;
		}
	}

	public int getReapeat() {
		return Reapeat;
	}

	public void setReapeat(int reapeat) {
		Reapeat = reapeat;
	}

}
