package seu.message.Property;

import java.util.List;
 
import rescuecore2.worldmodel.EntityID;

public abstract class MessageProperty<T extends Object> {
	public static final int BYTE_MAX = 256;

	protected PropertyName propertyName;
	protected int byteCount;
	protected int  ListUnitByteCount;

	public MessageProperty(PropertyName propertyName, int byteCount) {
		this.propertyName = propertyName;
		this.byteCount = byteCount;
		this.ListUnitByteCount=2;///lb
	}
	public int getListUnitByteCount() {//lb
		return ListUnitByteCount;
	}
	public int getByteCount() {
		return byteCount;
	}

	public PropertyName getPropertyName() {
		return propertyName;
	}

	public abstract List<Byte> getBytes(Object value);
	public abstract List<Byte> getListBytes(EntityID [] t );//lb
	protected abstract T getValue(byte[] bytes);

	public T getValue(byte[] bytes, int firstIndex) {
		byte[] tempBytes = new byte[byteCount];
		for (int i = 0; i < byteCount; i++) {
			tempBytes[i] = bytes[i + firstIndex];
		}
		return getValue(tempBytes);
	}
	public EntityID [] getListValue(byte[] bytes, int firstIndex) {//////LB
		
		EntityID [] t=new EntityID [byteCount/ListUnitByteCount];
		byte[] tempBytes = new byte[byteCount];
		for (int k = 0; k < byteCount/ListUnitByteCount; k++) {
		for (int i = 0; i < ListUnitByteCount; i++) {
			tempBytes[i] = bytes[i +ListUnitByteCount*k+ firstIndex];
		}
		try{
			EntityID a=new EntityID((Integer)getValue(tempBytes));
			t[k]= a;
			}catch(Exception e){System.err.println("bbbbb");System.err.println(e.getMessage());}
		}
		
		//System.out.println("t : " + t+" "+t[0]+" "+t[1]+" "+t[2] );
		return t;
	}
	@SuppressWarnings("unchecked")
	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final MessageProperty<T> other = (MessageProperty<T>) obj;
		if (this.propertyName != other.propertyName) {
			return false;
		}
		if (this.byteCount != other.byteCount) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 5;
		return hash;
	}

}
