package seu.model.object.seuZoneEntity;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Random;

import javolution.util.FastMap;
import rescuecore2.worldmodel.EntityID;


@SuppressWarnings("serial")
public class SeuZones extends ArrayList<SeuZone>{
	protected Map<EntityID, SeuZone> buildingZonePair = new FastMap<EntityID, SeuZone>();
	protected Random random;
	
	public SeuZones(Random random) {
		this.random = random;
	}
	
	public SeuZone getZone(int zoneId) {
		for (SeuZone next : this) {
			if (next.getZoneId() == zoneId)
				return next;
		}
		return null;
	}
	
	public void findNeighbourZone() {
		for (SeuZone next : this) {
			for (Integer id : next.getNeighbourZoneIds()) {
				next.addNeighbourZone(getZone(id.intValue()));
			}
		}
	}
	
	public void addBuildingZonePair(EntityID buildingId, SeuZone zone) {
		this.buildingZonePair.put(buildingId, zone);
	}
	
	public SeuZone getBuildingZone(EntityID buildingId) {
		return this.buildingZonePair.get(buildingId);
	}
}
