package seu.util;

import java.util.Comparator;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardWorldModel;

public class HumanDistanceComparator implements Comparator<Human> {
	private Human reference;
	private StandardWorldModel world;
	public HumanDistanceComparator(Human reference, StandardWorldModel world) {
		this.reference = reference;
		this.world = world;
	}

	@Override
	public int compare(Human o1, Human o2) {
		int dis_1 = world.getDistance(o1.getPosition(), reference.getPosition());
		int dis_2 = world.getDistance(o2.getPosition(), reference.getPosition());
		
		if (dis_1 > dis_2)
			return 1;
		if (dis_1 < dis_2)
			return -1;
		
		if (dis_1 == dis_2) {
			if (o1.getID().getValue() > o2.getID().getValue())
				return 1;
			if (o1.getID().getValue() < o2.getID().getValue())
				return -1;
		}
		return 0;
	}
}
