package seu.util;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;

import rescuecore2.standard.entities.Blockade;
import seu.model.SEUWorldModel;
import seu.geom.Distance;

public class MultiBlockDistanceComparator implements Comparator<Blockade> {
	private Collection<Point> references;
	public MultiBlockDistanceComparator(SEUWorldModel world,
			Point... references) {
		ArrayList<Point> points=new ArrayList<Point>();
		for (Point p : references) {
			points.add(p);
		}
		this.references = points;
	}

	@Override
	public int compare(Blockade a, Blockade b) {
		int d1, d2;

		d1 = 0;
		d2 = 0;
		for (Point reference : references) {
			d1 += Distance.getDistanceToBlock(a, reference);
			d2 += Distance.getDistanceToBlock(b, reference);
		}
		return d1 - d2;
	}
}
